package nc.bs.arap.plugin.tocmp;

import java.text.SimpleDateFormat;
import java.util.Calendar;
import java.util.Collection;
import java.util.Date;
import java.util.UUID;

import nc.bs.arap.util.NCToMyXmlUtil;
import nc.bs.businessevent.BusinessEvent;
import nc.bs.businessevent.BusinessEvent.BusinessUserObj;
import nc.bs.businessevent.IBusinessEvent;
import nc.bs.businessevent.IBusinessListener;
import nc.bs.dao.BaseDAO;
import nc.ui.pub.print.version55.print.output.excel.core.ExcelException;
import nc.vo.arap.pay.PayBillVO;
import nc.vo.cmp.settlement.SettlementAggVO;
import nc.vo.cmp.settlement.SettlementHeadVO;
import nc.vo.esb.EsbInfoAnnotatioVO;
import nc.vo.esb.QueryInfoVO;
import nc.vo.esb.RequestInfoVO;
import nc.vo.esb.RequestToEsbVO;
import nc.vo.esb.ResultEsbMyToNcVO;
import nc.vo.esb.ResultMyToNcVO;
import nc.vo.pub.BusinessException;

/**
 * @author zhengyao3/֣
 * @date 2018-9-25 11:10:47
 * @Description:ҵдԴ
 * 
 */
public class SettleAfterWriteToMyPlugin implements IBusinessListener {

	public static SimpleDateFormat dateFormat = new SimpleDateFormat(
			"yyyy-MM-dd HH:mm:ss:SSS");

	@Override
	public void doAction(IBusinessEvent event) throws BusinessException {
		SettlementAggVO[] settlementAggVOs = getVO(event);
		if (settlementAggVOs != null && settlementAggVOs.length >= 0) {
			for (SettlementAggVO aggvo : settlementAggVOs) {
				SettlementHeadVO headVO = (SettlementHeadVO) aggvo
						.getParentVO();
				String pk_busibill = headVO.getPk_busibill();
				String guidSql = " pk_paybill = '" + pk_busibill
						+ "' and nvl(dr,0) = 0";
				Collection<PayBillVO> paybillVOs = new BaseDAO()
						.retrieveByClause(PayBillVO.class, guidSql);
				for (PayBillVO paybillVO : paybillVOs) {
					if ( "F3-Cxx-W01".equals(paybillVO.getPk_tradetype())) {
						String guid = paybillVO.getDef1();
						//add by zhengyao3@֣ ýӿ 2018102518:03:36 begin
						if(null == guid) {
							throw new BusinessException("guidΪգ");
						}
						RequestToEsbVO ruquestVO = getEsbVO(guid);
						ruquestVO.getRequestInfo().setPayStatus("δ֧");
						if("CMPsettleAfter".equals(event.getEventType())){
							ruquestVO.getRequestInfo().setPayStatus("ȫ֧");
						}
						
						String resultXML = NCToMyXmlUtil.sendHttpXmlToMy(
								ruquestVO, "MY-NC-PM-001");// ȡ÷صԴXML
						ResultEsbMyToNcVO resultVO = NCToMyXmlUtil
								.getResultEsbMyToNcVO(resultXML);// ԴصXMLתɶӦVO
						if (resultVO != null) {
							ResultMyToNcVO vo = resultVO.getResultInfo();
							if (!"S".equals(vo.getStatus())) {// S,ʧ
								throw new BusinessException("Դ"
										+ vo.getBusinessGUID()
										+ "ʵдʧ,Ϊ:" + vo.getReturnMsg());
							}
						}
						//add by zhengyao3@֣ ýӿ 2018102518:03:36 end
					}
				}
			}
		}

	}

	/**
	 * ȡԴVO,ΪתΪXMLʹ
	 * 
	 * @param guid
	 * @return
	 */
	private RequestToEsbVO getEsbVO(String guid) {
		String status = "ȫ֧";
		RequestToEsbVO esb = new RequestToEsbVO();
		EsbInfoAnnotatioVO esbInfo = new EsbInfoAnnotatioVO();
		QueryInfoVO queryInfo = new QueryInfoVO();
		Date date = Calendar.getInstance().getTime();// ȡǰʱ
		// ʱ
		esbInfo.setRequestTime(dateFormat.format(date));
		esbInfo.setInstId(UUID.randomUUID().toString());// ʹUUIDΪˮ
		esb.setEsbInfo(esbInfo);
		esb.setQueryInfo(queryInfo);
		RequestInfoVO infovo = new RequestInfoVO();
		infovo.setFKApplyGUID(guid);
		infovo.setPayStatus(status);
		esb.setRequestInfo(infovo);
		return esb;
	}

	/**
	 * ȡVO
	 * 
	 * @param event
	 * @return
	 */
	private SettlementAggVO[] getVO(IBusinessEvent event) {
		if (!(event instanceof BusinessEvent)) {
			return null;
		}
		BusinessEvent businessEvent = (BusinessEvent) event;
		Object obj = ((BusinessUserObj) businessEvent.getUserObject())
				.getUserObj();
		if (obj == null) {
			return null;
		}
		SettlementAggVO[] settlementAggVOs = null;
		if (obj instanceof SettlementAggVO[]) {
			settlementAggVOs = (SettlementAggVO[]) obj;
		} else if (obj instanceof SettlementAggVO) {
			settlementAggVOs = new SettlementAggVO[] { (SettlementAggVO) obj };
		} else {
			return null;
		}
		if (settlementAggVOs == null || settlementAggVOs.length <= 0) {
			return null;
		}
		return settlementAggVOs;
	}

}
