package nc.bs.tianwen.wuye;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.io.PrintWriter;
import java.util.UUID;

import javax.servlet.ServletInputStream;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import com.alibaba.fastjson.JSONObject;

import nc.bs.framework.common.InvocationInfoProxy;
import nc.bs.framework.common.NCLocator;
import nc.bs.framework.comn.NetStreamContext;
import nc.bs.framework.server.ISecurityTokenCallback;
import nc.itf.ztbossxt.process.IWuYeZtBossxtBusiService;
import nc.net.servlet.IReturnStatus;
import nc.net.servlet.SapToNcEsbJsonServlet;
import nc.pubitf.para.SysInitQuery;
import nc.util.uap.twxt.WYTwxtUtil;
import nc.vo.esb.ResultEsbVO;
import nc.vo.esb.ResultVO;
import nc.vo.pub.BusinessException;


/**
 * @Description: 
 * 
 * @author Ƽ̹԰ҵ-ʽӿڡ
 * @date 2019-04-12
 * @version with NC V6.3
 */
@SuppressWarnings("restriction")
public class TWPayApplyServelet extends SapToNcEsbJsonServlet {

	@Override
	public void execFunction(HttpServletRequest request,
			HttpServletResponse response) {
		JSONObject jsonobj = null;
		try {
			initInvocationInfo();
			jsonobj = findPostJsonValue(request);// ȡPostֵ
			if (jsonobj == null || "".equals(jsonobj)) {// Postύֵ
				ResultVO result = new ResultVO();
				result.setCode(IReturnStatus.FAILING);// ʧ
				result.setMessage("PostύJsonʽֵ!");
				ResultEsbVO<ResultVO> esb = new ResultEsbVO<ResultVO>();
				createResultEsbVO(esb);
				esb.getEsbInfo().setReturnStatus(IReturnStatus.ESB_FAILING);
				esb.getEsbInfo().setReturnMsg("ʧ");
				esb.setResultInfo(result);
				sendResponse(response, esb);
			} else {
				JSONObject requestInfo = (JSONObject) jsonobj.get("requestInfo");
				JSONObject head = requestInfo.getJSONObject("Header");
				if(head.containsKey("bossid")) {
					String jsondata =  NCLocator.getInstance().lookup(IWuYeZtBossxtBusiService.class).writeBossPayableApplyInfo(jsonobj);
					sendResponse(response,jsondata);
				} else if(head.containsKey("ztId")){
					String jsondata =  NCLocator.getInstance().lookup(IWuYeZtBossxtBusiService.class).writeZtPayableApplyInfo(jsonobj);
					sendResponse(response,jsondata);
				} else {
					String jsondata = WYTwxtUtil.getIWuYeTwxtBusiService().writePayApplyInfo(new uap.json.JSONObject(jsonobj.toString()));
					sendResponse(response,jsondata);
				}
			}
		} catch (Exception e) {
			ResultVO result = new ResultVO();
			result.setCode(IReturnStatus.ERROR);// 쳣
			result.setError(getExceptionDetail(e));
			ResultEsbVO<ResultVO> esb = new ResultEsbVO<ResultVO>();// Ӧ
			createResultEsbVO(esb);// ʼӦ
			esb.getEsbInfo().setReturnStatus(IReturnStatus.ESB_ERROR);
			esb.getEsbInfo().setReturnMsg("쳣");
			esb.setResultInfo(result);// Ӧ
			sendResponse(response, esb);
		}
	}

	/**
	 * UUIDֵ
	 */
	public static String getStringUUID() {
		return UUID.randomUUID().toString();
	}

	/**
	 * ӦϢ
	 * 
	 * @param response
	 * @param esb
	 */
	public void sendResponse(final HttpServletResponse response, String jsondata) {
		PrintWriter out = null;
		try {
			response.setHeader("Content-type", "application/json;charset=UTF-8");
			out = new PrintWriter(new OutputStreamWriter(
					response.getOutputStream(), "UTF-8"));
			out.write(jsondata);
			out.flush();
		} catch (IOException e) {
			e.printStackTrace();
		} finally {
			if (out != null) {
				out.close();
			}
		}
	}

	/**
	 * PostύJson
	 * 
	 * @param request
	 * @return
	 * @throws Exception
	 */
	private JSONObject findPostJsonValue(final HttpServletRequest request)
			throws Exception {
		BufferedReader br = null;
		try {
			br = new BufferedReader(new InputStreamReader(
					(ServletInputStream) request.getInputStream(), "utf-8"));
			StringBuffer sb = new StringBuffer();
			String temp = null;
			while ((temp = br.readLine()) != null) {
				sb.append(temp);
			}
			return  JSONObject.parseObject(sb.toString());
		} catch (Exception e) {
			throw e;
		} finally {
			try {
				if (br != null)
					br.close();
			} catch (IOException e) {
				e.printStackTrace();
			}
		}
	}

	private void initInvocationInfo() throws BusinessException {
		InvocationInfoProxy.getInstance().setGroupId(SysInitQuery.getParaString("GLOBLE00000000000000", "GROUP"));
		InvocationInfoProxy.getInstance().setUserId(SysInitQuery.getParaString("GLOBLE00000000000000", "ITFUSER"));
		ISecurityTokenCallback tc = NCLocator.getInstance().lookup(
				ISecurityTokenCallback.class);
		byte[] token = tc.token("__system".getBytes(), "NC".getBytes());
		NetStreamContext.setToken(token);
	}
}
