package nc.bs.uap.bossxt.process;

import com.alibaba.fastjson.JSONObject;

import nc.bs.dao.BaseDAO;
import nc.jdbc.framework.processor.ColumnProcessor;
import nc.net.servlet.IReturnStatus;
import nc.util.uap.twxt.WYTwxtUtil;
import nc.vo.arap.payable.AggPayableBillVO;
import nc.vo.arap.payable.PayableBillItemVO;
import nc.vo.arap.payable.PayableBillVO;
import nc.vo.baseapp.jsontool.JsonTransfVOUtil;
import nc.vo.baseapp.jsontool.ParamVO;
import nc.vo.esb.ResultEsbVO;
import nc.vo.esb.ResultVO;
import nc.vo.pub.BusinessException;
import nc.vo.pubapp.pattern.data.ValueUtils;
import nc.vo.pubapp.pattern.exception.ExceptionUtils;
import nc.vo.twxt.log.WYTwxtLogVO;

/**
 * @Description: bossϵͳ->NC̨ӦͬNC
 * 
 * @author tsy ̹԰-ҵ-bossϵͳӿڡ
 * @date 2021-04-13
 * @version with NCC
 */	
public class WriteBossPayableApplyInfoProcess {


	public String writeBossPayableApplyInfo(JSONObject jsonobj) throws BusinessException {
		String rsdata = null;
		Object pk_bill=null;
		Object bossid=null;
		String pk_tradetype = null;
		ResultVO result = new ResultVO();
		result.setResult("");
		ResultEsbVO<ResultVO> esb = new ResultEsbVO<ResultVO>();
		esb.setResultInfo(result);
		try {
			if (jsonobj == null || "".equals(jsonobj.toString())) {// Postύֵ

				result.setCode(IReturnStatus.FAILING);// ʧ
				result.setMessage("PostύJsonʽֵ!");
				WYTwxtUtil.createResultEsbVO(esb);
				esb.getEsbInfo().setReturnStatus(IReturnStatus.ESB_FAILING);
				esb.getEsbInfo().setReturnMsg("ʧ");
				esb.setResultInfo(result);
			} else {
				JSONObject requestInfo = (JSONObject) jsonobj.get("requestInfo");
				if(requestInfo == null){
					throw new Exception("ӦϢΪգ");
				}
				
				JSONObject headerJsonObject =requestInfo.getJSONObject("Header");
				bossid =headerJsonObject.get("bossid");

				String sql="select count(def2) from ap_payablebill where def2 ='"+bossid+"'  and nvl(dr, 0) = 0";

				BaseDAO baseDAO=new BaseDAO();
				Object count=baseDAO.executeQuery(sql, new ColumnProcessor());
				
				if(ValueUtils.getInt(count)>0){
					result.setCode(IReturnStatus.SUCCEED);// ɹ
					com.alibaba.fastjson.JSONObject resJsonObject=new com.alibaba.fastjson.JSONObject();
					resJsonObject.put("billno", "");
					result.setResult(resJsonObject);
					result.setMessage("bossϵͳͬӦɹ");
					WYTwxtUtil.createResultEsbVO(esb);
					esb.setResultInfo(result);
					rsdata=com.alibaba.fastjson.JSONObject.toJSONString(esb);
					return rsdata;
				}

				ParamVO paramVO=new ParamVO();
				paramVO.setAggVOClass(AggPayableBillVO.class);
				paramVO.setHeadVOClass(PayableBillVO.class);
				paramVO.setBodyVOClass(PayableBillItemVO.class);
				paramVO.setBilldata(requestInfo.toString());
				paramVO.sethCfgCode("bossF1_HEAD");
				paramVO.setBfgCode("bossF1_BODY");
				
				AggPayableBillVO aggPayableBillVO=JsonTransfVOUtil.json2AggVO(paramVO);
				
				// תǰǿУ顢ִйʽǿУ
				JsonTransfVOUtil.notNullCheckAndExFormula("bossF1_HEAD", "bossF1_BODY", aggPayableBillVO);
				pk_tradetype=aggPayableBillVO.getHeadVO().getPk_tradetype();
				aggPayableBillVO.getHeadVO().setDef2(null == bossid ? null : bossid.toString());

				WYTwxtUtil.getIPFBusiAction().processAction("SAVE", aggPayableBillVO.getHeadVO().getPk_tradetype(), null, aggPayableBillVO, null, null);
				pk_bill=aggPayableBillVO.getPrimaryKey();
				WYTwxtUtil.getIPFBusiAction().processAction("APPROVE", aggPayableBillVO.getHeadVO().getPk_tradetype(), null, aggPayableBillVO, null, null);

				result.setCode(IReturnStatus.SUCCEED);// ɹ
				com.alibaba.fastjson.JSONObject resJsonObject=new com.alibaba.fastjson.JSONObject();
				resJsonObject.put("billno", aggPayableBillVO.getHeadVO().getBillno());
				result.setResult(resJsonObject);
				result.setMessage("bossϵͳͬӦɹ");
				WYTwxtUtil.createResultEsbVO(esb);
				esb.setResultInfo(result);
			}
		} catch (Exception e) {
			result.setCode(IReturnStatus.ERROR);// 쳣
			result.setError(null == bossid ?null : bossid.toString()+":"+ e.getMessage());
			result.setMessage(WYTwxtUtil.getExceptionDetail(e));
			WYTwxtUtil.createResultEsbVO(esb);// ʼӦ
			esb.getEsbInfo().setReturnStatus(IReturnStatus.ESB_ERROR);
			esb.getEsbInfo().setReturnMsg("쳣");
			esb.setResultInfo(result);// Ӧ
//			ExceptionUtils.marsh(e);
		} finally {
			rsdata=com.alibaba.fastjson.JSONObject.toJSONString(esb);
			WYTwxtLogVO logVO=new WYTwxtLogVO();
			
			logVO.setNc_id(pk_bill+"");
			logVO.setOther_id(bossid +"");
			logVO.setBillno("");
			logVO.setTranstypecode(pk_tradetype+"");
			logVO.setItfcode("Boss-NC-FI-003");
			logVO.setItfname("ҵbossӿڡӦ");
			logVO.setBilldata(jsonobj == null ? "" : jsonobj.toString());
			logVO.setRsdata(rsdata);
			logVO.setMsg(null);
			logVO.setIssuccess(IReturnStatus.SUCCEED.equals(result.getCode()) ? "Y" : "N");

			WYTwxtUtil.getIWuYeTwxtLogService().insertLog_RequiresNew(logVO);
		}
		return rsdata;
	}
}
