package nc.bs.uap.twxt.process;

import com.alibaba.fastjson.JSONObject;

import nc.bs.dao.BaseDAO;
import nc.bs.framework.common.InvocationInfoProxy;
import nc.bs.uap.boss.process.BossWriteGatherBillInfo;
import nc.jdbc.framework.processor.ColumnProcessor;
import nc.net.servlet.IReturnStatus;
import nc.pubitf.para.SysInitQuery;
import nc.util.uap.twxt.WYTwxtUtil;
import nc.vo.arap.gathering.AggGatheringBillVO;
import nc.vo.arap.gathering.GatheringBillItemVO;
import nc.vo.arap.gathering.GatheringBillVO;
import nc.vo.baseapp.jsontool.JsonTransfVOUtil;
import nc.vo.baseapp.jsontool.ParamVO;
import nc.vo.esb.ResultEsbVO;
import nc.vo.esb.ResultVO;
import nc.vo.pub.BusinessException;
import nc.vo.pubapp.pattern.data.ValueUtils;
import nc.vo.pubapp.pattern.exception.ExceptionUtils;
import nc.vo.twxt.log.WYTwxtLogVO;

/**
 * @Description: bossϵͳ,̨ϵͳ->NC
 * @author xuy
 * @date 2022-04-13
 */
public class BossWriteGatherBillInfoProcess implements BossWriteGatherBillInfo {
	/**
	 * bossϵͳտ
	 * */
	@SuppressWarnings("unchecked")
	public String writeGatherBillInfo(JSONObject jsonobj) throws BusinessException {
		String rsdata = null;
		Object pk_bill=null;
		Object bossid=null;
		String pk_tradetype = null;
		ResultVO result = new ResultVO();
		result.setResult("");
		ResultEsbVO<ResultVO> esb = new ResultEsbVO<ResultVO>();
		esb.setResultInfo(result);
		try {
			if (jsonobj == null || "".equals(jsonobj.toString())) {// Postύֵ
				result.setCode(IReturnStatus.FAILING);// ʧ
				result.setMessage("PostύJsonʽֵ!");
				WYTwxtUtil.createResultEsbVO(esb);
				esb.getEsbInfo().setReturnStatus(IReturnStatus.ESB_FAILING);
				esb.getEsbInfo().setReturnMsg("ʧ");
				esb.setResultInfo(result);
			} else {
				JSONObject requestInfo = (JSONObject) jsonobj.get("requestInfo");
				if(requestInfo == null){
					throw new Exception("տϢΪգ");
				}
				InvocationInfoProxy.getInstance().setGroupId(SysInitQuery.getParaString("GLOBLE00000000000000", "GROUP"));
				InvocationInfoProxy.getInstance().setUserId(SysInitQuery.getParaString("GLOBLE00000000000000", "ITFUSER"));
				JSONObject headerJsonObject =requestInfo.getJSONObject("Header");
				bossid =headerJsonObject.get("bossid");

				String sql="select count(def1) from ar_gatherbill where def1 = '"+bossid+"' and nvl(dr, 0) = 0";

				BaseDAO baseDAO=new BaseDAO();
				Object count=baseDAO.executeQuery(sql, new ColumnProcessor());

				if(ValueUtils.getInt(count)>0){
					result.setCode(IReturnStatus.SUCCEED);// ɹ
					result.setMessage("Bossϵͳͬտɹ");
					com.alibaba.fastjson.JSONObject resJsonObject=new com.alibaba.fastjson.JSONObject();
					resJsonObject.put("billno", null);
					result.setResult(resJsonObject);
					WYTwxtUtil.createResultEsbVO(esb);
					esb.setResultInfo(result);
					rsdata =com.alibaba.fastjson.JSONObject.toJSONString(esb);
					return rsdata;
				}

				ParamVO paramVO=new ParamVO();
				paramVO.setAggVOClass(AggGatheringBillVO.class);
				paramVO.setHeadVOClass(GatheringBillVO.class);
				paramVO.setBodyVOClass(GatheringBillItemVO.class);
				paramVO.setBilldata(requestInfo.toString());
				paramVO.sethCfgCode("bossF2_HEAD");//bossF2_HEAD
				paramVO.setBfgCode("bossF2_BODY");//bossF2_BODY
				
				AggGatheringBillVO aggGatheringBillVO=JsonTransfVOUtil.json2AggVO(paramVO);
				
				// תǰǿУ顢ִйʽǿУ
				JsonTransfVOUtil.notNullCheckAndExFormula("bossF2_HEAD", "bossF2_BODY", aggGatheringBillVO);
				pk_tradetype=aggGatheringBillVO.getHeadVO().getPk_tradetype();
				aggGatheringBillVO.getHeadVO().setDef1(null==bossid?null:bossid.toString());//bossiddef1
				//Ӧռᵥ
				Object saveObject=WYTwxtUtil.getIPFBusiAction().processAction("SAVE", aggGatheringBillVO.getHeadVO().getPk_tradetype(), null, aggGatheringBillVO, null, null);
				pk_bill=aggGatheringBillVO.getPrimaryKey();
//				InvocationInfoProxy.getInstance().setUserId(SysInitQuery.getParaString("GLOBLE00000000000000", "ITFUSER"));
				aggGatheringBillVO.getHeadVO().setApprovedated(aggGatheringBillVO.getHeadVO().getBilldate());
				InvocationInfoProxy.getInstance().setBizDateTime(aggGatheringBillVO.getHeadVO().getBilldate().getMillis());
				WYTwxtUtil.getIPFBusiAction().processAction("APPROVE", aggGatheringBillVO.getHeadVO().getPk_tradetype(), null, aggGatheringBillVO, null, null);
				result.setCode(IReturnStatus.SUCCEED);// ɹ
				result.setMessage("Bossϵͳͬտɹ");
				com.alibaba.fastjson.JSONObject resJsonObject=new com.alibaba.fastjson.JSONObject();
				resJsonObject.put("billno", aggGatheringBillVO.getHeadVO().getBillno());
				result.setResult(resJsonObject);
				WYTwxtUtil.createResultEsbVO(esb);
				esb.setResultInfo(result);
				
			}
		} catch (Exception e) {
			result.setCode(IReturnStatus.ERROR);// 쳣
			result.setError(WYTwxtUtil.getExceptionDetail(e));
			result.setMessage(null == bossid ? null : bossid.toString()+":"+e.getMessage());
			WYTwxtUtil.createResultEsbVO(esb);// ʼӦ
			esb.getEsbInfo().setReturnStatus(IReturnStatus.ESB_ERROR);
			esb.getEsbInfo().setReturnMsg("쳣");
			esb.setResultInfo(result);// Ӧ
			ExceptionUtils.marsh(e);
		} finally {
			rsdata =com.alibaba.fastjson.JSONObject.toJSONString(esb);
			WYTwxtLogVO logVO=new WYTwxtLogVO();
			
			logVO.setNc_id(pk_bill+"");
			logVO.setOther_id(bossid +"");
			logVO.setBillno("");
			logVO.setTranstypecode(pk_tradetype+"");
			logVO.setItfcode("BO-NC-FI-002");
			logVO.setItfname("ҵBossӿڡտ");
			logVO.setBilldata(jsonobj == null ? "" : jsonobj.toString());
			logVO.setRsdata(rsdata);
			logVO.setMsg(null);
			logVO.setIssuccess(IReturnStatus.SUCCEED.equals(result.getCode()) ? "Y" : "N");

			WYTwxtUtil.getIWuYeTwxtLogService().insertLog_RequiresNew(logVO);
		}
		return rsdata;
	}
	/**
	    * ̨ϵͳտ
	 * */
	@SuppressWarnings("unchecked")
	public String writeGatherBillInfo2(JSONObject jsonobj) throws BusinessException {
		String rsdata = null;
		Object pk_bill=null;
		Object ztid=null;
		String def19=null;
		String pk_tradetype = null;
		ResultVO result = new ResultVO();
		result.setResult("");
		ResultEsbVO<ResultVO> esb = new ResultEsbVO<ResultVO>();
		esb.setResultInfo(result);
		try {
			if (jsonobj == null || "".equals(jsonobj.toString())) {// Postύֵ
				result.setCode(IReturnStatus.FAILING);// ʧ
				result.setMessage("PostύJsonʽֵ!");
				WYTwxtUtil.createResultEsbVO(esb);
				esb.getEsbInfo().setReturnStatus(IReturnStatus.ESB_FAILING);
				esb.getEsbInfo().setReturnMsg("ʧ");
				esb.setResultInfo(result);
			} else {
				JSONObject requestInfo = (JSONObject) jsonobj.get("requestInfo");
				if(requestInfo == null){
					throw new Exception("տϢΪգ");
				}
				InvocationInfoProxy.getInstance().setGroupId(SysInitQuery.getParaString("GLOBLE00000000000000", "GROUP"));
				InvocationInfoProxy.getInstance().setUserId(SysInitQuery.getParaString("GLOBLE00000000000000", "ITFZTUSER"));
				JSONObject headerJsonObject =requestInfo.getJSONObject("Header");
				ztid =headerJsonObject.get("ztId");
				def19=headerJsonObject.getString("def19");
				String sql="select count(def1) from ar_gatherbill where def1 = '"+ztid+"' and nvl(dr, 0) = 0";

				BaseDAO baseDAO=new BaseDAO();
				Object count=baseDAO.executeQuery(sql, new ColumnProcessor());

				if(ValueUtils.getInt(count)>0){
					result.setCode(IReturnStatus.SUCCEED);// ɹ
					result.setMessage("̨ϵͳͬտɹ");
					com.alibaba.fastjson.JSONObject resJsonObject=new com.alibaba.fastjson.JSONObject();
					resJsonObject.put("billno", null);
					result.setResult(resJsonObject);
					WYTwxtUtil.createResultEsbVO(esb);
					esb.setResultInfo(result);
					rsdata =com.alibaba.fastjson.JSONObject.toJSONString(esb);
					return rsdata;
				}

				ParamVO paramVO=new ParamVO();
				paramVO.setAggVOClass(AggGatheringBillVO.class);
				paramVO.setHeadVOClass(GatheringBillVO.class);
				paramVO.setBodyVOClass(GatheringBillItemVO.class);
				paramVO.setBilldata(requestInfo.toString());
				paramVO.sethCfgCode("ZTF2_HEAD");
				paramVO.setBfgCode("ZTF2_BODY");
				
				AggGatheringBillVO aggGatheringBillVO=JsonTransfVOUtil.json2AggVO(paramVO);
				
				// תǰǿУ顢ִйʽǿУ
				JsonTransfVOUtil.notNullCheckAndExFormula("ZTF2_HEAD", "ZTF2_BODY", aggGatheringBillVO);
				pk_tradetype=aggGatheringBillVO.getHeadVO().getPk_tradetype();
				aggGatheringBillVO.getHeadVO().setDef1(null==ztid?null:ztid.toString());//ztiddef1
				//Ӧռᵥ
				Object saveObject=WYTwxtUtil.getIPFBusiAction().processAction("SAVE", aggGatheringBillVO.getHeadVO().getPk_tradetype(), null, aggGatheringBillVO, null, null);
				pk_bill=aggGatheringBillVO.getPrimaryKey();
//				InvocationInfoProxy.getInstance().setUserId(SysInitQuery.getParaString("GLOBLE00000000000000", "ITFUSER"));
				aggGatheringBillVO.getHeadVO().setApprovedated(aggGatheringBillVO.getHeadVO().getBilldate());
				InvocationInfoProxy.getInstance().setBizDateTime(aggGatheringBillVO.getHeadVO().getBilldate().getMillis());
				WYTwxtUtil.getIPFBusiAction().processAction("APPROVE", aggGatheringBillVO.getHeadVO().getPk_tradetype(), null, aggGatheringBillVO, null, null);
				result.setCode(IReturnStatus.SUCCEED);// ɹ
				result.setMessage("̨ϵͳͬտɹ");
				com.alibaba.fastjson.JSONObject resJsonObject=new com.alibaba.fastjson.JSONObject();
				resJsonObject.put("billno", aggGatheringBillVO.getHeadVO().getBillno());
				result.setResult(resJsonObject);
				WYTwxtUtil.createResultEsbVO(esb);
				esb.setResultInfo(result);
				
			}
		} catch (Exception e) {
			result.setCode(IReturnStatus.ERROR);// 쳣
			result.setError(WYTwxtUtil.getExceptionDetail(e));
			result.setMessage(null == def19 ? null : def19.toString()+":"+e.getMessage());
			WYTwxtUtil.createResultEsbVO(esb);// ʼӦ
			esb.getEsbInfo().setReturnStatus(IReturnStatus.ESB_ERROR);
			esb.getEsbInfo().setReturnMsg("쳣");
			esb.setResultInfo(result);// Ӧ
		} finally {
			rsdata =com.alibaba.fastjson.JSONObject.toJSONString(esb);
			WYTwxtLogVO logVO=new WYTwxtLogVO();
			
			logVO.setNc_id(pk_bill+"");
			logVO.setOther_id(ztid +"");
			logVO.setBillno("");
			logVO.setTranstypecode(pk_tradetype+"");
			logVO.setItfcode("ZT-NC-FI-002");
			logVO.setItfname("ҵ̨Bossӿڡտ");
			logVO.setBilldata(jsonobj == null ? "" : jsonobj.toString());
			logVO.setRsdata(rsdata);
			logVO.setMsg(null);
			logVO.setIssuccess(IReturnStatus.SUCCEED.equals(result.getCode()) ? "Y" : "N");

			WYTwxtUtil.getIWuYeTwxtLogService().insertLog_RequiresNew(logVO);
		}
		return rsdata;
	}

}
