package nc.impl.om.eventlistener;

import java.io.ByteArrayInputStream;
import java.text.SimpleDateFormat;
import java.util.Calendar;
import java.util.Date;
import java.util.UUID;

import org.dom4j.Document;
import org.dom4j.Element;
import org.dom4j.io.SAXReader;

import com.thoughtworks.xstream.XStream;
import com.thoughtworks.xstream.io.xml.DomDriver;
import com.thoughtworks.xstream.io.xml.XmlFriendlyNameCoder;

import nc.bs.arap.util.NCToMyXmlUtil;
import nc.bs.businessevent.IBusinessEvent;
import nc.bs.businessevent.IBusinessListener;
import nc.bs.businessevent.bd.BDCommonEvent;
import nc.bs.framework.common.NCLocator;
import nc.itf.uap.IUAPQueryBS;
import nc.jdbc.framework.processor.BeanProcessor;
import nc.jdbc.framework.processor.ColumnProcessor;
import nc.vo.esb.EsbInfoAnnotatioVO;
import nc.vo.esb.QueryInfoVO;
import nc.vo.esb.RequestDeptInfoVO;
import nc.vo.esb.RequestDeptToEsbVO;
import nc.vo.esb.ResultFinanceDeptFramMyToNcVO;
import nc.vo.org.DeptVO;
import nc.vo.pub.BusinessException;
import nccloud.commons.lang.ArrayUtils;
import nccloud.commons.lang.StringUtils;



/**
 * @author libx3/
 * @date 2019-3-29 19:30:47
 * @Description:NCɾıʱͬԴ
 *
 */
public class SynNCFinanceDeptManagerListener implements IBusinessListener {
	
	public static SimpleDateFormat dateFormat = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss:SSS");
	
	private final  String EVENT_ADD = "1002"; //
	private final  String EVENT_EDIT = "1004"; //޸
	private final  String EVENT_DELETE = "1006"; //ɾ
	//add by zhengfyao3@֣ Ӳ 20194412:01:17
	private final  String EVENT_DELETEBEFORE = "1005"; //ɾ
	private final  String EVENT_FIRSTENABLE = "1067"; //δñ
	private final  String EVENT_DISTENABLE = "1069"; //ñͣ
	private final  String EVENT_ENABLE = "1071"; //ͣñ
	
	@Override
	public void doAction(IBusinessEvent event) throws BusinessException {
		BDCommonEvent.BDCommonUserObj userObj = (BDCommonEvent.BDCommonUserObj) event.getUserObject();
		Object newObj = userObj.getNewObjects();
		Object oldObj = userObj.getOldObjects();
		if(newObj.getClass().isArray()) {
			Object[] newVOs = (Object[])newObj;
			Object[] oldVOs = (Object[])oldObj;
			if(ArrayUtils.isEmpty(newVOs)) {
				return;
			}
			String oldPrincipal = "";
			if(!ArrayUtils.isEmpty(oldVOs)) {
				oldPrincipal = ((DeptVO)oldVOs[0]).getPrincipal();
			}
			String newPrincipal = ((DeptVO)newVOs[0]).getPrincipal();
			if((!StringUtils.isEmpty(newPrincipal)) && (!StringUtils.isEmpty(oldPrincipal)) && newPrincipal.equalsIgnoreCase(oldPrincipal)) {
				return;
			}
			String eventType = event.getEventType();
			String MsgType = "1";//,,ɾ1
			//add by zhengfyao3@֣ ɾǰԴ 20194412:01:17
			//update by zhengyao3@֣ 20194417:14:16 ɾʱݸԴͣñʶ begin
			//update by zhengyao3@֣  20194816:25:54 ֶ begin
			for(Object deptVO: newVOs){
				DeptVO newDeptVO = (DeptVO)deptVO;
				String pk_dept = newDeptVO.getPk_dept();
				//add by ƹڻ 40331 ⡿޷沿Žڵ ,ֶβԼԱ  begin
				//update by zhengyao3@֣ 201942317:36:11 ԭsqlҪȥֻ֯Ҫorg_orgs begin
				String sql = "select d1.pk_dept NC_PK_Dept,d1.code DepartmentCode,d1.name DepartmentName,d2.pk_dept FatherDepartmentPK," +
						" d2.code FatherDepartmentCode,d2.name FatherDepartmentName,o1.code FinanceCode,o1.name FinanceName," +
						" def.code BUGUID,def.name Area,d1.enablestate Enabledstate,d1.modifiedtime UpdateDate,d1.modifier modifier," +
						" o2.code ParentFinanceCode,o2.name ParentFinanceName,d1.creationtime CreateDate,'' HtTypeDepartmentName,doc2.code DepartmentPropertyCode,doc2.name DepartmentPropertyName from org_dept d1 " +
						" left join org_dept d2 on d1.pk_fatherorg=d2.pk_dept " +
						" left join org_orgs o1 on d1.pk_org=o1.pk_org " +
						" left join org_orgs o2 on o1.pk_fatherorg=o2.pk_org " +
						" left join bd_defdoc def on o1.def11=def.pk_defdoc " +
						" left join bd_defdoc doc2 on  d1.def20=doc2.pk_defdoc "+
						" where d1.pk_dept='" + pk_dept+"'";
				//update by zhengyao3@֣ 201942317:36:11 ԭsqlҪȥֻ֯Ҫorg_orgs end
				//add by ƹڻ 40331 ⡿޷沿Žڵ end
				IUAPQueryBS bs = NCLocator.getInstance().lookup(IUAPQueryBS.class);
				RequestDeptInfoVO requestDeptInfoVO = (RequestDeptInfoVO) bs.executeQuery(sql, new BeanProcessor(RequestDeptInfoVO.class));
				if(requestDeptInfoVO == null){
					throw new BusinessException("޸ɾŴԴ,ѯӦ!");
				}
				
				//add by ־ 2019-12-11 ֯Ϊҵµ֯ begin
				//update by zhengyao3@֣ ŴݰԶ嵵İд 202062817:16:46 begin
		        //String queryorgsql = "select pk_org from org_orgs where isbusinessunit = 'Y' and code = '" + requestDeptInfoVO.getFinanceCode() + "' start with pk_org = '0001H21000000000G2RL' connect by prior pk_org = pk_fatherorg";
				String queryorgsql = new StringBuilder("SELECT PK_ORG")
				.append("  FROM ORG_ORGS")
				.append(" WHERE ISBUSINESSUNIT = 'Y'")
				.append("   AND CODE = '" + requestDeptInfoVO.getFinanceCode() + "'")
				.append("  START WITH PK_ORG IN (SELECT T3.PK_ORG ")
				.append("                         FROM BD_DEFDOC T1 ")
				.append("                         LEFT JOIN BD_DEFDOCLIST T2 ")
				.append("                           ON T1.PK_DEFDOCLIST = T2.PK_DEFDOCLIST ")
				.append("                         LEFT JOIN ORG_ORGS T3 ")
				.append("                           ON T3.CODE = T1.CODE ")
				.append("                          AND T3.ISBUSINESSUNIT = 'Y' ")
				.append("                        WHERE T2.CODE = 'BGY-MY01') ")
				.append(" CONNECT BY PRIOR PK_ORG = PK_FATHERORG ").toString();
				//update by zhengyao3@֣ ŴݰԶ嵵İд 202062817:16:46 end
				String pk_org = (String) bs.executeQuery(queryorgsql, new ColumnProcessor());
		        if(pk_org == null) {
		        	return;
		        }
				//add by ־ 2019-12-11 ֯Ϊҵµ֯ end
				//update by zhengyao3@֣ 20194816:25:54 ֶ end
				if(EVENT_DELETE.equals(eventType) || EVENT_DELETEBEFORE.equals(eventType)){
					requestDeptInfoVO.setEnabledstate(3);//ɾʱͣñʶ
				}
				//update by zhengyao3@֣ 20194417:14:16 ɾʱݸԴͣñʶ end
				requestDeptInfoVO.setMsgType(MsgType);
				RequestDeptToEsbVO ruquestVO = getEsbVO(requestDeptInfoVO);
				String xml = EsbVOToXML(ruquestVO);
				String resultXML = NCToMyXmlUtil.sendXMLToMy(xml, "NC-MY-FY-001", ruquestVO.getRequestDeptInfo().getNC_PK_Dept());
				ResultFinanceDeptFramMyToNcVO resultEsbXmlToNcVo = getResultEsbXmlToNcVo(resultXML);
				if(resultEsbXmlToNcVo != null){
					EsbInfoAnnotatioVO esbInfo = resultEsbXmlToNcVo.getEsbInfo();
					if(!"S".equals(esbInfo.getReturnStatus())) {
						throw new BusinessException("ͬԴ󣬴Ϊ: " + esbInfo.getReturnMsg());
					}
				}
			}
		}
	}
	
	/**
	 * ԴVOתXML
	 * @param ruquestVO
	 * @return
	 */
	private String EsbVOToXML(RequestDeptToEsbVO ruquestVO){
		XStream x = new XStream(new DomDriver("utf-8", new XmlFriendlyNameCoder("_-", "_")));
		x.autodetectAnnotations(true);
		x.processAnnotations(RequestDeptToEsbVO.class);
		x.aliasAttribute("NC_PK_Dept", "NC_PK_Dept");
		return x.toXML(ruquestVO);
	}
	
	/**
	 * ȡԴVOתXML
	 * @param requestDeptInfoVO
	 * @return
	 */
	private RequestDeptToEsbVO getEsbVO(RequestDeptInfoVO requestDeptInfoVO){
		RequestDeptToEsbVO RequestDeptToEsbVO = new RequestDeptToEsbVO();
		EsbInfoAnnotatioVO esbInfo = new EsbInfoAnnotatioVO();
		QueryInfoVO queryInfo = new QueryInfoVO();
		Date date = Calendar.getInstance().getTime();// ȡǰʱ
		// ʱ
		esbInfo.setRequestTime(dateFormat.format(date));
		esbInfo.setInstId(UUID.randomUUID().toString());// ʹUUIDΪˮ
		RequestDeptToEsbVO.setEsbInfo(esbInfo);
		RequestDeptToEsbVO.setQueryInfo(queryInfo);
		RequestDeptToEsbVO.setRequestDeptInfo(requestDeptInfoVO);
		return RequestDeptToEsbVO;
	}
	
	/**
	 * ԴصXMLݣתNCVO
	 * @param resultXML
	 * @return
	 * @throws BusinessException
	 */
	private ResultFinanceDeptFramMyToNcVO getResultEsbXmlToNcVo(String resultXML) throws BusinessException {
		SAXReader reader = new SAXReader();
		Document document = null;
		Element resultElement = null;
		try {
			document = reader.read(new ByteArrayInputStream(resultXML.getBytes("UTF-8")));
			Element rootElement = document.getRootElement();
			if(rootElement == null) {
				throw new BusinessException("ԴӿϢ쳣,ϵѹʲ鿴־!!־ sap_po_log");
			}
			resultElement = rootElement.element("Body").
					element("FinanceDepartmentFramNCResponse").
					element("FinanceDepartmentFramNCResult");
		} catch (Exception e) {
			throw new BusinessException("ԴӿϢ쳣,ϵѹʲ鿴־!!־ sap_po_log");
		}
		if(resultElement == null) {
			throw new BusinessException("ԴӿϢ쳣,ϵѹʲ鿴־!!־ sap_po_log");
		}
		XStream xStream = new XStream();
		xStream.alias("FinanceDepartmentFramNCResult", ResultFinanceDeptFramMyToNcVO.class);
		xStream.alias("esbInfo", EsbInfoAnnotatioVO.class);
		ResultFinanceDeptFramMyToNcVO NcVo = (ResultFinanceDeptFramMyToNcVO) xStream.fromXML(resultElement.asXML());
		return NcVo;
	}
	
}
