package nc.wy.baseapp.log;

import java.io.FileWriter;
import java.io.PrintWriter;
import java.io.StringWriter;
import java.text.SimpleDateFormat;
import java.util.Date;

import org.apache.commons.lang3.StringUtils;

import nc.bs.framework.server.BusinessAppServer;
import nc.vo.pubapp.AppContext;

public class ImageLogger {
	
	public static void log(String code, String name, Throwable t, String msg) {
		msg = msg + "\r\n" + getStackTrace(t);
		log(code, name, msg);
	}

	private static void log(String code, String name, String msg) {
		FileWriter writer = null;
		try {
			if (StringUtils.isBlank(code)) {
				code = "";
			}
			Date currDate = AppContext.getInstance().getServerTime().getDate().toDate();
			SimpleDateFormat sdf = new SimpleDateFormat("yyyyMMdd");
			String logFileName = "Image_" + code + "_" + sdf.format(currDate) + ".log";
			String filepath = BusinessAppServer.getInstance().getServerBase() + "/nclogs/"
					+ BusinessAppServer.getInstance().getServer().getServerName() + "/" + logFileName;
			// һдļ캯еĵڶtrueʾ׷ʽдļ
			writer = new FileWriter(filepath, true);
			SimpleDateFormat formater = new SimpleDateFormat("HH:mm:ss");
			Date date = new Date();
			String time = formater.format(date);
			writer.write("\r\n===Imagebegin===\r\n" + time + ":\r\n" + name + " 쳣\r\n" + msg + "\r\n===Imageend===");
		} catch (Exception e) {
			nc.bs.logging.Logger.error(e.getMessage(), e);
		} finally {
			if (writer != null) {
				try {
					writer.close();
				} catch (Exception e) {
					e.printStackTrace();
					nc.bs.logging.Logger.error(e.getMessage(), e);
				}
			}
		}
	}

	/**
	 * ȡ쳣ĶջϢ
	 * 
	 * @param t
	 * @return
	 */
	public static String getStackTrace(Throwable t) {
		if (t == null) {
			return "";
		}
		StringWriter sw = new StringWriter();
		PrintWriter pw = new PrintWriter(sw);
		try {
			t.printStackTrace(pw);
			return sw.toString();
		} finally {
			pw.close();
		}
	}
}
