package nc.bs.cmp.report.task;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import nc.bs.dao.BaseDAO;
import nc.bs.pub.pa.PreAlertObject;
import nc.bs.pub.pa.PreAlertReturnType;
import nc.bs.pub.taskcenter.BgWorkingContext;
import nc.bs.pub.taskcenter.IBackgroundWorkPlugin;
import nc.jdbc.framework.JdbcSession;
import nc.jdbc.framework.PersistenceManager;
import nc.jdbc.framework.exception.DbException;
import nc.vo.pub.BusinessException;
import nc.vo.pub.lang.UFDate;
import nc.vo.pubapp.pattern.exception.ExceptionUtils;
import nccloud.commons.lang.StringUtils;

/**
 * 
 * @Description: ʽִϸֹ˾ݽڳʱ
 * 
 * @author  ̹԰-ҵNCC-ʽִϸֹ˾
 * @date 2021-10-11
 * @version with NCC V2005
 */
public class FundExecutionDetailGenPlugin implements IBackgroundWorkPlugin {
	@Override
	public PreAlertObject executeTask(BgWorkingContext bg) throws BusinessException {
		String beginDate = "";
		String endDate = "";
		
		//ȡõĲֵ
		Map paraMap = bg.getKeyMap();
		if (paraMap.containsKey("beginDate")) {
			if (paraMap.get("beginDate") != null)
				beginDate = paraMap.get("beginDate").toString();
			else
				throw new BusinessException("ڿʼʱ䲻Ϊգ");
		} else {
			throw new BusinessException("beginData");
		}
		
		if (paraMap.containsKey("endDate")) {
			if (paraMap.get("endDate") != null)
				endDate = paraMap.get("endDate").toString();
			else
				throw new BusinessException("ڽʱ䲻Ϊգ!");
		} else {
			throw new BusinessException("endData");
		}
		
		//
		genData(beginDate, endDate);
		
		// غ̨Ϣ
		PreAlertObject retObj = new PreAlertObject();
		retObj.setReturnType(PreAlertReturnType.RETURNMESSAGE);
		retObj.setMsgTitle("ʽִϸֹ˾ʱ");
		retObj.setReturnObj("");
		return retObj;
	}
	
	/**
	 * 
	* @Title: queryݲѯ
	* @Description:
	* @author: 
	* @date 20211011 19:49:49
	* @param allVOList
	* @throws BusinessException void
	* @version
	 */
	private void genData(String beginDate, String endDate) throws BusinessException {
		BaseDAO dao = new BaseDAO();
		List<String> sqlList = new ArrayList<String>();
		//ȡݵʱ
		//ѯ
		String whereSql = "where SETTLEDATE between '" + beginDate + "' and '" + new UFDate(endDate).getDateAfter(1).toString() + "'; ";
		String cols = StringUtils.join(ncccols,",") + ",to_char(sysdate,'yyyy-mm-dd hh24:mi:ss') TS,null ID";
		sqlList.add("truncate table tmp_ncc_view_zjjh");
		//1 view_zjjh_sk տ
		sqlList.add(" insert into tmp_ncc_view_zjjh select " + cols + " from view_zjjh_sk " + whereSql);
		
		//2 view_zjjh_fk 
		sqlList.add(" insert into tmp_ncc_view_zjjh select " + cols + " from view_zjjh_fk " + whereSql);
		
		//3 view_zjjh_jk 
		sqlList.add(" insert into tmp_ncc_view_zjjh select " + cols + " from view_zjjh_jk " + whereSql);
		
		//4 view_zjjh_hk 
		sqlList.add(" insert into tmp_ncc_view_zjjh select " + cols + " from view_zjjh_hk " + whereSql);
		
		//5 view_zjjh_bx 
		sqlList.add(" insert into tmp_ncc_view_zjjh select " + cols + " from view_zjjh_bx " + whereSql);
		
		//6 view_zjjh_fkjs 㵥
		sqlList.add(" insert into tmp_ncc_view_zjjh select " + cols + " from view_zjjh_fkjs " + whereSql);
		
		//7 view_zjjh_hzjs ˽
		sqlList.add(" insert into tmp_ncc_view_zjjh select " + cols + " from view_zjjh_hzjs " + whereSql);
		
		//8 view_zjjh_yhts յ
		sqlList.add(" insert into tmp_ncc_view_zjjh select " + cols + " from view_zjjh_yhts " + whereSql);
		
		//9 view_zjjh_txbl ְ
		sqlList.add(" insert into tmp_ncc_view_zjjh select " + cols + " from view_zjjh_txbl " + whereSql);
		
		//10 view_zjjh_pjqf Ʊǩ
		sqlList.add(" insert into tmp_ncc_view_zjjh select " + cols + " from view_zjjh_pjqf " + whereSql);
		
		//11 view_zjjh_pjfk Ʊݸ
		sqlList.add(" insert into tmp_ncc_view_zjjh select " + cols + " from view_zjjh_pjfk " + whereSql);
		
		//12 view_zjjh_yfpjtx ӦƱֵ
		sqlList.add(" insert into tmp_ncc_view_zjjh select " + cols + " from view_zjjh_yfpjtx " + whereSql);
		
		//13 view_zjjh_lccpdj ƲƷǼ
		sqlList.add(" insert into tmp_ncc_view_zjjh select " + cols + " from view_zjjh_lccpdj " + whereSql);
		
		//14 view_zjjh_lccpsh ƲƷ
		sqlList.add(" insert into tmp_ncc_view_zjjh select " + cols + " from view_zjjh_lccpsh " + whereSql);
		
		//15 view_zjjh_lccpsy ƲƷ
		sqlList.add(" insert into tmp_ncc_view_zjjh select " + cols + " from view_zjjh_lccpsy " + whereSql);
		
		//15 view_zjjh_skjs տ㵥
		sqlList.add(" insert into tmp_ncc_view_zjjh select " + cols + " from view_zjjh_skjs " + whereSql);
		
		PersistenceManager persist = null;
	    try {
	      //ҵݲм
	      persist = PersistenceManager.getInstance();
	      JdbcSession jdbc = persist.getJdbcSession();
	      for(String sql : sqlList) {
	        jdbc.addBatch(sql);
	        jdbc.addBatch("commit");
	      }
	      int res = jdbc.executeBatch();
	    } catch (DbException e) {
	    	ExceptionUtils.wrappBusinessException("ִsql쳣" + e.getMessage() + "");
	    } finally {
	      if (persist != null)
	        persist.release();
	    }
	}
	
    
	/**
	 * 鵽ݵͼ
	 */
	private Map<String,String> billTypeViewNameMap = new HashMap<String,String>(){
		private static final long serialVersionUID = 1L;
		{
			put("տҵ", "view_zjjh_sk");//տҵ
			put("տת", "view_zjjh_sk");//տת
			put("", "view_zjjh_fk");//
			put("ɹ", "view_zjjh_fk");//ɹ
			put("ҵԴ", "view_zjjh_fk");//ҵԴ
			put("ʸҵ", "view_zjjh_fk");//ʸҵ
			put("˸ҵ", "view_zjjh_fk");//˸ҵ
			put("˿۸ҵ", "view_zjjh_fk");//˿۸ҵ
			put("ת", "view_zjjh_fk");//ת
			put("ҵ", "view_zjjh_jk");//ҵ
			put("ҵ", "view_zjjh_hk");//ҵ
			put("ڽͨ", "view_zjjh_bx");//ڽͨ
			put("⹫ҵѱ", "view_zjjh_bx");//⹫ҵѱҵ
			put("޶ñ", "view_zjjh_bx");//޶ñҵ
			put("Աñ", "view_zjjh_bx");//Աñҵ
			//put("ջص", "view_zjjh_sshd");//ջص
			//put("²ص", "view_zjjh_xbhd");//²ص
			put("ڲλתˣ", "view_zjjh_fkjs");//ڲλתˣ
			put("", "view_zjjh_fkjs");//㵥
			put("㵥գ", "view_zjjh_fkjs");//㵥գ
			put("㵥Эͬ", "view_zjjh_fkjs");//㵥Эͬ
			put("ڲλתˣշ", "view_zjjh_skjs");//ڲλתˣշ
			put("տ", "view_zjjh_skjs");//տ㵥
			put("տ㵥²", "view_zjjh_skjs");//տ㵥²
			put("տ㵥Эͬ", "view_zjjh_skjs");//տ㵥Эͬ
			put("˽", "view_zjjh_hzjs");//˽
			put("յ", "view_zjjh_yhts");//յ
			put("ְ", "view_zjjh_txbl");//ְ
			put("Ʊǩ", "view_zjjh_pjqf");//Ʊǩ
			put("Ʊݸ", "view_zjjh_pjfk");//Ʊݸ
			put("ӦƱֵ", "view_zjjh_yfpjtx");//ӦƱֵ
			put("ƲƷǼ", "view_zjjh_lccpdj");//ƲƷǼ
			put("ƲƷ", "view_zjjh_lccpsh");//ƲƷ
			put("ƲƷ", "view_zjjh_lccpsy");//ƲƷ
		}
	};
	
	 /**м
     * 
     */
	private String[] ncccols = new String[]{
			"PK_ORG","BILLNAME","PK_ACCOUNT","BILL_DATE","SETTLEDATE",
		    "MEMO","BILL_NO","PK_CUST_SUPPLIER","CP_CODE","CP_NAME",
		    "DFZT_CODE","DFZT_NAME","PK_DEPT","REC_TYPE","balatype_name",
		    "CHARGE_TYPE","EXPENSE_TYPE","PK_RECPROJECT_63","BANKROLL_PROJET_63","CASH_ITEM_63",
		    "PK_RECPROJECT","BANKROLL_PROJET","CASH_ITEM","RECPROJECT_ISOK","PLANITEM_ISOK",
		    "CASH_ITEM_ISOK","PK_PROJECT","REC_PRIMAL","PAY_PRIMAL","REC_LOCAL",
		    "PAY_LOCAL","PK_CURRTYPE","LOCAL_RATE","STATE"};
}
