package nc.bs.cmp.settlement.listener;

import com.alibaba.fastjson.JSONObject;

import nc.bs.businessevent.BusinessEvent;
import nc.bs.businessevent.IBusinessEvent;
import nc.bs.businessevent.IBusinessListener;
import nc.bs.dao.BaseDAO;
import nc.bs.framework.common.InvocationInfoProxy;
import nc.bs.framework.common.NCLocator;
import nc.bs.logging.Logger;
import nc.cmp.utils.SettleUtils;
import nc.impl.pubapp.env.BSContext;
import nc.itf.pu.m21.IOrderClose;
import nc.itf.pu.m21.IOrderQuery;
import nc.util.mmf.framework.base.MMStringUtil;
import nc.util.mmf.framework.base.MMValueCheck;
import nc.util.uap.wgpt.WuYeWgptUtil;
import nc.vo.arap.pay.AggPayBillVO;
import nc.vo.cmp.settlement.SettlementAggVO;
import nc.vo.pu.m21.entity.OrderVO;
import nc.vo.pub.BusinessException;
import nc.vo.pub.lang.UFBoolean;
import nc.vo.pub.lang.UFDouble;
import nc.vo.pubapp.AppContext;
import nc.vo.pubapp.pattern.data.ValueUtils;
import nc.vo.pubapp.pattern.exception.ExceptionUtils;
import nc.vo.tmpub.util.DateUtil;
import nc.vo.wgpt.log.WuYeWgptLogVO;
import ncc.pub.wywgpt.utils.WyWGPTUtils;

public class WYCGPaybillRedSettleWriteListener implements IBusinessListener {

	@Override
	public void doAction(IBusinessEvent event) throws BusinessException {
		WuYeWgptLogVO logVO = new WuYeWgptLogVO();
		logVO.setItfcode("NC-WGPT-PU-003");
		logVO.setTranstypecode("F3");
		logVO.setItfname("ҵɹ帶дϢ");
		StringBuilder sb=new StringBuilder();

		if(event instanceof BusinessEvent) {
			logVO.setIssuccess(UFBoolean.TRUE.toString());
			BusinessEvent updateEvent1 = (BusinessEvent)event;
			Object obj1 = updateEvent1.getObject();
			//zhoulpc B֯ĺָͨͬҪرնӦɹشϢ֪̲̳ͨ
			if("CMPsettleAfter".equals(updateEvent1.getEventType()) || "1020".equals(updateEvent1.getEventType())){//¼ͱ
				if(obj1 instanceof SettlementAggVO[]) {
					String esbResultinfoStr = null;
					JSONObject requestInfo=new JSONObject();
					SettlementAggVO[] settlementAggVOs = (SettlementAggVO[])((SettlementAggVO[])updateEvent1.getObject());
					String billType =SettleUtils.getbilltype(MMStringUtil.toNotNullValue(ValueUtils.getString(settlementAggVOs[0].getParentVO().getAttributeValue("pk_tradetype"))), AppContext.getInstance().getPkGroup());

					if("F3".equals(billType)) {
						Object object =SettleUtils.getBuisAggVO(MMStringUtil.toNotNullValue(ValueUtils.getString(settlementAggVOs[0].getParentVO().getAttributeValue("pk_tradetype"))), MMStringUtil.toNotNullValue(ValueUtils.getString(settlementAggVOs[0].getParentVO().getAttributeValue("pk_busibill"))), AppContext.getInstance().getPkGroup());

						if(MMValueCheck.isNotEmpty(object)){
							AggPayBillVO aggPayBillVO= (AggPayBillVO) object;

							UFBoolean isRed =ValueUtils.getUFBoolean(aggPayBillVO.getHeadVO().getDef46());

							String wgptPoNo=aggPayBillVO.getHeadVO().getDef47();
							UFDouble money = aggPayBillVO.getHeadVO().getMoney();
							if(isRed.booleanValue() && (money == null || money.compareTo(UFDouble.ZERO_DBL) <= 0) && MMStringUtil.isNotEmpty(wgptPoNo) && "21".equals(aggPayBillVO.getBodyVOs()[0].getTop_billtype())) {
								
								IOrderClose closeService = NCLocator.getInstance().lookup(IOrderClose.class);
								IOrderQuery iOrderQuery=NCLocator.getInstance().lookup(IOrderQuery.class);
								
								OrderVO[] orderVOs =iOrderQuery.queryOrderVOsByIds(new String[] {aggPayBillVO.getBodyVOs()[0].getTop_billid()}, UFBoolean.FALSE);
								InvocationInfoProxy.getInstance().setProperty("isncredpay", UFBoolean.TRUE.toString());
								BSContext.getInstance().setSession("isncredpay", UFBoolean.TRUE.toString());
								
								closeService.close(orderVOs, 0, true);
								
								requestInfo.put("method", "sendRefundMsg");
								requestInfo.put("orderProviderNo", wgptPoNo);
								requestInfo.put("refundFormId", aggPayBillVO.getHeadVO().getDef48());
								requestInfo.put("refundState", Integer.parseInt(settlementAggVOs[0].getParentVO().getAttributeValue("settlestatus").toString())==5?"1":"0");
								requestInfo.put("refundMsg", "NC˿ɹ");

								String sendJsonData =WyWGPTUtils.getSendToEsbData("NC-WGPT-PU-003"+DateUtil.getCurrTime().getMillis(), requestInfo);
								logVO.setBilldata(requestInfo.toString());
								//
								try {
									aggPayBillVO.getHeadVO().setDef41(UFBoolean.TRUE.toString());
									JSONObject esbResultinfo = WyWGPTUtils.sendToESB(sendJsonData,"NC-WGPT-PU-003");
									if(esbResultinfo!=null){
										esbResultinfoStr = esbResultinfo.toString();
										sb.append("رģ"+esbResultinfoStr);
										logVO.setRsdata(esbResultinfoStr);
										Logger.error("帶дϢӿڡ"+sendJsonData+"\r\nز"+esbResultinfoStr);
										JSONObject esbInfo = (JSONObject)esbResultinfo.get("esbInfo");
										if(esbInfo!=null){
											//ӿڷ״̬Sɹ/W棩/E
											String returnStatus = esbInfo.get("returnStatus")+"";
											returnStatus = "E".equals(returnStatus)?"":"";
											if("".equals(returnStatus)){
												String returnMsg = esbInfo.get("returnMsg")+"";
												ExceptionUtils.wrappBusinessException("ӿڴ"+returnMsg);
											}
										}
										JSONObject resultInfo = esbResultinfo.getJSONObject("resultInfo");
										Object success = resultInfo.get("success");
										if(!ValueUtils.getUFBoolean(success).booleanValue()){
											Object result = resultInfo.get("result");
											ExceptionUtils.wrappBusinessException("̲̳ʾ:"+result);
										}
									}
								} catch (Exception e) {
									aggPayBillVO.getHeadVO().setDef41(UFBoolean.FALSE.toString());
									logVO.setIssuccess(UFBoolean.FALSE.toString());
									sb.append(WuYeWgptUtil.getExceptionDetail(e));
									ExceptionUtils.wrappBusinessException("쳣\n"+e.getMessage()+"\nģ\n"+sendJsonData+"\nرģ\n"+esbResultinfoStr);
								}finally{
									BaseDAO baseDAO=new BaseDAO();
									baseDAO.updateVO(aggPayBillVO.getHeadVO(), new String[] {"def41"});
									logVO.setMsg(sb.toString());
									WuYeWgptUtil.getIWuYeWgptLogService().insertLog_RequiresNew(logVO);
								}
							}
						}
					}
				}
			}
		}
	}

}
