package nc.impl.fa.alter;

import java.lang.reflect.InvocationTargetException;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;
import java.util.HashMap;
import java.util.HashSet;
import java.util.List;
import java.util.Map;
import java.util.Set;

import org.apache.commons.beanutils.MethodUtils;

import nc.bs.am.framework.action.ActionContext;
import nc.bs.am.framework.action.IActionTemplate;
import nc.bs.am.framework.action.IRule;
import nc.bs.am.framework.action.approve.ApproveActionTemplate;
import nc.bs.am.framework.action.approve.UnApproveActionTemplate;
import nc.bs.am.framework.common.rule.ValidateServiceRule;
import nc.bs.am.framework.constant.rule.RuleConst;
import nc.bs.dao.BaseDAO;
import nc.bs.dao.DAOException;
import nc.bs.framework.common.InvocationInfoProxy;
import nc.bs.framework.common.NCLocator;
import nc.bs.uif2.validation.Validator;
import nc.impl.am.bill.BillBaseDAO;
import nc.impl.am.bill.rule.BillCodeInsertAfterRule;
import nc.impl.am.bill.rule.BillCodeInsertBeforeRule;
import nc.impl.am.bill.rule.BillCodeUpdateRule;
import nc.impl.am.bill.rule.VOSagasStatusCheckBeforeRule;
import nc.impl.am.common.InSqlManager;
import nc.impl.am.common.PfUtilToolsAM;
import nc.impl.am.db.DBAccessUtil;
import nc.impl.am.db.QueryUtil;
import nc.impl.am.db.VOPersistUtil;
import nc.impl.am.db.processor.BeanListMapProcessor;
import nc.impl.am.db.processor.BooleanProcessor;
import nc.impl.am.db.processor.ColumnSetProcessor;
import nc.impl.fa.alter.rule.AlterBillCodeDeleteRule;
import nc.impl.fa.alter.rule.AlterCategoryCheckRule;
import nc.impl.fa.alter.rule.AlterDealValueAfterRule;
import nc.impl.fa.alter.rule.AlterDeleteFipAfterRule;
import nc.impl.fa.alter.rule.AlterPushTraceAfterRule;
import nc.impl.fa.alter.rule.AlterSendFipAfterRule;
import nc.impl.fa.alter.rule.AlterStorageBillVORule;
import nc.impl.fa.alter.rule.AlterUpdateDepLogAfterRule;
import nc.impl.fa.alter.rule.AlterWriteBackToCardAfterRule;
import nc.impl.fa.alter.rule.SendARCAlterRule;
import nc.impl.fa.alter.rule.UpdateBillStatusOfWorkFlowAfterRule;
import nc.impl.fa.alter.trace.TraceManager;
import nc.impl.fa.alter.validator.AlterCapitalUnapproveValidator;
import nc.impl.fa.alter.validator.AlterCheckCardLegalValidator;
import nc.impl.fa.alter.validator.AlterSrcBillLegalValidator;
import nc.impl.fa.common.pf.PfUtilToolsFA;
import nc.impl.fa.common.rule.CreateBillLogAfterRule;
import nc.impl.fa.common.rule.DeleteBillLogAfterRule;
import nc.impl.fa.common.rule.UpdateCardLogAfterRule;
import nc.impl.fa.common.validator.CheckCardLegalValidator;
import nc.impl.fa.common.validator.CheckHasFipMakeVoucherForAccbooks;
import nc.impl.fa.common.validator.CheckMinUnClosedBookPeriodValidator;
import nc.impl.fa.rule.AssetCodeIsSameCheckRule;
import nc.impl.fa.rule.FAAccbookCheckSealRule;
import nc.impl.fa.rule.PKAccbookBeforeRule;
import nc.impl.fa.rule.ReceiptScanBeforeRule;
import nc.impl.fa.rule.SrcMessageExistValidator;
import nc.impl.fa.rule.UpdateSrcMsgState4BillAfterRule;
import nc.itf.aim.pub.IEquipToFaService;
import nc.itf.am.pub.ILocationService;
import nc.itf.fa.byzlog.IbyzLogRcord;
import nc.itf.fa.prv.IAlter;
import nc.itf.fa.service.IAccbookInfoService;
import nc.itf.fa.service.IAssetService;
import nc.itf.fa.service.ILogService;
import nc.itf.fa.service.IReduceService;
import nc.itf.fa.service.IUseDeptScaleService;
import nc.itf.org.IOrgConst;
import nc.itf.pca.domain.cvtfixedasset.ICostToFixedBillQuery;
import nc.jdbc.framework.SQLParameter;
import nc.jdbc.framework.processor.ColumnListProcessor;
import nc.jdbc.framework.processor.ResultSetProcessor;
import nc.pub.am.common.validator.SrcBillUnApproveValidator;
import nc.pub.billcode.IBCRConst;
import nc.pub.billcode.itf.IBillcodeManage;
import nc.pub.billcode.vo.BillCodeContext;
import nc.pub.fa.alter.trace.TraceResultVO;
import nc.pub.fa.alter.trace.TraceVO;
import nc.pub.fa.card.AssetFieldConst;
import nc.pub.fa.card.AssetStateConst;
import nc.pub.fa.common.consts.FlagConsts;
import nc.pub.fa.common.consts.LogTypeConst;
import nc.pub.fa.common.manager.DeptScaleManager;
import nc.pub.fa.common.manager.VOManager;
import nc.pub.fa.common.util.FAScaleUtils;
import nc.pub.fa.common.util.FAUseDeptKeyGenerator;
import nc.pub.fa.common.util.StringUtils;
import nc.pub.fa.common.util.UseDeptScaleUtils;
import nc.pub.fa.msg.MsgManager;
import nc.pub.fa.msg.MsgVO;
import nc.pubitf.org.IAccountingBookPubService;
import nc.pubitf.org.IDeptPubService;
import nc.pubitf.org.IOrgRelationDataPubService;
import nc.vo.aim.equip.EquipHeadVO;
import nc.vo.am.addreducestyle.AddreduceStyleVO;
import nc.vo.am.common.AMSuperVO;
import nc.vo.am.common.BaseLockData;
import nc.vo.am.common.BizContext;
import nc.vo.am.common.TransportBillVO;
import nc.vo.am.common.util.ArrayUtils;
import nc.vo.am.common.util.BaseVOUtils;
import nc.vo.am.common.util.BillTransportTool;
import nc.vo.am.common.util.CloneUtil;
import nc.vo.am.common.util.CollectionUtils;
import nc.vo.am.common.util.ExceptionUtils;
import nc.vo.am.common.util.MapUtils;
import nc.vo.am.common.util.MultiLanguageUtil;
import nc.vo.am.common.util.OrgUtils;
import nc.vo.am.common.util.UFDoubleUtils;
import nc.vo.am.constant.BillStatusConst;
import nc.vo.am.constant.BillTypeConst_4A;
import nc.vo.am.constant.BillTypeConst_4B;
import nc.vo.am.constant.BillTypeConst_FA;
import nc.vo.am.constant.BillTypeOther;
import nc.vo.am.constant.CommonKeyConst;
import nc.vo.am.constant.IWorkOrderFields;
import nc.vo.am.manager.AccbookManager;
import nc.vo.am.manager.AccperiodVO;
import nc.vo.am.manager.CurrencyRateManager;
import nc.vo.am.manager.LockManager;
import nc.vo.am.manager.PeriodManager;
import nc.vo.am.proxy.AMProxy;
import nc.vo.fa.accbookinfo.AccbookHeadVO;
import nc.vo.fa.accbookinfo.ConvertData;
import nc.vo.fa.alter.AlterBodyVO;
import nc.vo.fa.alter.AlterHeadVO;
import nc.vo.fa.alter.AlterSheetVO;
import nc.vo.fa.alter.AlterVO;
import nc.vo.fa.alter.helper.AlterKeyConst;
import nc.vo.fa.alter.helper.AlterTransiTypeConst;
import nc.vo.fa.asset.AssetVO;
import nc.vo.fa.byzLogVO.ByzLogRcordVO;
import nc.vo.fa.deptscale.DeptScaleVO;
import nc.vo.logging.Debug;
import nc.vo.org.AccountingBookVO;
import nc.vo.org.DeptVO;
import nc.vo.pub.AggregatedValueObject;
import nc.vo.pub.BusinessException;
import nc.vo.pub.SuperVO;
import nc.vo.pub.VOStatus;
import nc.vo.pub.compiler.PfParameterVO;
import nc.vo.pub.lang.UFBoolean;
import nc.vo.pub.lang.UFDate;
import nc.vo.pub.lang.UFDouble;
import nc.vo.uif2.LoginContext;
import nc.vo.util.AuditInfoUtil;
import nccloud.commons.lang.builder.EqualsBuilder;

/**
 * 䶯̨ʵ
 * 
 * @author weizq
 */
public class AlterImpl extends BillBaseDAO<AlterVO> implements IAlter {

	private DBAccessUtil dbAccessUtil = new DBAccessUtil();

	/*
	 * ǰ̨õķؽʱ
	 * 
	 * @date 2010-5-26
	 */
	@Override
	public TransportBillVO insert(LoginContext context, AlterVO billVO, List<String> showAlterKeyList)
			throws BusinessException {
		AlterHeadVO headVO = (AlterHeadVO) billVO.getParentVO();
		String pk_accbook = headVO.getPk_accbook();
		// ʲ䶯ڲֶΣͷʲ˲Ϣ󣩣У飬ʾûʲ˲
		for (String alterItem : showAlterKeyList) {
			List<String> finance_fieldList = Arrays.asList(AssetFieldConst.ACCOUNT_FIELD); // Ƭвֶ
			if (finance_fieldList.contains(alterItem) && null == pk_accbook) {
				ExceptionUtils.asBusinessException(nc.vo.ml.NCLangRes4VoTransl.getNCLangRes().getStrByID("alter_0",
						"02012010-0086")/* @res "䶯ĿаֶΣ뽫ͷġʲ˲ֶʾ\n" */
				);
			}
		}

		// òķ
		billVO = insertAlterVO(context, billVO, showAlterKeyList);

		// תVOֻͽ治ڵֶ,pk,ts,creator...
		TransportBillVO transportBillVO = BillTransportTool.createTransportBill(billVO, BillTransportTool.MODE_INSERT);

		return transportBillVO;
	}

	/**
	 * ̨ķ
	 * 
	 * @param context
	 * @param billVO
	 * @return
	 * @throws BusinessException
	 * @date 2010-5-26
	 */
	protected AlterVO insertAlterVO(LoginContext context, AlterVO billVO, List<String> showAlterKeyList)
			throws BusinessException {

		// 䶯ĿΪ
		if (CollectionUtils.isEmpty(showAlterKeyList)) {
			throw new IllegalArgumentException(" showAlterKeyList can't be Empty!");
		}

		// У
		validateAlterData(billVO, showAlterKeyList);

		// 
		dealMultiCurrency(billVO);

		AlterVO retAlterVO = ArrayUtils.getFirstElem(super.insertBillVO(billVO));

		// ϸ
		AlterSheetVO[] sheetVOs = AlterHelper.generaterSheetVOs(retAlterVO, showAlterKeyList);
		VOPersistUtil.insert(sheetVOs);

		// ʹfinally:Ϊ汨ˣǰ̨Ȼڱ༭״̬Ӧȡť  ɹ˽
		releasePKCardLock(billVO);

		return retAlterVO;
	}

	/**
	 * 
	 * ޸ıУ
	 * <p>
	 * <b>examples:</b>
	 * <p>
	 * ʹʾ
	 * <p>
	 * <b>˵</b>
	 * 
	 * @param billVO
	 * @param showAlterKeyList
	 *                         <p>
	 * @author weizq
	 * @throws BusinessException
	 * @time 2011-4-1 03:18:04
	 */
	private void validateAlterData(AlterVO billVO, List<String> showAlterKeyList) throws BusinessException {

		// 1. У˲
		checkAccbook(billVO, showAlterKeyList);

		// 2. Уԭԭֵ䶯еԭֵϷԣԭֵԴԭԭֵ
		checkOrginvalueLocalValue(billVO);

		// 3. У䶯ʲǷ䶯ǰʲ()ͬ˲
		checkCategory(billVO, showAlterKeyList);

		// 4. Уʲ׷ֻһڼһ
		checkTraceOnceCard(billVO);

		// 5. УʲǷһ
		checkAssetCode(billVO, showAlterKeyList);
	}

	/**
	 * УʲΨһ
	 * <p>
	 * 
	 * @author weizq
	 * @throws BusinessException
	 * @time 2011-11-11 10:31:33
	 */
	private void checkAssetCode(AlterVO billVO, List<String> showAlterKeyList) throws BusinessException {

		// 䶯ǰ䶯һʲ
		List<String> notEqualAfterAssetCodes = new ArrayList<String>();

		AlterHeadVO headVO = (AlterHeadVO) billVO.getParentVO();
		if (showAlterKeyList.contains(AssetFieldConst.ASSET_CODE)) {
			AlterBodyVO[] bodyVOs = (AlterBodyVO[]) billVO.getChildrenVO();
			if (bodyVOs == null || bodyVOs.length == 0) {
				return;
			}
			for (AlterBodyVO bodyVO : bodyVOs) {
				// ɾ̬ı岻ҪУ
				if (VOStatus.DELETED != bodyVO.getStatus()) {
					String beforeAssetCode = (String) bodyVO
							.getAttributeValue(AssetFieldConst.ASSET_CODE + AlterKeyConst.BEFORE_SUFFIX);
					String afterAssetCode = (String) bodyVO
							.getAttributeValue(AssetFieldConst.ASSET_CODE + AlterKeyConst.AFTER_SUFFIX);
					if (!beforeAssetCode.equals(afterAssetCode)) {
						notEqualAfterAssetCodes.add(afterAssetCode);
					}
				}
			}

			String pk_group = InvocationInfoProxy.getInstance().getGroupId();
			String pk_org = headVO.getPk_org();
			// ȡõıϢ
			BillCodeContext billCodeContext = AMProxy.lookup(IBillcodeManage.class)
					.getBillCodeContext(AssetFieldConst.ASSET_CODE, pk_group, pk_org);

			// ͬʲ
			String[] sameCodes = getSameCode(billCodeContext, AssetFieldConst.ASSET_CODE,
					notEqualAfterAssetCodes.toArray(new String[0]), pk_org);

			if (sameCodes != null && sameCodes.length != 0) {
				String msg = StringUtils.getInSqlStringByArray(sameCodes);

				String message = nc.vo.ml.NCLangRes4VoTransl.getNCLangRes().getStrByID("alter_0", "02012010-0076", null,
						new String[] { msg })/*
												 * @res "䶯ʲ[{0}]ظ \n"
												 */;
				ExceptionUtils.asBusinessException(message);
			}
		}
	}

	/**
	 * ѯظĺš
	 * 
	 * @param billCodeContext
	 * @param field
	 * @param codes
	 * @param pk_org
	 * @return
	 * @throws BusinessException
	 */
	private String[] getSameCode(BillCodeContext billCodeContext, String field, String[] codes, String pk_org)
			throws BusinessException {

		if (ArrayUtils.isNotEmpty(codes)) {
			String pk_group = InvocationInfoProxy.getInstance().getGroupId();
			if (billCodeContext != null) {
				// ʱ򣬶
				StringBuffer sql = new StringBuffer();
				sql.append("select");
				sql.append(" " + field);
				sql.append(" from fa_card");
				sql.append(" where ");
				sql.append(field);
				sql.append(" in" + InSqlManager.getInSQLValue(codes));
				// ձеı뷶ΧȥжΨһԡ
				if (billCodeContext.getUniquescope().equals(IBCRConst.UNIQUE_GRP)) {
					sql.append(" and pk_group = '" + pk_group + "'");
				} else if (billCodeContext.getUniquescope().equals(IBCRConst.UNIQUE_ORG)) {
					sql.append(" and pk_org = '" + pk_org + "'");
				}
				sql.append(" and dr = 0");
				Set<String> sameCodes = new DBAccessUtil().executeQuery(sql.toString(),
						new ColumnSetProcessor<String>());
				if (sameCodes != null && sameCodes.size() > 0) {
					return CollectionUtils.toArray(sameCodes);
				}
			} else {
				ExceptionUtils.asBusinessException(nc.vo.ml.NCLangRes4VoTransl.getNCLangRes().getStrByID("facard_0",
						"02012005-0383")/* @res "ʲû" */);
			}
		}
		return null;
	}

	/**
	 * 
	 * Уʲ׷ֻһڼһ
	 * <p>
	 * <b>examples:</b>
	 * <p>
	 * ʹʾ
	 * <p>
	 * <b>˵</b>
	 * 
	 * @param billVO
	 *               <p>
	 * @author weizq
	 * @throws BusinessException
	 * @time 2011-6-27 07:26:07
	 */
	private void checkTraceOnceCard(AlterVO billVO) throws BusinessException {

		String trace_type = (String) billVO.getParentVO().getAttributeValue(AlterHeadVO.TRANSI_TYPE);
		if (AlterTransiTypeConst.ASSET_TRACE.equals(trace_type)) {
			String pk_alter = billVO.getParent().getPrimaryKey();
			String pk_accbook = (String) billVO.getParentVO().getAttributeValue(AlterHeadVO.PK_ACCBOOK);
			UFDate bizDate = (UFDate) billVO.getParentVO().getAttributeValue(AlterHeadVO.BUSINESS_DATE);
			Set<String> resultSet = queryMadeAlterTrace(pk_alter, pk_accbook, bizDate);
			List<String> cards = new ArrayList<String>();
			AlterBodyVO[] bodyVOs = (AlterBodyVO[]) billVO.getChildrenVO();
			if (bodyVOs == null) {
				return;
			}

			for (AlterBodyVO bodyVO : bodyVOs) {
				// ֻҪȥж
				if (bodyVO.getStatus() == VOStatus.NEW) {
					cards.add(bodyVO.getPk_card());
				}
			}

			if (cards.size() == 0) {
				return;
			}

			List<String> doTraceCards = new ArrayList<String>();

			// ˵ʲ׷ݵĿƬPK
			for (String value : cards) {
				if (resultSet.contains(value)) {
					doTraceCards.add(value);
				}
			}

			if (doTraceCards.size() != 0) {
				Map<String, String> cardCodes = AMProxy.lookup(IAssetService.class)
						.gainCard_code(doTraceCards.toArray(new String[0]));
				String errorMsg = nc.vo.ml.NCLangRes4VoTransl.getNCLangRes().getStrByID("alter_0", "02012010-0060",
						null, new String[] { StringUtils.getInSqlStringByArray(cardCodes.values()
								.toArray(new String[0])) })/*
															 * @res "ƬΪ{0}ĿƬڴڼʲ׷, ѡƬ \n"
															 */;
				ExceptionUtils.asBusinessException(errorMsg);
			}
		}
	}

	/**
	 * 
	 * У䶯ʲǷ䶯ǰʲ()ͬ˲
	 * <p>
	 * <b>examples:</b>
	 * <p>
	 * ʹʾ
	 * <p>
	 * <b>˵</b>
	 * 
	 * @param billVO
	 * @param showAlterKeyList
	 *                         <p>
	 * @author weizq
	 * @throws BusinessException
	 * @time 2011-4-1 03:20:17
	 */
	private void checkCategory(AlterVO billVO, List<String> showAlterKeyList) throws BusinessException {

		// ֻʲ䶯Žж
		if (showAlterKeyList.contains(AlterKeyConst.PK_CATEGORY)) {
			// 䶯ǰ
			List<String> before_categorys = new ArrayList<String>();
			// 䶯
			List<String> after_categorys = new ArrayList<String>();

			AlterBodyVO[] bodyVOs = (AlterBodyVO[]) billVO.getChildrenVO();
			// ֻе޸ֱӵ㱣棬ᴩʱ
			if (ArrayUtils.isEmpty(bodyVOs)) {
				return;
			}

			// 忨Ƭеֵbefore_categorysafter_categorys
			for (AlterBodyVO bodyVO : bodyVOs) {
				// ֻ޸Ĳж
				if (bodyVO.getStatus() == VOStatus.NEW || bodyVO.getStatus() == VOStatus.UPDATED) {
					String before_category = (String) bodyVO.getAttributeValue(AlterKeyConst.PK_CATEGORY_BEFORE);
					String after_category = (String) bodyVO.getAttributeValue(AlterKeyConst.PK_CATEGORY_AFTER);
					if (!before_categorys.contains(before_category)) {
						before_categorys.add(before_category);
					}
					if (!after_categorys.contains(after_category)) {
						after_categorys.add(after_category);
					}
				}
			}

			before_categorys.addAll(after_categorys);

			if (before_categorys.size() == 0) {
				return;
			}

			// ʾ
			StringBuffer errorMsg = new StringBuffer();

			String pk_org = ((AlterHeadVO) billVO.getParentVO()).getPk_org();
			UFDate business_date = ((AlterHeadVO) billVO.getParentVO()).getBusiness_date();

			// ѯ֯õ˲
			AccountingBookVO[] accounting = AMProxy.lookup(IAccountingBookPubService.class)
					.queryAccountingBookByFinanceOrgIDAndDate(pk_org, business_date.toString());

			if (accounting == null || accounting.length == 0) {
				errorMsg.append(nc.vo.ml.NCLangRes4VoTransl.getNCLangRes().getStrByID("alter_0",
						"02012010-0061")/*
										 * @ res " ֯ûй˲ \n "
										 */);
				ExceptionUtils.asBusinessException(errorMsg.toString());
			}

			List<String> accbooks = new ArrayList<String>();
			for (int i = 0; i < accounting.length; i++) {
				accbooks.add(accounting[i].getPk_accountingbook());
			}

			// Ӧ˲
			Map<String, List<String>> categorySetBooks = AMProxy.lookup(IAccbookInfoService.class)
					.queryAccbookWithQueryCategory(pk_org, accbooks.toArray(new String[0]),
							before_categorys.toArray(new String[0]));

			categorySetBooks = getCategoryWithAccbook(categorySetBooks);

			for (int i = 0; i < bodyVOs.length; i++) {
				AlterBodyVO bodyVO = bodyVOs[i];
				if (bodyVO.getStatus() == VOStatus.NEW || bodyVO.getStatus() == VOStatus.UPDATED) {
					String before_category = (String) bodyVO.getAttributeValue(AlterKeyConst.PK_CATEGORY_BEFORE);
					String after_category = (String) bodyVO.getAttributeValue(AlterKeyConst.PK_CATEGORY_AFTER);
					List<String> beforeAccbooks = categorySetBooks.get(before_category);
					List<String> afterAccbooks = categorySetBooks.get(after_category);
					if (CollectionUtils.isEmpty(afterAccbooks) || beforeAccbooks.size() != afterAccbooks.size()) {
						errorMsg.append(nc.vo.ml.NCLangRes4VoTransl.getNCLangRes().getStrByID("alter_0",
								"02012010-0062", null,
								new String[] { String.valueOf(i + 1) })/*
																		 * @ res "{0}б䶯ǰ˲ͬ \n"
																		 */);
					} else if (afterAccbooks.size() != 0) {
						// ȣʾ
						for (String pk_accbook : afterAccbooks) {
							if (!beforeAccbooks.contains(pk_accbook)) {
								errorMsg.append(nc.vo.ml.NCLangRes4VoTransl.getNCLangRes().getStrByID("alter_0",
										"02012010-0062", null, new String[] {
												String.valueOf(i + 1) })/*
																		 * @ res "{0}б䶯ǰ˲ͬ \n"
																		 */);
							}
						}
					}
				}
			}

			if (errorMsg.length() != 0) {
				ExceptionUtils.asBusinessException(errorMsg.toString());
			}
		}
	}

	/**
	 * õʲ˲
	 * 
	 * @param accbookDataMap Map<˲, List<ʲ>>
	 * @return Map<ʲ,Set<˲>>
	 */
	private Map<String, List<String>> getCategoryWithAccbook(Map<String, List<String>> accbookDataMap) {

		// ʲ˲<ֵ>л
		Map<String, List<String>> returnData = new HashMap<String, List<String>>();
		for (String pk_accbook : accbookDataMap.keySet()) {
			List<String> queryCategory = accbookDataMap.get(pk_accbook);
			if (queryCategory != null && queryCategory.size() > 0) {
				for (String pk_category : queryCategory) {
					if (returnData.containsKey(pk_category)) {
						returnData.get(pk_category).add(pk_accbook);
					} else {
						List<String> accbookset = new ArrayList<String>();
						accbookset.add(pk_accbook);
						returnData.put(pk_category, accbookset);
					}
				}
			}
		}

		return returnData;
	}

	/**
	 * Уԭԭֵ䶯еԭֵϷԣԭֵԴԭԭֵ
	 * <p>
	 * 
	 * @author weizq
	 * @throws BusinessException
	 * @time 2011-3-4 01:25:50
	 */
	private void checkOrginvalueLocalValue(AlterVO billVO) throws BusinessException {

		AlterHeadVO headVO = (AlterHeadVO) billVO.getParent();
		String transi_type = headVO.getTransi_type();

		// <pk_card, BodyVO>
		Map<String, AlterBodyVO> cardBodyVO = new HashMap<String, AlterBodyVO>();
		// ֻ޸ֱӵ㱣棬ᴫΪյ.
		if (ArrayUtils.isEmpty(billVO.getChildrenVO())) {
			return;
		}
		for (AlterBodyVO bodyVO : (AlterBodyVO[]) billVO.getChildrenVO()) {
			cardBodyVO.put(bodyVO.getPk_card(), bodyVO);
		}
//		ByzLogRcordVO logvo = new ByzLogRcordVO();
		String[] pk_cards = VOManager.getAttributeValueArray(billVO.getChildrenVO(), AlterBodyVO.PK_CARD);	
		AssetVO[] cards = AMProxy.lookup(IAssetService.class).queryAssetVOByPk(pk_cards);
//		logvo.setItf_type("");
//		logvo.setByztonccresult("AlterBodyVO.PK_CARD:"+AlterBodyVO.PK_CARD+"||pk_cards:"+pk_cards.toString()+"||cards:"+cards.toString());
//		NCLocator.getInstance().lookup(IbyzLogRcord.class).RcordLogBYZ__RequiresNew(logvo);
		
		if (cards == null || cards.length == 0) {
			ExceptionUtils.asBusinessException(nc.vo.ml.NCLangRes4VoTransl.getNCLangRes().getStrByID("alter_0",
					"02012010-0064")/* @res "ƬѾ٣ˢ \n " */);
		}

		// <pk_accbook, List<AssetVO>> ˲ͿƬVO
		Map<String, List<AssetVO>> accbookAssetVOs = new HashMap<String, List<AssetVO>>();
		for (AssetVO assetVO : cards) {
			String pk_accbook = assetVO.getPk_accbook();
			if (accbookAssetVOs.get(pk_accbook) == null) {
				List<AssetVO> list = new ArrayList<AssetVO>();
				list.add(assetVO);
				accbookAssetVOs.put(pk_accbook, list);
			} else {
				accbookAssetVOs.get(pk_accbook).add(assetVO);
			}
		}

		// ԭֵ䶯͹ۿ䶯
		if (AlterTransiTypeConst.ORIGINVALUE.equals(transi_type) || AlterTransiTypeConst.CURRMONEY.equals(transi_type)
				|| AlterTransiTypeConst.FA_ALTER.equals(transi_type)) {

			// Ƭ
			List<String> pk_categorys = new ArrayList<String>();

			for (Map.Entry<String, List<AssetVO>> entry : accbookAssetVOs.entrySet()) {
				List<AssetVO> cardVOs = entry.getValue();

				for (AssetVO vo : cardVOs) {
					if (!pk_categorys.contains(vo.getPk_category())) {
						pk_categorys.add(vo.getPk_category());
					}
				}
			}

			// <pk_accbook+pk_category, ԭֵԴ>
			Map<String, String> accbookCategoryMap = getLocalValueSourceKeyMap(headVO.getPk_org(),
					Arrays.asList(accbookAssetVOs.keySet().toArray(new String[0])), pk_categorys);

			if (accbookCategoryMap == null || accbookCategoryMap.size() == 0) {
				return;
			}

			// ʾ
			StringBuffer errorMsg = new StringBuffer();

			// ѯ˲Ӧ
			Map<String, String> accbookNameByPK = AccbookManager.queryAccbookNamesByOrg(headVO.getPk_org(),
					headVO.getBusiness_date().toString());

			if (accbookNameByPK == null || accbookNameByPK.size() == 0) {
				ExceptionUtils.asBusinessException(nc.vo.ml.NCLangRes4VoTransl.getNCLangRes().getStrByID("alter_0",
						"02012010-0065", null,
						new String[] { headVO.getBusiness_date().toString() })/*
																				 * @ res " ֯ҵ{0}ʱδ˲ \n"
																				 */);
			}

			for (Map.Entry<String, List<AssetVO>> entry : accbookAssetVOs.entrySet()) {
				String pk_accbook = entry.getKey();
				List<AssetVO> cardVOs = entry.getValue();

				for (AssetVO vo : cardVOs) {
					// ԭֵԴ
					String localValueSource = accbookCategoryMap.get(pk_accbook + vo.getPk_category());

					// ԭֵԴԭԭֵ߹ۿ
					if (StringUtils.isNotEmpty(localValueSource)
							&& ((localValueSource.trim().equals(AssetVO.ORIGINVALUE)
									&& transi_type.equals(AlterTransiTypeConst.ORIGINVALUE))
									|| (localValueSource.trim().equals(AssetVO.CURRMONEY)
											&& transi_type.equals(AlterTransiTypeConst.CURRMONEY))
									|| transi_type.equals(AlterTransiTypeConst.FA_ALTER))) {

						// У鱾ԭֵ
						if (errorMsg.length() == 0) {
							// 䶯ԭԭֵ
							UFDouble originvalue_alter = UFDouble.ZERO_DBL;
							if (localValueSource.trim().equals(AssetVO.ORIGINVALUE)) {
								originvalue_alter = (UFDouble) cardBodyVO.get(vo.getPk_card())
										.getAttributeValue(AlterKeyConst.ORIGINVALUE_ALTER);
							} else {
								// 䶯ۿ
								originvalue_alter = (UFDouble) cardBodyVO.get(vo.getPk_card())
										.getAttributeValue(AlterKeyConst.CURRMONEY_ALTER);
							}

							// Ҫ
							String pk_currency_src = vo.getPk_currency();
							originvalue_alter = CurrencyRateManager.getAccbookAmountByOpp(pk_accbook, pk_currency_src,
									originvalue_alter, headVO.getBusiness_date());

							// ±ԭֵ
							UFDouble localvalue_after = UFDoubleUtils.add(vo.getLocaloriginvalue(), originvalue_alter);

							// ֵ
							UFDouble salvage = UFDoubleUtils.multiply(localvalue_after, vo.getSalvagerate()).div(100);

							// 
							UFDouble netring = UFDoubleUtils.sub(UFDoubleUtils.sub(localvalue_after, vo.getAccudep()),
									vo.getPredevaluate());
							if (netring.compareTo(salvage) < 0) {
								errorMsg.append(vo.getCard_code());
							}
						}
					} else
						continue;
				}
			}

			if (errorMsg.length() != 0) {
				ExceptionUtils.asBusinessException(
						nc.vo.ml.NCLangRes4VoTransl.getNCLangRes().getStrByID("alter_0", "02012010-0068", null,
								new String[] { errorMsg.toString() }))/*
																		 * @ res "ƬΪ{0}ĿƬоСھֵ޸ġ \n"
																		 */;
			}
		}
	}

	/**
	 * õԭַԴ <b>˵</b>
	 * 
	 * @param pk_org
	 * @param accbooks
	 * @param pk_categorys
	 * @return <pk_accbook+pk_category, ԭֵԴ>
	 *         <p>
	 * @author weizq
	 * @throws BusinessException
	 * @time 2011-1-21 11:52:08
	 */
	private Map<String, String> getLocalValueSourceKeyMap(String pk_org, List<String> accbooks,
			List<String> pk_categorys) throws BusinessException {

		// <pk_accbook+pk_category, ԭֵԴ>
		Map<String, String> accbooksMap = new HashMap<String, String>();

		for (String pk_accbook : accbooks) {
			// <pk_category, ԭ֭Դ>
			Map<String, String> categoryFromLocalvage = AMProxy.lookup(IAccbookInfoService.class).queryFormula(pk_org,
					pk_categorys.toArray(new String[0]), pk_accbook);

			for (Map.Entry<String, String> categoryFrom : categoryFromLocalvage.entrySet()) {
				String pk_category = categoryFrom.getKey();
				String from = categoryFrom.getValue();
				accbooksMap.put(pk_accbook + pk_category, from);
			}
		}

		return accbooksMap;
	}

	/**
	 * ֤˲ԱԶʲ䶯ֶΣҵֶζ䵽һģϣҪ飬ֶα䶯仯ǰ˲ĿƬֶΣ
	 * ҵֶα仯е˲µۿƬ仯
	 * 
	 * @param billVO
	 * @throws BusinessException
	 * @date 2010-5-7
	 */
	private void checkAccbook(AlterVO billVO, List<String> showAlterKeyList) throws BusinessException {

		AlterHeadVO headVO = (AlterHeadVO) billVO.getParentVO();
		String pk_accbook = headVO.getPk_accbook();
		String pk_org = headVO.getPk_org();
		UFDate biz_date = headVO.getBusiness_date();
		boolean isOneAccbook = true;
		Map<String, String> map = AccbookManager.queryAccbookNamesByOrg(pk_org, StringUtils.toString(biz_date));
		if (!MapUtils.isEmpty(map) && map.size() > 1) {
			isOneAccbook = false;
		}

		if (isOneAccbook)
			return;

		// ж϶˲

		// ֻģвֶΣѡ ҵ˲Ųܲܲ
		if (AccbookManager.isBizAccbook(pk_accbook)) {
			Set<String> accountSet = new HashSet<String>();
			CollectionUtils.addAll(accountSet, AssetFieldConst.ACCOUNT_FIELD);
			for (String key : showAlterKeyList) {
				// ۾ɳе
				if (!key.equals(AssetFieldConst.PAYDEPT_FLAG) && accountSet.contains(key)) {
					ExceptionUtils.asBusinessException(nc.vo.ml.NCLangRes4VoTransl.getNCLangRes().getStrByID("alter_0",
							"02012010-0069")/*
											 * @res "˲ Ϣѡ˲вϢ"
											 */);
				}
			}
		}
	}

	/**
	 * ̨ʽķ
	 * 
	 * @param context
	 * @param billVO
	 * @return
	 * @throws BusinessException
	 * @date 2010-5-26
	 */
	protected AlterVO insertPushAlterVO(LoginContext context, AlterVO billVO, List<String> showAlterKeyList)
			throws BusinessException {

		// 䶯ĿΪ
		if (CollectionUtils.isEmpty(showAlterKeyList)) {
			throw new IllegalArgumentException(" showAlterKeyList can't be Empty!");
		}

		// У˲
		checkAccbook(billVO, showAlterKeyList);

		// жǷܹ
		AuditInfoUtil.addData(billVO.getParent());

		// , ֻ
		dealMultiCurrency(billVO);

		AlterVO retAlterVO = ArrayUtils.getFirstElem(super.pushSaveBillVO(billVO));

		// ϸ
		AlterSheetVO[] sheetVOs = AlterHelper.generaterSheetVOs(retAlterVO, showAlterKeyList);
		VOPersistUtil.insert(sheetVOs);

		// ʹfinally:Ϊ汨ˣǰ̨Ȼڱ༭״̬Ӧȡť  ɹ˽
		releasePKCardLock(billVO);

		return retAlterVO;
	}

	/**
	 * ̵
	 * 
	 * @param context
	 * @param billVO
	 * @return
	 * @throws BusinessException
	 * @date 2010-5-26
	 */
	protected AlterVO approveAlterVO(LoginContext context, AlterVO billVO, List<String> showAlterKeyList)
			throws BusinessException {

		// Уʲ䶯ʱǷ˲ֹڴ֮ǰ˲Ϣʲɾ by guozhq
		checkCategory(billVO, showAlterKeyList);
		// ҵ
		// ͨ
		List<IRule<AlterVO>> approvePassAfterRules = new ArrayList<IRule<AlterVO>>();

		// 1. ¿Ƭʷ
		approvePassAfterRules.add(new AlterWriteBackToCardAfterRule<AlterVO>(true));
		// 2. ӵLogVO
		approvePassAfterRules.add(new CreateBillLogAfterRule<AlterVO>(LogTypeConst.alter));
		// 3. ±忨Ƭ־
		approvePassAfterRules.add(new UpdateCardLogAfterRule<AlterVO>(true));
		// 4. ۾ɼ־
		approvePassAfterRules.add(new AlterUpdateDepLogAfterRule());
		// 5. жʱҪ˲䶯
		approvePassAfterRules.add(new AlterDealValueAfterRule<AlterVO>(true));
		// 6. ͻƽ̨
		approvePassAfterRules.add(new AlterSendFipAfterRule());

		// ͨ
		ActionContext<AlterVO> actionContext = new ActionContext<AlterVO>("InsertAction");
		PfParameterVO parameterVo = new PfParameterVO();
		parameterVo.m_userObj = showAlterKeyList;
		actionContext.addImutableUserObj(RuleConst.PfParameterVo, parameterVo);
		for (IRule<AlterVO> rule : approvePassAfterRules) {
			rule.process(actionContext, billVO);
		}

		return billVO;
	}

	/*
	 * ʽĹ
	 * 
	 * @date 2010-5-28
	 */
	@Override
	protected void initPushSaveActionRules(IActionTemplate<AlterVO> insertAction) {

		super.initPushSaveActionRules(insertAction);
		// У
		List<Validator> validators = new ArrayList<Validator>();
		// У鿨ƬϷ
		validators.add(new CheckCardLegalValidator());
		// УСδ
		validators.add(new CheckMinUnClosedBookPeriodValidator());
		// УǷƵ
		validators.add(new CheckHasFipMakeVoucherForAccbooks());

		insertAction.addBeforeRule(new ValidateServiceRule<AlterVO>(validators));

		// Ӹ¿Ƭ־򣬸¡bill_codebill_typebill_status
		insertAction.addBeforeRule(new UpdateCardLogAfterRule<AlterVO>(false));
		insertAction.addBeforeRule(new PKAccbookBeforeRule<AlterVO>());
		// ϢԴ״̬
		insertAction.addAfterRule(new UpdateSrcMsgState4BillAfterRule<AlterVO>());
	}

	@SuppressWarnings("unchecked")
	@Override
	protected void initDeleteActionRules(IActionTemplate<AlterVO> deleteAction) {

		super.initDeleteActionRules(deleteAction);
		// saga״̬У
		deleteAction.addBeforeRule(new VOSagasStatusCheckBeforeRule<AlterVO>());
		// Ӹ¿Ƭ־աbill_codebill_typebill_status
		deleteAction.addBeforeRule(new UpdateCardLogAfterRule<AlterVO>(false, true));
		deleteAction.addAfterRule(new AlterBillCodeDeleteRule());
	}

	@Override
	protected void initInsertActionRules(IActionTemplate<AlterVO> insertAction) {

		super.initInsertActionRules(insertAction);
		// У
		List<Validator> validators = new ArrayList<Validator>();
		// Ƿ˲У
		validators.add(new FAAccbookCheckSealRule());
		// УϢڱʱǷɾ
		validators.add(new SrcMessageExistValidator());
		// У鿨ƬϷ
		validators.add(new CheckCardLegalValidator());
		// УСδ
		validators.add(new CheckMinUnClosedBookPeriodValidator());
		// УǷƵ
		validators.add(new CheckHasFipMakeVoucherForAccbooks());
		// ʲģҪУԴǷ
		// validators.add(new SrcBillUnApproveValidator<AlterVO>()); //
		// SrcMessageExistValidatorУѾ
		// ǴĿϢɱ䶯УԴ״̬ǷϷ
		validators.add(new AlterSrcBillLegalValidator());

		insertAction.addBeforeRule(new ValidateServiceRule<AlterVO>(validators));

		// Ӹ¿Ƭ־򣬸¡bill_codebill_typebill_status
		insertAction.addBeforeRule(new BillCodeInsertBeforeRule<AlterVO>());
		insertAction.addBeforeRule(new PKAccbookBeforeRule<AlterVO>());
		insertAction.addAfterRule(new BillCodeInsertAfterRule<AlterVO>());
		// ϢԴ״̬
		insertAction.addAfterRule(new UpdateCardLogAfterRule<AlterVO>(false));
		insertAction.addAfterRule(new UpdateSrcMsgState4BillAfterRule<AlterVO>());
	}

	@SuppressWarnings("rawtypes")
	@Override
	protected void initUpdateActionRules(IActionTemplate<AlterVO> updateAction) {

		super.initUpdateActionRules(updateAction);
		// У
		List<Validator> validators = new ArrayList<Validator>();
		// У鿨ƬϷ
		validators.add(new CheckCardLegalValidator());
		// УСδ
		validators.add(new CheckMinUnClosedBookPeriodValidator());
		// ʲģҪУԴǷ
		validators.add(new SrcBillUnApproveValidator());
		// УǷƵ
		validators.add(new CheckHasFipMakeVoucherForAccbooks());
		updateAction.addBeforeRule(new ValidateServiceRule<AlterVO>(validators));

		// Ӹ¿Ƭ־򣬸¡bill_codebill_typebill_status
		updateAction.addBeforeRule(new UpdateCardLogAfterRule<AlterVO>(false));
		updateAction.addBeforeRule(new BillCodeUpdateRule<AlterVO>());
		updateAction.addBeforeRule(new PKAccbookBeforeRule<AlterVO>());
		updateAction.addAfterRule(new UpdateCardLogAfterRule<AlterVO>(false, false, true));
	}

	@Override
	protected void initCommitActionRules(IActionTemplate<AlterVO> template) {
		// saga״̬У
		template.addBeforeRule(new VOSagasStatusCheckBeforeRule<AlterVO>());
		// Ӱɨ
		template.addBeforeRule(new ReceiptScanBeforeRule<AlterVO>());
	}

	@SuppressWarnings("unchecked")
	@Override
	protected void initApproveRule(ApproveActionTemplate<AlterVO> template) {

		// ʼУб
		List<Validator> validators = new ArrayList<Validator>();
		// Ƿ˲У
		validators.add(new FAAccbookCheckSealRule());
		// У[䶯ʲ]дʱǷظ
		validators.add(new AssetCodeIsSameCheckRule(true));
		// жϲǷѾƳ۾嵥У顣
		validators.add(new CheckHasFipMakeVoucherForAccbooks());
		// У䶯ʲǷ˲ by guozhq
		validators.add(new AlterCategoryCheckRule());
		template.addApprovedBeforeRule(new ValidateServiceRule<AlterVO>(validators));
		// saga״̬У
		template.addApprovedBeforeRule(new VOSagasStatusCheckBeforeRule<AlterVO>());

		// ҵ
		// ͨ
		List<IRule<AlterVO>> approvePassAfterRules = new ArrayList<IRule<AlterVO>>();

		// ͬ״̬Ż
		approvePassAfterRules.add(new UpdateBillStatusOfWorkFlowAfterRule<AlterVO>());
		// 1. ¿Ƭʷ
		approvePassAfterRules.add(new AlterWriteBackToCardAfterRule<AlterVO>(true));
		// 2. ӵLogVO
		approvePassAfterRules.add(new CreateBillLogAfterRule<AlterVO>(LogTypeConst.alter));
		// 3. ±忨Ƭ־
		approvePassAfterRules.add(new UpdateCardLogAfterRule<AlterVO>(true));
		// 4. ۾ɼ־
		approvePassAfterRules.add(new AlterUpdateDepLogAfterRule());
		// 5. жǼֵҪ˲䶯
		approvePassAfterRules.add(new AlterDealValueAfterRule<AlterVO>(true));
		// 6. жģʲ׷ݵҪ˲䶯
		approvePassAfterRules.add(new AlterPushTraceAfterRule<AlterVO>(true));
		// 7. ͻƽ̨
		approvePassAfterRules.add(new AlterSendFipAfterRule());
		// 8. ͸ARC
//		approvePassAfterRules.add(new SendARCAlterRule());

		// ͨ
		template.addApprovePassAfterRule(approvePassAfterRules);

	}

	@Override
	protected void initUnApproveRule(UnApproveActionTemplate<AlterVO> template) {

		// У
		List<Validator> validators = new ArrayList<Validator>();
		// Ƿ˲У
		validators.add(new FAAccbookCheckSealRule());
		// У鹤ʱ˲
		validators.add(new AlterCapitalUnapproveValidator());
		// У[䶯ǰʲ]дʱǷظ
		validators.add(new AssetCodeIsSameCheckRule(false));
		// У鿨ƬϷ
		validators.add(new AlterCheckCardLegalValidator());
		// Сδ
		validators.add(new CheckMinUnClosedBookPeriodValidator());
		// жϲǷѾƳ۾嵥У顣
		validators.add(new CheckHasFipMakeVoucherForAccbooks());

		// ǰҵ
		List<IRule<AlterVO>> unApprovedBeforeRules = new ArrayList<IRule<AlterVO>>();
		// saga״̬У
		unApprovedBeforeRules.add(new VOSagasStatusCheckBeforeRule<AlterVO>());
		unApprovedBeforeRules.add(new ValidateServiceRule<AlterVO>(validators));
		template.addUnApprovedBeforeRules(unApprovedBeforeRules);

		// ȡȡҵ
		List<IRule<AlterVO>> lastUnApprovedAfterRules = new ArrayList<IRule<AlterVO>>();

		// 1. ¼˲ĵ, Ϊ˸ƽ̨
		lastUnApprovedAfterRules.add(new AlterStorageBillVORule<AlterVO>());
		// 1. ͻƽ̨(ɾ)
		lastUnApprovedAfterRules.add(new AlterDeleteFipAfterRule());
		// 2. ¿Ƭʷ
		lastUnApprovedAfterRules.add(new AlterWriteBackToCardAfterRule<AlterVO>(false));
		// 3. ɾLogVO
		lastUnApprovedAfterRules.add(new DeleteBillLogAfterRule<AlterVO>());
		// 4. ±忨Ƭ־
		lastUnApprovedAfterRules.add(new UpdateCardLogAfterRule<AlterVO>(false));
		// 5. ۾ɼ־
		lastUnApprovedAfterRules.add(new AlterUpdateDepLogAfterRule());
		// 6. жʱҪ˲䶯
		lastUnApprovedAfterRules.add(new AlterDealValueAfterRule<AlterVO>(false));
		// 7. жģʲ׷ݵҪ˲䶯
		lastUnApprovedAfterRules.add(new AlterPushTraceAfterRule<AlterVO>(false));

		// ȡ˺ҵ
		template.addLastUnApprovedAfterRules(lastUnApprovedAfterRules);
	}

	/**
	 * ʼջҵ
	 * 
	 * @author zhangypm
	 * @time 2020110
	 */
	@Override
	protected void initUnSaveActionRules(IActionTemplate<AlterVO> template) {
		super.initUnSaveActionRules(template);
		// saga״̬У
		template.addBeforeRule(new VOSagasStatusCheckBeforeRule<AlterVO>());
	}

	/**
	 * ǰ̨õύ
	 * 
	 * @see nc.itf.fa.prv.IReduce#commit(nc.vo.uif2.LoginContext,
	 *      nc.vo.fa.reduce.AlterVO)
	 * 
	 * @date 2010-5-26
	 */
	@Override
	public AlterVO commit(LoginContext context, AlterVO billVO) throws BusinessException {

		// 
		billVO = commitAlerVO(context, billVO);

		return billVO;

	}

	/**
	 * ջ
	 * 
	 * @param vos
	 * @return
	 * @throws BusinessException
	 */
	@Override
	public Object unSave(AlterVO[] vos) throws BusinessException {
		return super.unSaveBillVOs(vos);
	}

	/**
	 * ̨õύ
	 * 
	 * @param context
	 * @param billVO
	 * @return
	 * @throws BusinessException
	 * @date 2010-5-26
	 */
	protected AlterVO commitAlerVO(LoginContext context, AlterVO billVO) throws BusinessException {

		return ArrayUtils.getFirstElem(commitBillVO(billVO));
	}

	/**
	 * ǰ̨õɾ
	 * 
	 * @see nc.itf.fa.prv.IAlter#delete(nc.vo.uif2.LoginContext,
	 *      nc.vo.fa.alter.AlterVO)
	 * 
	 * @date 2010-5-26
	 */
	@Override
	public void delete(LoginContext context, AlterVO billVO) throws BusinessException {

		// ¼
		billVO = reloadAlterVO(billVO.getPrimaryKey());
		// ɾ
		deleteAlterVO(context, billVO);

	}

	/**
	 * ¼ر䶯
	 * 
	 * @param primaryKey
	 * @return
	 * @throws BusinessException
	 * @date 2010-5-26
	 */
	@Override
	public AlterVO reloadAlterVO(String primaryKey) throws BusinessException {

		// Ȳͷ
		AlterVO billVO = ArrayUtils.getFirstElem(queryAlterVOByPKs(new String[] { primaryKey }, false));

		if (billVO == null) {
			return null;
		}

		// ˲
		String pk_accbook = (String) billVO.getParentVO().getAttributeValue(CommonKeyConst.pk_accbook);

		// ٲѯָ˲ı
		billVO.setChildrenVO(queryAlterBodyVOs(primaryKey, pk_accbook));

		return billVO;
	}

	/**
	 * ¼ر䶯 ҪĹܡ
	 * <p>
	 * <b>˵</b>
	 * 
	 * @param primaryKeys 䶯
	 * @return
	 * @throws BusinessException
	 *                           <p>
	 * @author weizq
	 * @time 2010-12-23 04:51:03
	 */
	@Override
	public AlterVO[] reloadAlterVOs(String[] primaryKeys) throws BusinessException {

		List<AlterVO> alterVOs = new ArrayList<AlterVO>();
		for (String pk : primaryKeys) {
			AlterVO billVO = reloadAlterVO(pk);
			if (billVO == null) {
				continue;
			}
			// modified by wangweiak 2015-07-17
			// ΪalterVOshowAlterKeyListֵӡϢġ-
			// ʱApproveAction࣬getUserObject()޷ע룬ںAlterWriteBackToCardAfterRule
			// ͨObject m_userObj = ((PfParameterVO)
			// context.getImutableUserObj(RuleConst.PfParameterVo)).m_userObj;
			// ȡֵ¡ʧ
			if (billVO.getChildrenVO() instanceof AlterBodyVO[]) {
				AlterBodyVO[] bodyVOs = (AlterBodyVO[]) billVO.getChildrenVO();
				String[] pk_alter_bs = VOManager.getAttributeValueArray(bodyVOs, AlterBodyVO.PK_ALTER_B);

				// ֿ
				AlterSheetVO[] alterSheetVOs = QueryUtil.queryVOByCond(AlterSheetVO.class,
						" pk_alter_b in " + InSqlManager.getInSQLValue(pk_alter_bs), null);
				List<String> item_codesList = VOManager.getAttributeValueList(alterSheetVOs, AlterSheetVO.ITEM_CODE,
						true, false);
				billVO.setShowAlterKeyList(item_codesList);
			}
			alterVOs.add(billVO);
		}

		return alterVOs.toArray(new AlterVO[0]);
	}

	/**
	 * ѯ䶯(AlterSheetVO[])
	 * <p>
	 * 
	 * @param primaryKeys
	 * @return
	 * @throws BusinessException
	 *                           <p>
	 * @author weizq
	 * @time 2011-4-2 08:59:41
	 */
	public AlterVO[] queryAlters(String[] primaryKeys) throws BusinessException {

		// ѯ䶯ͱ
		AlterVO[] alterVOs = queryAlterVOByPKs(primaryKeys, true);

		List<String> bodyPKs = new ArrayList<String>();
		Map<String, AlterBodyVO> bodyVOsMap = new HashMap<String, AlterBodyVO>();
		for (AlterVO alterVO : alterVOs) {
			AlterBodyVO[] bodyVOs = (AlterBodyVO[]) alterVO.getChildrenVO();
			for (AlterBodyVO bodyVO : bodyVOs) {
				if (!bodyPKs.contains(bodyVO.getPk_alter_b())) {
					bodyPKs.add(bodyVO.getPk_alter_b());
				}
				bodyVOsMap.put(bodyVO.getPrimaryKey(), bodyVO);
			}
		}

		// <pk_alter_b, List<AlterSheetVO>>
		Map<String, List<AlterSheetVO>> bodySheetsMap = new HashMap<String, List<AlterSheetVO>>();
		if (bodyPKs != null && bodyPKs.size() != 0) {
			bodySheetsMap = queryAlterSheetVOByBodyPKs(bodyPKs.toArray(new String[0]));
		}

		for (Map.Entry<String, List<AlterSheetVO>> entry : bodySheetsMap.entrySet()) {
			String pk_alter_b = entry.getKey();

			AlterBodyVO bodyVO = bodyVOsMap.get(pk_alter_b);

			bodyVO.setAltersheetvos(entry.getValue().toArray(new AlterSheetVO[0]));
		}

		for (AlterVO alterVO : alterVOs) {
			for (AlterBodyVO bodyVO : (AlterBodyVO[]) alterVO.getChildrenVO()) {
				bodyVO.setAltersheetvos(bodySheetsMap.get(bodyVO.getPrimaryKey()).toArray(new AlterSheetVO[0]));
			}
		}

		return alterVOs;
	}

	/**
	 * ̨õɾ
	 * 
	 * @param context
	 * @param billVO
	 * @throws BusinessException
	 * @date 2010-5-26
	 */
	public void deleteAlterVO(LoginContext context, AlterVO billVO) throws BusinessException {

		// ݼ
		LockManager.lock(new BaseLockData<AlterVO>(billVO));

		AlterBodyVO[] bodyVOs = (AlterBodyVO[]) billVO.getChildrenVO();

		deleteSheetVOs(bodyVOs);
		super.deleteBillVO(billVO);
	}

	private ILogService getLogService() {

		return AMProxy.lookup(ILogService.class);
	}

	/**
	 * ǰ̨õĸ·
	 * 
	 * @see nc.itf.fa.prv.IAlter#update(nc.vo.uif2.LoginContext,
	 *      nc.vo.fa.alter.AlterVO)
	 * 
	 * @date 2010-5-26
	 */
	@Override
	public TransportBillVO update(LoginContext context, AlterVO billVO, List<String> showAlterKeyList)
			throws BusinessException {

		// ñ淽
		billVO = updateAlterVO(context, billVO, showAlterKeyList);

		// 
		TransportBillVO transportBillVO = BillTransportTool.createTransportBill(billVO, BillTransportTool.MODE_UPDATE);
		return transportBillVO;
	}

	/**
	 * ̨õĸ·
	 * 
	 * @param context
	 * @param billVO
	 * @return
	 * @throws BusinessException
	 * @date 2010-5-26
	 */
	protected AlterVO updateAlterVO(LoginContext context, AlterVO billVO, List<String> showAlterKeyList)
			throws BusinessException {

		// ӵ
		LockManager.lock(new BaseLockData<AlterVO>(billVO));

		// У
		validateAlterData(billVO, showAlterKeyList);

		// ɾԭеϢ²µ
		AlterBodyVO[] bodyVOs = (AlterBodyVO[]) billVO.getChildrenVO();
		deleteSheetVOs(bodyVOs);

		// 
		dealMultiCurrency(billVO);

		// µʱҪɾɱ忨Ƭ־±忨Ƭ־
		AlterHeadVO headVO = (AlterHeadVO) billVO.getParentVO();
		String[] pk_cards = queryBodyCardId(headVO.getPrimaryKey(), headVO.getPk_accbook());
		String bill_code = headVO.getBill_code();
		String bill_type = headVO.getBill_type();
		Integer bill_status = headVO.getBill_status();
		String pk_accbook = headVO.getPk_accbook();

		// ־û
		AlterVO retVo = ArrayUtils.getFirstElem(super.updateBillVO(new AlterVO[] { billVO }, null));

		// ޸ĺ䶯Ϣ, retVoԭֱӵ޸ģԵֵΪ
		setAlterVOInfo(billVO, retVo);

		// עʹò
		AlterBodyVO[] retBodyVOs = (AlterBodyVO[]) billVO.getChildrenVO();
		if (ArrayUtils.isNotEmpty(retBodyVOs)) {
			for (int i = 0; i < retBodyVOs.length; i++) {
				AlterBodyVO tbodyVO = retBodyVOs[i];
				// 䶯ǰʹò
				tbodyVO.setOld_deptscalevos(bodyVOs[i].getOld_deptscalevos());
				// 䶯ʹò
				tbodyVO.setNew_deptscalevos(bodyVOs[i].getNew_deptscalevos());
			}
		}

		// ±忨Ƭ־
		pk_cards = queryBodyCardId(headVO.getPrimaryKey(), headVO.getPk_accbook());

		// ¸¿Ƭ־еbill_code
		updateCardLog(pk_accbook, bill_code, bill_type, bill_status, pk_cards);

		// ϸ ȥɾ
		BaseVOUtils.removeDeletedBodys(billVO);
		AlterSheetVO[] sheetVOs = AlterHelper.generaterSheetVOs(billVO, showAlterKeyList);
		if (ArrayUtils.isNotEmpty(sheetVOs)) {
			VOPersistUtil.insert(sheetVOs);
		}

		// ʹfinally:Ϊ汨ˣǰ̨Ȼڱ༭״̬Ӧȡť  ɹ˽
		releasePKCardLock(billVO);

		return billVO;
	}

	/**
	 * ޸ĺ䶯Ϣ
	 * 
	 * @param retVo
	 * @param billVO
	 * @time 2011-3-22 07:13:10
	 */
	private void setAlterVOInfo(AlterVO billVO, AlterVO retVo) {

		if (retVo == null || billVO == null) {
			return;
		}
		// ɵı壬Ҫts
		billVO.getParent().setAttributeValue(CommonKeyConst.ts, retVo.getParent().getAttributeValue(CommonKeyConst.ts));
		//  bill_status
		billVO.getParent().setAttributeValue(CommonKeyConst.bill_status,
				retVo.getParent().getAttributeValue(CommonKeyConst.bill_status));
		if (billVO.getChildrenVO() == null) {
			return;
		}
		// <pk_card, pk_alter_b>
		AlterBodyVO[] retBodyVOs = (AlterBodyVO[]) retVo.getChildrenVO();
		Map<String, String> cardRetBodyMap = new HashMap<String, String>();
		for (AlterBodyVO ret : retBodyVOs) {
			cardRetBodyMap.put(ret.getPk_card(), ret.getPk_alter_b());
		}

		for (AlterBodyVO vo : (AlterBodyVO[]) billVO.getChildrenVO()) {
			if (vo.getStatus() == VOStatus.DELETED) {
				continue;
			}
			String pk_alter_b = cardRetBodyMap.get(vo.getPk_card());
			vo.setPk_alter_b(pk_alter_b);
		}

	}

	/**
	 * ɾ
	 * 
	 * @param bodyVOs
	 * @throws BusinessException
	 */
	private void deleteSheetVOs(AlterBodyVO[] bodyVOs) throws BusinessException {

		if (ArrayUtils.isEmpty(bodyVOs))
			return;

		List<String> deleteBodyPKs = VOManager.getAttributeValueList(bodyVOs, AlterBodyVO.PK_ALTER_B);

		if (CollectionUtils.isEmpty(deleteBodyPKs)) {
			return;
		}
		String sql = " dr = 0 and pk_alter_b in " + InSqlManager.getInSQLValue(deleteBodyPKs);
		new DBAccessUtil().deleteByCond(new AlterSheetVO().getTableName(), sql);
	}

	@Override
	public AlterBodyVO[] queryAlterBodyVOs(String parentPK, String pk_accbook) throws BusinessException {

		String whereSql = " dr =0 and pk_alter = '" + parentPK + "' ";
		if (AccbookManager.isBizAccbook(pk_accbook)) {
			pk_accbook = FlagConsts.FLAG_NULL;
		}
		whereSql = whereSql + " and pk_accbook = '" + pk_accbook + "' ";
		whereSql = " pk_alter_b in ( select min(pk_alter_b) from fa_alter_b where " + whereSql + " group by pk_card ) ";

		AlterBodyVO[] bodyVOs = QueryUtil.queryVOByCond(AlterBodyVO.class, whereSql, null);
		// ϸ
		AlterHelper.loadAlterSheet(bodyVOs);
		return bodyVOs;
	}

	@Override
	public AlterBodyVO[] queryAlterBodyVOsNoFilter(String parentPK, String pk_accbook) throws BusinessException {

		String whereSql = " dr =0 and pk_alter = '" + parentPK + "' ";
		if (AccbookManager.isBizAccbook(pk_accbook)) {
			pk_accbook = FlagConsts.FLAG_NULL;
		}
		whereSql = whereSql + " and pk_accbook = '" + pk_accbook + "' ";

		AlterBodyVO[] bodyVOs = QueryUtil.queryVOByCond(AlterBodyVO.class, whereSql, null);
		// ϸ
		AlterHelper.loadAlterSheet(bodyVOs);
		return bodyVOs;
	}

	/**
	 * PKsѯ䶯ͳһĽӿڵģ
	 * 
	 * @param whereSql     whereSql
	 * @param orderColumns ֶ
	 * @param isQueryBody  Ƿѯ
	 * @return
	 * @throws BusinessException
	 * @date 2010-4-13
	 */
	private AlterVO[] queryAlterVOByPKs(String[] pks, boolean isQueryBody) throws BusinessException {

		String sql = " pk_alter in " + InSqlManager.getInSQLValue(pks);
		return queryAlterVOByHeadCond(sql, isQueryBody);

	}

	/**
	 * whereѯ䶯ͳһĽӿڵģ
	 * 
	 * @param whereSql     whereSql
	 * @param orderColumns ֶ
	 * @param isQueryBody  Ƿѯ
	 * @return
	 * @throws BusinessException
	 * @date 2010-4-13
	 */
	private AlterVO[] queryAlterVOByHeadCond(String whereSql, boolean isQueryBody) throws BusinessException {

		// ݱͷѯ
		return QueryUtil.queryBillVOByHeadCond(AlterVO.class, whereSql, null, isQueryBody);
	}

	@SuppressWarnings({ "unchecked", "deprecation" })
	@Override
	public String[] queryPksByWhereSql(String whereSql, LoginContext context) throws BusinessException {

		SuperVO superVO = BaseVOUtils.initClass(AlterHeadVO.class);
		String pk_fieldName = superVO.getPKFieldName();
		StringBuffer sql = new StringBuffer("select ").append(pk_fieldName).append(" from ");
		sql.append(superVO.getTableName() + " as h  where dr = 0 and pk_group = '"
				+ InvocationInfoProxy.getInstance().getGroupId() + "'");
		if (whereSql != null && whereSql.trim().length() > 0)
			sql.append("and ").append(whereSql);

		DBAccessUtil dbAcc = new DBAccessUtil();
		List<String> list = (List<String>) dbAcc.getBaseDAO().executeQuery(sql.toString(), new ColumnListProcessor());
		if (list != null && list.size() > 0)
			return list.toArray(new String[list.size()]);

		return null;
	}

	/**
	 * ̨⿨Ƭ: ע⣺һҪfinallyУøݾҵ̽пǣñʱҪע˵ǷҪfinally顣
	 * 
	 * @param billVO
	 * @throws BusinessException
	 * @date 2010-3-19
	 */
	private void releasePKCardLock(AlterVO billVO) throws BusinessException {

		if (billVO == null || ArrayUtils.isEmpty(billVO.getChildrenVO()))
			return;

		AlterBodyVO[] bodyVOs = (AlterBodyVO[]) billVO.getChildrenVO();
		List<String> pk_cards = new ArrayList<String>();
		for (int i = 0; i < bodyVOs.length; i++) {
			String pk_card = bodyVOs[i].getPk_card();
			if (StringUtils.isEmpty(pk_card))
				continue;

			pk_cards.add(pk_card);
		}
		LockManager.releasePKLocks(pk_cards.toArray(new String[0]), InvocationInfoProxy.getInstance().getUserId());

		AlterHeadVO headVO = (AlterHeadVO) billVO.getParentVO();
		String srcBillPk = headVO.getPk_bill_src();
		if (StringUtils.isNotEmpty(srcBillPk)) {
			LockManager.releasePKLocks(new String[] { srcBillPk }, InvocationInfoProxy.getInstance().getUserId());
		}

	}

	/**
	 * 
	 * 
	 * @param billVO
	 * @param isCurrencyRate Ƿ
	 * @throws BusinessException
	 * @date 2010-3-30
	 */
	private void dealMultiCurrency(AlterVO billVO) throws BusinessException {

		AlterHeadVO headVO = (AlterHeadVO) billVO.getParentVO();
		AlterBodyVO[] bodyVOs = (AlterBodyVO[]) billVO.getChildrenVO();

		if (ArrayUtils.isEmpty(bodyVOs)) {
			return;
		}

		// Ĭ֯˲
		String pk_accbook = headVO.getPk_accbook();
		if (AccbookManager.isBizAccbook(pk_accbook)) {
			pk_accbook = AccbookManager.queryMainAccbookIDByFinanceOrg(headVO.getPk_org());
		}
		for (AlterBodyVO bodyVO : bodyVOs) {
			bodyVO.setPk_group(headVO.getPk_group());
			CurrencyRateManager.setLocalMoneyByAccbook(bodyVO, AlterKeyConst.MULTI_CURRENCY_FIELDS, pk_accbook,
					headVO.getBusiness_date());

			// ֻ
			// Դ
			// String pk_currency_src = (String)
			// bodyVO.getAttributeValue(AlterKeyConst.PK_SRC_CURRENCY);
			// if (StringUtils.isNotEmpty(pk_currency_src)) {
			// //䶯ֱԭֵ
			// UFDouble alterLocalValue = (UFDouble)
			// bodyVO.getAttributeValue(AlterKeyConst.LOCALORIGINVALUE_ALTER);
			// //䶯ǰԭֵ
			// UFDouble beforeLocalValue = (UFDouble)
			// bodyVO.getAttributeValue(AlterKeyConst.LOCALORIGINVALUE_BEFORE);
			//
			// //Ҫ
			// UFDouble alterLocalValueByCurrencyRate = CurrencyRateManager
			// .getAccbookAmountByOpp(pk_accbook, pk_currency_src,
			// alterLocalValue, headVO.getBusiness_date());
			//
			// bodyVO.setAttributeValue(AlterKeyConst.LOCALORIGINVALUE_ALTER,
			// alterLocalValueByCurrencyRate);
			// bodyVO.setAttributeValue(AlterKeyConst.LOCALORIGINVALUE_AFTER,
			// UFDoubleUtils.add(beforeLocalValue,
			// alterLocalValueByCurrencyRate));
			// }
		}

	}

	@Override
	public boolean isMadeAlterTrace(String pk_accbook, UFDate bizDate, String... pk_cards) throws BusinessException {

		AccperiodVO periodVO = PeriodManager.getInstance().queryPerriodMonth(pk_accbook, bizDate);

		StringBuilder sqlBuilder = new StringBuilder();
		sqlBuilder.append(" select top 1 '1' from fa_alter h");
		sqlBuilder.append(" left outer join fa_alter_b b on h.pk_alter = b.pk_alter ");
		sqlBuilder.append(" where h.dr = 0 and b.dr = 0 ");
		sqlBuilder.append(" b.pk_card in " + InSqlManager.getInSQLValue(pk_cards));
		sqlBuilder.append(" and h.business_date >= '" + periodVO.getStartdate().toStdString() + "'");
		sqlBuilder.append(" and h.business_date <= '" + periodVO.getEnddate().toStdString() + "'");
		sqlBuilder.append(" and h.pk_accbook = '" + pk_accbook + "'");
		sqlBuilder.append(" and h.transi_type= 'HG-04'");

		return (Boolean) new BaseDAO().executeQuery(sqlBuilder.toString(), new BooleanProcessor());

	}

	@SuppressWarnings("unchecked")
	@Override
	public Set<String> queryMadeAlterTrace(String pk_accbook, UFDate bizDate) throws BusinessException {

		AccperiodVO periodVO = PeriodManager.getInstance().queryPerriodMonth(pk_accbook, bizDate);

		StringBuilder sqlBuilder = new StringBuilder();
		sqlBuilder.append(" select b.pk_card from fa_alter h");
		sqlBuilder.append(" left outer join fa_alter_b b on h.pk_alter = b.pk_alter ");
		sqlBuilder.append(" where h.dr = 0 and b.dr = 0 ");
		sqlBuilder.append(" and h.business_date >= '" + periodVO.getStartdate().toPersisted() + "'");
		sqlBuilder.append(" and h.business_date <= '" + periodVO.getEnddate().toPersisted() + "'");
		sqlBuilder.append(" and h.pk_accbook = '" + pk_accbook + "'");
		sqlBuilder.append(" and h.transi_type = 'HG-04'");

		return (Set<String>) new BaseDAO().executeQuery(sqlBuilder.toString(), new ColumnSetProcessor<String>());

	}

	@SuppressWarnings("unchecked")
	@Override
	public Set<String> queryMadeAlterTrace(String pk_alter, String pk_accbook, UFDate bizDate)
			throws BusinessException {

		AccperiodVO periodVO = PeriodManager.getInstance().queryPerriodMonth(pk_accbook, bizDate);

		StringBuilder sqlBuilder = new StringBuilder();
		sqlBuilder.append(" select b.pk_card from fa_alter h");
		sqlBuilder.append(" left outer join fa_alter_b b on h.pk_alter = b.pk_alter ");
		sqlBuilder.append(" where h.dr = 0 and b.dr = 0 ");
		sqlBuilder.append(" and h.business_date >= '" + periodVO.getStartdate().toPersisted() + "'");
		sqlBuilder.append(" and h.business_date <= '" + periodVO.getEnddate().toPersisted() + "'");
		sqlBuilder.append(" and h.pk_accbook = '" + pk_accbook + "'");
		sqlBuilder.append(" and h.transi_type = 'HG-04'");
		sqlBuilder.append(" and h.pk_alter <> '" + pk_alter + "'");

		return (Set<String>) new BaseDAO().executeQuery(sqlBuilder.toString(), new ColumnSetProcessor<String>());

	}

	@SuppressWarnings("unchecked")
	@Override
	public Set<String> queryMadeAlterTraceByPeriod(String pk_accbook, String year, String period, String... pk_cards)
			throws BusinessException {

		StringBuilder sqlBuilder = new StringBuilder();
		String[] periodVOs = PeriodManager.getInstance().queryPerriodDate(pk_accbook, year, period);

		sqlBuilder.append(" select b.pk_card from fa_alter h");
		sqlBuilder.append(" left outer join fa_alter_b b on h.pk_alter = b.pk_alter ");
		sqlBuilder.append(" where h.dr = 0 and b.dr = 0 ");
		sqlBuilder.append(" and h.business_date >= '" + periodVOs[0] + "'");
		sqlBuilder.append(" and h.business_date <= '" + periodVOs[1] + "'");
		sqlBuilder.append(" and h.pk_accbook = '" + pk_accbook + "'");
		sqlBuilder.append(" and h.transi_type = 'HG-04'");
		sqlBuilder.append(" and b.pk_card in ").append(InSqlManager.getInSQLValue(pk_cards));

		return (Set<String>) new BaseDAO().executeQuery(sqlBuilder.toString(), new ColumnSetProcessor<String>());
	}

	/**
	 * ʵﴫFA䶯
	 * 
	 * @see nc.itf.fa.prv.IAlter#queryAlterVOFromPAM(nc.pub.fa.msg.MsgVO)
	 */
	@Override
	public AlterVO queryAlterVOFromPAM(MsgVO msgVO) throws BusinessException {

		if (isExistByMsg(msgVO)) {
			ExceptionUtils.asBusinessException(nc.vo.ml.NCLangRes4VoTransl.getNCLangRes().getStrByID("alter_0",
					"02012010-0070")/* @res "ϢѾ˱䶯\n" */);
		}
		AlterVO billVO = MsgManager.queryPamByFA(msgVO);

		AlterHeadVO headVO = (AlterHeadVO) billVO.getParentVO();
		String bill_type_src = (String) headVO.getAttributeValue(AlterHeadVO.BILL_TYPE_SRC);

		AlterBodyVO[] bodyVOs = (AlterBodyVO[]) billVO.getChildrenVO();

		headVO.setPk_accbook(FlagConsts.FLAG_NULL);
		headVO.setPk_org(msgVO.getPk_org());
		headVO.setPk_org_v(OrgUtils.getCurVidByPkOrg(msgVO.getPk_org()));
		headVO.setTransi_type(headVO.getTransi_type());
		headVO.setPk_group(msgVO.getPk_group());
		headVO.setBill_type_src(msgVO.getSrc_bill_type());
		headVO.setTransi_type_src(msgVO.getSrc_transi_type());

		// ίйϵίиǰ֯ҵԪ
		Map<String, List<String>> pk_orgMapFromUAP = null;
		// ǰݵ֯
		String pk_org = msgVO.getPk_org();
		try {
			pk_orgMapFromUAP = AMProxy.lookup(IOrgRelationDataPubService.class)
					.queryOrgUnitByPkFinanceorg(new String[] { pk_org });
		} catch (BusinessException e) {
			try {
				pk_orgMapFromUAP = null;
				String errMsg = nc.vo.ml.NCLangRes4VoTransl.getNCLangRes().getStrByID("fapub_0",
						"02012000-0138")/*
										 * @ res "˺ίйϵݲ֯ȡίиҵԪʧܣ"
										 */;
				ExceptionUtils.asBusinessException(errMsg);
			} catch (BusinessException e2) {
				pk_orgMapFromUAP = null;
			}
		}

		// ԿƬ
		String[] pk_cards = VOManager.getAttributeValueArray(bodyVOs, AlterBodyVO.PK_CARD);

		Map<String, AssetVO> assetVOMap = MapUtils
				.toMap(AMProxy.lookup(IAssetService.class).queryMainAssetVOByPks(null, pk_cards));

		// ȡÿƬӦpk_equip
		String[] pk_equips = VOManager.getAttributeValueArray(CollectionUtils.toArray(assetVOMap.values()),
				AssetVO.PK_EQUIP);

		// ʹòlink_key
		String[] link_keys = VOManager.getAttributeValueArray(CollectionUtils.toArray(assetVOMap.values()),
				AssetVO.PK_USEDEPT);

		// ȡ豸֯
		Map<String, EquipHeadVO> equipHeadVOMap = AMProxy.lookup(IEquipToFaService.class).queryEqVosByIds(pk_equips);

		// ʵﴫλPK

		List<String> pkLocationList = new ArrayList<String>();
		for (AlterBodyVO bodyVO : bodyVOs) {
			String pk_before = (String) bodyVO.getAttributeValue(AlterKeyConst.POSITION_BEFORE);
			if (StringUtils.isNotBlank(pk_before)) {
				pkLocationList.add(pk_before);
			}
			String pk_after = (String) bodyVO.getAttributeValue(AlterKeyConst.POSITION_AFTER);
			if (StringUtils.isNotBlank(pk_after)) {
				pkLocationList.add(pk_after);
			}
		}
		Map<String, String> locationPk2NameMap = null;
		if (CollectionUtils.isNotEmpty(pkLocationList)) {
			locationPk2NameMap = AMProxy.lookup(ILocationService.class)
					.queryLocationNameMap(CollectionUtils.toArray(pkLocationList));
		} else {
			locationPk2NameMap = Collections.emptyMap();
		}

		// ͨlink_keyõӦDeptScaleVO
		Map<String, List<DeptScaleVO>> deptScaleVOs = UseDeptScaleUtils.queryDeptScaleBatchWithDeptInfo(link_keys);

		// ¼Ƭб䶯ĿĿƬȥûб䶯bodyVO
		List<AlterBodyVO> hasAlterItemBodyVOs = new ArrayList<AlterBodyVO>();

		// ͨOIDȡVID 
		String[] mandeptOIDs = VOManager.getAttributeValueArray(CollectionUtils.toArray(assetVOMap.values()),
				AssetFieldConst.PK_MANDEPT);
		HashMap<String, String> mandetpOidVids = AMProxy.lookup(IDeptPubService.class)
				.getLastVIDSByDeptIDS(mandeptOIDs);

		String[] checkItems = new String[] { AlterKeyConst.PK_MANDEPT, AlterKeyConst.PK_EQUIP_USEDEPT,
				AlterKeyConst.PK_EQUIP_ORG, AlterKeyConst.USEDEPT, AlterKeyConst.PK_ASSETUSER, AlterKeyConst.PK_USER,
				AlterKeyConst.POSITION, AlterKeyConst.PK_JOBMNGFIL, AlterKeyConst.PK_OWNERORG };

		// ⴦䶯Ŀ
		for (AlterBodyVO bodyVO : bodyVOs) {
			// ڱVO֮ԭʼ״̬жԴݵı䶯
			// ǿ¡VOڸֵ
			AlterBodyVO clonedBodyVO = CloneUtil.clone(bodyVO);

			String pk_card = bodyVO.getPk_card();
			AssetVO assetVO = assetVOMap.get(pk_card);
			String pk_equip = assetVO.getPk_equip();
			String equipOwnOrg = equipHeadVOMap.get(pk_equip).getPk_ownerorg();

			DeptScaleVO[] deptVOs = null;
			if (MapUtils.isNotEmpty(deptScaleVOs)) {
				deptVOs = CollectionUtils.toArray(deptScaleVOs.get(assetVO.getPk_usedept()));
			}
			AlterBodyVO cloneBodyVO = new AlterBodyVO();
			for (String item : checkItems) {
				String beforeKey = item + AlterKeyConst.BEFORE_SUFFIX;
				String afterKey = item + AlterKeyConst.AFTER_SUFFIX;
				cloneBodyVO.setAttributeValue(beforeKey, bodyVO.getAttributeValue(beforeKey));
				cloneBodyVO.setAttributeValue(afterKey, bodyVO.getAttributeValue(afterKey));
			}

			// ñ䶯ǰ
			bodyVO.setAttributeValue(AlterKeyConst.PK_MANDEPT_BEFORE, assetVO.getPk_mandept());

			// ñ䶯ǰ豸ʹò
			// String pk_equip_usedept_after = (String)
			// bodyVO.getAttributeValue(AlterKeyConst.PK_EQUIP_USEDEPT_AFTER);
			// 䶯ǰ豸ʹòֱȡƬֵ
			// String originEquipUsedeptBefore = (String)
			// bodyVO.getAttributeValue(AlterKeyConst.PK_EQUIP_USEDEPT_BEFORE);
			bodyVO.setAttributeValue(AlterKeyConst.PK_EQUIP_USEDEPT_BEFORE, assetVO.getPk_equip_usedept());

			// ñ䶯ǰʹȨ
			bodyVO.setAttributeValue(AlterKeyConst.PK_EQUIP_ORG_BEFORE, assetVO.getPk_equiporg());
			bodyVO.setAttributeValue(AlterKeyConst.PK_EQUIP_ORG_V_BEFORE, assetVO.getPk_equiporg_v());

			// ñ䶯ǰ֯
			bodyVO.setAttributeValue(AlterKeyConst.PK_OWNERORG_BEFORE, assetVO.getPk_ownerorg());
			bodyVO.setAttributeValue(AlterKeyConst.PK_OWNERORG_V_BEFORE, assetVO.getPk_ownerorg_v());
			// 䶯֯
			if (null == bodyVO.getAttributeValue(AlterKeyConst.PK_OWNERORG_AFTER)) {
				bodyVO.setAttributeValue(AlterKeyConst.PK_OWNERORG_AFTER, assetVO.getPk_ownerorg());
			}
			if (null == bodyVO.getAttributeValue(AlterKeyConst.PK_OWNERORG_V_AFTER)) {
				bodyVO.setAttributeValue(AlterKeyConst.PK_OWNERORG_V_AFTER, assetVO.getPk_ownerorg_v());
			}
			String pk_ownerorg_after = (String) bodyVO.getAttributeValue(AlterKeyConst.PK_OWNERORG_AFTER);
			// δݹġ䶯֯͵ǰ֯ͬ  û֯ڡίйϵûίиǰ֯
			if ((null != pk_org && null != pk_ownerorg_after && !pk_org.equals(pk_ownerorg_after))
					&& (pk_orgMapFromUAP == null || (pk_orgMapFromUAP != null
							&& !pk_orgMapFromUAP.get(pk_org).contains(pk_ownerorg_after)))) {
				ExceptionUtils.asBusinessException(nc.vo.ml.NCLangRes4VoTransl.getNCLangRes().getStrByID("alter_0",
						"02012010-0085")/* @res "εݴݹġ䶯֯ڡίйϵûίиǰ֯\n" */
				);
			}

			String useDeptBefore = (String) bodyVO.getAttributeValue(AlterKeyConst.USEDEPT_BEFORE);

			// ñ䶯ǰʹò
			bodyVO.setAttributeValue(AlterKeyConst.USEDEPT_BEFORE, DeptScaleManager.getShowVidName(deptVOs));
			// 䶯ǰʹòŻKey
			String pk_dept_before_key = FAUseDeptKeyGenerator.generatorKeyForAssetSplit(deptVOs);
			bodyVO.setAttributeValue(AlterBodyVO.PK_DEPT_BEFORE_KEY, pk_dept_before_key);
			bodyVO.setOld_deptscalevos(deptVOs);

			// ñ䶯ǰʹ
			bodyVO.setAttributeValue(AlterKeyConst.PK_ASSETUSER_BEFORE, assetVO.getPk_assetuser());

			// ñ䶯ǰ
			bodyVO.setAttributeValue(AlterKeyConst.PK_USER_BEFORE, assetVO.getPk_user());

			// ñ䶯ǰλ
			bodyVO.setAttributeValue(AlterKeyConst.POSITION_BEFORE, assetVO.getPosition());

			// ñ䶯ǰĿ
			bodyVO.setAttributeValue(AlterKeyConst.PK_JOBMNGFIL_BEFORE, assetVO.getPk_jobmngfil());

			// ֯ͻ֯򲻽йŵı䶯
			// if (!headVO.getPk_org().equals(equipOwnOrg)) {
			// bodyVO.setAttributeValue(AlterKeyConst.PK_MANDEPT_V_AFTER,
			// assetVO.getPk_mandept_v());
			// } else {
			String pk_mandept_after = (String) bodyVO.getAttributeValue(AlterKeyConst.PK_MANDEPT_V_AFTER);
			if (StringUtils.isEmpty(pk_mandept_after)) {
				pk_mandept_after = assetVO.getPk_mandept_v();
			}
			bodyVO.setAttributeValue(AlterKeyConst.PK_MANDEPT_V_AFTER, pk_mandept_after);
			// nccoidҪ⴦
			if (!StringUtils.isEmpty(pk_mandept_after)) {
				HashMap<String, String> mandeptOids = AMProxy.lookup(IDeptPubService.class)
						.getOIDSByDeptVIDS(new String[] { pk_mandept_after });
				if (mandeptOids.get(pk_mandept_after) != null) {
					bodyVO.setAttributeValue(AlterKeyConst.PK_MANDEPT_AFTER, mandeptOids.get(pk_mandept_after));
				}
			}

			// }

			// ñ䶯ʹȨʹò
			String pk_equip_org_after = (String) bodyVO.getAttributeValue(AlterKeyConst.PK_EQUIP_ORG_AFTER);
			/** modified by wangweiak 2015-01-29 б䶯ʹȨ  䶯ͷ֯һжϣV636֯ѡ */
			// if (headVO.getPk_org().equals(pk_equip_org_after)) {
			// if (true) {
			// || (headVO.getPk_org().equals(equipHeadVOMap.get(pk_equip).getPk_usedunit()))
			// ֯ʹȨͬһ֯  䶯ʹȨ Ͳ֯һFAƬĹŵı䶯
			// Ȼʹһʵĵݿûж豸Žб䶯ʱ̶ʲԹŽб䶯

			// ʵﴫPKֵֻһֵ
			String usedept_after = (String) bodyVO.getAttributeValue(AlterKeyConst.USEDEPT_AFTER);
			String pk_usedept_before = assetVO.getPk_usedept();
			List<DeptScaleVO> deptScaleBefore = new ArrayList<DeptScaleVO>();
			if (MapUtils.isNotEmpty(deptScaleVOs)) {
				deptScaleBefore = deptScaleVOs.get(pk_usedept_before);
			}

			// ֵŽб䶯
			if (StringUtils.isNotBlank(usedept_after)) {
				// 䶯ǰʹò
				if (deptScaleBefore.size() == 1 && usedept_after.equals(useDeptBefore)) {
					bodyVO.setNew_deptscalevos(deptVOs);
					bodyVO.setAttributeValue(AlterKeyConst.USEDEPT_AFTER, DeptScaleManager.getShowName(deptVOs));
					// 䶯ʹòŻKey
					String pk_dept_after_key = FAUseDeptKeyGenerator.generatorKeyForAssetSplit(deptVOs);
					bodyVO.setAttributeValue(AlterBodyVO.PK_DEPT_AFTER_KEY, pk_dept_after_key);
				} else {
					DeptVO deptVO = ArrayUtils.getFirstElem(DeptScaleManager.queryDeptVO(usedept_after));
					if (deptVO != null) {
						DeptScaleVO scaleVO = new DeptScaleVO();
						String usedeptName = (String) deptVO
								.getAttributeValue(MultiLanguageUtil.getMultiNameField(DeptVO.NAME));
						// ǰȡֵΪգȡֵ by wangqsh
						if (usedeptName == null) {
							usedeptName = (String) deptVO.getAttributeValue(DeptVO.NAME);
						}
						scaleVO.setDeptName(usedeptName);
						scaleVO.setPk_dept(deptVO.getPk_dept());
						scaleVO.setUsescale(new UFDouble(100));
						DeptScaleVO[] insertedVO = AMProxy.lookup(IUseDeptScaleService.class)
								.insert(new DeptScaleVO[] { scaleVO });
						bodyVO.setAttributeValue(AlterKeyConst.USEDEPT_AFTER, usedeptName);
						// 䶯ʹòŻKey
						String pk_dept_after_key = FAUseDeptKeyGenerator.generatorKeyForAssetSplit(insertedVO);
						bodyVO.setAttributeValue(AlterBodyVO.PK_DEPT_AFTER_KEY, pk_dept_after_key);
						bodyVO.setNew_deptscalevos(insertedVO);
					}
				}
			}
			// } else {
			// // ͬʹȨ
			// String usedept_after = (String)
			// bodyVO.getAttributeValue(AlterKeyConst.USEDEPT_BEFORE);
			// bodyVO.setAttributeValue(AlterKeyConst.USEDEPT_AFTER, usedept_after);
			// bodyVO.setNew_deptscalevos(bodyVO.getOld_deptscalevos());
			//
			// String pk_assetuser_after = (String)
			// bodyVO.getAttributeValue(AlterKeyConst.PK_ASSETUSER_BEFORE);
			// bodyVO.setAttributeValue(AlterKeyConst.PK_ASSETUSER_AFTER,
			// pk_assetuser_after);
			// }

			// ЩʵĵݲὫеı䶯ֵҪжϣı䶯Ϊnullʾûнб䶯
			// 
			pk_mandept_after = (String) bodyVO.getAttributeValue(AlterKeyConst.PK_MANDEPT_V_AFTER);

			if (StringUtils.isBlank(pk_mandept_after)) {
				pk_mandept_after = assetVO.getPk_mandept_v();
				bodyVO.setAttributeValue(AlterKeyConst.PK_MANDEPT_V_AFTER, pk_mandept_after);
			}
			// ʹǰֵֶ
			bodyVO.setAttributeValue(AlterKeyConst.PK_MANDEPT_V_BEFORE, assetVO.getPk_mandept_v());

			// ʹò
			String tusedept_after = (String) bodyVO.getAttributeValue(AlterKeyConst.USEDEPT_AFTER);
			if (StringUtils.isBlank(tusedept_after)) {
				tusedept_after = (String) bodyVO.getAttributeValue(AlterKeyConst.USEDEPT_BEFORE);
				bodyVO.setAttributeValue(AlterKeyConst.USEDEPT_AFTER, tusedept_after);
				bodyVO.setNew_deptscalevos(bodyVO.getOld_deptscalevos());
			}

			// 䶯ʹ
			String pk_assetuser_after = (String) bodyVO.getAttributeValue(AlterKeyConst.PK_ASSETUSER_AFTER);
			// ʲò漰̶ʲƬϡʹˡı䶯ֱȡƬϵʹ˼
			if (BillTypeConst_4A.unused.equals(bill_type_src)) {
				bodyVO.setAttributeValue(AlterKeyConst.PK_ASSETUSER_AFTER, assetVO.getPk_assetuser());
			} else {
				if (StringUtils.isEmpty(pk_assetuser_after)) {
					// Դݲ漰ʹˡı䶯
					if (!hasValueAltered(clonedBodyVO, AlterKeyConst.PK_ASSETUSER)) {
						if (null != assetVO.getPk_assetuser()) {
							bodyVO.setAttributeValue(AlterKeyConst.PK_ASSETUSER_AFTER, assetVO.getPk_assetuser());
						}
					} // Դݱ䶯ˡʹˡ
					else {
						bodyVO.setAttributeValue(AlterKeyConst.PK_ASSETUSER_AFTER, pk_assetuser_after);
					}
					// bodyVO.setAttributeValue(AlterKeyConst.PK_ASSETUSER_AFTER,
					// assetVO.getPk_assetuser());
				}
			}
			bodyVO.setAttributeValue(AlterKeyConst.PK_ASSETUSER_BEFORE, assetVO.getPk_assetuser());
			// 䶯
			// String pk_user_after = (String)
			// bodyVO.getAttributeValue(AlterKeyConst.PK_USER_AFTER);
			// if (StringUtils.isEmpty(pk_user_after)) {
			// // Դݲ漰ˡı䶯
			// if (!hasValueAltered(clonedBodyVO, AlterKeyConst.PK_USER)) {
			// if (null != assetVO.getPk_user()) {
			// bodyVO.setAttributeValue(AlterKeyConst.PK_USER_AFTER, assetVO.getPk_user());
			// }
			// } // Դݱ䶯ˡˡ
			// else {
			// bodyVO.setAttributeValue(AlterKeyConst.PK_USER_AFTER, pk_user_after);
			// }
			// } else {
			// bodyVO.setAttributeValue(AlterKeyConst.PK_USER_AFTER, pk_user_after);
			// }

			// 䶯ʹλ
			String position_after = (String) bodyVO.getAttributeValue(AlterKeyConst.POSITION_AFTER);
			if (StringUtils.isNotEmpty(position_after)) {
				bodyVO.setAttributeValue(AlterKeyConst.POSITION_AFTER, locationPk2NameMap.get(position_after));
			} else {
				// bodyVO.setAttributeValue(AlterKeyConst.POSITION_AFTER,
				// assetVO.getPosition());
			}
			bodyVO.setAttributeValue(AlterKeyConst.POSITION_BEFORE, assetVO.getPosition());
			// Դݱ䶯ˡʹλá
			// λõͨơжǷ䶯
			if (hasValueAltered(bodyVO, AlterKeyConst.POSITION)) {
				hasAlterItemBodyVOs.add(bodyVO);
			}

			// 䶯Ŀ
			String jobproject_after = (String) bodyVO.getAttributeValue(AlterKeyConst.PK_JOBMNGFIL_AFTER);
			if (StringUtils.isEmpty(jobproject_after)) {
				// Դݲ漰Ŀı䶯
				if (!hasValueAltered(clonedBodyVO, AlterKeyConst.PK_JOBMNGFIL)) {
					bodyVO.setAttributeValue(AlterKeyConst.PK_JOBMNGFIL_AFTER, assetVO.getPk_jobmngfil());
				} // Դݱ䶯ˡĿ
				else {
					bodyVO.setAttributeValue(AlterKeyConst.PK_JOBMNGFIL_AFTER, jobproject_after);
				}
			} else {
				bodyVO.setAttributeValue(AlterKeyConst.PK_JOBMNGFIL_AFTER, jobproject_after);
			}
			bodyVO.setAttributeValue(AlterKeyConst.PK_JOBMNGFIL_BEFORE, assetVO.getPk_jobmngfil());
			// 䶯ʹȨ
			String equipOrgAfterValue = (String) bodyVO.getAttributeValue(AlterKeyConst.PK_EQUIP_ORG_AFTER);
			String equipOrgBeforeValue = (String) cloneBodyVO.getAttributeValue(AlterKeyConst.PK_EQUIP_ORG_BEFORE);
			if (StringUtils.isEmpty(equipOrgAfterValue) && StringUtils.isEmpty(equipOrgBeforeValue)) {
				bodyVO.setAttributeValue(AlterKeyConst.PK_EQUIP_ORG_AFTER, assetVO.getPk_equiporg());
				bodyVO.setAttributeValue(AlterKeyConst.PK_EQUIP_ORG_V_AFTER, assetVO.getPk_equiporg_v());
			} else if (StringUtils.isEmpty(equipOrgBeforeValue) && StringUtils.isNotEmpty(equipOrgAfterValue)) {
				bodyVO.setAttributeValue(AlterKeyConst.PK_EQUIP_ORG_AFTER, equipOrgAfterValue);
			} else {
				if (!equipOrgBeforeValue.equals(equipOrgAfterValue)) {
					bodyVO.setAttributeValue(AlterKeyConst.PK_EQUIP_ORG_AFTER, equipOrgAfterValue);
				}
			}
			bodyVO.setAttributeValue(AlterKeyConst.PK_EQUIP_ORG_BEFORE, assetVO.getPk_equiporg());
			bodyVO.setAttributeValue(AlterKeyConst.PK_EQUIP_ORG_V_BEFORE, assetVO.getPk_equiporg_v());
			// ̶ʲƬġ䶯ǰ豸ʹòšԴݵġ䶯豸ʹòšȽϡ
			// String equipUsedeptAfter = (String)
			// bodyVO.getAttributeValue(AlterKeyConst.PK_EQUIP_USEDEPT_AFTER);
			// // String equipUsedeptBefore = (String)
			// bodyVO.getAttributeValue(AlterKeyConst.PK_EQUIP_USEDEPT_BEFORE);
			// if ((StringUtils.isEmpty(equipUsedeptAfter) &&
			// StringUtils.isEmpty(originEquipUsedeptBefore))
			// || (StringUtils.isNotEmpty(equipUsedeptAfter)
			// && StringUtils.isNotEmpty(originEquipUsedeptBefore)
			// && equipUsedeptAfter.equals(originEquipUsedeptBefore))) {
			// // bodyVO.setAttributeValue(AlterKeyConst.PK_EQUIP_USEDEPT_AFTER,
			// assetVO.getPk_equip_usedept());
			// } // Դݱ䶯ˡ豸ʹòš
			// else {
			// bodyVO.setAttributeValue(AlterKeyConst.PK_EQUIP_USEDEPT_AFTER,
			// pk_equip_usedept_after);
			// }

			// ûб䶯VO
			boolean isHasAlter = filterHasNotAlterItemBodyVO(bodyVO, mandetpOidVids, checkItems);
			if (isHasAlter && hasNotAddCurrentBody(hasAlterItemBodyVOs, bodyVO)) {
				hasAlterItemBodyVOs.add(bodyVO);
			} else {
				continue;
			}
		}

		if (hasAlterItemBodyVOs.size() == 0) {
			ExceptionUtils.asBusinessException(nc.vo.ml.NCLangRes4VoTransl.getNCLangRes().getStrByID("alter_0",
					"02012010-0080")/* @res "ûзκα䶯ԴݵĲǷɹ̶ʲ䶯\n" */);
		} else {
			billVO.setChildrenVO(null);
			billVO.setChildrenVO(hasAlterItemBodyVOs.toArray(new AlterBodyVO[0]));
		}

		return billVO;
	}

	/**
	 * <p>
	 * жָĿǷб䶯
	 * 
	 * @param bodyVO
	 * @param itemCode
	 * @return
	 */
	private boolean hasValueAltered(AlterBodyVO bodyVO, String itemCode) {

		boolean result = false;

		// ǿա
		if (bodyVO != null && StringUtils.isNotEmpty(itemCode + AlterKeyConst.BEFORE_SUFFIX)
				&& StringUtils.isNotEmpty(itemCode + AlterKeyConst.AFTER_SUFFIX)) {
			// ȡñ䶯ǰ䶯ֵ
			Object bodyValueBefore = bodyVO.getAttributeValue(itemCode + AlterKeyConst.BEFORE_SUFFIX);
			Object bodyValueAfter = bodyVO.getAttributeValue(itemCode + AlterKeyConst.AFTER_SUFFIX);
			// 䶯ǰա䶯ǿա
			if ((bodyValueBefore == null && bodyValueAfter != null)
					// 䶯ǰǿա䶯ա
					|| (bodyValueBefore != null && bodyValueAfter == null)
					// 䶯ǰǿա䶯ǿգҶ߲ȡ
					|| ((bodyValueBefore != null && bodyValueAfter != null)
							&& !(bodyValueBefore.equals(bodyValueAfter)))) {
				result = true;
			}
		}

		return result;
	}

	/**
	 * <p>
	 * жָıǷѾбС<br>
	 * ⴦豸ƬϵġλáϢпΪλñ䶯ǰǰбˡ
	 * 
	 * @param hasAlterItemBodyVOs
	 * @param bodyVO
	 * @return
	 */
	private boolean hasNotAddCurrentBody(List<AlterBodyVO> hasAlterItemBodyVOs, AlterBodyVO bodyVO) {

		boolean hasNotAddCurrentBody = true;

		if (hasAlterItemBodyVOs != null && !hasAlterItemBodyVOs.isEmpty() && bodyVO != null) {
			for (AlterBodyVO hasAlterItemBodyVO : hasAlterItemBodyVOs) {
				if (hasAlterItemBodyVO.getPk_card().equals(bodyVO.getPk_card())) {
					hasNotAddCurrentBody = false;
					break;
				}
			}
		}

		return hasNotAddCurrentBody;
	}

	/**
	 * 
	 * ûб䶯VO
	 * <p>
	 * 
	 * @author weizq
	 * @param mandetpOidVids
	 * @param checkItems2
	 * @time 2011-11-24 03:32:34
	 */
	private boolean filterHasNotAlterItemBodyVO(AlterBodyVO bodyVO, HashMap<String, String> mandetpOidVids,
			String[] checkItems) {

		boolean isHasAlter = false;
		for (String item : checkItems) {
			EqualsBuilder eb = new EqualsBuilder();

			// 
			if (item.equals(AlterKeyConst.PK_MANDEPT)) {
				String mandeptBefore = (String) bodyVO.getAttributeValue(AlterKeyConst.PK_MANDEPT_BEFORE);
				String mandeptAfter = (String) bodyVO.getAttributeValue(AlterKeyConst.PK_MANDEPT_V_AFTER);

				if (StringUtils.isNotEmpty(mandeptBefore) && StringUtils.isNotEmpty(mandeptAfter)) {
					// ȡVIDĹŽбȽ
					mandeptBefore = mandetpOidVids.get(mandeptBefore);
				}

				eb.append(mandeptBefore, mandeptAfter);
				if (!eb.isEquals()) {
					isHasAlter = true;
					break;
				}
			}

			// else if (item.equals(AlterKeyConst.POSITION)) {
			// ˴λѾΪƣ޷Ƚˡ
			// Уڷֵ֮ǰִС
			// }
			else {
				Object beforeValue = bodyVO.getAttributeValue(item + AlterKeyConst.BEFORE_SUFFIX);
				Object afterValue = bodyVO.getAttributeValue(item + AlterKeyConst.AFTER_SUFFIX);

				if (AlterKeyConst.USEDEPT.equals(item)) {
					beforeValue = StringUtils.toString(bodyVO.getAttributeValue(AlterBodyVO.PK_DEPT_BEFORE_KEY));
					afterValue = StringUtils.toString(bodyVO.getAttributeValue(AlterBodyVO.PK_DEPT_AFTER_KEY));
					// 䶯ʹòΪգĬϴΪ䶯Ϊ̶ʲʹòΪ
					if (afterValue == null || "".equals(afterValue)) {
						afterValue = beforeValue;
					}
				}

				eb.append(beforeValue, afterValue);
				if (!eb.isEquals()) {
					isHasAlter = true;
					break;
				}
			}
		}

		return isHasAlter;
	}

	@Override
	public AlterVO[] queryAlterVOByPKs(String... pks) throws BusinessException {

		return queryAlterVOByPKs(pks, false);
	}

	@Override
	public AlterVO[] queryFullAlterVOByPKs(String... pks) throws BusinessException {

		AlterHeadVO[] headVOs = (AlterHeadVO[]) VOManager.getHeadVOs(queryAlterVOByPKs(pks));

		List<AlterVO> alterVOs = new ArrayList<AlterVO>();
		if (ArrayUtils.isNotEmpty(headVOs)) {
			for (AlterHeadVO headVO : headVOs) {
				AlterVO alterVO = new AlterVO();
				alterVO.setParent(headVO);
				alterVO.setChildrenVO(queryAlterBodyVOs(headVO.getPk_alter(), headVO.getPk_accbook()));
				alterVOs.add(alterVO);
			}
		}

		return alterVOs.toArray(new AlterVO[0]);
	}

	/**
	 * ݱ䶯ͷPKѯм¼
	 * 
	 * @param pk_alter
	 * @return
	 * @throws BusinessException
	 * @date 2010-5-10
	 */
	public AlterSheetVO[] queryAlterSheetVOByBillPk(String pk_alter) throws BusinessException {

		String sql = " dr =0 and pk_alter = '" + pk_alter + "' ";
		return QueryUtil.queryVOByCond(AlterSheetVO.class, sql, null);
	}

	public Map<String, List<AlterSheetVO>> queryAlterSheetVOByBillPKs(String... pk_alters) throws BusinessException {

		String sql = " select pk_alter,item_code, old_content, new_content, altertype from fa_altersheet where dr =0 and pk_alter in "
				+ InSqlManager.getInSQLValue(pk_alters);

		BeanListMapProcessor<AlterSheetVO> p = new BeanListMapProcessor<AlterSheetVO>(AlterSheetVO.PK_ALTER,
				AlterSheetVO.class);

		return new DBAccessUtil().executeQuery(sql, p);
	}

	public Map<String, List<AlterSheetVO>> queryAlterSheetVOByBodyPKs(String... bodyPKs) throws BusinessException {

		String sql = " select pk_alter_b,item_code, old_content, new_content, local_differ, differ, altertype  from fa_altersheet where dr =0 and pk_alter_b in "
				+ InSqlManager.getInSQLValue(bodyPKs);

		BeanListMapProcessor<AlterSheetVO> p = new BeanListMapProcessor<AlterSheetVO>(AlterSheetVO.PK_ALTER_B,
				AlterSheetVO.class);

		return new DBAccessUtil().executeQuery(sql, p);
	}

	/**
	 * ݱ䶯ͷPKѯӱм¼ܻ'~';˲ı
	 * 
	 * @param pk_alter
	 * @return
	 * @throws BusinessException
	 * @date 2010-5-10
	 */
	public AlterBodyVO[] queryAlterBodyVOByBillPk(String pk_alter) throws BusinessException {

		String sql = " dr =0 and pk_alter = '" + pk_alter + "' ";
		return QueryUtil.queryVOByCond(AlterBodyVO.class, sql, null);
	}

	/**
	 * ڵ˲¼ٺ󣬻ҵ˲¼˲ݣҪδٵ˲з¿Ƭ־
	 * 
	 * @param billVO
	 * @param isDelete Ƿɾ
	 * @throws BusinessException
	 * @date 2010-5-17
	 */
	private void updateCardLog(String pk_accbook, String bill_code, String bill_type, Integer bill_status,
			String[] pk_cards) throws BusinessException {

		// Map<pk_accbook,List<pk_card>>ͬ˲ĿƬŪһĿΪ˰˲з
		Map<String, List<String>> accbookToCardMap = new HashMap<String, List<String>>();
		// еĿƬ
		// ҵ˲
		if (AccbookManager.isBizAccbook(pk_accbook)) {
			// Map<pk_accbook,List<pk_card>>Ƭûбٵ˲
			accbookToCardMap = AMProxy.lookup(IAssetService.class).queryNotReducedAccbookToCardMap(pk_cards);
		} else {
			// ֻһ˲и
			accbookToCardMap.put(pk_accbook, Arrays.asList(pk_cards));
		}

		// ˲ԿƬݺŽи
		for (Map.Entry<String, List<String>> entry : accbookToCardMap.entrySet()) {
			getLogService().updateLog(entry.getKey(), CollectionUtils.toArray(entry.getValue()), bill_code, bill_type,
					bill_status);
		}
	}

	/**
	 * ѯепƬPK
	 * 
	 * @param parentPK
	 * @param pk_accbook
	 * @return
	 * @throws DAOException
	 * @date 2010-5-17
	 */
	@SuppressWarnings("unchecked")
	private String[] queryBodyCardId(String parentPK, String pk_accbook) throws DAOException {

		String sql = "select pk_card from fa_alter_b where dr= 0 and pk_alter = '" + parentPK + "' and pk_accbook = '"
				+ AccbookManager.getValidAccbook(pk_accbook) + "'";
		Set<String> set = (Set<String>) new DBAccessUtil().executeQuery(sql, new ColumnSetProcessor<String>());
		return CollectionUtils.toArray(set);
	}

	/**
	 * ԴIDжϸõɵı䶯Ƿ
	 * 
	 * @param pk_bill_src
	 * @return
	 * @throws DAOException
	 * @date 2010-5-19
	 */
	protected boolean isExistBySrcBillPk(String pk_bill_src) throws BusinessException {

		String sql = " select top 1 '1' from fa_alter where dr = 0 and pk_bill_src = ?";
		SQLParameter params = new SQLParameter();
		params.addParam(pk_bill_src);
		return ((Boolean) new DBAccessUtil().executeQuery(sql, params, new BooleanProcessor())).booleanValue();
	}

	/**
	 * ݵͲ֯жǷ䶯
	 * 
	 * @param pk_bill_src
	 * @return
	 * @throws DAOException
	 * @date 2010-5-19
	 */
	protected boolean isExistByMsg(MsgVO msgVO) throws BusinessException {

		StringBuffer sqlBuff = new StringBuffer();
		sqlBuff.append(" select top 1 '1' ").append("   from fa_alter ").append("  where dr = 0 ")
				.append("    and pk_bill_src = ? ").append("    and transi_type = ? ").append("    and pk_org = ? ");
		SQLParameter params = new SQLParameter();
		params.addParam(msgVO.getSrc_billid());
		params.addParam(msgVO.getDest_transi_type());
		params.addParam(msgVO.getPk_org());

		return ((Boolean) new DBAccessUtil().executeQuery(sqlBuff.toString(), params, new BooleanProcessor()))
				.booleanValue();
	}

	@Override
	public Map<String, TraceResultVO> handlerTrace(UFBoolean check, TraceVO... traceVOs) throws BusinessException {

		return TraceManager.trace(check, traceVOs);
	}

	/**
	 * -----ʱ
	 */
	@Override
	public AlterVO queryAlterVOFromWorkOrder(MsgVO msgVO) throws BusinessException {

		// ѯϢεݵĽӿ
		Object serviceObject = AMProxy.lookup(msgVO.getService_class_name());

		AlterVO destVO = null;
		try {
			// ͨPKVO
			AMSuperVO workOrderHeadVO = (AMSuperVO) MethodUtils.invokeMethod(serviceObject, msgVO.getMethod_name(),
					new Object[] { msgVO.getSrc_billid() });

			// е豸
			String pk_equip = (String) workOrderHeadVO.getAttributeValue(CommonKeyConst.pk_equip);
			// ʱ豸
			String pk_equip_capital = (String) workOrderHeadVO.getAttributeValue(IWorkOrderFields.PK_EQUIP_CAPITAL);

			// ѯ豸VO
			Map<String, EquipHeadVO> equipHeadVOMap = AMProxy.lookup(IEquipToFaService.class)
					.queryEqVosByIds(new String[] { pk_equip, pk_equip_capital });
			EquipHeadVO equipHeadVO = equipHeadVOMap.get(pk_equip);
			EquipHeadVO equipHeadVO1 = equipHeadVOMap.get(pk_equip_capital);
			// ̶ʲƬ
			String pk_card = equipHeadVO.getPk_card();
			// 豸δ̶ʲʱ豸ȡ̶ʲƬ
			if (null == pk_card) {
				pk_card = equipHeadVO1.getPk_card();
			}

			if (StringUtils.isEmpty(pk_card)) {
				ExceptionUtils.asBusinessException(nc.vo.ml.NCLangRes4VoTransl.getNCLangRes().getStrByID("alter_0",
						"02012010-0072")/* @res "ûд˹̶ʲƬ.  \n " */);
			}
			// ѯ˲Ƭ
			AssetVO[] cardVOs = AMProxy.lookup(IAssetService.class).queryMainAssetVOByPks(null, pk_card);
			AssetVO mainAccbookCardVO = ArrayUtils.isNotEmpty(cardVOs) ? cardVOs[0] : null;

			if (mainAccbookCardVO != null) {
				msgVO.setPk_org(mainAccbookCardVO.getPk_org());
			}
			if (isExistByMsg(msgVO)) {
				ExceptionUtils.asBusinessException(nc.vo.ml.NCLangRes4VoTransl.getNCLangRes().getStrByID("alter_0",
						"02012010-0071")/* @res "ϢѾ˱䶯. \n" */);
			}

			if (mainAccbookCardVO == null || !mainAccbookCardVO.getAsset_state().equals(AssetStateConst.exist)) {
				ExceptionUtils.asBusinessException(nc.vo.ml.NCLangRes4VoTransl.getNCLangRes().getStrByID("alter_0",
						"02012010-0073")/* @res "֯µĿƬڣ Ѿ,   \n " */);
			} else {
				// VOתɱ䶯VO
				destVO = convertToAlterVOByWorkOrder(workOrderHeadVO, pk_card, mainAccbookCardVO);
			}
		} catch (Exception e) {
			Debug.error(e.getMessage());
			ExceptionUtils.asBusinessException(e);
		}

		return destVO;
	}

	/**
	 * VOתɱ䶯VO
	 * 
	 * @param workOrderHeadVO
	 * @param pk_card
	 * @param mainAccbookCardVO
	 * @return
	 * @throws BusinessException
	 */
	private static AlterVO convertToAlterVOByWorkOrder(AMSuperVO workOrderHeadVO, String pk_card,
			AssetVO mainAccbookCardVO) throws BusinessException {

		String pk = workOrderHeadVO.getPrimaryKey();

		// ʵܳɱ ʱɱ
		UFDouble captionValue = (UFDouble) workOrderHeadVO.getAttributeValue("ac_ttl_mny_org");
		// ıλ
		String pk_currtype = (String) workOrderHeadVO.getAttributeValue("pk_currtype");

		AlterVO billVO = new AlterVO();
		AlterHeadVO headVO = new AlterHeadVO();
		headVO.setPk_bill_src(pk);
		headVO.setPk_accbook(mainAccbookCardVO.getPk_accbook());
		headVO.setPk_org(mainAccbookCardVO.getPk_org());
		headVO.setPk_org_v(OrgUtils.getCurVidByPkOrg(mainAccbookCardVO.getPk_org()));
		headVO.setTransi_type(AlterTransiTypeConst.Value);
		headVO.setBill_status(BillStatusConst.free_check);
		headVO.setBill_type(BillTypeConst_FA.ALTER);
		headVO.setBill_type_src(BillTypeConst_4B.WORKORDER);
		headVO.setTransi_type_src((String) workOrderHeadVO.getAttributeValue(AssetFieldConst.TRANSI_TYPE));
		headVO.setBusiness_date(BizContext.getInstance().getBizDate());
		headVO.setPk_group(mainAccbookCardVO.getPk_group());

		List<AlterBodyVO> bodyVOs = new ArrayList<AlterBodyVO>();
		AlterBodyVO bodyVO = new AlterBodyVO();
		bodyVO.setPk_currency(mainAccbookCardVO.getPk_currency());
		bodyVO.setPk_card(pk_card);
		bodyVO.setPk_bill_b_src(pk);
		bodyVO.setPk_bill_src(pk);
		bodyVO.setPk_accbook(mainAccbookCardVO.getPk_accbook());

		captionValue = CurrencyRateManager.getAccbookAmountByOpp(mainAccbookCardVO.getPk_accbook(), pk_currtype,
				captionValue, headVO.getBusiness_date());

		// ԭֵ
		bodyVO.setAttributeValue(AlterKeyConst.LOCALORIGINVALUE_ALTER, captionValue);
		bodyVO.setAttributeValue(AlterKeyConst.LOCALORIGINVALUE_BEFORE, mainAccbookCardVO.getLocaloriginvalue());
		bodyVO.setAttributeValue(AlterKeyConst.LOCALORIGINVALUE_AFTER,
				UFDoubleUtils.add(captionValue, mainAccbookCardVO.getLocaloriginvalue()));

		// 䶯ǰֵ
		bodyVO.setAttributeValue(AlterKeyConst.SALVAGE_BEFORE, mainAccbookCardVO.getSalvage());
		// 䶯󾻲ֵ
		UFDouble after_salvage = UFDoubleUtils
				.multiply((UFDouble) bodyVO.getAttributeValue(AlterKeyConst.LOCALORIGINVALUE_AFTER),
						mainAccbookCardVO.getSalvagerate())
				.div(100);
		bodyVO.setAttributeValue(AlterKeyConst.SALVAGE_AFTER, after_salvage);
		// 䶯
		bodyVO.setAttributeValue(AlterKeyConst.SALVAGE_ALTER,
				UFDoubleUtils.sub(after_salvage, mainAccbookCardVO.getSalvage()));

		bodyVO.setAttributeValue(AlterKeyConst.SALVAGERATE_BEFORE, mainAccbookCardVO.getSalvagerate());
		bodyVO.setAttributeValue(AlterKeyConst.SALVAGERATE_AFTER, mainAccbookCardVO.getSalvagerate());
		bodyVOs.add(bodyVO);

		billVO.setParentVO(headVO);
		billVO.setChildrenVO(bodyVOs.toArray(new AlterBodyVO[0]));

		return billVO;
	}

	/**
	 * ⲿģ(Ŀ)Ϣɼֵʲ׷ݵ
	 */
	@Override
	public AlterVO queryAlterVOFromOtherModule(MsgVO msgVO) throws BusinessException {

		// 1. УϢǷɱ䶯
		if (isExistByMsg(msgVO)) {
			// ϢѾ˱䶯.
			ExceptionUtils.asBusinessException(
					nc.vo.ml.NCLangRes4VoTransl.getNCLangRes().getStrByID("alter_0", "02012010-0071"));
		}

		/*
		 * 2. VO
		 */
		// ѯϢεݵĽӿ
		Object serviceObject = AMProxy.lookup(msgVO.getService_class_name());
		AlterVO destVO = null;
		try {
			/** modified by wangweiak 2014-07-17 ۻרĿɱת̵ɱԭֵ */
			// ݳɱת̵ӿڲѯɱת̵VO
			AggregatedValueObject[] srcVOs;
			// ӷ֧רĿɱת̵ԭֵϢ
			if (BillTypeOther.cbs_project.equals(msgVO.getSrc_bill_type())) {
				srcVOs = new AggregatedValueObject[1];
				srcVOs[0] = NCLocator.getInstance().lookup(ICostToFixedBillQuery.class)
						.getCostToFixedAggvoByPk(msgVO.getSrc_billid());
				if (null == srcVOs[0]) {
					// ԴΪ,  \n
					ExceptionUtils.asBusinessException(
							nc.vo.ml.NCLangRes4VoTransl.getNCLangRes().getStrByID("facard_0", "02012005-0488"));
				}
			} else { // ԭϢVO
				srcVOs = (AggregatedValueObject[]) MethodUtils.invokeMethod(serviceObject, msgVO.getMethod_name(),
						new Object[] { new String[] { msgVO.getSrc_billid() }, msgVO.getDest_transi_type() });
			}
			if (ArrayUtils.isEmpty(srcVOs)) {
				// ԴΪ,  \n
				ExceptionUtils.asBusinessException(
						nc.vo.ml.NCLangRes4VoTransl.getNCLangRes().getStrByID("facard_0", "02012005-0488"));
			}

			AggregatedValueObject[] retVOs;
			// ӷ֧רĿɱת̵ԭֵϢ
			if (BillTypeOther.cbs_project.equals(msgVO.getSrc_bill_type())) {
				// Ŀɱת̵--ת̵ VO
				retVOs = PfUtilToolsAM.runChangeDataAryWithItfDef(BillTypeOther.cbs_project, BillTypeConst_FA.ALTER,
						srcVOs);
			} else { // ԭϢVO

				// εVOյεVO (ڶչ: Ƭ,Դ, Դ,Դ,
				// ĿĽ, )
				retVOs = PfUtilToolsFA.runChangeDataAryWithItfDef(msgVO.getDest_bill_type(),
						msgVO.getDest_transi_type(), srcVOs);
			}
			/** end */

			/*
			 * 3. 䶯ֵ
			 */
			// صһԪֵ, ֻһϢһ, ֻ1
			destVO = (AlterVO) ArrayUtils.getFirstElem(retVOs);

			// added by wangweiak 2015-02-04
			// ⴦豸ûй̶ʲƬ豸̶ʲƬʱʱ󡣹ĵΪ4B36
			if (BillTypeConst_4B.WORKORDER.equals(msgVO.getSrc_bill_type())) {
				// е豸
				String pk_equip = (String) srcVOs[0].getParentVO().getAttributeValue(CommonKeyConst.pk_equip);
				// ʱ豸
				String pk_equip_capital = (String) srcVOs[0].getParentVO()
						.getAttributeValue(IWorkOrderFields.PK_EQUIP_CAPITAL);
				// ѯ豸VO
				Map<String, EquipHeadVO> equipHeadVOMap = AMProxy.lookup(IEquipToFaService.class)
						.queryEqVosByIds(new String[] { pk_equip, pk_equip_capital });
				EquipHeadVO equipHeadVO = equipHeadVOMap.get(pk_equip);
				EquipHeadVO equipHeadVO1 = equipHeadVOMap.get(pk_equip_capital);
				// ̶ʲƬ
				String pk_card = equipHeadVO.getPk_card();
				// 豸δ̶ʲʱ豸ȡ̶ʲƬ
				if (null == pk_card) {
					pk_card = equipHeadVO1.getPk_card();
				}
				AlterBodyVO[] alterBodyVO = (AlterBodyVO[]) destVO.getChildrenVO();
				alterBodyVO[0].setPk_card(pk_card); // 
			}
			/** end */

			// ˲ǵǰ֯ĿƬ
			filterCardByPkOrg(destVO, msgVO);
			// ˹̶ʲģѾҵĿƬ
			filterReducedAsset(destVO);
			// Ľݱ
			dealWithVOComparisonAfterByOtherModule(destVO);
		} catch (InvocationTargetException ite) {
			if (StringUtils.isEmpty(ite.getMessage()) && ite.getCause() != null) {
				Debug.debug(ite.getCause().getMessage());
				ExceptionUtils.asBusinessException(ite.getCause());
			}
		} catch (Exception e) {
			Debug.debug(e.getMessage());
			ExceptionUtils.asBusinessException(e);
		}

		return destVO;
	}

	/**
	 * <p>
	 * ˺ѾٵĿƬı塣
	 * 
	 * @param vo
	 * @throws BusinessException
	 */
	private void filterReducedAsset(AlterVO vo) throws BusinessException {

		if (vo != null) {
			List<AlterBodyVO> newAlterBodyVOs = getAlterBodysWithExistAsset(vo);

			if (newAlterBodyVOs != null && !newAlterBodyVOs.isEmpty()) {
				vo.setChildrenVO(newAlterBodyVOs.toArray(new AlterBodyVO[] {}));
			}
		}
	}

	/**
	 * <p>
	 * ȡúδٿƬı塣
	 * 
	 * @param vo
	 * @return
	 * @throws BusinessException
	 */
	private List<AlterBodyVO> getAlterBodysWithExistAsset(AlterVO vo) throws BusinessException {

		List<AlterBodyVO> alterBodysWithExistAsset = new ArrayList<AlterBodyVO>();

		AlterBodyVO[] bodys = (AlterBodyVO[]) vo.getChildrenVO();

		if (ArrayUtils.isNotEmpty(bodys)) {
			// ȡñʲƬǷٵжϽ
			String[] pk_cards = VOManager.getAttributeValueArray(bodys, AssetFieldConst.PK_CARD);
			Map<String, Boolean> reducedAsset = AMProxy.lookup(IReduceService.class).isCardReduced(pk_cards);

			// ȡúδٿƬı塣
			for (AlterBodyVO body : bodys) {
				if (!reducedAsset.get(body.getPk_card())) {
					alterBodysWithExistAsset.add(body);
				}
			}
		}

		return alterBodysWithExistAsset;
	}

	private void filterCardByPkOrg(AlterVO billVO, MsgVO msgVO) throws BusinessException {

		AlterBodyVO[] bodyVOs = (AlterBodyVO[]) billVO.getChildrenVO();
		List<String> pk_cardList = new ArrayList<String>();

		// // ȥûй̶ʲƬı
		for (SuperVO bodyVO : bodyVOs) {
			String pk_card = (String) bodyVO.getAttributeValue(CommonKeyConst.pk_card);
			if (StringUtils.isNotBlank(pk_card)) {
				if (pk_card.contains(":")) {
					String[] pk_cards = pk_card.split(":");
					for (int i = 0; i < pk_cards.length; i++) {
						pk_cardList.add(pk_cards[i]);
					}
				} else {
					pk_cardList.add(pk_card);
				}
			}
		}

		if (pk_cardList.size() == 0) {
			ExceptionUtils.asBusinessException(nc.vo.ml.NCLangRes4VoTransl.getNCLangRes().getStrByID("facard_0",
					"02012005-0489")/* @res "Ƭпܱɾ \n " */);
		}

		// ˵MsgVO.getPk_org()֯ĿƬ
		Set<String> pk_cardSet = new HashSet<String>();
		String[] filterCardIds = AMProxy.lookup(IAssetService.class).filterOrgCards(msgVO.getPk_org(),
				CollectionUtils.toArray(pk_cardList));
		Collections.addAll(pk_cardSet, filterCardIds);

		List<SuperVO> newBodyList = new ArrayList<SuperVO>();
		for (SuperVO bvo : bodyVOs) {
			List<SuperVO> splitBodyList = new ArrayList<SuperVO>();
			String pk_card = (String) bvo.getAttributeValue(CommonKeyConst.pk_card);
			if (StringUtils.isEmpty(pk_card) || AccbookManager.FLAG_NULL.equals(pk_card)) {
				continue;
			}
			/**
			 * added by wangweiak 2015-03-13
			 * ĿɵĿɱת̵ɼֵʱҪɵĿƬԭԭֵ̯䶯ֱԭֵ
			 */
			// Ϊɱת̵һбԶӦŹ̶ʲƬƴЭVOչÿбϿƬʽΪ"AA:BB"
			if (pk_card.contains(":")) {
				String[] pk_cardArr = pk_card.split(":");
				// Ƭ
				Arrays.sort(pk_cardArr);
				for (int i = 0; i < pk_cardArr.length - 1; i++) {
					SuperVO[] alterBodyVOClones = CloneUtil.deepClone(bvo, pk_cardArr.length - 1);
					if (pk_cardSet.contains(pk_cardArr[i])) {
						alterBodyVOClones[i].setAttributeValue(AssetFieldConst.PK_CARD, pk_cardArr[i]);
						splitBodyList.add(alterBodyVOClones[i]);
					}
				}
				bvo.setAttributeValue(AssetFieldConst.PK_CARD, pk_cardArr[pk_cardArr.length - 1]);
				splitBodyList.add(bvo);
				if (CollectionUtils.isNotEmpty(splitBodyList) && splitBodyList.size() > 1) {
					// ÿ尴տƬֲɼֵı壬磺δ2壺һӦ2ſƬڶӦ3ſƬǼֵ5塣
					// ̯ʱ23Ϊ㣬б˵CBSһʲҲһ
					removeReducedAssetVO(splitBodyList);
					if (CollectionUtils.isEmpty(splitBodyList)) { // ˲ĿƬȫ
						continue;
					}
					splitLocaloriginvalueAlter(splitBodyList);
				}
				newBodyList.addAll(splitBodyList);
			} else {
				if (pk_cardSet.contains(pk_card)) {
					newBodyList.add(bvo);
				}
			}
		}
		billVO.setChildrenVO(CollectionUtils.toArray(newBodyList));
	}

	/**
	 * VO֮䶯VO 1. Ľݱ(ⲿģ鴫䶯) 2. ӻϢ(pk_org, pk_org_v,
	 * pk_accbook)
	 * 
	 * @param destVO
	 * @throws BusinessException
	 */
	private void dealWithVOComparisonAfterByOtherModule(AlterVO destVO) throws BusinessException {

		AlterBodyVO[] alterBodyVOs = (AlterBodyVO[]) destVO.getChildrenVO();
		AlterHeadVO alterHeadVO = (AlterHeadVO) destVO.getParentVO();

		/*
		 * 1. ͨƬ˲ĿƬVO
		 */
		List<String> cardsList = VOManager.getAttributeValueList(alterBodyVOs, AlterBodyVO.PK_CARD, true, true);
		if (CollectionUtils.isEmpty(cardsList)) {
			ExceptionUtils.asBusinessException(
					nc.vo.ml.NCLangRes4VoTransl.getNCLangRes().getStrByID("alter_0", "02012010-0081"));
		}
		// ѯ˲Ƭ
		AssetVO[] cardVOs = AMProxy.lookup(IAssetService.class).queryMainAssetVOByPks(null,
				cardsList.toArray(new String[0]));
		AssetVO mainAccbookCardVO = ArrayUtils.isNotEmpty(cardVOs) ? cardVOs[0] : null;
		if (mainAccbookCardVO == null) {
			// ûд˹̶ʲƬ.
			ExceptionUtils.asBusinessException(
					nc.vo.ml.NCLangRes4VoTransl.getNCLangRes().getStrByID("alter_0", "02012010-0072"));
		}

		// ƬתmapͣkeyǿƬ<pk_card, AssetVO>
		Map<String, AssetVO> mainAccbookCardVOsMap = new HashMap<String, AssetVO>();
		for (AssetVO cardVO : cardVOs) {
			mainAccbookCardVOsMap.put(cardVO.getPk_card(), cardVO);
		}

		/*
		 * 2. ûϢ(pk_org, pk_org_v, pk_accbook)
		 */
		// ñ䶯ͷϢ
		alterHeadVO.setPk_org(mainAccbookCardVO.getPk_org());
		alterHeadVO.setPk_org_v(OrgUtils.getCurVidByPkOrg(mainAccbookCardVO.getPk_org()));
		alterHeadVO.setPk_accbook(mainAccbookCardVO.getPk_accbook());
		alterHeadVO.setBusiness_date(BizContext.getInstance().getBizDate());

		/*
		 * 3. ͷֵ
		 */
		// ׷VO
		List<TraceVO> traceVOList = new ArrayList<TraceVO>();

		// ñıԭֵ
		for (AlterBodyVO alterBodyVO : alterBodyVOs) {
			// ǰƬVO
			AssetVO currentCardVO = mainAccbookCardVOsMap.get(alterBodyVO.getPk_card());
			// 3.1 
			dealWithConvertBodyVO(alterBodyVO, currentCardVO, alterHeadVO);

			// 3.2 ʲ׷ݵ
			if (AlterTransiTypeConst.ASSET_TRACE.equals(alterHeadVO.getTransi_type())) {
				// װTraceVO
				TraceVO traceVO = assembeTraceVO(currentCardVO, alterBodyVO);
				traceVOList.add(traceVO);
			}
		}

		/*
		 * 4. ʲ׷ݱ䶯
		 */
		if (traceVOList.size() != 0) {
			// ׷ϢVO
			Map<String, TraceResultVO> traceDataVOs = handlerTrace(UFBoolean.FALSE,
					traceVOList.toArray(new TraceVO[0]));
			for (AlterBodyVO bodyVO : alterBodyVOs) {
				String pk_card = bodyVO.getPk_card();
				TraceResultVO resultVO = traceDataVOs.get(pk_card);
				// ׷ݵϢõ䶯
				setAlterBodyVOByTraceResult(bodyVO, resultVO);
			}
		}
	}

	/**
	 * ׷ݵϢõ䶯
	 * 
	 * @param bodyVO
	 * @param resultVO
	 */
	private void setAlterBodyVOByTraceResult(AlterBodyVO bodyVO, TraceResultVO resultVO) {

		if (resultVO == null) {
			return;
		}
		// ۼ۾
		UFDouble accudepBefore = (UFDouble) bodyVO.getAttributeValue(AlterKeyConst.ACCUDEP_BEFORE);
		// ȡֵ
		// Ӱǰۼ۾
		UFDouble affectBeforeAccudep = resultVO.getAffectBeforeAccduep();
		// Ӱ챾ۼ۾
		UFDouble affectCurrentAccudep = resultVO.getAffectCurrentAccduep();

		// 䶯ۼ۾
		UFDouble accudepAlter = UFDoubleUtils.add(affectBeforeAccudep, affectCurrentAccudep);

		UFDouble accudepAfter = UFDoubleUtils.add(accudepBefore, accudepAlter);

		// ֵõVO
		bodyVO.setAttributeValue(AlterKeyConst.DEP_VALUE_BEFORE, affectBeforeAccudep);
		bodyVO.setAttributeValue(AlterKeyConst.DEP_VALUE_CURRENT, affectCurrentAccudep);
		bodyVO.setAttributeValue(AlterKeyConst.ACCUDEP_ALTER, accudepAlter);
		bodyVO.setAttributeValue(AlterKeyConst.ACCUDEP_AFTER, accudepAfter);
		bodyVO.setAttributeValue(AlterBodyVO.TRACEDATE, resultVO.getTraceDate());

	}

	/**
	 * VOȴ
	 * 
	 * @param alterBodyVO
	 * @param currentCardVO
	 * @param alterHeadVO
	 * @throws BusinessException
	 */
	private void dealWithConvertBodyVO(AlterBodyVO alterBodyVO, AssetVO currentCardVO, AlterHeadVO alterHeadVO)
			throws BusinessException {

		// ò֯
		alterBodyVO.setPk_org(alterHeadVO.getPk_org());
		alterBodyVO.setPk_org_v(alterHeadVO.getPk_org_v());
		alterBodyVO.setPk_accbook(currentCardVO.getPk_accbook());
		alterBodyVO.setPk_currency(currentCardVO.getPk_currency());

		// 䶯ֱԭֵ
		UFDouble localoriginvalueAlter = (UFDouble) alterBodyVO.getAttributeValue(AlterKeyConst.LOCALORIGINVALUE_ALTER);

		// ⲿģı
		String pk_src_currtype = (String) alterBodyVO.getAttributeValue(AlterKeyConst.PK_SRC_CURRENCY);

		if (StringUtils.isEmpty(pk_src_currtype)) {
			ExceptionUtils.asBusinessException(
					nc.vo.ml.NCLangRes4VoTransl.getNCLangRes().getStrByID("alter_0", "02012010-0079")
			/*
			 * @res "ԴıΪ, . "
			 */);
		}

		// ȡ˲Ϣıͷ
		AccbookHeadVO accbookHeadVO = AMProxy.lookup(IAccbookInfoService.class)
				.queryAccbookHeadVOByAccbook(currentCardVO.getPk_accbook());
		//  0 -- Ƭ 1 -- ҵ
		int convertInt = accbookHeadVO.getConvert_date();
		// 
		UFDate convertDate = null;
		// Ƭ
		if (ConvertData.CARD_CREATE_DATA.value().equals(convertInt)) {
			convertDate = currentCardVO.getBusiness_date();
		} else {
			convertDate = alterHeadVO.getBusiness_date();
		}
		// 󣬱䶯ֱԭֵ
		localoriginvalueAlter = CurrencyRateManager.getAccbookAmountByOpp(currentCardVO.getPk_accbook(),
				pk_src_currtype, localoriginvalueAlter, convertDate);

		// ԭֵ
		UFDouble localoriginvalueBefore = currentCardVO.getLocaloriginvalue();
		alterBodyVO.setAttributeValue(AlterKeyConst.LOCALORIGINVALUE_ALTER, localoriginvalueAlter);
		alterBodyVO.setAttributeValue(AlterKeyConst.LOCALORIGINVALUE_BEFORE, localoriginvalueBefore);
		UFDouble localoriginvalueAfter = UFDoubleUtils.add(localoriginvalueAlter, localoriginvalueBefore);
		alterBodyVO.setAttributeValue(AlterKeyConst.LOCALORIGINVALUE_AFTER, localoriginvalueAfter);

		if (UFDoubleUtils.isNullOrZero(localoriginvalueAfter)
				|| localoriginvalueAfter.compareTo(UFDouble.ZERO_DBL) < 0) {
			ExceptionUtils.asBusinessException(
					nc.vo.ml.NCLangRes4VoTransl.getNCLangRes().getStrByID("alter_0", "02012010-0078")
			/*
			 * @res "ԴĽ¹̶ʲıԭֵС0,   \n "
			 */);
		}

		// ֵ
		alterBodyVO.setAttributeValue(AlterKeyConst.SALVAGE_BEFORE, currentCardVO.getSalvage());
		UFDouble after_salvage = UFDoubleUtils
				.multiply((UFDouble) alterBodyVO.getAttributeValue(AlterKeyConst.LOCALORIGINVALUE_AFTER),
						currentCardVO.getSalvagerate())
				.div(100);
		alterBodyVO.setAttributeValue(AlterKeyConst.SALVAGE_AFTER, after_salvage);
		alterBodyVO.setAttributeValue(AlterKeyConst.SALVAGE_ALTER,
				UFDoubleUtils.sub(after_salvage, currentCardVO.getSalvage()));

		// ֵ
		alterBodyVO.setAttributeValue(AlterKeyConst.SALVAGERATE_BEFORE, currentCardVO.getSalvagerate());
		alterBodyVO.setAttributeValue(AlterKeyConst.SALVAGERATE_AFTER, currentCardVO.getSalvagerate());

		// ۼ۾(ʲ׷)
		if (AlterTransiTypeConst.ASSET_TRACE.equals(alterHeadVO.getTransi_type())) {
			alterBodyVO.setAttributeValue(AlterKeyConst.ACCUDEP_BEFORE, currentCardVO.getAccudep());
		}

		// ʹ
		alterBodyVO.setAttributeValue(AlterKeyConst.SERVICEMONTH_BEFORE, currentCardVO.getServicemonth());
		alterBodyVO.setAttributeValue(AlterKeyConst.SERVICEMONTH_AFTER, currentCardVO.getServicemonth());
		alterBodyVO.setAttributeValue(AlterKeyConst.NATUREMONTH_BEFORE, currentCardVO.getNaturemonth());
		alterBodyVO.setAttributeValue(AlterKeyConst.NATUREMONTH_AFTER, currentCardVO.getNaturemonth());
	}

	/**
	 * װ׷VO
	 * 
	 * @param currentCardVO
	 * @param alterBodyVO
	 * @return
	 */
	private TraceVO assembeTraceVO(AssetVO currentCardVO, AlterBodyVO alterBodyVO) {

		// ԭֵ
		UFDouble localOriginValueAfter = (UFDouble) alterBodyVO.getAttributeValue(AlterKeyConst.LOCALORIGINVALUE_AFTER);
		// ʹ
		Integer useMonthAfter = currentCardVO.getServicemonth();
		// ֵ
		UFDouble salvageRateAfter = currentCardVO.getSalvagerate();

		// ׷ڣĬϿƬġ۾ɿʼڡ
		UFDate traceDate = currentCardVO.getDep_start_date();

		// Ƭpk
		String pk_card = currentCardVO.getPk_card();

		// ǰڵĲ˲
		String pk_accbook = currentCardVO.getPk_accbook();

		String pk_org = currentCardVO.getPk_org();

		String pk_depmethod = currentCardVO.getPk_accbook();

		String card_code = currentCardVO.getCard_code();

		TraceVO traceVO = new TraceVO();
		traceVO.setPk_org(pk_org);
		traceVO.setPk_card(pk_card);
		traceVO.setPk_accbook(pk_accbook);
		traceVO.setTraceDate(traceDate);
		traceVO.setLocalOriginValueAfter(localOriginValueAfter);
		traceVO.setUseMonthAfter(useMonthAfter);
		traceVO.setSalvageRateAfter(salvageRateAfter);
		traceVO.setPk_depmethod(pk_depmethod);
		traceVO.setCard_code(card_code);

		traceVO.setSalvageAfter(
				new UFDouble(localOriginValueAfter.doubleValue() * salvageRateAfter.doubleValue() / 100));
		return traceVO;
	}

	/**
	 * ݹܿģʽѯ䶯ʽƣV631ƽӿڲѯݣ
	 * 
	 * @param pk_org
	 * @return
	 * @throws BusinessException add by wangweiak
	 */
	@SuppressWarnings({ "unchecked", "serial" })
	public List<AlterBodyVO> queryAlterStyleData(String pk_org) throws BusinessException {
		// ȡ
		String pk_group = InvocationInfoProxy.getInstance().getGroupId();

		// һѯʽ-šеݣ
		// 1װѯsqlܿģʽΪšȫ֣
		// String querySQL = "select style_code, style_name from pam_addreducestyle
		// where ( pk_org = '"
		// + pk_group + "' or pk_org = '" + IOrgConst.GLOBEORG + "') ";
		StringBuffer querySql = new StringBuffer();
		querySql.append(" select style_code ").append("       ,style_name ").append("   from pam_addreducestyle ")
				.append("  where pk_org = '" + pk_group + "' ").append("     or pk_org = '" + IOrgConst.GLOBEORG + "' ")
				.append("  order by style_code ");

		DBAccessUtil dbUtil = new DBAccessUtil();
		final List<AlterBodyVO> alterBodyVOList = (List<AlterBodyVO>) dbUtil.getBaseDAO()
				.executeQuery(querySql.toString(), new ResultSetProcessor() {

					@Override
					public Object handleResultSet(ResultSet rs) throws SQLException {

						List<AlterBodyVO> alterBodyVOList = new ArrayList<AlterBodyVO>();
						while (rs.next()) {
							String style_code = rs.getString(AddreduceStyleVO.STYLE_CODE);
							String style_name = rs.getString(AddreduceStyleVO.STYLE_NAME);
							AlterBodyVO alterBodyVO = new AlterBodyVO();
							alterBodyVO.setDef1(style_code); // Զ1ʱ洢䶯ʽ
							alterBodyVO.setDef2(style_name); // Զ2ʱ洢䶯ʽ
							alterBodyVOList.add(alterBodyVO);
						}
						return alterBodyVOList;
					}
				});

		// ѯ¡ʲ䶯õнͱͽ
		// 1װѯsqlbd_billtype
		// String queryAlterSQL = " select pk_billtypecode, billtypename from
		// bd_billtype where parentbilltype = 'HG' " +
		// " and pk_group = '" + pk_group + "'";
		StringBuffer queryAlterSql = new StringBuffer();
		queryAlterSql.append(" select pk_billtypecode ").append("       ,billtypename ").append("   from bd_billtype ")
				.append("  where parentbilltype = 'HG' ").append("    and pk_group = '" + pk_group + "' ")
				.append("  order by pk_billtypecode ");
		dbUtil.getBaseDAO().executeQuery(queryAlterSql.toString(), new ResultSetProcessor() {

			@Override
			public Object handleResultSet(ResultSet rs) throws SQLException {
				while (rs.next()) {
					String billtypeCode = rs.getString("pk_billtypecode"); // ȡʲ䶯µĽͱ룬ʽΪHG-01
					String new_billtypeCode = "03" + billtypeCode.substring(3); // ʽΪ0301
					String billypeName = rs.getString("billtypename"); // ȡʲ䶯µĽ
					AlterBodyVO alterBodyVO = new AlterBodyVO();
					alterBodyVO.setDef1(new_billtypeCode); // Զ1ʱ洢ͱ
					alterBodyVO.setDef2(billypeName); // Զ2ʱ洢
					if (CollectionUtils.isNotEmpty(alterBodyVOList)) {
						alterBodyVOList.add(alterBodyVO);
					}
				}
				return alterBodyVOList;
			}
		});

		return alterBodyVOList;
	}

	/**
	 * ݱиƬԭԭֵռı̯䶯ֱԭֵ
	 * 
	 * @param splitBodyList Ҫбı䶯
	 * @throws BusinessException
	 */
	public void splitLocaloriginvalueAlter(List<SuperVO> splitBodyList) throws BusinessException {
		List<String> cardsList = VOManager.getAttributeValueList(splitBodyList.toArray(new AlterBodyVO[0]),
				AlterBodyVO.PK_CARD, true, true);
		// ѯ˲Ƭ
		AssetVO[] assetVOs = AMProxy.lookup(IAssetService.class).queryMainAssetVOByPks(null,
				cardsList.toArray(new String[0]));
		// 䶯ֱԭֵҪֵpk_cardArr[]иƬռԭԭֵз̯
		UFDouble localoriginvalueAlter = (UFDouble) splitBodyList.get(0)
				.getAttributeValue(AlterKeyConst.LOCALORIGINVALUE_ALTER);
		UFDouble originvalueSum = UFDouble.ZERO_DBL;
		UFDouble localoriginvalueUsed = UFDouble.ZERO_DBL;
		for (AssetVO assetVO : assetVOs) {
			originvalueSum = originvalueSum.add(assetVO.getOriginvalue());
		}
		// ȡ䶯˲ľ
		String pk_accbook = assetVOs[0].getPk_accbook();
		for (AssetVO assetVO : assetVOs) {
			for (int i = 0; i < splitBodyList.size() - 1; i++) {
				AlterBodyVO bodyVO = (AlterBodyVO) splitBodyList.get(i);
				if (assetVO.getPk_card().equals(bodyVO.getPk_card())) {
					UFDouble originvalue = assetVO.getOriginvalue(); // ԭԭֵ
					UFDouble localoriginvalue_acc = FAScaleUtils.setScaleByAccbook(
							localoriginvalueAlter.multiply(originvalue).div(originvalueSum), pk_accbook);
					bodyVO.setAttributeValue(AlterKeyConst.LOCALORIGINVALUE_ALTER, localoriginvalue_acc);
					localoriginvalueUsed = FAScaleUtils
							.setScaleByAccbook(localoriginvalueUsed.add(localoriginvalue_acc), pk_accbook);
				}
			}
		}
		// һбõķʽ
		splitBodyList.get(splitBodyList.size() - 1).setAttributeValue(AlterKeyConst.LOCALORIGINVALUE_ALTER,
				localoriginvalueAlter.sub(localoriginvalueUsed));
	}

	/**
	 * ˵˲ٵĿƬ
	 * 
	 * @param splitBodyList
	 * @throws BusinessException
	 */
	private void removeReducedAssetVO(List<SuperVO> splitBodyList) throws BusinessException {
		// ȡñʲƬǷٵжϽ
		String[] pk_cards = VOManager.getAttributeValueArray(splitBodyList.toArray(new SuperVO[0]),
				AssetFieldConst.PK_CARD);
		Map<String, Boolean> reducedAsset = AMProxy.lookup(IReduceService.class).isCardMainAccbookReduced(pk_cards);
		List<AlterBodyVO> countList = new ArrayList<AlterBodyVO>();

		// ȡúδٿƬı塣
		for (SuperVO bodyVO : splitBodyList) {
			AlterBodyVO alterBodyVO = (AlterBodyVO) bodyVO;
			if (reducedAsset.get(alterBodyVO.getPk_card())) {
				countList.add(alterBodyVO);
			}
		}
		if (CollectionUtils.isNotEmpty(countList)) {
			splitBodyList.removeAll(countList);
		}
	}

	/**
	 * 䶯Ƭ༭¼ʹ, Զ ΪӴʹ
	 * 
	 * @author tanghui5
	 */
	@Override
	public Map<String, Object> fetchAlterCardEditData(String pk_org, String pk_accbook, String[] queryFields,
			String[] pk_cards) throws BusinessException {
		Map<String, Object> alterCardEditData = new HashMap<String, Object>();

		// ѯƬ
		AssetVO[] assetVOs = null;
		String[] tqueryFields = ArrayUtils.addElement(queryFields, new String[] { "accyear", "period" });
		assetVOs = AMProxy.lookup(IAssetService.class).queryAssetVOByAlter(pk_org, pk_accbook, tqueryFields, pk_cards);
		alterCardEditData.put("assetVOs", assetVOs);

		// ѯʹò
		Map<String, List<DeptScaleVO>> deptMap = new HashMap<String, List<DeptScaleVO>>();
		deptMap = AMProxy.lookup(IAssetService.class).queryUseDeptBatch(pk_cards);
		alterCardEditData.put("deptMap", deptMap);

		// ˺ͣòŵĶʹò
		Map<String, List<DeptScaleVO>> filteredDeptMap = new HashMap<String, List<DeptScaleVO>>();
		filteredDeptMap = AMProxy.lookup(IUseDeptScaleService.class).filterDeptSeal(deptMap, pk_org);
		alterCardEditData.put("filteredDeptMap", filteredDeptMap);

		return alterCardEditData;
	}

}/// :~
