package nc.impl.fa.alter.rule;

import java.io.IOException;
import java.lang.reflect.InvocationTargetException;
import java.util.List;
import java.util.Map;

import com.fasterxml.jackson.core.JsonProcessingException;
import com.fasterxml.jackson.databind.JsonNode;
import com.fasterxml.jackson.databind.ObjectMapper;
import com.fasterxml.jackson.databind.node.ArrayNode;
import com.fasterxml.jackson.databind.node.ObjectNode;

import nc.bs.am.framework.action.ActionContext;
import nc.bs.am.framework.action.IRule;
import nc.bs.dao.BaseDAO;
import nc.bs.dao.DAOException;
import nc.bs.framework.common.NCLocator;
import nc.bs.hz.utils.BillInfoQueryUtil;
import nc.bs.hz.utils.SafeObject;
import nc.bs.hz.utils.SendUtil;
import nc.bs.logging.Logger;
import nc.itf.fa.byzlog.IbyzLogRcord;
import nc.jdbc.framework.SQLParameter;
import nc.jdbc.framework.processor.ColumnListProcessor;
import nc.jdbc.framework.processor.ColumnProcessor;
import nc.util.fa.httputil.BillHttpRequestUtil;
import nc.vo.fa.alter.AlterBodyVO;
import nc.vo.fa.alter.AlterHeadVO;
import nc.vo.fa.alter.AlterVO;
import nc.vo.fa.asset.AssetVO;
import nc.vo.fa.byzLogVO.ByzLogRcordVO;
import nc.vo.fa.category.CategoryVO;
import nc.vo.fa.depmethod.DepmethodVO;
import nc.vo.pub.BusinessException;
import nc.vo.pubapp.pattern.exception.ExceptionUtils;
import nccloud.web.byz.action.ARCApproveAction;

public class SendARCAlterRule implements IRule<AlterVO> {
	// 䶯Ŀ
	private ArrayNode pk_fa_alters;
	private ObjectMapper mapper;

	// ȡݿ
	private BaseDAO baseDAO;

	private BaseDAO getBaseDAO() {
		if (baseDAO == null) {
			baseDAO = new BaseDAO();
		}
		return baseDAO;
	}

	@Override
	public void process(ActionContext<AlterVO> context, AlterVO... vos) throws BusinessException {
		if (vos == null || vos.length == 0) {
			throw new BusinessException("VOΪ");
		}
		mapper = new ObjectMapper();
		ObjectNode data = mapper.createObjectNode();
		String request = null, response = null, billno = null;
		String arcip = SendUtil.getSysinittempValue("altertobyz");
		try {
			for (AlterVO vo : vos) {
				AlterHeadVO head = (AlterHeadVO) vo.getParentVO();
				AlterBodyVO[] body = (AlterBodyVO[]) vo.getChildrenVO();
				if ("".equals(head.getDef1())) {
					// ͸ARC
					new ARCApproveAction().sendApprove(body[0].getPk_card(), head.getDef4(), 1);
				} else if (BillInfoQueryUtil.isARC(head.getPk_org())) {
					// ǷARC
					//б䶯Ŀһȡһо
					if(body!=null&&body.length>0)
						this.pk_fa_alters = getChangeItem(getItem_code(body[0].getPk_alter_b()));
						
					data.set("head", setHead(head));
					data.set("body", setBody(body));
					billno = SafeObject.toString(head.getAttributeValue("bill_code"));
					
					if (data.has("head")) {
						request = SendUtil.getResult(data);
						// ͸ARC
						response = BillHttpRequestUtil.sendPost(arcip, request);
						JsonNode json = mapper.readTree(response);
						if (json.findValue("code").asInt() != 200) {
							throw new BusinessException("ARCϢ"+json.findValue("msg").asText());
						}
						BillInfoQueryUtil.updateStatus("HG", new String[] { head.getPk_alter() });
					}
				}
				
			}
		} catch (Exception e) {
			ExceptionUtils.wrappBusinessException(e.getMessage());
		} finally {
//			if (billno != null) {
//				IbyzLogRcord ibyzLogRcord = (IbyzLogRcord) NCLocator.getInstance().lookup(IbyzLogRcord.class);
				ByzLogRcordVO byzLogRcordVO = new ByzLogRcordVO();
				byzLogRcordVO.setVbillcode(billno);
				byzLogRcordVO.setItf_type("NC䶯ͱ");
				byzLogRcordVO.setItfclass(this.getClass().toString());
				byzLogRcordVO.setNcctobyzresult(request);
				byzLogRcordVO.setByztonccparam(response);
				byzLogRcordVO.setItfaddress(arcip);
//				try {	
					BillInfoQueryUtil.insertlog(byzLogRcordVO);
//					ibyzLogRcord.RcordLogBYZ__RequiresNew(byzLogRcordVO);
//				} catch (BusinessException e) {
//					Logger.error(e.getMessage(), e);
//					Logger.error("־ʧܣnc.itf.fa.byzlog.IbyzLogRcord");
//				}
//			}
		}
	}

	/**
	 * ݱ䶯Ŀòֶͬ
	 * 
	 * @param bodyVO
	 */
	private void judgeChangeItem(ObjectNode bodyVO, AlterBodyVO body) {
		for (JsonNode fa_alter : pk_fa_alters) {
			switch (fa_alter.asText()) {
			// ԭԭֵ䶯
			case "BD01":
				// 䶯ǰԭԭֵ
				bodyVO.put("originvalue_before", SafeObject.toString(body.getAttributeValue("originvalue_before")));
				// 䶯ԭԭֵ
				bodyVO.put("originvalue_alter", SafeObject.toString(body.getAttributeValue("originvalue_alter")));
				// 䶯ԭԭֵ
				bodyVO.put("originvalue_after", SafeObject.toString(body.getAttributeValue("originvalue_after")));
				break;
			// ԭֵ䶯
			case "BD02":
				// 䶯ǰԭֵ
				bodyVO.put("localoriginvalue_before",
						SafeObject.toString(body.getAttributeValue("localoriginvalue_before")));
				// 䶯ֱԭֵ
				bodyVO.put("localoriginvalue_alter",
						SafeObject.toString(body.getAttributeValue("localoriginvalue_alter")));
				// 䶯󱾱ԭֵ
				bodyVO.put("localoriginvalue_after",
						SafeObject.toString(body.getAttributeValue("localoriginvalue_after")));
				break;
			// ۼ۾ɱ䶯
			case "BD03":
				// 䶯ǰۼ۾
				bodyVO.put("accudep_before", SafeObject.toString(body.getAttributeValue("accudep_before")));
				// 䶯ۼ۾
				bodyVO.put("accudep_alter", SafeObject.toString(body.getAttributeValue("accudep_alter")));
				// 䶯ۼ۾
				bodyVO.put("accudep_after", SafeObject.toString(body.getAttributeValue("accudep_after")));
				break;
			// ʹޱ䶯
			case "BD09":
				// 䶯ǰʹ
				bodyVO.put("naturemonth_before", SafeObject.toString(body.getAttributeValue("naturemonth_before")));
				// 䶯ʹ
				bodyVO.put("naturemonth_after", SafeObject.toString(body.getAttributeValue("naturemonth_after")));
				break;
			// ۾ɷ䶯
			case "BD11":
				// 䶯ǰ۾ɷ
				DepmethodVO methodbefor=BillInfoQueryUtil.selectDepmethod(SafeObject.toString(body.getAttributeValue("pk_depmethod_before")));
				if(methodbefor!=null)
					bodyVO.put("pk_depmethod_before", methodbefor.getDepmethod_code());
				// 䶯۾ɷ
				DepmethodVO methodater=BillInfoQueryUtil.selectDepmethod(SafeObject.toString(body.getAttributeValue("pk_depmethod_after")));
				if(methodater!=null)
					bodyVO.put("pk_depmethod_after", methodater.getDepmethod_code());
				break;
			// ֵʱ䶯
			case "BD12":
				// 䶯ǰֵʣ%
				bodyVO.put("salvagerate_before", SafeObject.toString(body.getAttributeValue("salvagerate_before")));
				// 䶯󾻲ֵʣ%
				bodyVO.put("salvagerate_after", SafeObject.toString(body.getAttributeValue("salvagerate_after")));
				break;
			// ֵ䶯
			case "BD13":
				// 䶯ǰֵ
				bodyVO.put("salvage_before", SafeObject.toString(body.getAttributeValue("salvage_before")));
				// 䶯󾻲ֵ
				bodyVO.put("salvage_after", SafeObject.toString(body.getAttributeValue("salvage_after")));
				break;
			// ʲͱ䶯
			case "BD15":
				// 䶯ǰ
				CategoryVO befor=BillInfoQueryUtil.selectCategory(SafeObject.toString(body.getAttributeValue("pk_category_before")));
				if(befor!=null)
					bodyVO.put("pk_category_before", befor.getCate_code());
				// 䶯
				CategoryVO after=BillInfoQueryUtil.selectCategory(SafeObject.toString(body.getAttributeValue("pk_category_after")));
				if(after!=null)
					bodyVO.put("pk_category_after", after.getCate_code());
				break;
			// ۿ䶯
			case "BD29":
				// 䶯ǰۿ
				bodyVO.put("currmoney_before", SafeObject.toString(body.getAttributeValue("currmoney_before")));
				// 䶯ֹۿ
				bodyVO.put("currmoney_alter", SafeObject.toString(body.getAttributeValue("currmoney_alter")));
				// 䶯ۿ
				bodyVO.put("currmoney_after", SafeObject.toString(body.getAttributeValue("currmoney_after")));
				break;
			// ˰ѱ䶯
			case "BD30":
				// 䶯ǰۿ
				bodyVO.put("tax_cost_before", SafeObject.toString(body.getAttributeValue("tax_cost_before")));
				// 䶯ֹۿ
				bodyVO.put("tax_cost_alter", SafeObject.toString(body.getAttributeValue("tax_cost_alter")));
				// 䶯ۿ
				bodyVO.put("tax_cost_after", SafeObject.toString(body.getAttributeValue("tax_cost_after")));
				break;
			// ñ䶯
			case "BD33":
				// 䶯ǰ
				bodyVO.put("other_cost_before", SafeObject.toString(body.getAttributeValue("other_cost_before")));
				// 䶯
				bodyVO.put("other_cost_alter", SafeObject.toString(body.getAttributeValue("other_cost_alter")));
				// 䶯
				bodyVO.put("other_cost_after", SafeObject.toString(body.getAttributeValue("other_cost_after")));
				break;
			// ˰䶯
			case "BD34":
				// 䶯ǰ˰
				bodyVO.put("tax_input_before", SafeObject.toString(body.getAttributeValue("tax_input_before")));
				// 䶯ֽ˰
				bodyVO.put("tax_input_alter", SafeObject.toString(body.getAttributeValue("tax_input_alter")));
				// 䶯˰
				bodyVO.put("tax_input_after", SafeObject.toString(body.getAttributeValue("tax_input_after")));
				break;
			default:
				// 䶯ǰԭԭֵ
				bodyVO.put("originvalue_before", SafeObject.toString(body.getAttributeValue("originvalue_before")));
				// 䶯ԭԭֵ
				bodyVO.put("originvalue_alter", SafeObject.toString(body.getAttributeValue("originvalue_alter")));
				// 䶯ԭԭֵ
				bodyVO.put("originvalue_after", SafeObject.toString(body.getAttributeValue("originvalue_after")));
				break;
			}
		}

	}

	/**
	 * 
	 * 
	 * @param vo
	 * @return
	 * @throws IOException
	 * @throws NoSuchMethodException
	 * @throws InvocationTargetException
	 * @throws IllegalAccessException
	 * @throws DAOException
	 */
	private ArrayNode setBody(AlterBodyVO[] body) throws BusinessException, IOException, IllegalAccessException,
			InvocationTargetException, NoSuchMethodException {
		ArrayNode arrayNode = mapper.createArrayNode();
		// AlterBodyVO[] body = (AlterBodyVO[]) vo.getChildrenVO();
		for (int i = 0; i < body.length; i++) {
			ObjectNode bodyVO = mapper.createObjectNode();
			// ̶ʲ
			String pk_card = SafeObject.toString(body[i].getAttributeValue("pk_card"));
			bodyVO.put("pk_card", pk_card);
			AssetVO assetVO = BillInfoQueryUtil.selectCard(pk_card);
			// Ƭ
			bodyVO.put("card_code", assetVO.getCard_code());
			// ̶ʲ
			bodyVO.put("asset_name", assetVO.getAsset_name());
			// 䶯ԭ
			bodyVO.put("pk_reason", getPk_reason(body[i].getPk_reason()));
			// ݱ䶯Ŀòֶͬ
			judgeChangeItem(bodyVO, body[i]);
			arrayNode.add(bodyVO);
		}
		return arrayNode;
	}

	private String getPk_reason(String pk) throws BusinessException {
		String sql = "SELECT REASON_NAME FROM FA_REASON WHERE PK_REASON = ? AND DR = 0";
		String result = getColumn(sql, pk);
		if (result == null) {
			throw new BusinessException("ûҵñ䶯ԭ(pk_reason),:" + pk);
		}
		return result;
	}

	/**
	 * ֵͨòѯ
	 * 
	 * @param sql
	 * @param code
	 * @return
	 * @throws DAOException
	 */
	private String getColumn(String sql, String code) throws DAOException {
		SQLParameter parameter = new SQLParameter();
		parameter.addParam(code);
		return SafeObject.toString(getBaseDAO().executeQuery(sql, parameter, new ColumnProcessor()));
	}

	/**
	 * ͷ
	 * 
	 * @param vo
	 * @return
	 * @throws BusinessException
	 * @throws JsonProcessingException
	 */
	private JsonNode setHead(AlterHeadVO head) throws BusinessException {
		ObjectNode headVO = mapper.createObjectNode();
		// AlterHeadVO head = (AlterHeadVO) vo.getParentVO();
		// ֯
		headVO.put("pk_org_v", SafeObject.toString(head.getAttributeValue("pk_org_v")));
		// ҵ
		headVO.put("business_date", SafeObject.toString(head.getAttributeValue("business_date")));
		// 
		headVO.put("bill_code", SafeObject.toString(head.getAttributeValue("bill_code")));
		// ͱ
		headVO.put("transi_type", SafeObject.toString(head.getAttributeValue("transi_type")));
		// 䶯Ŀ
//		this.pk_fa_alters = getChangeItem(getItem_code(head.getPk_alter()));
		headVO.set("pk_fa_alters", pk_fa_alters);
		// Ƶ
		headVO.put("billmaker", SafeObject.toString(head.getAttributeValue("billmaker")));
		return headVO;
	}

	/**
	 * ѯ䶯
	 * 
	 * @param pk
	 * @return
	 * @throws BusinessException
	 */
	private List<String> getItem_code(String pk) throws BusinessException {
		String sql = "SELECT ITEM_CODE FROM FA_ALTERSHEET WHERE PK_ALTER_B = ? AND DR = 0";
		SQLParameter parameter = new SQLParameter();
		parameter.addParam(pk);
		List<String> result = (List<String>) getBaseDAO().executeQuery(sql, parameter, new ColumnListProcessor());
		if (result == null) {
			throw new BusinessException("ûҵñ䶯(item_code),:" + pk);
		}
		return result;
	}

	/**
	 * ѯ䶯Ŀ
	 * 
	 * @param pk
	 * @return
	 */
	private ArrayNode getChangeItem(List<String> pks) {
		ArrayNode node = mapper.createArrayNode();
		Map<String, String> map = BillInfoQueryUtil.getAlterItemValue();
		for (String pk : pks) {
			for (Map.Entry<String, String> entry : map.entrySet()) {
				if (pk.equals(entry.getValue())) {
					node.add(entry.getKey());
					break;
				}
			}
		}
		return node;
	}
}
