package nc.impl.fa.reduce;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.Set;

import nc.bs.am.framework.action.ActionContext;
import nc.bs.am.framework.action.IActionTemplate;
import nc.bs.am.framework.action.IRule;
import nc.bs.am.framework.action.approve.ApproveActionTemplate;
import nc.bs.am.framework.action.approve.UnApproveActionTemplate;
import nc.bs.am.framework.common.rule.ValidateServiceRule;
import nc.bs.dao.DAOException;
import nc.bs.framework.common.InvocationInfoProxy;
import nc.bs.uif2.validation.Validator;
import nc.impl.am.bill.BillBaseDAO;
import nc.impl.am.bill.rule.BillCodeDeleteRule;
import nc.impl.am.bill.rule.BillCodeInsertAfterRule;
import nc.impl.am.bill.rule.BillCodeInsertBeforeRule;
import nc.impl.am.bill.rule.BillCodeUpdateRule;
import nc.impl.am.bill.rule.VOSagasStatusCheckBeforeRule;
import nc.impl.am.common.InSqlManager;
import nc.impl.am.db.DBAccessUtil;
import nc.impl.am.db.QueryUtil;
import nc.impl.am.db.processor.BooleanProcessor;
import nc.impl.am.db.processor.ColumnSetProcessor;
import nc.impl.fa.common.rule.CreateBillLogAfterRule;
import nc.impl.fa.common.rule.DeleteBillLogAfterRule;
import nc.impl.fa.common.rule.UpdateCardLogAfterRule;
import nc.impl.fa.common.validator.CheckCardLegalValidator;
import nc.impl.fa.common.validator.CheckMinUnClosedBookPeriodValidator;
import nc.impl.fa.reduce.rule.CreateReduceBodyInfoAfterRule;
import nc.impl.fa.reduce.rule.DeleteReduceBodyInfoAfterRule;
import nc.impl.fa.reduce.rule.ReduceSendFipAfterRule;
import nc.impl.fa.reduce.rule.ReduceUpdateDepLogAfterRule;
import nc.impl.fa.reduce.rule.ReduceWriteBackToCardhistoryAfterRule;
import nc.impl.fa.reduce.rule.SendARCReduceRule;
import nc.impl.fa.reduce.rule.UpdateBillStatusOfWorkFlowAfterRule;
import nc.impl.fa.reduce.rule.WriteBackEquipCardAfterRule;
import nc.impl.fa.rule.FAAccbookCheckSealRule;
import nc.impl.fa.rule.PKAccbookBeforeRule;
import nc.impl.fa.rule.ReceiptScanBeforeRule;
import nc.impl.fa.rule.UpdateSrcMsgState4BillAfterRule;
import nc.itf.fa.prv.IReduce;
import nc.itf.fa.service.IAccbookInfoService;
import nc.itf.fa.service.IAssetService;
import nc.itf.fa.service.ICloseBookService;
import nc.itf.fa.service.IDepmethodService;
import nc.itf.fa.service.ILogService;
import nc.jdbc.framework.SQLParameter;
import nc.jdbc.framework.processor.ColumnListProcessor;
import nc.pub.fa.card.AssetFieldConst;
import nc.pub.fa.card.AssetUseConst;
import nc.pub.fa.common.checker.DepChecker;
import nc.pub.fa.common.consts.BillTypeConst;
import nc.pub.fa.common.consts.FlagConsts;
import nc.pub.fa.common.consts.LogTypeConst;
import nc.pub.fa.common.manager.DeptScaleManager;
import nc.pub.fa.common.manager.FipManager;
import nc.pub.fa.common.manager.VOManager;
import nc.pub.fa.dep.ReduceSimulateManager;
import nc.pub.fa.msg.MsgManager;
import nc.pub.fa.msg.MsgVO;
import nc.vo.am.common.AMSuperVO;
import nc.vo.am.common.BaseLockData;
import nc.vo.am.common.MappedBaseVO;
import nc.vo.am.common.TransportBillVO;
import nc.vo.am.common.util.ArrayUtils;
import nc.vo.am.common.util.BillTransportTool;
import nc.vo.am.common.util.CollectionUtils;
import nc.vo.am.common.util.ExceptionUtils;
import nc.vo.am.common.util.MapUtils;
import nc.vo.am.common.util.OrgUtils;
import nc.vo.am.common.util.StringUtils;
import nc.vo.am.common.util.UFDoubleUtils;
import nc.vo.am.constant.BillTypeConst_FA;
import nc.vo.am.constant.CommonKeyConst;
import nc.vo.am.manager.AccbookManager;
import nc.vo.am.manager.AccperiodVO;
import nc.vo.am.manager.CurrencyManager;
import nc.vo.am.manager.CurrencyRateManager;
import nc.vo.am.manager.LockManager;
import nc.vo.am.proxy.AMProxy;
import nc.vo.am.pub.uap.ModuleInfoQuery;
import nc.vo.fa.asset.AssetVO;
import nc.vo.fa.depmethod.DepmethodVO;
import nc.vo.fa.deptscale.DeptScaleVO;
import nc.vo.fa.reduce.ReduceBodyVO;
import nc.vo.fa.reduce.ReduceHeadVO;
import nc.vo.fa.reduce.ReduceMsgConst;
import nc.vo.fa.reduce.ReduceVO;
import nc.vo.fa.reduce.helper.ReduceVOGenerator;
import nc.vo.fa.reduce.validator.ReduceCheckHasVoucherForAccbooks;
import nc.vo.pub.BusinessException;
import nc.vo.pub.SuperVO;
import nc.vo.pub.lang.UFBoolean;
import nc.vo.pub.lang.UFDate;
import nc.vo.pub.lang.UFDouble;
import nc.vo.uif2.LoginContext;

/**
 * ʲٺ̨
 *
 * @author weizq
 * @date 2009-12-31
 *
 */
public class ReduceImpl extends BillBaseDAO<ReduceVO> implements IReduce {

	/**
	 * ԽϵVOɾǰ̨õĽӿ
	 *
	 * @param context
	 * @param vo
	 * @throws BusinessException
	 * @see nc.itf.fa.prv.IReduce#delete(nc.vo.uif2.LoginContext,
	 *      nc.vo.fa.reduce.ReduceVO)
	 */
	@Override
	public void delete(LoginContext context, ReduceVO billVO) throws BusinessException {

		// »ȡݣ洫͹ĽΪpk ts
		billVO = reloadReduceVO(billVO.getPrimaryKey());

		// ȫVOɾ
		deleteReduceVO(context, billVO);
	}

	/*
	 * Ӱ
	 */
	@Override
	protected void initCommitActionRules(IActionTemplate<ReduceVO> template) {
		super.initCommitActionRules(template);
		// saga״̬У
		template.addBeforeRule(new VOSagasStatusCheckBeforeRule<ReduceVO>());
		// Ӱ
		template.addBeforeRule(new ReceiptScanBeforeRule<ReduceVO>());
	}

	/**
	 * ȫVOɾ̨
	 *
	 * @param context
	 * @param vo
	 * @throws BusinessException
	 * @date 2010-5-26
	 */
	protected void deleteReduceVO(LoginContext context, ReduceVO billVO) throws BusinessException {
		deleteBillVO(billVO);
	}

	/**
	 * 
	 *
	 * @param context
	 * @param billVO
	 * @return
	 * @throws BusinessException
	 */
	@Override
	public TransportBillVO insert(LoginContext context, ReduceVO billVO) throws BusinessException {
		// òķ
		billVO = insertReduceVO(context, billVO);

		// תVOֻͽ治ڵֶ,pk,ts,creator...
		TransportBillVO transportBillVO = BillTransportTool.createTransportBill(billVO, BillTransportTool.MODE_INSERT);

		return transportBillVO;
	}

	/**
	 * ı淽
	 *
	 * @param context
	 * @param billVO
	 * @return
	 * @throws BusinessException
	 * @date 2010-5-26
	 */
	protected ReduceVO insertReduceVO(LoginContext context, ReduceVO billVO) throws BusinessException {
		// ж۾Ƶ
		checkAfterDapMade(billVO);

		// 
		dealMultiCurrency(billVO);

		// ˲
		dealBodyAccbook(billVO);

		ReduceVO[] retReduceVOs = insertBillVO(billVO);
		// ֻȡһ
		ReduceVO reduceVO = ArrayUtils.getFirstElem(retReduceVOs);

		// ʹfinally:Ϊ汨ˣǰ̨Ȼڱ༭״̬Ӧȡť  ɹ˽
		releasePKCardLock(billVO);

		return reduceVO;
	}

	/**
	 *
	 * Ǳͷ˲ǿգ ˲Ҳ~
	 * <p>
	 * <b>˵</b>
	 * 
	 * @param billVO
	 *               <p>
	 * @author weizq
	 * @time 2010-12-30 03:44:48
	 */
	private void dealBodyAccbook(ReduceVO billVO) {
		ReduceHeadVO headVO = (ReduceHeadVO) billVO.getParent();

		ReduceBodyVO[] bodyVOs = (ReduceBodyVO[]) billVO.getChildrenVO();

		String pk_accbook = headVO.getPk_accbook();
		if (AccbookManager.isBizAccbook(pk_accbook)) {
			VOManager.setAttributeValue(bodyVOs, AssetFieldConst.PK_ACCBOOK, FlagConsts.FLAG_NULL);
		}
	}

	/**
	 * ǰ
	 * 
	 * @param insertAction
	 * @see nc.impl.am.bill.BillBaseDAO#initInsertActionRules(nc.impl.am.bill.action.BillInsertAction)
	 */
	@Override
	protected void initInsertActionRules(IActionTemplate<ReduceVO> insertAction) {
		super.initInsertActionRules(insertAction);
		// У
		List<Validator> validators = new ArrayList<Validator>();
		// Ƿ˲У
		validators.add(new FAAccbookCheckSealRule());
		// У鿨ƬϷ
		validators.add(new CheckCardLegalValidator());
		// УСδ
		validators.add(new CheckMinUnClosedBookPeriodValidator());
		// жϲǷѾƳ۾嵥У顣
		validators.add(new ReduceCheckHasVoucherForAccbooks());

		insertAction.addBeforeRule(new ValidateServiceRule<ReduceVO>(validators));

		// ̶ʲ˲
		insertAction.addBeforeRule(new PKAccbookBeforeRule<ReduceVO>());
		// ݺŴ
		insertAction.addBeforeRule(new BillCodeInsertBeforeRule<ReduceVO>());
		// ݺŴ
		insertAction.addAfterRule(new BillCodeInsertAfterRule<ReduceVO>());
		// Ӹ¿Ƭ־򣬸¡bill_codebill_typebill_status
		insertAction.addAfterRule(new UpdateCardLogAfterRule<ReduceVO>(false));
		// ϢԴ״̬
		insertAction.addAfterRule(new UpdateSrcMsgState4BillAfterRule<ReduceVO>());
	}

	@Override
	protected void initPushSaveActionRules(IActionTemplate<ReduceVO> insertAction) {
		super.initPushSaveActionRules(insertAction);
		// У
		List<Validator> validators = new ArrayList<Validator>();
		// У鿨ƬϷ
		validators.add(new CheckCardLegalValidator());
		// УСδ
		validators.add(new CheckMinUnClosedBookPeriodValidator());
		insertAction.addBeforeRule(new ValidateServiceRule<ReduceVO>(validators));

		// Ӹ¿Ƭ־򣬸¡bill_codebill_typebill_status
		insertAction.addBeforeRule(new UpdateCardLogAfterRule<ReduceVO>(false));
		// ̶ʲ˲
		insertAction.addBeforeRule(new PKAccbookBeforeRule<ReduceVO>());
	}

	@SuppressWarnings("unchecked")
	@Override
	protected void initApproveRule(ApproveActionTemplate<ReduceVO> template) {
		// ʼУб.
		List<Validator> validators = new ArrayList<Validator>();
		// Ƿ˲У
		validators.add(new FAAccbookCheckSealRule());
		// жϲǷѾƳ۾嵥У顣
		// validators.add(new CheckHasFipMakeVoucherForAccbooks());
		validators.add(new ReduceCheckHasVoucherForAccbooks());
		// УСδ
		validators.add(new CheckMinUnClosedBookPeriodValidator());
		// saga״̬У
		template.addApprovedBeforeRule(new VOSagasStatusCheckBeforeRule<ReduceVO>());
		template.addApprovedBeforeRule(new ValidateServiceRule<ReduceVO>(validators));

		// ҵ
		// ͨ
		List<IRule<ReduceVO>> approvePassAfterRules = new ArrayList<IRule<ReduceVO>>();

		// ,µ״̬
		approvePassAfterRules.add(new UpdateBillStatusOfWorkFlowAfterRule<ReduceVO>());

		// reduceӿ
		// ˺Ҫfa_logеĿƬ־
		approvePassAfterRules.add(new UpdateCardLogAfterRule<ReduceVO>(true));

		// 1. ɱ------һ߼Ƿ¼
		approvePassAfterRules.add(new CreateReduceBodyInfoAfterRule<ReduceVO>());

		// 2. ¼־
		approvePassAfterRules.add(new ReduceUpdateDepLogAfterRule());

		// 3. 豸Ƭ
		approvePassAfterRules.add(new WriteBackEquipCardAfterRule<ReduceVO>(true));

		// 4. дƬʷ
		approvePassAfterRules.add(new ReduceWriteBackToCardhistoryAfterRule(true));

		// 5. ͻƽ̨
		approvePassAfterRules.add(new ReduceSendFipAfterRule(true));

		// 6. ӵݵfa_log¼
		approvePassAfterRules.add(new CreateBillLogAfterRule<ReduceVO>(LogTypeConst.reduce));
		
		// 7. ͸ARC
//		approvePassAfterRules.add(new SendARCReduceRule());

		// ͨ
		template.addApprovePassAfterRule(approvePassAfterRules);
	}

	@Override
	protected void initUnApproveRule(UnApproveActionTemplate<ReduceVO> template) {
		// У
		List<Validator> validators = new ArrayList<Validator>();
		// Ƿ˲У
		validators.add(new FAAccbookCheckSealRule());
		// Сδ
		validators.add(new CheckMinUnClosedBookPeriodValidator());
		// жϲǷѾƳ۾嵥У顣
		validators.add(new ReduceCheckHasVoucherForAccbooks());

		// ǰҵ
		List<IRule<ReduceVO>> unApprovedBeforeRules = new ArrayList<IRule<ReduceVO>>();
		// saga״̬У
		unApprovedBeforeRules.add(new VOSagasStatusCheckBeforeRule<ReduceVO>());
		unApprovedBeforeRules.add(new ValidateServiceRule<ReduceVO>(validators));
		// ȡǰҵ
		template.addUnApprovedBeforeRules(unApprovedBeforeRules);

		// ȡȡҵ
		List<IRule<ReduceVO>> lastUnApprovedAfterRules = new ArrayList<IRule<ReduceVO>>();
		// cancelReduceӿ
		// 1. ɾ˲"N/A"
		lastUnApprovedAfterRules.add(new DeleteReduceBodyInfoAfterRule<ReduceVO>());
		// 2. дƬʷ
		lastUnApprovedAfterRules.add(new ReduceWriteBackToCardhistoryAfterRule(false));
		// 3. ¼־
		lastUnApprovedAfterRules.add(new ReduceUpdateDepLogAfterRule());
		// 4. ͻƽ̨(ɾ)
		lastUnApprovedAfterRules.add(new ReduceSendFipAfterRule(false));

		// 5. ɾ־
		lastUnApprovedAfterRules.add(new DeleteBillLogAfterRule<ReduceVO>());

		// 6. ¿Ƭ־
		lastUnApprovedAfterRules.add(new UpdateCardLogAfterRule<ReduceVO>(false));

		// 7. ԭ豸ƬĲ
		lastUnApprovedAfterRules.add(new WriteBackEquipCardAfterRule<ReduceVO>(false));

		template.addLastUnApprovedAfterRules(lastUnApprovedAfterRules);
	}

	/**
	 * ʼջҵ
	 * 
	 * @author zhangypm
	 * @time 2020110
	 */
	@Override
	protected void initUnSaveActionRules(IActionTemplate<ReduceVO> template) {
		super.initUnSaveActionRules(template);
		// saga״̬У
		template.addBeforeRule(new VOSagasStatusCheckBeforeRule<ReduceVO>());
	}

	@Override
	protected void initDeleteActionRules(IActionTemplate<ReduceVO> deleteAction) {
		super.initDeleteActionRules(deleteAction);
		// saga״̬У
		deleteAction.addBeforeRule(new VOSagasStatusCheckBeforeRule<ReduceVO>());
		// Ӹ¿Ƭ־աbill_codebill_typebill_status
		deleteAction.addBeforeRule(new UpdateCardLogAfterRule<ReduceVO>(false, true));

		deleteAction.addAfterRule(new BillCodeDeleteRule<ReduceVO>());
	}

	@Override
	protected void initUpdateActionRules(IActionTemplate<ReduceVO> updateAction) {
		super.initUpdateActionRules(updateAction);
		// У
		List<Validator> validators = new ArrayList<Validator>();
		// У鿨ƬϷ
		validators.add(new CheckCardLegalValidator());
		// УСδ
		validators.add(new CheckMinUnClosedBookPeriodValidator());
		updateAction.addBeforeRule(new ValidateServiceRule<ReduceVO>(validators));

		updateAction.addBeforeRule(new BillCodeUpdateRule<ReduceVO>());
		updateAction.addBeforeRule(new PKAccbookBeforeRule<ReduceVO>());
	}

	/*
	 * ǰ̨ı淽
	 * 
	 * @date 2010-5-26
	 */
	@Override
	public TransportBillVO update(LoginContext context, ReduceVO billVO) throws BusinessException {

		// ñ淽
		billVO = updateReduceVO(context, billVO);

		// 
		TransportBillVO transportBillVO = BillTransportTool.createTransportBill(billVO, BillTransportTool.MODE_UPDATE);
		return transportBillVO;
	}

	/**
	 * ĸ±淽
	 *
	 * @param context
	 * @param billVO
	 * @return
	 * @throws BusinessException
	 * @date 2010-5-26
	 */
	protected ReduceVO updateReduceVO(LoginContext context, ReduceVO billVO) throws BusinessException {

		// ۾Ƶж
		checkAfterDapMade(billVO);

		// ӵ
		LockManager.lock(new BaseLockData<ReduceVO>(billVO));

		// µʱҪɾɱ忨Ƭ־±忨Ƭ־
		ReduceHeadVO headVO = (ReduceHeadVO) billVO.getParentVO();
		String[] pk_cards = queryBodyCardId(headVO.getPrimaryKey(), headVO.getPk_accbook());
		String bill_code = headVO.getBill_code();
		String bill_type = headVO.getBill_type();
		Integer bill_status = headVO.getBill_status();
		String pk_accbook = headVO.getPk_accbook();

		// ԭȵĿƬ־bill_code
		updateCardLog(pk_accbook, null, null, null, pk_cards);

		// 
		dealMultiCurrency(billVO);

		// ²ĳ־û
		ReduceVO reduceVO = ArrayUtils.getFirstElem(updateBillVO(new ReduceVO[] { billVO }, null));

		// ±忨Ƭ־
		pk_cards = queryBodyCardId(headVO.getPrimaryKey(), headVO.getPk_accbook());

		// ¸¿Ƭ־еbill_code
		updateCardLog(pk_accbook, bill_code, bill_type, bill_status, pk_cards);

		// ԿƬ:
		// ʹfinally:Ϊ汨ˣǰ̨Ȼڱ༭״̬Ӧȡť  ɹ˽
		releasePKCardLock(billVO);

		return reduceVO;
	}

	/*
	 * ǰ̨õύ
	 * 
	 * @date 2010-5-26
	 */
	@Override
	public ReduceVO commit(LoginContext context, ReduceVO billVO) throws BusinessException {
		// 
		billVO = commitReduceVO(context, billVO);

		return billVO;

	}

	/**
	 * ջ
	 * 
	 * @param vos
	 * @return
	 * @throws BusinessException
	 */
	@Override
	public Object unSave(ReduceVO[] vos) throws BusinessException {
		return super.unSaveBillVOs(vos);
	}

	/**
	 * ̨õύ
	 *
	 * @param context
	 * @param billVO
	 * @return
	 * @throws BusinessException
	 * @date 2010-5-26
	 */
	protected ReduceVO commitReduceVO(LoginContext context, ReduceVO billVO) throws BusinessException {
		billVO = ArrayUtils.getFirstElem(commitBillVO(billVO));
		return billVO;
	}

	/**
	 * ̨⿨Ƭ: ע⣺һҪfinallyУøݾҵ̽пǣñʱҪע˵ǷҪfinally顣
	 *
	 * @param billVO
	 * @param context
	 * @throws BusinessException
	 * @date 2010-1-5
	 */
	private void releasePKCardLock(ReduceVO billVO) throws BusinessException {
		if (billVO == null || ArrayUtils.isEmpty(billVO.getChildrenVO()))
			return;

		ReduceBodyVO[] bodyVOs = (ReduceBodyVO[]) billVO.getChildrenVO();
		List<String> list = new ArrayList<String>();
		for (int i = 0; i < bodyVOs.length; i++) {
			if (StringUtils.isNotEmpty(bodyVOs[i].getPk_card())) {
				list.add(bodyVOs[i].getPk_card());
			}
		}
		String[] pk_cardsAry = CollectionUtils.convertToArray(list, new String[0]);
		if (ArrayUtils.isNotEmpty(pk_cardsAry)) {
			LockManager.releasePKLocks(pk_cardsAry, InvocationInfoProxy.getInstance().getUserId());
		}
	}

	/**
	 * ȡ:ͼٽӿ෴<br>
	 * 1жСδ<br>
	 * 2ɾٱ壨ٵҪ<br>
	 * 3дٵĿƬ<br>
	 * 4Ӱ۾ɾ۾ɱ־<br>
	 * 5ɾƽ̨ļ<br>
	 * 6
	 *
	 * @param pk_bill pk_billֶΣ磺ֵֶΪӦͷID
	 * @date 2010-1-5
	 */
	protected void cancelReduce(SuperVO headVO) throws BusinessException {
		ReduceVO billVO = new ReduceVO();
		billVO.setParent(headVO);
		billVO.setChildrenVO(new AMSuperVO[0]);

		List<IRule<ReduceVO>> lastUnApprovedAfterRules = new ArrayList<IRule<ReduceVO>>();

		// 1. ɾ˲"N/A"
		lastUnApprovedAfterRules.add(new DeleteReduceBodyInfoAfterRule<ReduceVO>());
		// 2. дƬʷ
		lastUnApprovedAfterRules.add(new ReduceWriteBackToCardhistoryAfterRule(false));
		// 3. ¼־
		lastUnApprovedAfterRules.add(new ReduceUpdateDepLogAfterRule());
		// 4. ͻƽ̨(ɾ)
		lastUnApprovedAfterRules.add(new ReduceSendFipAfterRule(false));

		ActionContext<ReduceVO> actionContext = new ActionContext<ReduceVO>("InsertAction");
		for (IRule<ReduceVO> rule : lastUnApprovedAfterRules) {
			rule.process(actionContext, billVO);
		}
	}

	protected ReduceVO approveReduceVO(LoginContext context, ReduceVO billVO) throws BusinessException {
		// ͨ
		ActionContext<ReduceVO> actionContext = new ActionContext<ReduceVO>("InsertAction");

		// У
		List<Validator> validators = new ArrayList<Validator>();
		// жϲǷѾƳ۾嵥У顣
		validators.add(new ReduceCheckHasVoucherForAccbooks());
		// ǰҵ
		List<IRule<ReduceVO>> approvedBeforeRules = new ArrayList<IRule<ReduceVO>>();
		approvedBeforeRules.add(new ValidateServiceRule<ReduceVO>(validators));
		for (IRule<ReduceVO> rule : approvedBeforeRules) {
			rule.process(actionContext, billVO);
		}

		// ҵ
		// ͨ
		List<IRule<ReduceVO>> approvePassAfterRules = new ArrayList<IRule<ReduceVO>>();

		// ˺Ҫfa_logеĿƬ־
		approvePassAfterRules.add(new UpdateCardLogAfterRule<ReduceVO>(true));
		// reduceӿ

		// 1. ɱ
		approvePassAfterRules.add(new CreateReduceBodyInfoAfterRule<ReduceVO>());

		// 2. ¼־
		approvePassAfterRules.add(new ReduceUpdateDepLogAfterRule());

		// 3. дƬʷ
		approvePassAfterRules.add(new ReduceWriteBackToCardhistoryAfterRule(true));

		// 4. ͻƽ̨
		approvePassAfterRules.add(new ReduceSendFipAfterRule(true));

		// ӵݵfa_log¼
		approvePassAfterRules.add(new CreateBillLogAfterRule<ReduceVO>(LogTypeConst.reduce));

		for (IRule<ReduceVO> rule : approvePassAfterRules) {
			rule.process(actionContext, billVO);
		}

		return billVO;
	}

	/**
	 * pٷսӿ.<br>
	 * ӿڲ˵<br>
	 * 1ٱ<br>
	 * 2дٵĿƬ<br>
	 * 3Ӱ۾ɾ۾ɱ־<br>
	 * 4ݲ͵ƽ̨<br>
	 * 6
	 *
	 * @param bodyVO ͨVOյõļٵVO.<br>
	 *               ReduceBodyVOе˵<br>
	 *               1:pk_billԭݵıͷID磺ıͷID<br>
	 *               2:bill_type: ԭݵĵͣ磺HC<br>
	 *               3:pk_card : ٵĿƬ<br>
	 *               4:...<br>
	 * @date 2010-1-5
	 */
	public void reduce(ReduceVO reduceVO) throws BusinessException {
		List<IRule<ReduceVO>> approvePassAfterRules = new ArrayList<IRule<ReduceVO>>();

		approvePassAfterRules.add(new CreateReduceBodyInfoAfterRule<ReduceVO>());

		// 2. ¼־
		approvePassAfterRules.add(new ReduceUpdateDepLogAfterRule());

		// 3. дƬʷ
		approvePassAfterRules.add(new ReduceWriteBackToCardhistoryAfterRule(true));

		// 4. ͻƽ̨
		approvePassAfterRules.add(new ReduceSendFipAfterRule(true));

		ActionContext<ReduceVO> actionContext = new ActionContext<ReduceVO>("InsertAction");
		for (IRule<ReduceVO> rule : approvePassAfterRules) {
			rule.process(actionContext, reduceVO);
		}
	}

	@Override
	public ReduceVO[] queryReduceVOByPKs(String[] pks) throws BusinessException {
		return queryReduceVOByPKs(pks, false);
	}

	/**
	 * whereѯٵͳһĽӿڵģ
	 *
	 * @param whereSql     whereSql
	 * @param orderColumns ֶ
	 * @param isQueryBody  Ƿѯ
	 * @return
	 * @throws BusinessException
	 * @author yanjq
	 * @date 2010-4-13
	 */
	private ReduceVO[] queryReduceVOByHeadCond(String whereSql, boolean isQueryBody) throws BusinessException {

		// ĿǰֻѯͷVOVO
		// ڹ̶ʲٵ˲N/A;˲PKı¼
		ReduceVO[] billVOs = QueryUtil.queryBillVOByHeadCond(ReduceVO.class, whereSql, null, false);

		return billVOs;
	}

	/**
	 * PKsѯٵͳһĽӿڵģ
	 *
	 * @param whereSql     whereSql
	 * @param orderColumns ֶ
	 * @param isQueryBody  Ƿѯ
	 * @return
	 * @throws BusinessException
	 * @author yanjq
	 * @date 2010-4-13
	 */
	private ReduceVO[] queryReduceVOByPKs(String[] pks, boolean isQueryBody) throws BusinessException {
		String sql = " pk_reduce in " + InSqlManager.getInSQLValue(pks);
		return queryReduceVOByHeadCond(sql, isQueryBody);

	}

	@SuppressWarnings("unchecked")
	@Override
	public String[] queryReducePksByWhereSql(LoginContext context, String whereSql) throws BusinessException {

		StringBuffer sql = new StringBuffer("select h.pk_reduce from fa_reduce as h  where h.dr = 0 and bill_type = '"
				+ BillTypeConst.REDUCE + "' and pk_group = '" + InvocationInfoProxy.getInstance().getGroupId() + "'");
		if (whereSql != null && whereSql.trim().length() > 0)
			sql.append(" and ").append(whereSql);

		DBAccessUtil dbAcc = new DBAccessUtil();
		List<String> list = (List<String>) dbAcc.getBaseDAO().executeQuery(sql.toString(), new ColumnListProcessor());

		// صPKֵ
		String[] pks = null;
		if (list != null && list.size() > 0) {
			pks = list.toArray(new String[list.size()]);
		}

		return pks;
	}

	/**
	 * 
	 * ѯٱ
	 * 
	 * @param pk_accbook
	 * @param whereSql
	 * @return
	 * @throws BusinessException
	 * @return
	 */
	private ReduceBodyVO[] getReduceBodyVOs(String pk_accbook, String whereSql) throws BusinessException {

		// ѯҪı
		ReduceBodyVO[] bodyVOs = QueryUtil.queryVOByCond(ReduceBodyVO.class, whereSql, null);

		if (ArrayUtils.isEmpty(bodyVOs))
			return null;

		// 忨Ƭ
		String[] pk_cards = VOManager.getAttributeValueArray(bodyVOs, ReduceBodyVO.PK_CARD);

		// ѯʹò
		Map<String, List<DeptScaleVO>> deptMap = AMProxy.lookup(IAssetService.class).queryUseDeptBatch(pk_cards);

		// òѯƬ˲
		String queryPKAccbook = "";
		// жǷҵ˲
		if (FlagConsts.FLAG_NULL.equals(pk_accbook)) {
			// ȡPK_ORG
			String[] pk_orgs = VOManager.getAttributeValueArray(bodyVOs, ReduceBodyVO.PK_ORG);
			if (null != pk_orgs && pk_orgs.length > 0 && StringUtils.isNotEmpty(pk_orgs[0])) {
				// ûѡ˲ȡ˲
				queryPKAccbook = AccbookManager.queryMainAccbookIDByOrg(pk_orgs[0]);
			}
		} else {
			// ȡͷ˲
			queryPKAccbook = pk_accbook;
		}

		// ѯƬϢ
		MappedBaseVO[] mapBaseVOs = AMProxy.lookup(IAssetService.class).queryAssetFieldValues(pk_cards, queryPKAccbook,
				new String[] { "fa_card." + AssetFieldConst.PK_CARD, AssetFieldConst.ORIGINVALUE,
						AssetFieldConst.ASSET_STATE });

		for (ReduceBodyVO bodyVO : bodyVOs) {
			// Ƭ
			String pk_card = bodyVO.getPk_card();

			String name = DeptScaleManager.getShowName(CollectionUtils.toArray(deptMap.get(pk_card)));
			bodyVO.setAttributeValue(DeptScaleManager.USEDEPT, name);

			// ȡƬ¿Ƭ״̬˲
			String asset_state = "";

			if (ArrayUtils.isNotEmpty(mapBaseVOs)) {
				for (MappedBaseVO baseVO : mapBaseVOs) {
					// ÿƬPK
					String mbPk_card = (String) baseVO.getAttributeValue(CommonKeyConst.pk_card);
					if (StringUtils.isNotEmpty(mbPk_card) && StringUtils.isNotEmpty(pk_card)
							&& pk_card.equals(mbPk_card)) {

						// ÿƬ״̬
						String mbAssetState = (String) baseVO.getAttributeValue(AssetFieldConst.ASSET_STATE);

						// ȡ״̬
						asset_state = mbAssetState;
					}
				}
			}

			// ״̬
			bodyVO.setAttributeValue(AssetFieldConst.ASSET_STATE, asset_state);
		}

		return bodyVOs;
	}

	/**
	 * ѯ
	 *
	 * @param pk
	 * @param pk_accbook
	 * @return
	 * @throws BusinessException
	 * @see nc.itf.fa.prv.IReduce#queryReduceBodyVOs(java.lang.String,
	 *      java.lang.String)
	 */
	@Override
	public ReduceBodyVO[] queryReduceBodyVOs(String pk, String pk_accbook) throws BusinessException {

		if (AccbookManager.isBizAccbook(pk_accbook)) {
			pk_accbook = FlagConsts.FLAG_NULL;
		}
		// PKѯݣѯN/A
		String whereSql = " pk_reduce = '" + pk + "' and pk_accbook = '" + pk_accbook + "' and dr =0 ";

		ReduceBodyVO[] bodyVOs = getReduceBodyVOs(pk_accbook, whereSql);

		return bodyVOs;
	}

	/**
	 * 
	 *
	 * @param billVO
	 * @throws BusinessException
	 * @author yanjq
	 * @date 2010-4-12
	 */
	private void dealMultiCurrency(ReduceVO billVO) throws BusinessException {
		ReduceHeadVO headVO = (ReduceHeadVO) billVO.getParentVO();
		ReduceBodyVO[] bodyVOs = (ReduceBodyVO[]) billVO.getChildrenVO();

		// ʱ
		if (ArrayUtils.isEmpty(bodyVOs)) {
			return;
		}
		// Ĭ֯˲
		String pk_accbook = headVO.getPk_accbook();
		if (AccbookManager.isBizAccbook(pk_accbook)) {
			pk_accbook = AccbookManager.queryMainAccbookIDByOrg(headVO.getPk_org());
		}
		for (ReduceBodyVO bodyVO : bodyVOs) {
			bodyVO.setPk_group(headVO.getPk_group());
			CurrencyRateManager.setLocalMoneyByAccbook(bodyVO, ReduceVOGenerator.MULTI_CURRENCY_ATTRS, pk_accbook,
					headVO.getBusiness_date());
		}
	}

	/**
	 * ʵFAļٵ
	 *
	 * @param msgVO
	 * @return
	 * @throws BusinessException
	 * @author yanjq
	 * @see nc.itf.fa.prv.IReduce#queryReduceVOFromPAM(nc.pub.fa.msg.MsgVO)
	 */
	@Override
	public ReduceVO queryReduceVOFromPAM(MsgVO msgVO) throws BusinessException {
		if (isExistByMsg(msgVO)) {
			ExceptionUtils.asBusinessException(nc.vo.ml.NCLangRes4VoTransl.getNCLangRes().getStrByID("reduce_0",
					"02012015-0013")/* @res "ϢѾ˼ٵ\n" */);
		}
		ReduceVO reduceVO = null;
		if (null != msgVO.getService_class_name()) {
			// ݴ͵VOõVO
			reduceVO = MsgManager.queryPamByFA(msgVO);
		} else {
			if (null != msgVO.getSrc_billid()) {
				ReduceVO[] reduceVOs = queryReduceVOByPk(msgVO.getSrc_billid());
				if (ArrayUtils.isNotEmpty(reduceVOs)) {
					reduceVO = reduceVOs[0];
				}
			}
		}
		return reduceVO;
	}

	/**
	 * ԴIDжϸõɵı䶯Ƿ
	 *
	 * @param pk_bill_src
	 * @return
	 * @throws DAOException
	 * @date 2010-5-19
	 */
	protected boolean isExistBySrcBillPk(String pk_bill_src) throws BusinessException {
		String sql = " select top 1 '1' from fa_reduce where dr = 0 and pk_bill_src = ? ";
		SQLParameter params = new SQLParameter();
		params.addParam(pk_bill_src);
		return ((Boolean) new DBAccessUtil().executeQuery(sql, params, new BooleanProcessor())).booleanValue();
	}

	/**
	 * ԴIDжϸõɵı䶯Ƿ
	 *
	 * @param pk_bill_src
	 * @return
	 * @throws DAOException
	 * @date 2010-5-19
	 */
	protected boolean isExistByMsg(MsgVO msgVO) throws BusinessException {
		String pk_bill_src = msgVO.getSrc_billid();
		String pk_org = msgVO.getPk_org();
		String sql = " select top 1 '1' from fa_reduce where dr = 0 and pk_bill_src = ? and pk_org = ? ";
		SQLParameter params = new SQLParameter();
		params.addParam(pk_bill_src);
		params.addParam(pk_org);

		return ((Boolean) new DBAccessUtil().executeQuery(sql, params, new BooleanProcessor())).booleanValue();
	}

	/**
	 * ڵ˲¼ٺ󣬻ҵ˲¼˲ݣҪδٵ˲з¿Ƭ־
	 *
	 * @param billVO
	 * @param isDelete Ƿɾ
	 * @throws BusinessException
	 * @date 2010-5-17
	 */
	private void updateCardLog(String pk_accbook, String bill_code, String bill_type, Integer bill_status,
			String[] pk_cards) throws BusinessException {

		// Map<pk_accbook,List<pk_card>>ͬ˲ĿƬŪһĿΪ˰˲з
		Map<String, List<String>> accbookToCardMap = new HashMap<String, List<String>>();
		// еĿƬ
		// ҵ˲
		if (AccbookManager.isBizAccbook(pk_accbook)) {
			// Map<pk_accbook,List<pk_card>>Ƭûбٵ˲
			accbookToCardMap = AMProxy.lookup(IAssetService.class).queryNotReducedAccbookToCardMap(pk_cards);
		} else {
			// ֻһ˲и
			accbookToCardMap.put(pk_accbook, Arrays.asList(pk_cards));
		}

		// ˲ԿƬݺŽи
		for (Map.Entry<String, List<String>> entry : accbookToCardMap.entrySet()) {
			getLogService().updateLog(entry.getKey(), CollectionUtils.toArray(entry.getValue()), bill_code, bill_type,
					bill_status);
		}
	}

	/**
	 * ѯепƬPK
	 *
	 * @param parentPK
	 * @param pk_accbook
	 * @return
	 * @throws DAOException
	 * @date 2010-5-17
	 */
	@SuppressWarnings("unchecked")
	private String[] queryBodyCardId(String parentPK, String pk_accbook) throws DAOException {
		String sql = "select pk_card from fa_reduce_b where dr= 0 and pk_reduce = '" + parentPK + "' and pk_accbook = '"
				+ AccbookManager.getValidAccbook(pk_accbook) + "'";
		Set<String> set = (Set<String>) new DBAccessUtil().executeQuery(sql, new ColumnSetProcessor<String>());
		return CollectionUtils.toArray(set);
	}

	/**
	 * ¼صVO޸ĺ󣬺ܶʱҪڴǰ¼
	 *
	 * @param reduceVO
	 * @return
	 * @throws BusinessException
	 * @date 2010-5-26
	 */
	protected ReduceVO reloadReduceVO(String pk_reduce) throws BusinessException {
		// Ȳѯͷ
		ReduceVO billVO = ArrayUtils.getFirstElem(queryReduceVOByPKs(new String[] { pk_reduce }));

		if (billVO == null) {
			return null;
		}

		// ͷ˲
		String pk_accbook = (String) billVO.getParentVO().getAttributeValue(CommonKeyConst.pk_accbook);

		// ټر
		billVO.setChildrenVO(queryReduceBodyVOs(pk_reduce, pk_accbook));

		return billVO;
	}

	/**
	 * ¼ؼٵ ҪĹܡ
	 * <p>
	 * <b>˵</b>
	 * 
	 * @param primaryKeys ٵ
	 * @return
	 * @throws BusinessException
	 *                           <p>
	 * @author weizq
	 * @time 2010-12-23 04:51:03
	 */
	public ReduceVO[] reloadReduceVOs(String[] primaryKeys) throws BusinessException {
		List<ReduceVO> reduceVOs = new ArrayList<ReduceVO>();
		for (String pk : primaryKeys) {
			ReduceVO billVO = reloadReduceVO(pk);
			if (billVO == null) {
				continue;
			}
			reduceVOs.add(billVO);
		}

		return reduceVOs.toArray(new ReduceVO[0]);
	}

	protected ReduceVO pushSaveReduceVO(ReduceVO billVO) throws BusinessException {
		// 
		dealMultiCurrency(billVO);

		ReduceVO[] retReduceVOs = pushSaveBillVO(billVO);
		// ֻȡһ
		ReduceVO reduceVO = ArrayUtils.getFirstElem(retReduceVOs);

		// ʹfinally:Ϊ汨ˣǰ̨Ȼڱ༭״̬Ӧȡť  ɹ˽
		releasePKCardLock(billVO);

		return reduceVO;
	}

	/**
	 * ж۾Ƶ
	 *
	 * @param billVO
	 * @throws BusinessException
	 * @date 2010-7-5
	 */
	private void checkAfterDapMade(ReduceVO billVO) throws BusinessException {
		ReduceHeadVO headVO = (ReduceHeadVO) billVO.getParentVO();
		ReduceBodyVO[] bodyVOs = (ReduceBodyVO[]) billVO.getChildrenVO();

		if (ArrayUtils.isEmpty(bodyVOs))
			return;

		String pk_org = headVO.getPk_org();
		String pk_accbook = headVO.getPk_accbook();
		String pk_group = headVO.getPk_group();
		String[] pk_cards = VOManager.getAttributeValueArray(bodyVOs, CommonKeyConst.pk_card);

		checkAfterDapMade(pk_group, pk_org, pk_accbook, pk_cards);
	}

	/**
	 * ֤۾ƵǷϷ
	 *
	 * @param pk_org
	 * @param pk_accbook
	 * @param pk_cards
	 * @throws BusinessException
	 * @date 2010-7-13
	 */
	private void checkAfterDapMade(String pk_group, String pk_org, String pk_accbook, String... pk_cards)
			throws BusinessException {

		Map<String, List<String>> accbookCardIdsMap = null;

		if (AccbookManager.isBizAccbook(pk_accbook)) {
			accbookCardIdsMap = AMProxy.lookup(IAssetService.class).queryNotReducedAccbookToCardMap(pk_cards);
		} else {
			accbookCardIdsMap = new HashMap<String, List<String>>();
			accbookCardIdsMap.put(pk_accbook, Arrays.asList(pk_cards));
		}

		DepmethodVO[] methodVOs = AMProxy.lookup(IDepmethodService.class).queryAllDepmethods(pk_group);
		// ۾ɷMap<pk_depmethod,DepmethodVO>
		Map<String, DepmethodVO> depmethodMap = MapUtils.toMap(methodVOs);

		// ǷѾ
		if (!ModuleInfoQuery.isFIPEnabled()) {
			return;
		}

		for (Map.Entry<String, List<String>> entry : accbookCardIdsMap.entrySet()) {
			StringBuilder errbuilder = new StringBuilder();

			String tempAccbook = entry.getKey();
			AccperiodVO periodVO = AMProxy.lookup(ICloseBookService.class).queryMinUnClosebookPeriod(pk_org,
					tempAccbook);
			// ѾƵ
			if (FipManager.isFipMakeVoucher(pk_org, periodVO.getAccyear(), periodVO.getPeriod(), tempAccbook)
					.booleanValue()) {

				List<String> pk_cardList = entry.getValue();
				if (null == pk_cardList || pk_cardList.size() == 0) {
					return;
				}
				String[] tempCardIds = CollectionUtils.toArray(pk_cardList);

				Map<String, AssetVO> assetMap = AMProxy.lookup(IAssetService.class).queryAssetVO(pk_accbook,
						tempCardIds);
				// ʲPK
				String[] pk_categorys = VOManager.getAttributeValueArray(CollectionUtils.toArray(assetMap.values()),
						AssetVO.PK_CATEGORY);

				if (StringUtils.isEmpty(pk_accbook) || null == pk_categorys || pk_categorys.length == 0) {
					return;
				}
				// ʲĳ˲е۾Map<pk_category,Integer>
				Map<String, Integer> accbookDepMap = AMProxy.lookup(IAccbookInfoService.class)
						.queryDepmethodattr(pk_org, pk_categorys, pk_accbook);

				for (Map.Entry<String, AssetVO> assetEntry : assetMap.entrySet()) {
					AssetVO assetVO = assetEntry.getValue();
					String pk_category = assetVO.getPk_category();
					DepmethodVO depmethodVO = depmethodMap.get(assetVO.getPk_depmethod());

					String card_code = assetVO.getCard_code();
					boolean isNewAsset = assetVO.getNewasset_flag().intValue() == AssetUseConst.isNew;
					String depmethod_code = depmethodVO.getDepmethod_code();
					Integer depAttr = accbookDepMap.get(pk_category);
					String errMsg = DepChecker.checkCardWhenReduceAfterDAPMake(card_code, isNewAsset, depmethod_code,
							depAttr);
					errbuilder.append(errMsg);
				}
			}

			if (errbuilder.length() > 0) {
				ExceptionUtils.asBusinessException(errbuilder.toString());
			}
		}

	}

	/**
	 * ־ӿ
	 *
	 * @return
	 */
	private ILogService getLogService() {
		return AMProxy.lookup(ILogService.class);
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see nc.itf.fa.prv.IReduce#queryReduceVOByPk(java.lang.String)
	 */
	@Override
	public ReduceVO[] queryReduceVOByPk(String pk) throws BusinessException {
		ReduceVO billVO = reloadReduceVO(pk);
		return new ReduceVO[] { billVO };
	}

	/**
	 * 
	 * Ϊ˼Ӵô˷Ӻ̨
	 * 
	 * @return
	 * @throws BusinessException
	 * @return
	 */
	@SuppressWarnings("unchecked")
	public Map fetchMsgDate(LoginContext context, String trans_type, String bill_code, UFDate businessDate, MsgVO msgVO)
			throws BusinessException {

		// 洢MAP
		Map dataMap = new HashMap();

		msgVO.setDest_bill_type(BillTypeConst_FA.REDUCE);

		// ϢĲ֯
		String pk_org = msgVO.getPk_org();

		// MsgVOõٵVO
		// 쳣Ϊп˲ٲϢûȻڱ˲٣ȻٴϢ½հס
		// ڴ˸ʾ
		ReduceVO reduceVO = this.queryReduceVOFromPAM(msgVO);

		ReduceHeadVO headVO = (ReduceHeadVO) reduceVO.getParentVO();

		ReduceBodyVO[] bodyVOs = (ReduceBodyVO[]) reduceVO.getChildrenVO();

		String pk_org_v = OrgUtils.getCurVidByPkOrg(pk_org);

		// ȡʲñͷĲ֯
		// VO
		String sourcePk_org = headVO.getPk_org();

		// ֯λ
		// ˴֯ӦӦʲõݱͷĲ֯
		if (StringUtils.isEmpty(sourcePk_org)) {
			// ûVOлãȡϢе֯
			sourcePk_org = msgVO.getPk_org();
		}

		// ñ忨Ƭ
		String[] pk_cards = VOManager.getAttributeValueArray(bodyVOs, ReduceBodyVO.PK_CARD);
		pk_cards = ArrayUtils.removeNullElements(pk_cards);
		if (ArrayUtils.isEmpty(pk_cards)) {
			return dataMap;
			// ExceptionUtils.asBusinessException(nc.vo.ml.NCLangRes4VoTransl.getNCLangRes().getStrByID("reduce_0","02012015-0004")/*@res
			// "ûĿƬȨ  Ƭɾ!"*/);
		}

		// עͷ
		// ҵ˲
		// ˵ʵﴫ
		if (StringUtils.isNotEmpty(msgVO.getSrc_bill_type())) {
			headVO.setPk_accbook(FlagConsts.FLAG_NULL);
		}
		// 
		headVO.setTransi_type(trans_type);
		// ԭݺţʵĵݺ
		headVO.setPk_bill_src(msgVO.getSrc_billid());
		// PK
		headVO.setPk_group(context.getPk_group());
		// ֯
		headVO.setPk_org(msgVO.getPk_org());
		// ֯汾
		headVO.setPk_org_v(pk_org_v);
		// ҵ==== ȡǰ̨ҵ
		headVO.setBusiness_date(businessDate);
		// VO
		headVO.setStatus(2);
		// 
		headVO.setBill_type(BillTypeConst.REDUCE);
		// ״̬
		if (StringUtils.isNotEmpty(msgVO.getSrc_bill_type())) {
			headVO.setBill_status(0);
		}
		// Դ
		headVO.setBill_type_src(msgVO.getSrc_bill_type());
		// ֯˲
		String pk_accbook_main = AccbookManager.queryMainAccbookIDByOrg(pk_org);
		// ñı
		String bodyoppcurrtype = CurrencyManager.getLocalCurrencyPK(pk_org);
		// ֯λ
		// ˴֯ӦӦʲõݱͷĲ֯
		String oppcurrtype = CurrencyManager.getLocalCurrencyPK(sourcePk_org);

		// initDatąͣûл
		context.setInitData(null);
		// ֯
		context.setPk_org(msgVO.getPk_org());

		// ѯ˲ĿƬ
		AssetVO[] assetVOs = AMProxy.lookup(IAssetService.class).queryMainAssetVOByPks(context, pk_cards);
		if (ArrayUtils.isEmpty(assetVOs)) {
			return dataMap;
			// ExceptionUtils.asBusinessException(nc.vo.ml.NCLangRes4VoTransl.getNCLangRes().getStrByID("reduce_0","02012015-0005")/*@res
			// "ûĿƬȨ  Ƭɾ !"*/);
		}

		// ɼٵ
		ReduceBodyVO[] itemVOs = ReduceVOGenerator.generateReduceBodyVOByAssetVO(assetVOs, true,
				headVO.getBusiness_date());
		// Ƭɵļٵ飬תΪMap<pk_card, ReduceBodyVO>ʽ
		Map<String, ReduceBodyVO> bodyMap = MapUtils.toMap(itemVOs, ReduceBodyVO.PK_CARD);

		// ÿƬɵļٱ  VOı壬ֻnullΪ0ֵ䡣

		for (ReduceBodyVO bvo : bodyVOs) {
			for (String attr : bvo.getAttributeNames()) {
				Object value = bvo.getAttributeValue(attr);

				if (value == null) {
					// nullֵÿƬɵļٵֵ
					bvo.setAttributeValue(attr, bodyMap.get(bvo.getPk_card()).getAttributeValue(attr));
				} else {
					// 0ֵÿƬɵļٵֵ
					if (value instanceof UFDouble && UFDoubleUtils.isEqual((UFDouble) value, UFDouble.ZERO_DBL)) {
						bvo.setAttributeValue(attr, bodyMap.get(bvo.getPk_card()).getAttributeValue(attr));
					}
				}
			}
			// 
			bvo.setPk_currency(bodyoppcurrtype);
			// ˲--þ
			bvo.setPk_accbook_scale(pk_accbook_main);

			bvo.setStatus(2);
		}

		headVO.setPk_accbook_scale(pk_accbook_main);

		headVO.setPk_currency(bodyoppcurrtype);

		// ģ۾(ֻʾ˲Ϣ ˲˴)
		dealWithSimulatedep(context, headVO, bodyVOs, assetVOs);

		// , 
		dealCurrencyRate(headVO, bodyVOs, assetVOs, oppcurrtype);

		// õݱ
		// if(StringUtils.isEmpty(bill_code)){
		//
		// // ȡݺŹ
		// IBillcodeManage billCodeManager =
		// AMProxy.lookup(IBillcodeManage.class);
		//
		// // ȡݺŹ
		// // ȡµĵݺ
		// bill_code =
		// billCodeManager.getPreBillCode_RequiresNew(BillTypeConst.REDUCE,
		// context.getPk_group(), msgVO.getPk_org());
		//
		// }

		// reduceVO.getParentVO().setAttributeValue(ReduceHeadVO.BILL_CODE,
		// bill_code);

		// ݣǰ̨
		dataMap.put(ReduceMsgConst.reduceVOObj, reduceVO);
		dataMap.put(ReduceMsgConst.pk_cards, pk_cards);
		dataMap.put(ReduceMsgConst.assetVOs, assetVOs);

		return dataMap;
	}

	/**
	 * , 
	 * <p>
	 * <b>examples:</b>
	 * <p>
	 * ʹʾ
	 * <p>
	 * <b>˵</b>
	 * 
	 * @param headVO
	 * @param bodyVOs
	 *                <p>
	 * @author weizq
	 * @param assetVOs
	 * @throws BusinessException
	 * @time 2011-7-19 03:41:13
	 */
	private void dealCurrencyRate(ReduceHeadVO headVO, ReduceBodyVO[] bodyVOs, AssetVO[] assetVOs, String oppcurrtype)
			throws BusinessException {
		// <pk_card, AssetVO> mapʽ洢
		Map<String, AssetVO> cardMaps = new HashMap<String, AssetVO>();
		for (AssetVO vo : assetVOs) {
			cardMaps.put(vo.getPk_card(), vo);
		}

		for (ReduceBodyVO bodyVO : bodyVOs) {
			// 
			UFDouble purgefee = bodyVO.getPurgefee();
			// 
			UFDouble purgerevenue = bodyVO.getPurgerevenue();

			// ˲
			String pk_accbook = cardMaps.get(bodyVO.getPk_card()).getPk_accbook();
			// 
			String pk_currency = oppcurrtype;// cardMaps.get(bodyVO.getPk_card()).getPk_currency();
			// ҵ
			UFDate business_date = headVO.getBusiness_date();
			// 
			// 
			UFDouble purgefeeByCurrnecy = CurrencyRateManager.getAccbookAmountByOpp(pk_accbook, pk_currency, purgefee,
					business_date);
			// 
			UFDouble purgerevenueByCurrnecy = CurrencyRateManager.getAccbookAmountByOpp(pk_accbook, pk_currency,
					purgerevenue, business_date);

			// ֵֵ
			bodyVO.setPurgefee(purgefeeByCurrnecy);
			bodyVO.setPurgerevenue(purgerevenueByCurrnecy);

			// ִ
			CurrencyRateManager.setLocalMoneyByAccbook(bodyVO,
					new String[] { ReduceBodyVO.PURGEFEE, ReduceBodyVO.PURGEREVENUE }, pk_accbook,
					headVO.getBusiness_date());
		}
	}

	/**
	 *
	 * ģ۾(ֻ˲Ϣ)
	 * <p>
	 * <b>examples:</b> <b>˵</b>
	 * 
	 * @param context
	 * @param itemVOs
	 * @param assetVOs
	 *                 <p>
	 * @author weizq
	 * @throws BusinessException
	 * @time 2010-12-14 07:18:19
	 */
	private void dealWithSimulatedep(LoginContext context, ReduceHeadVO headVO, ReduceBodyVO[] reduceBodyVOs,
			AssetVO[] mainAssetVOs) throws BusinessException {
		ReduceSimulateManager simulateDepFactory = new ReduceSimulateManager();

		String pk_org = context.getPk_org();
		String pk_group = context.getPk_group();
		// ˲PK
		String pk_accbook = (String) ArrayUtils
				.getFirstElem(VOManager.getAttributeValueArray(mainAssetVOs, AssetFieldConst.PK_ACCBOOK));

		// ٿƬ
		String[] pk_cards = VOManager.getAttributeValueArray(reduceBodyVOs, AssetFieldConst.PK_CARD);

		// ۾
		simulateDepFactory.procSimulateDep(pk_cards, pk_group, pk_org, pk_accbook, headVO.getBusiness_date(),
				UFBoolean.FALSE);

		// ģ۾
		for (ReduceBodyVO bodyVO : reduceBodyVOs) {
			String reducePk_card = bodyVO.getPk_card();

			// ۼ۾
			UFDouble accddep = simulateDepFactory.getSimulateAccudepMap().get(reducePk_card);

			// ģ۾
			// UFDouble simulateDep =
			// simulateDepFactory.getSimulateAccudepMap().get(reducePk_card);
			UFDouble simulateDep = simulateDepFactory.getSimulateDepamoutMap().get(reducePk_card);

			// ۼ۾ = ۼ۾ + ģ۾
			// UFDouble red_accddep = UFDoubleUtils.add(accddep, simulateDep);
			// ۼ۾ = ۼ۾ + ģ۾
			UFDouble red_accddep = accddep;

			// ֵ
			UFDouble netvalue = UFDoubleUtils.sub(bodyVO.getRed_localoriginvalue(), accddep);

			// 
			UFDouble netrating = UFDoubleUtils.sub(netvalue, bodyVO.getRed_predevaluate());

			// עֵ
			bodyVO.setAccudep(accddep);
			bodyVO.setSimulatedep(simulateDep);
			bodyVO.setRed_accudep(red_accddep);
			bodyVO.setRed_netvalue(netvalue);
			bodyVO.setRed_netrating(netrating);
		}

	}

	/**
	 * 
	 * ԴͺԴPKѯٵ
	 * 
	 * @param bill_type_src
	 * @param pk_bill_src
	 * @throws BusinessException
	 * @return ReduceVO
	 */
	public ReduceVO queryReduceVOByOtherBill(String bill_type_src, String pk_bill_src, String pk_accbook)
			throws BusinessException {

		// ԴͺԴPKѯSQL
		String sql = "bill_type_src = '" + bill_type_src + "' and pk_bill_src = '" + pk_bill_src + "' and dr = 0";

		// ѯʵɵļٵ
		ReduceVO[] reduceVO = queryReduceVOByHeadCond(sql, false);

		// õһ
		ReduceVO billVO = ArrayUtils.getFirstElem(reduceVO);

		if (billVO == null) {
			return null;
		}

		// ͷ˲
		// String pk_accbook = (String)
		// billVO.getParentVO().getAttributeValue(CommonKeyConst.pk_accbook);
		// 
		String pk_reduce = billVO.getPrimaryKey();

		if (AccbookManager.isBizAccbook(pk_accbook)) {
			pk_accbook = FlagConsts.FLAG_NULL;
		}

		// PKѯݣѯN/A
		String whereSql = " dr = 0 and pk_reduce = '" + pk_reduce + "' ";

		// ҪѯƵļٵҪж
		if (StringUtils.isNotEmpty(pk_accbook)) {
			whereSql += " and pk_accbook = '" + pk_accbook + "'";
		}

		// ѯٱ
		ReduceBodyVO[] bodyVOs = getReduceBodyVOs(pk_accbook, whereSql);

		// ټر
		billVO.setChildrenVO(bodyVOs);

		return billVO;
	}

}