package nc.itf.fa.servlet;

import java.io.IOException;
import java.util.HashSet;
import java.util.Iterator;
import java.util.Map.Entry;
import java.util.Set;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import com.fasterxml.jackson.core.JsonParseException;
import com.fasterxml.jackson.core.JsonProcessingException;
import com.fasterxml.jackson.databind.DeserializationFeature;
import com.fasterxml.jackson.databind.JsonMappingException;
import com.fasterxml.jackson.databind.JsonNode;
import com.fasterxml.jackson.databind.ObjectMapper;
import com.fasterxml.jackson.databind.node.ObjectNode;

import nc.bs.dao.BaseDAO;
import nc.bs.dao.DAOException;
import nc.bs.framework.adaptor.IHttpServletAdaptor;
import nc.bs.framework.common.NCLocator;
import nc.bs.framework.comn.NetStreamContext;
import nc.bs.framework.server.ISecurityTokenCallback;
import nc.bs.hz.utils.BillInfoQueryUtil;
import nc.bs.hz.utils.SafeObject;
import nc.bs.hz.utils.SendUtil;
import nc.bs.logging.Logger;
import nc.cmp.utils.BillcodeGenerater;
import nc.itf.fa.byzlog.IbyzLogRcord;
import nc.itf.uap.IUAPQueryBS;
import nc.itf.uap.pf.IPFBusiAction;
import nc.jdbc.framework.SQLParameter;
import nc.jdbc.framework.processor.ColumnProcessor;
import nc.util.fa.httputil.HttpCommnUtil;
import nc.vo.arap.receivable.AggReceivableBillVO;
import nc.vo.arap.receivable.ReceivableBillItemVO;
import nc.vo.arap.receivable.ReceivableBillVO;
import nc.vo.fa.byzLogVO.ByzLogRcordVO;
import nc.vo.pub.BusinessException;
import nc.vo.pub.lang.UFBoolean;
import nc.vo.pub.lang.UFDate;
import nc.vo.pub.lang.UFDateTime;
import nc.vo.pub.lang.UFDouble;
import nccloud.bs.pub.pf.CloudPfUtil;
import uap.json.JSONObject;

public class ByzSysArapReciServlet implements IHttpServletAdaptor {

	// ȡݿ
	private BaseDAO baseDAO;

	// ܿյֶ
	private Set<String> filter = new HashSet<String>(0);

	// Jasksonmapper
	private ObjectMapper mapper = new ObjectMapper();

	private BaseDAO getBaseDAO() {
		if (baseDAO == null) {
			baseDAO = new BaseDAO();
		}
		return baseDAO;
	}

	@Override
	public void doAction(HttpServletRequest req, HttpServletResponse resp) throws ServletException, IOException {
		// ̨ģû¼
		ISecurityTokenCallback tc = NCLocator.getInstance().lookup(ISecurityTokenCallback.class);
		  byte[] token = tc.token("__system".getBytes(), "NC".getBytes());
		  NetStreamContext.setToken(token);
//		NCLocator.getInstance().lookup(ISecurityTokenCallback.class).token("NCSystem".getBytes(), "pfxx".getBytes());
		// óʼ
		// LoginContext context = new LoginContext();
		// context.setPk_group(InvocationInfoProxy.getInstance().getGroupId());
		// context.setPk_loginUser(InvocationInfoProxy.getInstance().getUserId());
		ObjectNode returnJson = mapper.createObjectNode();
		String src_code = null;
		ObjectNode jsonNode = (ObjectNode) mapper.readTree(HttpCommnUtil.requestJson(req));
		try {
			JSONObject jsonObject = new JSONObject(jsonNode.toString());
			JSONObject jsonohead = jsonObject.getJSONObject("data").getJSONObject("head");
			BillInfoQueryUtil.initEnvironment("0001H810000000000HS2", new UFDate(jsonohead.getString("billdate")));
			BillInfoQueryUtil.initSysBilltypeCache(new String[] { "F0" });
			// Ĭϵ½:ȡҪ½token
//			IFwLogin loginService = NCLocator.getInstance().lookup(IFwLogin.class);
//			String user = NCLocator.getInstance().lookup(ISysInitDAO.class).getSysInitTempVO("loginuser")
//					.getDefaultvalue();
//			String password = NCLocator.getInstance().lookup(ISysInitDAO.class).getSysInitTempVO("loginpass")
//					.getDefaultvalue();
//			byte[] token = loginService.login(user, password, null);
//			NetStreamContext.setToken(token);
			// JSONObject.parseObject(Base64Util.decode(json.getString("data")));
			// Base64data
			JsonNode data = mapper.readTree(mapper.writeValueAsString(jsonNode.get("data")));
			// 滻ԭܵdata
			jsonNode.replace("data", data);
			// Ƿпֵ
			checkItem(jsonNode);
			String head = mapper.writeValueAsString(jsonNode.findValue("head"));
			JsonNode bodys = jsonNode.findValue("bodys");
			int len = bodys.size();
			// Ӧյͷ
			ReceivableBillVO billVO = setReceivableBillVO(head);
			// Ӧյ
			ReceivableBillItemVO[] itemVOs = new ReceivableBillItemVO[len];
			for (int i = 0; i < len; i++) {
				String body = mapper.writeValueAsString(bodys.get(i));
				itemVOs[i] = setReceivableBillItemVO(billVO, body);
			}
			// װۺVO
			AggReceivableBillVO aggvo = new AggReceivableBillVO();
			aggvo.setParentVO(billVO);
			aggvo.setChildrenVO(itemVOs);
			IPFBusiAction ipf = NCLocator.getInstance().lookup(IPFBusiAction.class);
			// ִб涯
			ipf.processAction("SAVE", "F0", null, aggvo, null, null);
			// жǷ
			//modefy by djy 20220305 ĲҪ̬
//			if (CloudPfUtil.hasApproveflowDef("F0-Cxx-W63", aggvo)) {
//				// ִύ
//				ipf.processAction("COMMIT", "F0", null, aggvo, null, null);
//			} else {
				// ִ
//				ipf.processAction("APPROVE", "F0", null, aggvo, null, null);
//			}

			// صݱ
			src_code = billVO.getDef57();
			returnJson.put("billno", billVO.getBillno());
			returnJson.put("billpk", billVO.getPrimaryKey());
			returnJson.put("guid", src_code);
			returnJson.put("message", "̶ʲӦյɹ");
			returnJson.put("status", 1);
		} catch (Exception e) {
			e.printStackTrace();
			// شϢ
			returnJson.put("message", e.getMessage());
			returnJson.put("status", 0);
		} finally {
			String result = mapper.writeValueAsString(returnJson);
			HttpCommnUtil.responseWriter(resp, result);
			IbyzLogRcord ibyzLogRcord = (IbyzLogRcord) NCLocator.getInstance().lookup(IbyzLogRcord.class);
			ByzLogRcordVO byzLogRcordVO = new ByzLogRcordVO();
			byzLogRcordVO.setVbillcode(src_code);
			byzLogRcordVO.setItf_type("Ӧյ浽NC");
			byzLogRcordVO.setItfclass(this.getClass().toString());			
			byzLogRcordVO.setNcctobyzresult(SendUtil.unicodeToString(result));
			byzLogRcordVO.setByztonccparam(SendUtil.unicodeToString(mapper.writeValueAsString(jsonNode)));
			// byzLogRcordVO.setItfaddress(arcip);
			try {
				ibyzLogRcord.RcordLogBYZ__RequiresNew(byzLogRcordVO);
			} catch (BusinessException e) {
				Logger.error(e.getMessage(), e);
				Logger.error("־ʧܣnc.itf.fa.byzlog.IbyzLogRcord");
			}
		}
	}

	//ѯҵ񳡾
	private String getYwcj(String code) throws BusinessException{
		String pk_defoc="";
		String sql = "select pk_defdoc from bd_defdoc where pk_defdoclist=(select pk_defdoclist from bd_defdoclist where code='YWCJ' and nvl(dr,0)=0) and nvl(dr,0)=0  and enablestate=2 "
				+ "and code='" + code + "'";
		pk_defoc=(String) NCLocator.getInstance().lookup(IUAPQueryBS.class).executeQuery(sql, new ColumnProcessor());
		return pk_defoc;
	}
	
	/**
	 * ѯ˰
	 * 
	 * @param code
	 * @return
	 * @throws DAOException
	 */
	private String getPk_taxcode(String code) throws BusinessException {
		String sql = "SELECT PK_TAXCODE FROM BD_TAXCODE WHERE CODE = ?";
		String result = getColumn(sql, code);
		if (result == null) {
			throw new BusinessException("ûҵ˰(taxcodeid),:" + code);
		}
		return result;
	}

	/**
	 * ѯͻ
	 * 
	 * @param code
	 * @return
	 * @throws BusinessException
	 */
	private String getPk_customer(String code) throws BusinessException {
		String sql = "SELECT PK_CUSTOMER FROM BD_CUSTOMER WHERE CODE = ?";
		String result = getColumn(sql, code);
		if (result == null) {
			throw new BusinessException("ûҵÿͻ(customer),:" + code);
		}
		return result;
	}

	/**
	 * ѯ
	 * 
	 * @param code 
	 * @return 
	 * @throws DAOException
	 */
	private String getPk_currtype(String code) throws BusinessException {
		String sql = "SELECT PK_CURRTYPE FROM BD_CURRTYPE WHERE NAME = ? AND NVL(DR,0) = 0";
		String result = getColumn(sql, code);
		if (result == null) {
			throw new BusinessException("ûҵñ(pk_currtype),:" + code);
		}
		return result;
	}

	/**
	 * ѯ
	 * 
	 * @param code ͱ
	 * @return 
	 * @throws DAOException
	 */
	private String getPk_tradetypeid(String code) throws BusinessException {
		String sql = "SELECT PK_BILLTYPEID FROM BD_BILLTYPE WHERE PK_BILLTYPECODE = ? AND NVL(DR,0) = 0";
		String result = getColumn(sql, code);
		if (result == null) {
			throw new BusinessException("ûҵõͱ(pk_billtypeid),:" + code);
		}
		return result;
	}

	/**
	 * ֯ѯ
	 * 
	 * @param code ֯PK
	 * @return
	 * @throws DAOException
	 */
	private String getPk_group(String pk) throws BusinessException {
		String sql = "SELECT PK_GROUP FROM ORG_ORGS WHERE PK_ORG = ? AND NVL(DR,0) = 0";
		String result = getColumn(sql, pk);
		if (result == null) {
			throw new BusinessException("ûҵò֯(pk_org),:" + pk);
		}
		return result;
	}

	/**
	 * ѯ֯
	 * 
	 * @param code ֯
	 * @return ֯
	 * @throws DAOException
	 */
	private String getPk_org(String pk) throws BusinessException {
		String sql = "SELECT PK_ORG FROM ORG_ORGS_V WHERE PK_VID = ? AND NVL(DR,0) = 0";
		String result = getColumn(sql, pk);
		if (result == null) {
			throw new BusinessException("ûҵò֯汾(pk_org_v),:" + pk);
		}
		return result;

	}

	/**
	 * ѯⲿƵ
	 * 
	 * @return
	 * @throws DAOException
	 */
	private String getCreator(String code) throws BusinessException {
		String sql = "SELECT CUSERID FROM SM_USER WHERE USER_CODE = ? AND NVL(DR,0) = 0";
		String result = getColumn(sql, code);
		if (result == null) {
			throw new BusinessException("ûҵƵ(billmaker),:" + code);
		}
		return result;
	}

	/**
	 * жϵݽΨһ
	 * 
	 * @param src_id
	 * @throws BusinessException
	 */
	private void selectOnlyID(String src_id) throws BusinessException {
		String sql = "SELECT DEF57 FROM AR_RECBILL WHERE DEF57 = ? AND NVL(DR,0) = 0";
		String result = getColumn(sql, src_id);
		if (result != null) {
			throw new BusinessException("Դݺ(def57)Ѵ,:" + src_id);
		}
	}

	/**
	 * Ӧյͷ
	 * 
	 * @return
	 * @throws IOException
	 * @throws JsonMappingException
	 * @throws JsonParseException
	 * @throws BusinessException
	 * @throws Exception
	 */
	private ReceivableBillVO setReceivableBillVO(String head)
			throws JsonParseException, JsonMappingException, IOException, BusinessException {
		mapper.configure(DeserializationFeature.FAIL_ON_UNKNOWN_PROPERTIES, false);
		ReceivableBillVO vo = mapper.readValue(head, ReceivableBillVO.class);
		// жϵݽΨһ
		selectOnlyID(vo.getDef57());
		// ֯汾
		// String pk_org_v = vo.getPk_org_v();
		// ֯
		// vo.setPk_org(getPk_org(pk_org_v));
		// 
		vo.setPk_group(getPk_group(vo.getPk_org()));
		// Ӧ
		vo.setPk_tradetype("F0-Cxx-W63");
		// Ӧid
		vo.setPk_tradetypeid(getPk_tradetypeid("F0-Cxx-W63"));
		// 
		vo.setPk_currtype(getPk_currtype(vo.getPk_currtype()));
		// ͻ
		vo.setCustomer(getPk_customer(vo.getCustomer()));
		// ״̬
		vo.setBillstatus(-1);
		// ״̬
		// vo.setApprovestatus(3);
		// Ƶ
		vo.setBillmaker(getCreator("ARC"));
		// 
		vo.setCreator(vo.getBillmaker());
		// ʱ
		vo.setCreationtime(new UFDateTime());
		// ڳ־
		vo.setIsinit(UFBoolean.FALSE);
		// ݴ
		vo.setBillclass("ys");
		// 
		vo.setPk_billtype("F0");
		// ״̬
		vo.setSaga_frozen(0);
		// ״̬
		vo.setSaga_status(0);
		vo.setRate(new UFDouble(1));
		// 
		vo.setObjtype(0);
		// ϵͳ
		vo.setSyscode(0);
		//ҵ񳡾
		if(vo.getDef80()!=null)
			vo.setDef80(getYwcj(vo.getDef80()));
		
		// Դϵͳ
		vo.setSrc_syscode(0);
		// ݺ
		String billcode = new BillcodeGenerater().getBillCode("F0", vo.getPk_group(), vo.getPk_org(), null, null);
		vo.setBillno(billcode);
		return vo;
	}

	/**
	 * Ӧյ
	 * 
	 * @return
	 * @throws BusinessException
	 * @throws IOException
	 * @throws JsonMappingException
	 * @throws JsonParseException
	 */
	private ReceivableBillItemVO setReceivableBillItemVO(ReceivableBillVO head, String body)
			throws BusinessException, JsonParseException, JsonMappingException, IOException {
		ReceivableBillItemVO vo = mapper.readValue(body, ReceivableBillItemVO.class);
		// 
		vo.setPk_group(head.getPk_group());
		// ֯
		vo.setPk_org(head.getPk_org());
		// ֯汾
		vo.setPk_org_v(head.getPk_org_v());
		// ͻ
		vo.setCustomer(getPk_customer(vo.getCustomer()));
		// ˰
		// vo.setTaxcodeid(getPk_taxcode(vo.getTaxcodeid()));
		// ݴ
		vo.setBillclass(head.getBillclass());
		// 
		vo.setBilldate(head.getBilldate());
		// 
		vo.setDirection(1);
		// 
		vo.setPk_billtype(head.getPk_billtype());
		// Ӧ
		vo.setPk_tradetype(head.getPk_tradetype());
		// Ӧid
		vo.setPk_tradetypeid(head.getPk_tradetypeid());
		// 
		vo.setObjtype(0);
		// 
		vo.setPk_currtype(head.getPk_currtype());
		// 
		vo.setLocal_money_de(vo.getMoney_de());
		// ݺ
		vo.setBillno(head.getBillno());
		vo.setRate(new UFDouble(1));
		return vo;
	}

	/**
	 * ֵͨòѯ
	 * 
	 * @param sql
	 * @param code
	 * @return
	 * @throws DAOException
	 */
	private String getColumn(String sql, String code) throws DAOException {
		SQLParameter parameter = new SQLParameter();
		parameter.addParam(code);
		return SafeObject.toString(getBaseDAO().executeQuery(sql, parameter, new ColumnProcessor()));
	}

	/**
	 * жJSONǷֵΪ
	 * 
	 * @param jsonObject
	 * @throws BusinessException
	 * @throws JsonProcessingException
	 */
	private void checkItem(JsonNode node) throws JsonProcessingException, BusinessException {
		// жǷһڵݹ
		if (node.isValueNode()) {
			return;
		}

		if (node.isObject()) {
			Iterator<Entry<String, JsonNode>> it = node.fields();
			while (it.hasNext()) {
				Entry<String, JsonNode> entry = it.next();
				if (entry.getValue().toString().equals("\"\"") || entry.getValue().isNull()) {
					throw new BusinessException(entry.getKey() + "ڻnull");
				}
				checkItem(entry.getValue());
			}
		}

		if (node.isArray()) {
			Iterator<JsonNode> it = node.iterator();
			while (it.hasNext()) {
				checkItem(it.next());
			}
		}
	}
}