package nc.util.fa.httputil;
import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.net.HttpURLConnection;
import java.net.URL;
import java.net.URLConnection;
import java.util.List;
import java.util.Map;
import nc.vo.pub.BusinessException;
import org.apache.commons.httpclient.NameValuePair;
import org.apache.commons.httpclient.methods.PostMethod;
import com.alibaba.fastjson.JSONObject;

public class BillHttpRequestUtil {
	
	/**
     * ָ URL POST
     * 
     * @param url
     *             URL
    
     * @return ԶԴӦ
	 * @throws BusinessException 
     */
    public static String sendPost(String postUrl, String postData) throws BusinessException {
        try {
            //POST
            URL url = new URL(postUrl);
            HttpURLConnection conn = (HttpURLConnection) url.openConnection();
            conn.setRequestMethod("POST");
            conn.setRequestProperty("Content-Type", "application/json");
            conn.setRequestProperty("Connection", "Keep-Alive");
            conn.setUseCaches(false);
            conn.setDoOutput(true);
            conn.setConnectTimeout(60000);
            conn.setReadTimeout(60000);
            conn.setRequestProperty("Content-Length", "" + postData.length());
            OutputStreamWriter out = new OutputStreamWriter(conn.getOutputStream(), "UTF-8");
            out.write(postData);
            out.flush();
            out.close();
            //ȡӦ״̬
            if (conn.getResponseCode() != HttpURLConnection.HTTP_OK) {
                throw new BusinessException("connect failed!");
            }
            //ȡӦ
            String line, result = "";
            BufferedReader in = new BufferedReader(new InputStreamReader(conn.getInputStream(), "utf-8"));
            while ((line = in.readLine()) != null) {
                result += line + "\n";
            }
            in.close();
            return result;
        } catch (IOException e) {
        	 e.printStackTrace(System.out);
        	 throw new BusinessException(e.getMessage());
        }
    }
	
    /**
     * ָURLGET
     * 
     * @param url
     *            URL
     * @param param
     *            Ӧ name1=value1&name2=value2 ʽ
     * @return URL ԶԴӦ
     */
    public static String sendGet(String url, String param) {
        String result = "";
        BufferedReader in = null;
        try {
            String urlNameString = url + "?" + param;
            URL realUrl = new URL(urlNameString);
            
            //ƹhttps֤У
            if("https".equalsIgnoreCase(realUrl.getProtocol())){
            	SslUtils.ignoreSsl();
            }
            // 򿪺URL֮
            URLConnection connection = realUrl.openConnection();
            // ͨõ
            connection.setRequestProperty("accept", "*/*");
            connection.setRequestProperty("connection", "Keep-Alive");
            connection.setRequestProperty("user-agent",
                    "Mozilla/4.0 (compatible; MSIE 6.0; Windows NT 5.1;SV1)");
            connection.setConnectTimeout(120000);
            connection.setReadTimeout(120000);
            // ʵʵ
            connection.connect();
            // ȡӦͷֶ
            Map<String, List<String>> map = connection.getHeaderFields();
            // еӦͷֶ
            for (String key : map.keySet()) {
                System.out.println(key + "--->" + map.get(key));
            }
            //  BufferedReaderȡURLӦ
            in = new BufferedReader(new InputStreamReader(
                    connection.getInputStream(),"UTF-8"));
            String line;
            while ((line = in.readLine()) != null) {
                result += line;
            }
        } catch (Exception e) {
            System.out.println("GET쳣" + e);
            e.printStackTrace();
        }
        // ʹfinallyر
        finally {
            try {
                if (in != null) {
                    in.close();
                }
            } catch (Exception e2) {
                e2.printStackTrace();
            }
        }
        return result;
    }
    
    /**
     * ָ URL  x-www-form-urlencoded ʽ POST
     * 
     * @param url
     *             URL
    
     * @return ԶԴӦ
     */
    public static String sendFormPost(String postUrl, JSONObject postData) {
    	
    	String result = "";
    	try {
    		    PostMethod postMethod = null;
    		    postMethod = new PostMethod(postUrl) ;
    		    postMethod.setRequestHeader("Content-Type", "application/x-www-form-urlencoded;charset=utf-8") ;
    		    //ãҪעľ߲ܴNULLҪַ
    		    NameValuePair[] data = {
    		            new NameValuePair("version",postData.getString("version")),
    		            new NameValuePair("appid",postData.getString("appid")),
    		            new NameValuePair("timestamp",postData.getString("timestamp")),
    		            new NameValuePair("sign",postData.getString("sign")),
    		            new NameValuePair("data",postData.getString("data")),
    		            new NameValuePair("format",postData.getString("format")),
    		            new NameValuePair("token",postData.getString("token"))
    		    };
    		    postMethod.setRequestBody(data);
    		    org.apache.commons.httpclient.HttpClient httpClient = new org.apache.commons.httpclient.HttpClient();
    		    httpClient.executeMethod(postMethod); // ִPOST
    		    result = postMethod.getResponseBodyAsString();
    		} catch (Exception e) {
    			e.printStackTrace();
    			result = "{\"code\":\"100\",\"msg\":\"NCýӿʧ: " + e.getMessage()+"\"}";
    		}
    	return result;
    }
    
    /**
     * ӴͷϢֵPOST
     * @param postUrl URLַ
     * @param postData jsonַ
     * @param HeaderMap ͷϢֵMap
     * @return
     * @author czj 202067 12:24:16
     */
    public static String sendPostByHeader(String postUrl, String postData, Map<String,String> HeaderMap) {
        try {
            //POST
            URL url = new URL(postUrl);
            HttpURLConnection conn = (HttpURLConnection) url.openConnection();
            conn.setRequestMethod("POST");
            conn.setRequestProperty("Content-Type", "application/json");
            conn.setRequestProperty("Connection", "Keep-Alive");
            
            //ͷϢֵ
            if(null!=HeaderMap && !HeaderMap.isEmpty()){
            	for (String key : HeaderMap.keySet()) {
                    conn.setRequestProperty(key, HeaderMap.get(key));
                }
            }
            
            conn.setUseCaches(false);
            conn.setDoOutput(true);
            conn.setConnectTimeout(60000);
            conn.setReadTimeout(60000);
            conn.setRequestProperty("Content-Length", "" + postData.length());
            OutputStreamWriter out = new OutputStreamWriter(conn.getOutputStream(), "UTF-8");
            out.write(postData);
            out.flush();
            out.close();
            //ȡӦ״̬
            if (conn.getResponseCode() != HttpURLConnection.HTTP_OK) {
                throw new RuntimeException("connect failed!");
            }
            //ȡӦ
            String line, result = "";
            BufferedReader in = new BufferedReader(new InputStreamReader(conn.getInputStream(), "utf-8"));
            while ((line = in.readLine()) != null) {
                result += line + "\n";
            }
            in.close();
            return result;
        } catch (IOException e) {
        	 e.printStackTrace(System.out);
        	 throw new RuntimeException(e.getMessage());
        }
    }
    
    /**
     * MDMϵͳרPOST
     * @param postUrl URLַ
     * @param postData jsonַ
     * @param HeaderMap ͷϢֵMap
     * @return
     * @author czj 20201229 14:22:57
     */
    public static String sendMDMPostByHeader(String postUrl, String postData, Map<String,String> HeaderMap) {
        try {
            //POST
            URL url = new URL(postUrl);
            HttpURLConnection conn = (HttpURLConnection) url.openConnection();
            conn.setRequestMethod("POST");
            conn.setRequestProperty("Content-Type", "application/json");
            conn.setRequestProperty("Connection", "Keep-Alive");
            
            //ͷϢֵ
            if(null!=HeaderMap && !HeaderMap.isEmpty()){
            	for (String key : HeaderMap.keySet()) {
                    conn.setRequestProperty(key, HeaderMap.get(key));
                }
            }
            
            conn.setUseCaches(false);
            conn.setDoOutput(true);
            conn.setConnectTimeout(9000000);
            conn.setReadTimeout(9000000);
            conn.setRequestProperty("Content-Length", "" + postData.length());
            OutputStreamWriter out = new OutputStreamWriter(conn.getOutputStream(), "UTF-8");
            out.write(postData);
            out.flush();
            out.close();
            //ȡӦ״̬
            if (conn.getResponseCode() != HttpURLConnection.HTTP_OK) {
                throw new RuntimeException("connect failed!");
            }
            //ȡӦ
            String line, result = "";
            BufferedReader in = new BufferedReader(new InputStreamReader(conn.getInputStream(), "utf-8"));
            while ((line = in.readLine()) != null) {
                result += line + "\n";
            }
            in.close();
            return result;
        } catch (IOException e) {
        	 e.printStackTrace(System.out);
        	 throw new RuntimeException(e.getMessage());
        }
    }

}