package nc.service.rest.base;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.io.PrintWriter;
import java.io.Serializable;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.Properties;
import javax.servlet.ServletException;
import javax.servlet.ServletInputStream;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import com.alibaba.fastjson.JSONObject;
import nc.bs.dao.BaseDAO;
import nc.bs.dao.DAOException;
import nc.bs.framework.adaptor.IHttpServletAdaptor;
import nc.bs.framework.common.InvocationInfoProxy;
import nc.bs.framework.common.NCLocator;
import nc.bs.framework.comn.NetStreamContext;
import nc.bs.framework.server.ISecurityTokenCallback;
import nc.bs.logging.Logger;
import nc.itf.uap.IUAPQueryBS;
import nc.jdbc.framework.processor.ColumnProcessor;
import nc.jdbc.framework.processor.MapListProcessor;
import nc.vo.pub.BusinessException;

/**
 * @Description: NC63NCCϵͳṩRestӿڹ
 * 
 * @date 2020-11-12
 * @version NCC2005
 */
@SuppressWarnings("restriction")
public abstract class NcToNccBaseRestService implements IHttpServletAdaptor, Serializable {

	private static final long serialVersionUID = 1L; 
	private BaseDAO dao = new BaseDAO();
	
	@Override
	public void doAction(HttpServletRequest request,
			HttpServletResponse response) throws ServletException, IOException {
		
		JSONObject jsonObj = null; // NCϵͳ͹jsonַ

		// ӿӦݣĿǰӦݱȽϼ򵥣Mapиݽṹʱٷװɶ
		Map<String, Object> result = new HashMap<String, Object>();
		result.put("success", "true"); // Ĭִֵгɹ

		try {
			// 1.ϵͳʼ
			initSystemParams("sysConfig.properties");
			
			// 2.ȡ
			jsonObj = getPostJsonValue(request);// ȡPostֵ
			SimpleDateFormat format = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss:SSS");
			String beginDateStr = format.format(new Date()); // ʼʱ
			Logger.info("ʱ䣺" + beginDateStr + "Json:" + jsonObj);

			// 3.EsbKey֤
			if (!checkEsbkey(request)) { // ֤ʧ
				String errorMsg = "EsbKeyȨ֤ʧ!EsbKey[" + request.getHeader("esbkey") + "]Ƿȷ";
				result.put("success", "false");
				result.put("message", errorMsg);
				businessErrorLog(request, jsonObj, errorMsg); // ҵ־¼Զ壩
				sendResponse(response, result); // Ӧͻ
				return;
			}

			// 4.Ӧҵ
			if ((null == jsonObj) || (jsonObj.toString().trim().length() == 0)) { // Postύֵ
				String errorMsg = "PostύJsonʽֵ!";
				result.put("success", "false");
				result.put("message", errorMsg);
				businessErrorLog(request, jsonObj, errorMsg); // ҵ־¼Զ壩
			} else {
				Logger.info(this.getClass().getName() + "ӿִ");
				exeBoforeLog(request, jsonObj); // ӿִǰ־¼
				Object obj = execute(jsonObj); // ҵ񷽷ִ
				result.put("data", obj);
				exeAfterLog(request, jsonObj); // ӿִк־¼Զ壩
				Logger.info(this.getClass().getName() + "ӿִн");
			}

		} catch (Exception e) {
			Logger.error("ӿִ쳣: " + e.getMessage());
			result.put("success", "false");
			result.put("message", "ӿִ쳣:" + e.getMessage());
			try {
				businessErrorLog(request, jsonObj, "ӿִ쳣:" + e.getMessage()); // ¼־
			} catch (Exception e1) {
				Logger.error("¼־ʧ " + e1.getMessage());
			}
		}
		sendResponse(response, result); // Ӧͻ
	}

	/**
	 * ʼϵͳ
	 * @throws IOException
	 * @throws BusinessException 
	 */
	public void initSystemParams(String configFileName) throws IOException, BusinessException {
		
		// ȡļ
		InputStream in = NcToNccBaseRestService.class.getResourceAsStream(configFileName);
		Properties props = new Properties();
		props.load(new InputStreamReader(in));
		
		InvocationInfoProxy proxy = InvocationInfoProxy.getInstance();
		proxy.setUserDataSource(props.getProperty("datasource")); // Դ
		proxy.setGroupId(props.getProperty("group_id"));
		proxy.setUserId(props.getProperty("user_id"));
		proxy.setUserCode(props.getProperty("user_code"));
		
		String groupSql = "SELECT pk_group FROM org_group where nvl(dr,0)=0"; 
		String pk_group = (String) this.dao.executeQuery(groupSql,new ColumnProcessor());
		proxy.setGroupId(pk_group);
		
		ISecurityTokenCallback tc = NCLocator.getInstance().lookup(ISecurityTokenCallback.class);
		String tokenParam1 = props.getProperty("token_param1");
		String tokenParam2 = props.getProperty("token_param2");
		byte[] token = tc.token(tokenParam1.getBytes(), tokenParam2.getBytes());
		NetStreamContext.setToken(token);
	}
	
	/**
	 * ֤ EsbKey
	 * @param request 
	 * @return true(֤ͨ) || false(֤ʧ)
	 */
	@SuppressWarnings("unchecked")
	private boolean checkEsbkey(HttpServletRequest request) throws BusinessException {
		String interfaceName = request.getPathInfo(); // ·
		String esbKey = request.getHeader("esbkey") == null ? "~" : request.getHeader("esbkey");
		if (interfaceName == null) {
			return false;
		}
		String sql = "select e.isstart,c.esbkey from bgy_esbinfo e left join bgy_certificate c on e.certificate = c.pk_code where "
				+ " e.interfacename = '" + interfaceName + "'";
		List<Map<String, String>> res = (List<Map<String, String>>) this.dao.executeQuery(sql, new MapListProcessor());
		if (res == null || res.size() != 1) {
			throw new BusinessException("ӿڰȫϢ");
		}
		String isStart = res.get(0).get("isstart");
		if (isStart == null || (!"Y".equals(isStart.trim()) && !"1".equals(isStart.trim()))) {
			throw new BusinessException("ӿڰȫδ");
		}
		String dbEsbKey = res.get(0).get("esbkey"); // ݿеEsbKey
		if (dbEsbKey != null && !"".equals(dbEsbKey.trim()) && !esbKey.equals(dbEsbKey.trim())) {
			throw new BusinessException("ӿ֤ʧܣEsbKeyǷȷ");
		}
		return true;
	}
	
	/**
	 * ȡPostύJson
	 * 
	 * @param request
	 * @return
	 * @throws IOException 
	 * @throws Exception
	 */
	private JSONObject getPostJsonValue(HttpServletRequest request)
			throws BusinessException, IOException {
		BufferedReader br = null;
		try {
			br = new BufferedReader(new InputStreamReader((ServletInputStream) request.getInputStream(), "UTF-8"));
			StringBuffer sb = new StringBuffer();
			String temp = null;
			while ((temp = br.readLine()) != null) {
				sb.append(temp);
			}
			if (sb.length() == 0) {
				return new JSONObject();
			}
			return JSONObject.parseObject(sb.toString());

		} catch (Exception e) {
			throw new BusinessException("Ĵ");

		} finally {
			if (br != null) {
				br.close();
			}
		}
	}
	
	/**
	 * ӦϢ
	 * @param response
	 * @param esb
	 */
	public <T> void sendResponse(HttpServletResponse response, T respdata) {
		String jsonData = JSONObject.toJSONString(respdata);
		Logger.info("ӿӦģ" +jsonData);
		PrintWriter out = null;
		try {
			response.setHeader("Content-type", "application/json;charset=UTF-8");
			out = new PrintWriter(new OutputStreamWriter(response.getOutputStream(), "UTF-8"));
			out.write(jsonData);
			out.flush();
		} catch (IOException e) {
			Logger.error(this.getClass().getName() + "ӿӦ̳" + e.getMessage());
		} finally {
			if (out != null) {
				out.close();
			}
		}
	}
	
	/**
	 * ӿִǰ־Զ壩
	 * ӿҪԶĴҵ־ʱд˷
	 * @param request
	 * @param json
	 * @throws Exception
	 */
	protected void exeBoforeLog(HttpServletRequest request, JSONObject json) throws Exception { }
	
	/**
	 * ҵ߼ִк
	 * @param json
	 * @return
	 * @throws Exception
	 */
	protected abstract Object execute(JSONObject json) throws Exception;
	
	/**
	 * ӿִгɹ־Զ壩
	 * ӿҪԶĴҵ־ʱд˷
	 * @param request
	 * @param json
	 * @throws Exception
	 */
	protected void exeAfterLog(HttpServletRequest request, JSONObject json) throws Exception { }
	
	/**
	 * ҵ־¼Զ壩
	 * ӿҵ־ҪԶ崦Ļд˷
	 * @param request
	 * @param json
	 * @param errorMsg
	 * @throws Exceptioin
	 */
	protected void businessErrorLog(HttpServletRequest request, JSONObject json, String errorMsg) throws Exception { }
	
}
