

package nc.bs.ia.bill.rule.real.pub;

import nc.vo.ia.bill.entity.real.AbstractRealBill;
import nc.vo.ia.bill.entity.real.AbstractRealHeadVO;
import nc.vo.ia.bill.entity.real.AbstractRealItemVO;
import nc.vo.ia.pub.data.FieldConst;
import nc.vo.ia.pub.util.IAScaleUtil;
import nc.vo.ia.pub.util.VOValueUtil;
import nc.vo.ml.NCLangRes4VoTransl;
import nc.vo.pub.lang.UFDouble;
import nc.vo.pubapp.pattern.exception.ExceptionUtils;
import nc.vo.pubapp.pattern.log.TimeLog;
import nc.vo.pubapp.pattern.pub.MathTool;
import nc.vo.pubapp.res.NCModule;
import nc.vo.pubapp.scale.ScaleUtils;

import nc.itf.scmpub.reference.uap.bd.accesor.CurrtypeAccessor;
import nc.itf.scmpub.reference.uap.bd.accesor.MeasdocAccessor;

import nc.bs.ia.bill.pub.BillMsgUtil;

import nc.impl.pubapp.pattern.rule.IRule;

/**
 * ݺϷУ(ʵʵ)
 * <ol>
 * <li>Уλ,λ뻻֮ĹϵǷȷ
 * <li>У鵥,,֮ĹϵǷȷ
 * <li>У鵥,,Ƿȷ
 * </ol>
 * 
 * @since 6.0
 * @version 2010-1-14 02:34:25
 * @author Ƥ֮
 */
public class RealPubDataValidityCheckRule<E extends AbstractRealBill>
    implements IRule<E> {
	
	private Boolean pass=true;

  @Override
  public void process(E[] bills) {
    TimeLog.logStart();
    this.checkBill(bills);
    TimeLog.info(NCLangRes4VoTransl.getNCLangRes().getStrByID("2014010_0",
        "02014010-0115")/* У鵥Ϣ */); /*-=notranslate=-*/
  }

  /**
   * @param bills
   */
  private void checkBill(E[] bills) {
    for (AbstractRealBill bill : bills) {
      AbstractRealItemVO[] items = bill.getChildrenVO();
      AbstractRealHeadVO head = bill.getParentVO();
      String csrcmodulecode = bill.getParentVO().getCsrcmodulecode();
      for (AbstractRealItemVO item : items) {
        // У鵥, , ľԼ֮ĹϵǷȷ
        this.checkData(item, head);
        // У
//        this.checkScales(item, head);
//        if("~".equals(head.getVdef15())||"".equals(head.getVdef15())) {
//        	pass = false;
//        }
//        if(pass) {
//        // Դɹڲģĵݲ۽ݹϵУ
//        if (!csrcmodulecode.equals(NCModule.PO.getSystemCode())
//            && !csrcmodulecode.equals(NCModule.TO.getSystemCode())) {
//          this.checkPriceNumMny(item, head);
//        }
//        this.checkNumAstNum(item, head);
//      }
      }
    }
  }

  private void checkData(AbstractRealItemVO item, AbstractRealHeadVO head) {
    UFDouble nprice = item.getNprice();
    UFDouble nastnum = item.getNastnum();
    String vchangerate = item.getVchangerate();
    String rowno = item.getCrowno();

    if (vchangerate != null && nastnum == null) {
      String msg =
          NCLangRes4VoTransl.getNCLangRes().getStrByID("2014010_0",
              "02014010-0097", null, new String[] {
                rowno
              })/* кΪ {0} ĵΪգܱ */;
      String billmsg = BillMsgUtil.getBillMessage(head, item);
      ExceptionUtils.wrappBusinessException(msg + billmsg);
    }

    if (nprice != null && nprice.compareTo(UFDouble.ZERO_DBL) < 0) {
      String msg =
          NCLangRes4VoTransl.getNCLangRes().getStrByID("2014010_0",
              "02014010-0098", null, new String[] {
                rowno
              })/* кΪ {0} ĵݵΪܱ */;
      String billmsg = BillMsgUtil.getBillMessage(head, item);
      ExceptionUtils.wrappBusinessException(msg + billmsg);
    }
  }

  private void checkNumAstNum(AbstractRealItemVO item, AbstractRealHeadVO head) {
    UFDouble nnum = VOValueUtil.getUFDouble(item, FieldConst.NNUM);
    UFDouble nastnum = VOValueUtil.getUFDouble(item, FieldConst.NASTNUM);
    String vchangerate = VOValueUtil.getString(item, FieldConst.VCHANGERATE);
    String rowno = item.getCrowno();
    String cunitid = item.getCunitid();
    String castunitid = VOValueUtil.getString(item, FieldConst.CASTUNITID);
    ScaleUtils scale = ScaleUtils.getScaleUtilAtBS();
    // ,,ϵж
    if (nastnum != null && nastnum.compareTo(UFDouble.ZERO_DBL) != 0
        && vchangerate != null) {
      UFDouble newnum = scale.adjustNumScale(nnum, cunitid);
      UFDouble newastnum = scale.adjustNumScale(nastnum, castunitid);
      String newHsl = scale.adjustHslScale(vchangerate);
      if (!(nnum.equals(newnum) || nastnum.equals(newastnum) || vchangerate
          .equals(newHsl))) {
        StringBuffer errmsg = new StringBuffer();
        errmsg.append(NCLangRes4VoTransl.getNCLangRes().getStrByID("2014010_0",
            "02014010-0116")/* ݳϢ£\n */);
        errmsg.append(NCLangRes4VoTransl.getNCLangRes().getStrByID("2014010_0",
            "02014010-0117", null, new String[] {
              MeasdocAccessor.getDocByPk(cunitid).getName().toString()
            })/* λ :{0}\n */);
        errmsg.append(NCLangRes4VoTransl.getNCLangRes().getStrByID("2014010_0",
            "02014010-0118", null, new String[] {
              nnum.toString()
            })/* :{0}\n */);
        errmsg.append(NCLangRes4VoTransl.getNCLangRes().getStrByID("2014010_0",
            "02014010-0119", null, new String[] {
              newnum.toString()
            })/* ϵͳ:{0}\n */);
        errmsg.append(NCLangRes4VoTransl.getNCLangRes().getStrByID("2014010_0",
            "02014010-0120", null, new String[] {
              MathTool.equals(nnum, newnum) ? "Y" : "N"
            })/* ߵĴСȽ -> {0}\n */);
        errmsg.append(NCLangRes4VoTransl.getNCLangRes().getStrByID("2014010_0",
            "02014010-0121", null, new String[] {
              nastnum.toString()
            })/* :{0}\n */);
        errmsg.append(NCLangRes4VoTransl.getNCLangRes().getStrByID("2014010_0",
            "02014010-0122", null, new String[] {
              newastnum.toString()
            })/* ϵͳ:{0}\n */);
        errmsg.append(NCLangRes4VoTransl.getNCLangRes().getStrByID("2014010_0",
            "02014010-0123", null, new String[] {
              MathTool.equals(nastnum, newastnum) ? "Y" : "N"
            })/* ߵĴСȽ -> {0}\n */);
        errmsg.append(NCLangRes4VoTransl.getNCLangRes().getStrByID("2014010_0",
            "02014010-0124", null, new String[] {
              vchangerate
            })/* :{0}\n */);
        errmsg.append(NCLangRes4VoTransl.getNCLangRes().getStrByID("2014010_0",
            "02014010-0125", null, new String[] {
              newHsl
            })/* ϵͳĻ:{0}\n */);
        errmsg.append(NCLangRes4VoTransl.getNCLangRes().getStrByID("2014010_0",
            "02014010-0123", null, new String[] {
              vchangerate.equals(newHsl) ? "Y" : "N"
            })/* ߵĴСȽ -> {0}\n */);

        String msg =
            NCLangRes4VoTransl.getNCLangRes().getStrByID("2014010_0",
                "02014010-0099", null, new String[] {
                  rowno
                })/* кΪ {0} ĵ,,ʻϵ󣬲ܱ */;
        String billmsg = BillMsgUtil.getBillMessage(head, item);
        ExceptionUtils
            .wrappBusinessException(errmsg.toString() + msg + billmsg);
      }
    }
  }

  private void checkPriceNumMny(AbstractRealItemVO item, AbstractRealHeadVO head) {
    UFDouble nprice = VOValueUtil.getUFDouble(item, FieldConst.NPRICE);
    UFDouble nmny = item.getNmny();
    UFDouble nnum = VOValueUtil.getUFDouble(item, FieldConst.NNUM);
    String rowno = item.getCrowno();
    String currencyid = item.getCcurrencyid();
    String cunitid = item.getCunitid();
    ScaleUtils scale = ScaleUtils.getScaleUtilAtBS();
    // , , ϵж
    if (!this.isNull(nprice) && !this.isNull(nmny)) {
      UFDouble newMny = scale.adjustMnyScale(nprice.multiply(nnum), currencyid);
      UFDouble newPrice = scale.adjustPriceScale(nmny.div(nnum));
      UFDouble newNum = scale.adjustNumScale(nmny.div(nprice), cunitid);
      if (!(newMny.equals(nmny) || newPrice.equals(nprice) || newNum
          .equals(nnum))) {
        StringBuffer errmsg = new StringBuffer();
        errmsg.append(NCLangRes4VoTransl.getNCLangRes().getStrByID("2014010_0",
            "02014010-0116")/* ݳϢ£\n */);
        errmsg.append(NCLangRes4VoTransl.getNCLangRes().getStrByID("2014010_0",
            "02014010-0126", null, new String[] {
              CurrtypeAccessor.getDocByPk(currencyid).getName().toString()
            })/*  :{0}\n */);
        errmsg.append(NCLangRes4VoTransl.getNCLangRes().getStrByID("2014010_0",
            "02014010-0118", null, new String[] {
              nnum.toString()
            })/* :{0}\n */);
        errmsg.append(NCLangRes4VoTransl.getNCLangRes().getStrByID("2014010_0",
            "02014010-0127", null, new String[] {
              newNum.toString()
            })/* ϵͳ:{0}\n */);
        errmsg.append(NCLangRes4VoTransl.getNCLangRes().getStrByID("2014010_0",
            "02014010-0128", null, new String[] {
              MathTool.equals(nnum, newNum) ? "Y" : "N"
            })/* ߵĴСȽ -> {0}\n\n */);
        errmsg.append(NCLangRes4VoTransl.getNCLangRes().getStrByID("2014010_0",
            "02014010-0129", null, new String[] {
              nprice.toString()
            })/* :{0}\n */);
        errmsg.append(NCLangRes4VoTransl.getNCLangRes().getStrByID("2014010_0",
            "02014010-0130", null, new String[] {
              newPrice.toString()
            })/* ϵͳĵ:{0}\n\n */);
        errmsg.append(NCLangRes4VoTransl.getNCLangRes().getStrByID("2014010_0",
            "02014010-0123", null, new String[] {
              MathTool.equals(nprice, newPrice) ? "Y" : "N"
            })/* ߵĴСȽ -> {0}\n */);
        errmsg.append(NCLangRes4VoTransl.getNCLangRes().getStrByID("2014010_0",
            "02014010-0131", null, new String[] {
              nmny.toString()
            })/* :{0}\n */);
        errmsg.append(NCLangRes4VoTransl.getNCLangRes().getStrByID("2014010_0",
            "02014010-0132", null, new String[] {
              newMny.toString()
            })/* ϵͳĽ:{0}\n */);
        errmsg.append(NCLangRes4VoTransl.getNCLangRes().getStrByID("2014010_0",
            "02014010-0133", null, new String[] {
              MathTool.equals(nmny, newMny) ? "Y" : "N"
            })/* ߵĴСȽ -> {0}\n\n */);

        String bizmsg =
            NCLangRes4VoTransl.getNCLangRes().getStrByID("2014010_0",
                "02014010-0100", null, new String[] {
                  rowno
                })/* кΪ {0} ĵݵ, , ϵ󣬲ܱ */;
        String billmsg = BillMsgUtil.getBillMessage(head, item);
        ExceptionUtils.wrappBusinessException(errmsg.toString() + bizmsg
            + billmsg);
      }
    }
  }

  private void checkScales(AbstractRealItemVO item, AbstractRealHeadVO head) {
    IAScaleUtil scale = IAScaleUtil.getScaleUtils();
    String rowno = item.getCrowno();

    UFDouble nprice = item.getNprice();
    UFDouble nnewprice = scale.adjustPriceScale(nprice);
    if (!MathTool.equals(nprice, nnewprice)) {
      StringBuffer errmsg = new StringBuffer();
      errmsg.append(NCLangRes4VoTransl.getNCLangRes().getStrByID("2014010_0",
          "02014010-0116")/* ݳϢ£\n */);
      errmsg.append(NCLangRes4VoTransl.getNCLangRes().getStrByID("2014010_0",
          "02014010-0134", null, new String[] {
            String.valueOf(scale.getIACostPriceScaleDigit())
          })/* 㵥۾ :{0}\n */);
      errmsg.append(NCLangRes4VoTransl.getNCLangRes().getStrByID("2014010_0",
          "02014010-0129", null, new String[] {
            nprice.toString()
          })/* :{0}\n */);
      errmsg.append(NCLangRes4VoTransl.getNCLangRes().getStrByID("2014010_0",
          "02014010-0130", null, new String[] {
            nnewprice.toString()
          })/* ϵͳĵ:{0}\n */);
      errmsg.append(NCLangRes4VoTransl.getNCLangRes().getStrByID("2014010_0",
          "02014010-0120", null, new String[] {
            MathTool.equals(nprice, nnewprice) ? "Y" : "N"
          })/* ߵĴСȽ -> {0}\n */);
      String msg =
          NCLangRes4VoTransl.getNCLangRes().getStrByID("2014010_0",
              "02014010-0101", null, new String[] {
                rowno
              })/* кΪ {0} ĵݵ۾ϵͳòܱ */;
      String billmsg = BillMsgUtil.getBillMessage(head, item);
      ExceptionUtils.wrappBusinessException(errmsg + msg + billmsg);
    }

    String cunitid = item.getCunitid();
    UFDouble nnum = item.getNnum();
    UFDouble nnewnum = scale.adjustNumScale(nnum, cunitid);
    if (!MathTool.equals(nnum, nnewnum)) {
      StringBuffer errmsg = new StringBuffer();
      errmsg.append(NCLangRes4VoTransl.getNCLangRes().getStrByID("2014010_0",
          "02014010-0116")/* ݳϢ£\n */);
      errmsg.append(NCLangRes4VoTransl.getNCLangRes().getStrByID("2014010_0",
          "02014010-0117", null, new String[] {
            MeasdocAccessor.getDocByPk(cunitid).getName().toString()
          })/* λ :{0}\n */);
      errmsg.append(NCLangRes4VoTransl.getNCLangRes().getStrByID("2014010_0",
          "02014010-0135", null, new String[] {
            nnum.toString()
          })/* :{0}\n */);
      errmsg.append(NCLangRes4VoTransl.getNCLangRes().getStrByID("2014010_0",
          "02014010-0136", null, new String[] {
            nnewnum.toString()
          })/* ϵͳ:{0}\n */);
      errmsg.append(NCLangRes4VoTransl.getNCLangRes().getStrByID("2014010_0",
          "02014010-0120", null, new String[] {
            MathTool.equals(nnum, nnewnum) ? "Y" : "N"
          })/* ߵĴСȽ -> {0}\n */);
      String msg =
          NCLangRes4VoTransl.getNCLangRes().getStrByID("2014010_0",
              "02014010-0102", null, new String[] {
                rowno
              })/* кΪ {0} ĵϵͳòܱ */;
      String billmsg = BillMsgUtil.getBillMessage(head, item);
      ExceptionUtils.wrappBusinessException(errmsg.toString() + msg + billmsg);
    }

    String castunitid = item.getCastunitid();

    UFDouble nastnum = item.getNastnum();
    UFDouble nnewastnum = scale.adjustNumScale(nastnum, castunitid);
    if (!MathTool.equals(nastnum, nnewastnum)) {
      StringBuffer errmsg = new StringBuffer();
      errmsg.append(NCLangRes4VoTransl.getNCLangRes().getStrByID("2014010_0",
          "02014010-0116")/* ݳϢ£\n */);
      errmsg.append(NCLangRes4VoTransl.getNCLangRes().getStrByID("2014010_0",
          "02014010-0137", null, new String[] {
            MeasdocAccessor.getDocByPk(castunitid).getName().toString()
          })/* λ :{0}\n */);
      errmsg.append(NCLangRes4VoTransl.getNCLangRes().getStrByID("2014010_0",
          "02014010-0138", null, new String[] {
            nastnum.toString()
          })/* :{0}\n */);
      errmsg.append(NCLangRes4VoTransl.getNCLangRes().getStrByID("2014010_0",
          "02014010-0139", null, new String[] {
            nnewastnum.toString()
          })/* ϵͳ:{0}\n */);
      errmsg.append(NCLangRes4VoTransl.getNCLangRes().getStrByID("2014010_0",
          "02014010-0120", null, new String[] {
            MathTool.equals(nastnum, nnewastnum) ? "Y" : "N"
          })/* ߵĴСȽ -> {0}\n */);
      String msg =
          NCLangRes4VoTransl.getNCLangRes().getStrByID("2014010_0",
              "02014010-0103", null, new String[] {
                rowno
              })/* кΪ {0} ĵϵͳòܱ */;
      String billmsg = BillMsgUtil.getBillMessage(head, item);
      ExceptionUtils.wrappBusinessException(errmsg + msg + billmsg);
    }

    String currencyid = item.getCcurrencyid();
    UFDouble nmny = item.getNmny();
    UFDouble nnewmny = scale.adjustMnyScale(nmny, currencyid);
    if (!MathTool.equals(nmny, nnewmny)) {
      StringBuffer errmsg = new StringBuffer();
      errmsg.append(NCLangRes4VoTransl.getNCLangRes().getStrByID("2014010_0",
          "02014010-0116")/* ݳϢ£\n */);
      errmsg.append(NCLangRes4VoTransl.getNCLangRes().getStrByID("2014010_0",
          "02014010-0126", null, new String[] {
            CurrtypeAccessor.getDocByPk(currencyid).getName().toString()
          })/*  :{0}\n */);
      errmsg.append(NCLangRes4VoTransl.getNCLangRes().getStrByID("2014010_0",
          "02014010-0140", null, new String[] {
            nmny.toString()
          })/* :{0}\n */);
      errmsg.append(NCLangRes4VoTransl.getNCLangRes().getStrByID("2014010_0",
          "02014010-0141", null, new String[] {
            nnewmny.toString()
          })/* ϵͳĽ:{0}\n */);
      errmsg.append(NCLangRes4VoTransl.getNCLangRes().getStrByID("2014010_0",
          "02014010-0120", null, new String[] {
            MathTool.equals(nmny, nnewmny) ? "Y" : "N"
          })/* ߵĴСȽ -> {0}\n */);
      String msg =
          NCLangRes4VoTransl.getNCLangRes().getStrByID("2014010_0",
              "02014010-0104", null, new String[] {
                rowno
              })/* кΪ {0} ĵݽϵͳòܱ */;
      String billmsg = BillMsgUtil.getBillMessage(head, item);
      ExceptionUtils.wrappBusinessException(errmsg + msg + billmsg);
    }

    UFDouble ncost = VOValueUtil.getUFDouble(item, FieldConst.NCOST);
    UFDouble nnewcost = scale.adjustMnyScale(ncost, currencyid);
    if (!MathTool.equals(ncost, nnewcost)) {
      StringBuffer errmsg = new StringBuffer();
      errmsg.append(NCLangRes4VoTransl.getNCLangRes().getStrByID("2014010_0",
          "02014010-0116")/* ݳϢ£\n */);
      errmsg.append(NCLangRes4VoTransl.getNCLangRes().getStrByID("2014010_0",
          "02014010-0126", null, new String[] {
            CurrtypeAccessor.getDocByPk(currencyid).getName().toString()
          })/*  :{0}\n */);
      errmsg.append(NCLangRes4VoTransl.getNCLangRes().getStrByID("2014010_0",
          "02014010-0142", null, new String[] {
            ncost.toString()
          })/* :{0}\n */);
      errmsg.append(NCLangRes4VoTransl.getNCLangRes().getStrByID("2014010_0",
          "02014010-0143", null, new String[] {
            nnewcost.toString()
          })/* ϵͳķ:{0}\n */);
      errmsg.append(NCLangRes4VoTransl.getNCLangRes().getStrByID("2014010_0",
          "02014010-0120", null, new String[] {
            MathTool.equals(ncost, nnewcost) ? "Y" : "N"
          })/* ߵĴСȽ -> {0}\n */);
      String msg =
          NCLangRes4VoTransl.getNCLangRes().getStrByID("2014010_0",
              "02014010-0105", null, new String[] {
                rowno
              })/* кΪ {0} ĵݷþϵͳòܱ */;
      String billmsg = BillMsgUtil.getBillMessage(head, item);
      ExceptionUtils.wrappBusinessException(errmsg + msg + billmsg);
    }
  }

  private boolean isNull(UFDouble d) {
    if (d == null || d.compareTo(UFDouble.ZERO_DBL) == 0) {
      return true;
    }
    return false;
  }

}

