//qrY9dgujkUtRZAX6SgnJEAwjhpvihM+aNW3nVB+meHeCw1mul22nR+QaDleKzS6H
package nc.bs.ic.m45.insert;

import nc.bs.ic.general.insert.IInsertBP;
import nc.bs.ic.general.insert.InsertBPTemplate;
import nc.bs.ic.general.insert.rule.before.CheckCliabilityValue;
import nc.bs.ic.general.rule.after.AtpAfterUpdate;
import nc.bs.ic.general.rule.before.CtplcustomeridCheck;
import nc.bs.ic.m45.base.BPPlugInPoint;
import nc.bs.ic.m45.base.rule.FillCostOrgRule;
import nc.bs.ic.m45.base.rule.PurchaseBillCheckRule;
import nc.bs.ic.m45.base.rule.PurchaseInAssetWarehouseCheck;
import nc.bs.ic.m45.base.rule.PurchaseInVOScaleCheckRule;
import nc.bs.ic.m45.base.rule.PurchaseinRetMarginProcess;
import nc.bs.ic.m45.base.rule.PurchaseinRetMarginProcessFor5805;
import nc.bs.ic.m45.base.rule.ReturnSnIsExistInEquipcardCheck;
import nc.bs.ic.m45.base.rule.VmiCheckRule;
import nc.bs.ic.m45.insert.rule.FillInVqtunitRule;
import nc.bs.ic.m45.insert.rule.InsReWritePIM;
import nc.bs.ic.m45.insert.rule.InsertCheckCanInRule;
import nc.bs.ic.m45.insert.rule.InsertCheckMaterialUnit;
import nc.bs.ic.m45.insert.rule.InsertRewriteITRule;
import nc.bs.ic.m45.insert.rule.InsertRewritePORule;
import nc.bs.ic.m45.wgpt.rule.WuYeWgptCheckInfoRule;
import nc.bs.ic.pub.base.ICAroundProcesser;
import nc.bs.ic.pub.base.IInsertRuleProvider;
import nc.impl.pubapp.pattern.rule.processer.AroundProcesser;
import nc.vo.ic.general.define.MetaNameConst;
import nc.vo.ic.m45.entity.PurchaseInBodyVO;
import nc.vo.ic.m45.entity.PurchaseInVO;
import nc.vo.ic.pub.util.StringUtil;
import nccloud.bs.ic.mobile.inbound.operation.rewrite.MobAfterPurchaseInSave;

/**
 * ɹⵥ̨BP
 *   
 * @author songhy
 */
public class InsertBP implements IInsertBP<PurchaseInVO>,
    IInsertRuleProvider<PurchaseInVO> {

  @Override
  public void addAfterRule(PurchaseInVO[] vos,
      AroundProcesser<PurchaseInVO> processor) {

    /**
     * ִ¹OnhandAfterUpdate֮ΪִʱԤӿڣԤӿڻдɹ
     * =ԶرգرջԤº
     */
    ((ICAroundProcesser<PurchaseInVO>) processor).addAfterRuleAt(
        new InsertRewritePORule(), AtpAfterUpdate.class);
    processor.addAfterRule(new InsReWritePIM());
    processor.addAfterRule(new InsertRewriteITRule());
    processor.addAfterRule(new MobAfterPurchaseInSave());
    // processor.addAfterRule(new InsertRewritePORule());
  }

  @Override
  public void addBeforeRule(PurchaseInVO[] vos,
      AroundProcesser<PurchaseInVO> processor) {
    // Ƿⵥ
    processor.addBeforeRule(new InsertCheckCanInRule());
    processor.addBeforeRule(new FillCostOrgRule());
    processor.addBeforeRule(new PurchaseBillCheckRule());
    processor.addBeforeRule(new PurchaseInAssetWarehouseCheck());
    // ɹһʱʹɹⵥ۸͵ɹһ
    //Ĺʹⵥĸļ۲Ч hujieh
//    processor.addBeforeRule(new AdjustPriceAndMnyWhenSameNumRule());
    processor.addBeforeRule(new CtplcustomeridCheck<PurchaseInVO>());
    processor.addBeforeRule(new VmiCheckRule());
    processor.addBeforeRule(new ReturnSnIsExistInEquipcardCheck());
    // ⵥ
    processor.addBeforeRule(new PurchaseinRetMarginProcess());
    processor.addBeforeRule(new PurchaseinRetMarginProcessFor5805());
    processor.addBeforeRule(new PurchaseInVOScaleCheckRule());
    processor.addBeforeRule(new InsertCheckMaterialUnit());
 // У
    processor.addBeforeRule(new CheckCliabilityValue<PurchaseInVO>(MetaNameConst.CLIABILITYOID,MetaNameConst.CIOLIABILITYOID));
    // Դڽģ--򵥣䱨۵λۻ
    processor.addBeforeRule(new FillInVqtunitRule());
   //add by Ƽ ʱ֤ϢǷƽ̨һ 2020-10-21 begin
  	processor.addBeforeRule(new WuYeWgptCheckInfoRule());
  //add by Ƽ ʱ֤ϢǷƽ̨һ 2020-10-21 end
  }

  @Override
  public PurchaseInVO[] insert(PurchaseInVO[] bills) {
    // ӦڡɸԼ顱ִǰ乩Ӧ
    this.fillCvendorid(bills);

    InsertBPTemplate<PurchaseInVO> insertBP =
        new InsertBPTemplate<PurchaseInVO>(BPPlugInPoint.InsertBP, this);
    return insertBP.insert(bills);
  }

  /**
   * ĹӦ̣ӦѾŲͷĹӦҪͷӦһ
   * 
   * @param vos
   */
  private void fillCvendorid(PurchaseInVO[] vos) {
    String cvendor = null;
    for (PurchaseInVO vo : vos) {

      // ȡͷӦ
      cvendor = vo.getHead().getCvendorid();
      if (StringUtil.isSEmptyOrNull(cvendor)) {
        continue;
      }

      // Ϊ幩Ӧ̸ֵ
      for (PurchaseInBodyVO body : vo.getBodys()) {
        body.setCvendorid(cvendor);
      }
    }
  }

}

//qrY9dgujkUtRZAX6SgnJEAwjhpvihM+aNW3nVB+meHeCw1mul22nR+QaDleKzS6H