//SiA112pQbYz9aO1slHz59FQZr7qA9FaQaXFAJQIFYcdxBc58fxSdTiQM3pJjYnDg
package nc.bs.ic.m45.update;

import nc.bs.ic.general.insert.rule.before.CheckCliabilityValue;
import nc.bs.ic.general.rule.after.AtpAfterUpdate;
import nc.bs.ic.general.rule.before.CtplcustomeridCheck;
import nc.bs.ic.general.update.IUpdateBP;
import nc.bs.ic.general.update.UpdateBPTemplate;
import nc.bs.ic.m45.base.BPPlugInPoint;
import nc.bs.ic.m45.base.rule.FillCostOrgRule;
import nc.bs.ic.m45.base.rule.PurchaseBillCheckRule;
import nc.bs.ic.m45.base.rule.PurchaseInAssetWarehouseCheck;
import nc.bs.ic.m45.base.rule.PurchaseInVOScaleCheckRule;
import nc.bs.ic.m45.base.rule.PurchaseinRetMarginProcess;
import nc.bs.ic.m45.base.rule.PurchaseinRetMarginProcessFor5805;
import nc.bs.ic.m45.base.rule.ReturnSnIsExistInEquipcardCheck;
import nc.bs.ic.m45.base.rule.VmiCheckRule;
import nc.bs.ic.m45.insert.rule.InsertCheckMaterialUnit;
import nc.bs.ic.m45.update.rule.UpdReWritePIM;
import nc.bs.ic.m45.update.rule.UpdateRewriteITRule;
import nc.bs.ic.m45.update.rule.UpdateRewritePORule;
import nc.bs.ic.m45.wgpt.rule.WuYeWgptCheckInfoRule;
import nc.bs.ic.pub.base.ICCompareAroundProcesser;
import nc.bs.ic.pub.base.IUpdateRuleProvider;
import nc.bs.scmpub.rule.VOSagaFrozenValidateRule;
import nc.impl.pubapp.pattern.rule.processer.CompareAroundProcesser;
import nc.vo.ic.general.define.MetaNameConst;
import nc.vo.ic.m45.entity.PurchaseInBodyVO;
import nc.vo.ic.m45.entity.PurchaseInVO;
import nc.vo.ic.pub.util.StringUtil;
import nc.vo.pub.VOStatus;
import nccloud.bs.ic.mobile.inbound.operation.rewrite.MobAfterPurchaseInUpdate;
import nccloud.bs.ic.mobile.inbound.operation.rewrite.MobBeforePurchaseInUpdate;

/**
 * ɹⵥ̨BP
 * 
 * @author songhy
 */
public class UpdateBP implements IUpdateBP<PurchaseInVO>, IUpdateRuleProvider<PurchaseInVO> {

	@Override
	public void addAfterRule(PurchaseInVO[] vos, PurchaseInVO[] originVOs,
			CompareAroundProcesser<PurchaseInVO> processor) {
		/**
		 * ִ¹OnhandAfterUpdate֮ΪִʱԤӿڣԤӿڻдɹ
		 * =ԶرգرջԤº
		 */
		((ICCompareAroundProcesser<PurchaseInVO>) processor).addAfterRuleAt(new UpdateRewritePORule(),
				AtpAfterUpdate.class);
		processor.addAfterRule(new UpdReWritePIM());
		// processor.addAfterRule(new UpdateRewritePORule());
		processor.addAfterRule(new UpdateRewriteITRule());
		// 2020319 ΢ЭͬӲɹⵥ޸ĺϢ
		processor.addAfterRule(new MobAfterPurchaseInUpdate());
	}

	@Override
	public void addBeforeRule(PurchaseInVO[] vos, PurchaseInVO[] originVOs,
			CompareAroundProcesser<PurchaseInVO> processor) {
		// sagasУ
		processor.addBeforeRule(new VOSagaFrozenValidateRule<PurchaseInVO>(true));
		processor.addBeforeRule(new FillCostOrgRule());
		processor.addBeforeRule(new PurchaseBillCheckRule());
		processor.addBeforeRule(new PurchaseInAssetWarehouseCheck());
		processor.addBeforeRule(new CtplcustomeridCheck<PurchaseInVO>());
		processor.addBeforeRule(new VmiCheckRule());
		processor.addBeforeRule(new ReturnSnIsExistInEquipcardCheck());
		processor.addBeforeRule(new PurchaseinRetMarginProcess());
		processor.addBeforeRule(new PurchaseinRetMarginProcessFor5805());
		processor.addBeforeRule(new PurchaseInVOScaleCheckRule());
		// У
		processor.addBeforeRule(
				new CheckCliabilityValue<PurchaseInVO>(MetaNameConst.CLIABILITYOID, MetaNameConst.CIOLIABILITYOID));
		processor.addBeforeRule(new InsertCheckMaterialUnit());
		processor.addBeforeRule(new MobBeforePurchaseInUpdate());
		//add by Ƽ ʱ֤ϢǷƽ̨һ 2020-10-21 begin
	  	processor.addBeforeRule(new WuYeWgptCheckInfoRule());
	    //add by Ƽ ʱ֤ϢǷƽ̨һ 2020-10-21 end
	}

	/**
	 * ෽д
	 * 
	 */
	@Override
	public PurchaseInVO[] update(PurchaseInVO[] vos, PurchaseInVO[] originVOs) {
		this.fillCvendorid(vos);
		UpdateBPTemplate<PurchaseInVO> updateBP = new UpdateBPTemplate<PurchaseInVO>(BPPlugInPoint.UpdateBP, this);
		PurchaseInVO[] retVOs = updateBP.update(vos, originVOs);
		return retVOs;
	}

	private void fillCvendorid(PurchaseInVO[] vos) {
		String cvendor = null;
		for (PurchaseInVO vo : vos) {
			// ȡͷӦ
			cvendor = vo.getHead().getCvendorid();

			// Ϊ幩Ӧ̸ֵ
			for (PurchaseInBodyVO body : vo.getBodys()) {
				if (StringUtil.isStringEqual(cvendor, body.getCvendorid()))
					continue;
				body.setCvendorid(cvendor);
				if (VOStatus.UNCHANGED == body.getStatus()) {
					// ˴ж״̬ȫΪUPDATEDɾкУᱨ
					body.setStatus(VOStatus.UPDATED);
				}

			}
		}
	}

}

//SiA112pQbYz9aO1slHz59FQZr7qA9FaQaXFAJQIFYcdxBc58fxSdTiQM3pJjYnDg