package nc.nc2nc.ncimpl.pub.plgin.v65;

import java.util.ArrayList;
import java.util.List;

import nc.bs.framework.common.NCLocator;
import nc.bs.logging.Logger;
import nc.nc2nc.mid.pub.AbstractNcDataImporter;
import nc.nc2nc.mid.pub.DataClassWraper;
import nc.nc2nc.mid.pub.ISynObject;
import nc.nc2nc.mid.pub.OrgVO;
import nc.nc2nc.mid.pub.ParameterDef;
import nc.nc2nc.mid.pub.SynObjType;
import nc.nc2nc.mid.pub.SynUtil;
import nc.nc2nc.mid.pub.itf.ISyn2ncPubService;
import nc.nc2nc.mid.vo.SynPsnDocVO;
import nc.nc2nc.ncimpl.pub.plgin.v61.cvter.PsnDocVOConvert;
import nc.nc2nc.ncimpl.pub.plgin.v61.cvter.SynOperateType;
import nc.nc2nc.ncimpl.pub.plgin.v61.cvter.SynWriteDataParam;
import nc.nc2nc.ncimpl.pub.plgin.v61.itf.IImpPsnDocService;
import nc.nc2nc.ncimpl.vo.bak.SynPsndocBakVO;
import nc.nc2nc.ncimpl.vo.cfg.context.SynContextCfgVO;
import nc.nc2nc.ncimpl.vo.log.SynLogBVO;
import nc.vo.bd.psn.PsndocVO;
import nc.vo.pub.BusinessException;

public class PsnDocDataImporter extends AbstractNcDataImporter
{

	@Override
	public SynLogBVO[] impData2NC(DataClassWraper dataWraper) throws Exception
	{

		if (dataWraper == null)
		{
			return null;
		}
		
		List<SynLogBVO> synlogList = new ArrayList<SynLogBVO>();
		if (!doSynContextValidition(synlogList))
		{
			return synlogList.toArray(new SynLogBVO[synlogList.size()]);
		}
		
		SynContextCfgVO synContextCfg = this.getSynContext().getSynContextCfg();
		String to_org = synContextCfg.getTo_org();
		OrgVO orgvo = getSynContext().getTargetOrgVO();
		String pk_group = orgvo.getPk_group();

		ISyn2ncPubService syn2ncPubService = NCLocator.getInstance().lookup(ISyn2ncPubService.class);
		IImpPsnDocService psnService = NCLocator.getInstance().lookup(IImpPsnDocService.class);
		SynWriteDataParam objSynParam = new SynWriteDataParam();
		objSynParam.setTo_org(to_org);
		objSynParam.setTo_pk_group(pk_group);
		objSynParam.setTo_Pk_AccountingBook(synContextCfg.getTo_glbook());

		if (getStep().getDo_new_action().booleanValue() && dataWraper.getNewObjects() != null && dataWraper.getNewObjects().size() > 0)
		{
			boolean isCheckPsnRepeate = "true".equalsIgnoreCase(getPlgSelfParamValue("is_check_repeat"));
			List<ISynObject> addObjs = dataWraper.getNewObjects();
			for (ISynObject addObj : addObjs)
			{
				doAddAction(addObj, dataWraper, objSynParam,orgvo, to_org, pk_group, isCheckPsnRepeate, psnService, syn2ncPubService, synlogList);
			}
		}
		else
		{
			Logger.debug(">>>>>PsnDocDataImporter:ԱʱΪգ");
			SynLogBVO log = new SynLogBVO();
			log.setMessage(">>>>>PsnDocDataImporter:ԱʱΪգ");
			log.setObj_type(getEntityType());
			log.setSuccess(true);
			log.setPk_context(synContextCfg.getPk_context_cfg());
			log.setContext_code(synContextCfg.getCfg_code());
			log.setObj_name("<ԱϢ>");
			synlogList.add(log);
		}
		
		if (getStep().getDo_update_action().booleanValue() && dataWraper.getUpdateObjects() != null && dataWraper.getUpdateObjects().size() > 0)
		{
			boolean isCheckPsnRepeate = "true".equalsIgnoreCase(getPlgSelfParamValue("is_check_repeat"));
			List<ISynObject> updateObjs = dataWraper.getUpdateObjects();
			synlogList = new ArrayList<SynLogBVO>();
			for (ISynObject updateObj : updateObjs)
			{
				doUpdateAction(updateObj, dataWraper, objSynParam,orgvo, to_org, pk_group, isCheckPsnRepeate, psnService, syn2ncPubService, synlogList);
			}
		}
		else
		{
			Logger.debug(">>>>>PsnDocDataImporter:ԱʱΪգ");
			SynLogBVO log = new SynLogBVO();
			log.setMessage(">>>>>PsnDocDataImporter:ԱʱΪգ");
			log.setObj_type(getEntityType());
			log.setSuccess(true);
			log.setPk_context(synContextCfg.getPk_context_cfg());
			log.setContext_code(synContextCfg.getCfg_code());
			log.setObj_name("<ԱϢ>");
			synlogList.add(log);
		}
		
		return synlogList.toArray(new SynLogBVO[synlogList.size()]);
	}

	protected void doAddAction(ISynObject addObj, DataClassWraper dataWraper, SynWriteDataParam objSynParam,OrgVO orgvo, String to_org, String pk_group, boolean isCheckPsnRepeate, IImpPsnDocService psnService, ISyn2ncPubService syn2ncPubService, List<SynLogBVO> synlogList)
	{
		try
		{
			SynPsnDocVO svo = (SynPsnDocVO) addObj;

			ISynObject originobj = dataWraper.getOriginExtSystemSynObjById(addObj.getObject_id());
			SynPsndocBakVO synbakvo = svo.toSynObjectBak();
			synbakvo.setSynObj(originobj);
			PsnDocVOConvert psnDocVOConvert = new PsnDocVOConvert();
			PsndocVO psnDoc = psnDocVOConvert.convert(svo, objSynParam,null,orgvo, to_org, pk_group, SynOperateType.syn_type_insert,synlogList);
			PsndocVO addVo = psnService.insertPsndoc_RequiresNew(psnDoc, isCheckPsnRepeate, synbakvo);
			if (null == addVo)
			{
				throw new BusinessException("ԱʧܣΪգΪ" + svo.getObject_code() + ",Ϊ" + svo.getObject_name());
			}
			
			svo.setPk_nc_object(addVo.getPk_psndoc());
			svo.setSuccess2nc(true);

			SynLogBVO log = new SynLogBVO(svo, " ɹ");
			log.setObj_type(getEntityType());
			synlogList.add(log);
		}
		catch (Exception e)
		{
			Logger.error(">>>>>PsnDocDataImporter:ʱ" + e.getMessage(), e);
			SynLogBVO log = new SynLogBVO(addObj, "ԱݳϢ" + SynUtil.getExceptionStackMsg(e));
			log.setObj_type(getEntityType());
			log.setSuccess(false);
			synlogList.add(log);
		}
	}
	
	protected void doUpdateAction(ISynObject updateObj, DataClassWraper dataWraper, SynWriteDataParam objSynParam,OrgVO orgvo, String to_org, String pk_group, boolean isCheckPsnRepeate, IImpPsnDocService psnService, ISyn2ncPubService syn2ncPubService, List<SynLogBVO> synlogList)
	{
		try
		{
			SynPsnDocVO svo = (SynPsnDocVO) updateObj;

			ISynObject originobj = dataWraper.getOriginExtSystemSynObjById(updateObj.getObject_id());
			SynPsndocBakVO synbakvo = svo.toSynObjectBak();
			synbakvo.setSynObj(originobj);

			PsndocVO psnOld = psnService.queryPsndoc(svo.getPk_nc_object());
			if (null == psnOld)
			{
				try
				{
					// ɾӳϵ
					syn2ncPubService.deleteByVOClassAndPk_RequiresNew(getEntityBackupVOClass(), updateObj.getPk_bak());
					
					// Ҫִ
					doAddAction(updateObj, dataWraper, objSynParam,orgvo, to_org, pk_group, isCheckPsnRepeate, psnService, syn2ncPubService, synlogList);
				}
				catch(Exception e)
				{
					Logger.error("ɡ¡ת쳣:" + e.getMessage(), e);
					updateObj.setSuccess2nc(false);
					synlogList.add(getSynLogBVO(updateObj, SynUtil.getExceptionStackMsg(e)));
				}
				
				return;
			}
			PsnDocVOConvert psnDocVOConvert = new PsnDocVOConvert();
			PsndocVO psnDoc = psnDocVOConvert.convert(svo, objSynParam,psnOld,orgvo, to_org, pk_group, SynOperateType.syn_type_update,synlogList);
			PsndocVO updateVo = psnService.updatePsndoc_RequiresNew(psnDoc, isCheckPsnRepeate, synbakvo);
			if (null == updateVo)
			{
				throw new BusinessException("ԱʧܣΪգΪ" + svo.getObject_code() + ",Ϊ" + svo.getObject_name());
			}
			svo.setSuccess2nc(true);

			SynLogBVO log = new SynLogBVO(svo, " ³ɹ");
			log.setObj_type(getEntityType());
			synlogList.add(log);
		}
		catch (Exception e)
		{
			Logger.error(">>>>>PsnDocDataImporter:ʱ" + e.getMessage(), e);
			SynLogBVO log = new SynLogBVO(updateObj, "ԱݳϢ" + SynUtil.getExceptionStackMsg(e));
			log.setObj_type(getEntityType());
			log.setSuccess(false);
			synlogList.add(log);
		}
	}

	@Override
	public String getEntityType()
	{
		return SynObjType.PsnDoc;
	}

	@Override
	public ParameterDef[] getPlginSelfParamDefs()
	{
		ParameterDef paramDef = new ParameterDef();
		paramDef.setCode("is_check_repeat");
		paramDef.setDescription("true/false");
		paramDef.setName("ǷԱظм");
		return new ParameterDef[] { paramDef };
	}

	@Override
	public Class<SynPsndocBakVO> getEntityBackupVOClass()
	{
		return SynPsndocBakVO.class;
	}

	@Override
	public Class<SynPsnDocVO> getEntityVOClass()
	{
		return SynPsnDocVO.class;
	}
	
	public SynLogBVO getSynLogBVO(ISynObject synObj, String msg)
	{
		SynLogBVO logBVO = new SynLogBVO(synObj, msg);
		logBVO.setObj_type(getEntityType());
		return logBVO;
	}

	@Override
	public boolean isNeedDataClassifyService()
	{
		return true;
	}
}
