package nc.bs.pu.m25.wgpt.rule;


import com.alibaba.fastjson.JSONObject;

import nc.bs.logging.Logger;
import nc.impl.pubapp.pattern.rule.IRule;
import nc.vo.pu.m25.entity.InvoiceHeaderVO;
import nc.vo.pu.m25.entity.InvoiceVO;
import nc.vo.pub.lang.UFDateTime;
import nc.vo.pubapp.pattern.exception.ExceptionUtils;
import ncc.pub.wywgpt.utils.WyWGPTUtils;
import nccloud.commons.lang.ArrayUtils;
/**
 * @Description: ƽ̨ķƱɾشƽ̨
 * 
 * @author л ̹԰-ҵ-ƽ̨ӿڡ
 * @date 2019-3-6
 * @version with NCC
 */
public class InvoiceDeleteWgptRule  implements IRule<InvoiceVO> {

	@Override
	public void process(InvoiceVO[] invoiceVOs) {
		if(ArrayUtils.isEmpty(invoiceVOs)){ 
			return;
		}
		String sendJsonData = null;
		String esbResultinfoStr = null;
		try {
			for(InvoiceVO invoiceVO:invoiceVOs){
				InvoiceHeaderVO headerVO = invoiceVO.getParentVO();
				//vdef29	ƽ̨㵥
				//vdef14	Ƿƽ̨
				if("Y".equals(headerVO.getVdef8()) && headerVO.getVdef10()!=null){
					JSONObject requestInfo = new JSONObject();
					//method ӿڷ
					requestInfo.put("method", "cancelBalance");
					//ʱ
					requestInfo.put("createTime",new UFDateTime().toString());
					//ƽ̨㵥
					requestInfo.put("billNo",headerVO.getVdef10());
					
					String instId = "D91S008-WYOSP-1903-013-"+System.currentTimeMillis();
					sendJsonData = WyWGPTUtils.getSendToEsbData(instId, requestInfo);
					//
					JSONObject esbResultinfo = WyWGPTUtils.sendToESB(sendJsonData,"NC-WGPT-PU-002");
					if(esbResultinfo!=null){
						esbResultinfoStr = esbResultinfo.toString();
						Logger.error("ƽ̨ķƱɾشƽ̨"+sendJsonData+"\r\nز"+esbResultinfoStr);
						JSONObject esbInfo = (JSONObject)esbResultinfo.get("esbInfo");
						if(esbInfo!=null){
							//ӿڷ״̬Sɹ/W棩/E
							String returnStatus = esbInfo.get("returnStatus")+"";
							returnStatus = "E".equals(returnStatus)?"":"";
							if("".equals(returnStatus)){
								String returnMsg = esbInfo.get("returnMsg")+"";
								ExceptionUtils.wrappBusinessException("ӿڴ"+returnMsg);
							}
						}
						JSONObject resultInfo = esbResultinfo.getJSONObject("resultInfo");
						Object success = resultInfo.get("success");
						if(!"true".equals(success+"")){
							Object result = resultInfo.get("result");
							ExceptionUtils.wrappBusinessException("ƽ̨ʾ:"+result);
						}
					}
				}
			}
		} catch (Exception e) {
			Logger.error(e);
			e.printStackTrace();
			ExceptionUtils.wrappBusinessException("쳣\n"+e.getMessage()+"\nģ\n"+sendJsonData+"\nرģ\n"+esbResultinfoStr);
		}
	
	}

}
