package nc.bs.pu.wgpt.process;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import nc.bs.dao.BaseDAO;
import nc.bs.framework.common.NCLocator;
import nc.itf.pubapp.pub.smart.IBillQueryService;
import nc.itf.uap.pf.IPFWorkflowQry;
import nc.jdbc.framework.processor.ColumnListProcessor;
import nc.net.servlet.IReturnStatus;
import nc.pub.sap.constant.SapConstants;
import nc.pubitf.pu.m4201.IStockFinanceSettleInfoQuery;
import nc.util.uap.wgpt.WuYeWgptUtil;
import nc.vo.esb.ResultEsbVO;
import nc.vo.esb.ResultVO;
import nc.vo.ic.general.define.MetaNameConst;
import nc.vo.ic.m45.entity.PurchaseInBodyVO;
import nc.vo.ic.m45.entity.PurchaseInVO;
import nc.vo.ic.pub.util.CollectionUtils;
import nc.vo.ic.pub.util.NCBaseTypeUtils;
import nc.vo.ic.pub.util.StringUtil;
import nc.vo.ic.pub.util.VOEntityUtil;
import nc.vo.ic.pub.util.ValueCheckUtil;
import nc.vo.pu.m25.entity.InvoiceHeaderVO;
import nc.vo.pu.m25.entity.InvoiceItemVO;
import nc.vo.pu.m25.entity.InvoiceVO;
import nc.vo.pub.BusinessException;
import nc.vo.pub.lang.UFDouble;
import nc.vo.pubapp.pattern.exception.ExceptionUtils;
import nc.vo.pubapp.pattern.model.entity.bill.AbstractBill;
import nc.vo.tmpub.util.ArrayUtil;
import nc.vo.tmpub.util.SqlUtil;
import nc.vo.wgpt.log.WuYeWgptLogVO;
import ncc.bs.wy.tools.WyWGPTJsonTools;
import ncc.pub.wywgpt.utils.WyWGPTUtils;
import uap.json.JSONObject;

/**
 * @Description: ƽ̨->NC/޸ĲɹƱ
 * 
 * @author л ̹԰-ҵ-ƽ̨ӿڡ
 * @date 2019-3-6
 * @version with NC V6.3
 */
public class WriteInvoiceInfoProcess {

	@SuppressWarnings("unchecked")
	public String writeInvoiceInfo(JSONObject jsonobj) throws BusinessException {
		String rsdata = null;
		String nc_id = null;
		ResultVO result = new ResultVO();
		result.setResult("");
		Object deliveryNum = null;
		ResultEsbVO<ResultVO> esb = new ResultEsbVO<ResultVO>();
		esb.setResultInfo(result);
		try {
			if (jsonobj == null || "".equals(jsonobj)) {// Postύֵ

				result.setCode(IReturnStatus.FAILING);// ʧ
				result.setMessage("PostύJsonʽֵ!");
				WuYeWgptUtil.createResultEsbVO(esb);
				esb.getEsbInfo().setReturnStatus(IReturnStatus.ESB_FAILING);
				esb.getEsbInfo().setReturnMsg("ʧ");
				esb.setResultInfo(result);
			} else {
				JSONObject requestInfo = (JSONObject) jsonobj.get("requestInfo");
				JSONObject head = (JSONObject) requestInfo.get("Header");
				deliveryNum = head.get("csourceid");

				if (null != deliveryNum) {
					InvoiceVO invoiceVO = WyWGPTJsonTools.jsonToOrderVO(jsonobj, InvoiceVO.class, InvoiceHeaderVO.class, InvoiceItemVO.class, null);
					// תǰǿУ顢ִйʽǿУ
					WyWGPTUtils.notNullCheckAndExFormula("WY25_HEAD", "WY25_BODY", invoiceVO);
					//xug  Ƿ˿⣨freplenishflag ˿ĵ
					String sql = "select cgeneralhid from ic_purchasein_h where nvl(dr,0)=0 and nvl(freplenishflag,'N') = 'N' and " + SqlUtil.buildSqlForIn("vdef16", deliveryNum.toString().split(","));
					BaseDAO baseDAO = new BaseDAO();
					List<String> list = (List<String>) baseDAO.executeQuery(sql, new ColumnListProcessor());

					if (null != list && list.size() > 0) {
						IBillQueryService billQuery = NCLocator.getInstance().lookup(IBillQueryService.class);

						String qryInvoicSql = "select distinct pk_invoice from po_invoice_b where nvl(dr,0)=0 and "
								+ SqlUtil.buildSqlForIn("csourceid", list.toArray(new String[0]));

						List<String> pk_invoics = (List<String>) baseDAO.executeQuery(qryInvoicSql, new ColumnListProcessor());
						if (pk_invoics != null && pk_invoics.size() > 1) {
							throw new BusinessException("NC" + pk_invoics.size() + "ŷƱ");
						}
						if (pk_invoics != null && pk_invoics.size() > 0) {
							nc_id = pk_invoics.get(0);
							IPFWorkflowQry workflowQry = NCLocator.getInstance().lookup(IPFWorkflowQry.class);
							boolean isApproveFlowStartup = workflowQry.isApproveFlowStartup(pk_invoics.get(0), "25");
							if (isApproveFlowStartup) {
								result.setCode(IReturnStatus.FAILING);// ʧ
								result.setMessage("ţ" + deliveryNum + "NCϵͳӦĲɹƱѽ̣޸ģ");
								WuYeWgptUtil.createResultEsbVO(esb);
								esb.getEsbInfo().setReturnStatus(IReturnStatus.ESB_FAILING);
								esb.getEsbInfo().setReturnMsg("ʧ");
								esb.setResultInfo(result);
							} else {
								InvoiceVO oldInvoiceVO = billQuery.querySingleBillByPk(InvoiceVO.class, pk_invoics.get(0));
								HashMap<String, ArrayList<String>> hFormulaone = WyWGPTUtils.getFormulas("WY25_HEAD", SapConstants.DIRECTION_SAP2NC);
								List<String> headKeys = hFormulaone.get(SapConstants.NC_FIELD_CODE);
								for (int j = 0; j < headKeys.size(); j++) {
									oldInvoiceVO.getParentVO().setAttributeValue(headKeys.get(j), invoiceVO.getParentVO().getAttributeValue(headKeys.get(j)));
								}
								WyWGPTUtils.getIPFBusiAction().processAction("SAVEBASE", oldInvoiceVO.getParentVO().getVtrantypecode(), null, oldInvoiceVO, null, null);
								result.setCode(IReturnStatus.SUCCEED);// ɹ
								result.setMessage("޸ĲɹƱɹ");
								WuYeWgptUtil.createResultEsbVO(esb);
								esb.setResultInfo(result);
							}
						} else {

							AbstractBill[] abstractBills = billQuery.queryAbstractBillsByPks(PurchaseInVO.class, list.toArray(new String[0]));
							/**
							 * add by ҫ 2019-12-19 ˵ѾĲɹⵥ  begin
							 */
							List<PurchaseInVO> queryInVOs=new ArrayList<PurchaseInVO>();
							
							for(int i=0;i<abstractBills.length;i++){
								queryInVOs.add((PurchaseInVO) abstractBills[i]);
							}
							
							PurchaseInVO[] filterVos =filterHasInvoicePurchaseIn(queryInVOs.toArray(new PurchaseInVO[0]));
							
							if(ArrayUtil.isNull(filterVos)){
								ExceptionUtils.wrappBusinessException("ûзɷƱУ");
							}
							
							InvoiceVO[] exchangeVos = (InvoiceVO[]) WuYeWgptUtil.getExchangeService().runChangeDataAry("45", "25", filterVos, null);
							/**
							 * add by ҫ 2019-12-19 ˵ѾĲɹⵥ  end
							 */
							List<InvoiceItemVO> allItemVOs = new ArrayList<InvoiceItemVO>();
							for (int i = 0; i < exchangeVos.length; i++) {
								ArrayUtil.addArrayToList(allItemVOs, exchangeVos[i].getChildrenVO());
							}
							for (int row = 0; row < allItemVOs.size(); row++) {
								allItemVOs.get(row).setCrowno(String.valueOf((row + 1) * 10));
							}
							HashMap<String, ArrayList<String>> hFormulaone = WyWGPTUtils.getFormulas("WY25_HEAD", SapConstants.DIRECTION_SAP2NC);
							List<String> headKeys = hFormulaone.get(SapConstants.NC_FIELD_CODE);
							for (int j = 0; j < headKeys.size(); j++) {
								exchangeVos[0].getParentVO().setAttributeValue(headKeys.get(j), invoiceVO.getParentVO().getAttributeValue(headKeys.get(j)));
							}
							invoiceVO.setParentVO(exchangeVos[0].getParentVO());
							invoiceVO.setChildrenVO(allItemVOs.toArray(new InvoiceItemVO[0]));

							WyWGPTUtils.getIPFBusiAction().processAction("SAVEBASE", invoiceVO.getParentVO().getVtrantypecode(), null, invoiceVO, null, null);

							result.setCode(IReturnStatus.SUCCEED);// ɹ
							result.setMessage("ɹƱɹ");
							WuYeWgptUtil.createResultEsbVO(esb);
							esb.setResultInfo(result);

							nc_id = invoiceVO.getParentVO().getPrimaryKey();
							//xug longht δĿǰ uat 2021-12-09 
//							//Ӱ񴫵
//							this.sendBacklog(invoiceVO);
						}
					} else {
						result.setCode(IReturnStatus.FAILING);// ʧ
						result.setMessage("ݷţ" + deliveryNum + "NCϵͳҲӦĲɹⵥϢ");
						WuYeWgptUtil.createResultEsbVO(esb);
						esb.getEsbInfo().setReturnStatus(IReturnStatus.ESB_FAILING);
						esb.getEsbInfo().setReturnMsg("ʧ");
						esb.setResultInfo(result);
					}
				} else {
					result.setCode(IReturnStatus.FAILING);// ʧ
					result.setMessage("(csourceid)Ϊգ");
					WuYeWgptUtil.createResultEsbVO(esb);
					esb.getEsbInfo().setReturnStatus(IReturnStatus.ESB_FAILING);
					esb.getEsbInfo().setReturnMsg("ʧ");
					esb.setResultInfo(result);
				}
			}
		} catch (Exception e) {
			result.setCode(IReturnStatus.ERROR);// 쳣
			result.setError(e.getMessage());
			result.setMessage(WuYeWgptUtil.getExceptionDetail(e));
			WuYeWgptUtil.createResultEsbVO(esb);// ʼӦ
			esb.getEsbInfo().setReturnStatus(IReturnStatus.ESB_ERROR);
			esb.getEsbInfo().setReturnMsg("쳣");
			esb.setResultInfo(result);// Ӧ
		} finally {
			rsdata = com.alibaba.fastjson.JSONObject.toJSONString(esb);

			WuYeWgptLogVO logVO = new WuYeWgptLogVO();
			logVO.setNc_id(nc_id);
			logVO.setOther_id(deliveryNum + " ");
			logVO.setBillno("");
			logVO.setTranstypecode("25");
			logVO.setItfcode("WGPT-NC-CG-003");
			logVO.setItfname("ƽ̨->NC/޸ĲɹƱ");
			logVO.setBilldata(jsonobj == null ? "" : jsonobj.toString());
			logVO.setRsdata(rsdata);
			logVO.setMsg(null);
			logVO.setIssuccess(IReturnStatus.SUCCEED.equals(result.getCode()) ? "Y" : "N");

			WuYeWgptUtil.getIWuYeWgptLogService().insertLog_RequiresNew(logVO);
		}
		return rsdata;
	}
	
	/**˵ѾĲɹⵥ
	 * @author ҫ
	 * @time 2019-12-19
	 * @param vos
	 * @return
	 * @throws BusinessException
	 */
	private PurchaseInVO[] filterHasInvoicePurchaseIn(PurchaseInVO[] vos) throws BusinessException{
		 Map<String, UFDouble> map = this.getNinvoicenumMap(vos);
	      List<PurchaseInVO> volist = new ArrayList<PurchaseInVO>();
	    //xug Է Ͳɹ ݣظ   sta 
	      List<String> setkey = new ArrayList<String>();
	      for (PurchaseInVO vo : vos) {
	    	  //xug У ظ 
	    	  if(!setkey.contains(vo.getHead().getVdef16())) {
	    		  setkey.add(vo.getHead().getVdef16());
	    	  }else {
	    		  throw new BusinessException("ţ" + vo.getHead().getVdef16() + ",NCϵͳӦ[ɹ]ظ飡");
	    	  }
	    	//xug Է Ͳɹ ݣظ   end
	        PurchaseInBodyVO[] bodyvos = vo.getBodys();
	        List<PurchaseInBodyVO> list = new ArrayList<PurchaseInBodyVO>();
	        for (PurchaseInBodyVO bodyvo : bodyvos) {
	          // 1.˼Ĵ湩Ӧ̷ǿݣĴҵĻܴƱ;2.ƷѾ㣬ҪƱ(sqlж)
	          if (!StringUtil.isSEmptyOrNull(bodyvo.getCvmivenderid())) {
	            continue;
	          }
	          // ˲ɿƱ
	          if (this.canNinvoicenum(bodyvo, map.get(bodyvo.getCgeneralbid())))
	            list.add(bodyvo);
	        }
	        if (ValueCheckUtil.isNullORZeroLength(list))
	          continue;
	        vo.setChildrenVO(CollectionUtils.listToArray(list));
	        volist.add(vo);
	      }

	      return CollectionUtils.listToArray(volist);
	}
	
	/**
	   * ɿƱ=-max(ۼƿƱۼƽ)ƱԺҪ㣬ĲҪƱ
	   * @author ҫ
	   * @time 2019-12-19
	   * @param bodyvo
	   * @param naccumsettlenum
	   * @return
	   */
	  private boolean canNinvoicenum(PurchaseInBodyVO bodyvo,
	      UFDouble naccumsettlenum) {

	    // max(ۼƿƱۼƽ)
	    UFDouble tmp =
	        NCBaseTypeUtils
	            .isGt(
	                bodyvo.getNsignnum() == null ? UFDouble.ZERO_DBL : bodyvo
	                    .getNsignnum().abs(),
	                naccumsettlenum == null ? UFDouble.ZERO_DBL : naccumsettlenum
	                    .abs()) ? bodyvo.getNsignnum() : naccumsettlenum;
	    // ɿƱ
	    tmp = NCBaseTypeUtils.sub(bodyvo.getNnum(), tmp);

	    /**
	     * @author ҫ
	     * @time 2019-12-19
	     * ɿƱ
	     * >0;ɿƱ>0
	     * <0;ɿƱ<0
	     * */
	    if (NCBaseTypeUtils.isLEZero(NCBaseTypeUtils.mult(tmp, bodyvo.getNnum())))
	      return false;
	    bodyvo.setNinvoicenum(tmp);
	    return true;
	  }
	
	  /**
	   * ⵥѽ
	   * @author ҫ
	   * @time 2019-12-19
	   * @param vos
	   * @return key:bid,value:
	   * @throws BusinessException
	   */
	  private Map<String, UFDouble> getNinvoicenumMap(PurchaseInVO[] vos)
	      throws BusinessException {
	    String[] bids =
	        VOEntityUtil.getVOsNotRepeatValue(VOEntityUtil.getBodyVOs(vos),
	            MetaNameConst.CGENERALBID);

	    return NCLocator.getInstance().lookup(IStockFinanceSettleInfoQuery.class)
	        .getTotalSettleNum(bids);
	  } 
	  
//	  /**
//		 * Ӱ
//		 * @throws BusinessException 
//		 * 
//		 * */
//		public  void sendBacklog(InvoiceVO invoiceVO) throws BusinessException {
//			
//			com.alibaba.fastjson.JSONObject json = this.changeToJson(invoiceVO.getParentVO());
//			com.alibaba.fastjson.JSONObject result = ImageCaptureAPI.postRequest(json, "IMAGE-NCC-ERM");
//			String billid = json.getJSONObject("billMain").getString("billCode");
//			String billcode = json.getJSONObject("billMain").getString("settlementNo");
//			this.insertImageLog_RequiresNew(billid, billcode, json, result, "IMAGE-NCC-ERM");
//			String code = result.getString("code");
//			if (!"200".equals(code)) {
//				ExceptionUtils.wrappBusinessException("" + ImageCaptureAPI.map.get(ImageCommonConstant.IMAGE_NCC_ERM)
//						+ "ӿʧܣ" + result.get("message").toString());
//			}
//			
//		}
//		/**
//		 * jsonת
//		 * nc.pubitf.payablebill.yx
//		 * */
//		private com.alibaba.fastjson.JSONObject changeToJson(InvoiceHeaderVO invo) {
//			ImageContentVO imageContentVO = new ImageContentVO();
//			imageContentVO.setBillCode(invo.getPk_invoice());
//			imageContentVO.setBillCodeType("expensesBill");
//			imageContentVO.setBusinessType("305");
//			imageContentVO.setBillUse("30501");	
//			imageContentVO.setUserName(ImageCommonUtil.getUserName(InvocationInfoProxy.getInstance().getUserId()));
//			imageContentVO.setUserCode(InvocationInfoProxy.getInstance().getUserCode());
//			imageContentVO.setPurchaserName(ImageCommonUtil.getCorporationName(invo.getPk_org()));
//			imageContentVO.setPurchaserTaxNo(ImageCommonUtil.getTaxPayerCode(invo.getPk_org()));
//			imageContentVO.setRequestNo(invo.getVbillcode());
//			imageContentVO.setSettlementNo(invo.getVbillcode());
//			imageContentVO.setCreateTime((new UFDateTime()).toStdString());
//			imageContentVO.setTotalAmount(invo.getNtotalorigmny().toString());
//			imageContentVO.setRemark(invo.getVmemo());
//			imageContentVO.setSystemOrig(2);
//			ImageVO imageVO = new ImageVO();
//			imageVO.setBillMain(imageContentVO);
//			return (com.alibaba.fastjson.JSONObject) com.alibaba.fastjson.JSONObject.toJSON(imageVO);
//		}
//		
//		/**
//		 * Ӱӿ־д
//		 * @author xuy
//		 * */
//		public void insertImageLog_RequiresNew(String billid, String billcode, com.alibaba.fastjson.JSONObject send, 
//				com.alibaba.fastjson.JSONObject result, String urlcode) throws BusinessException {
//			String code = result.getString("code");
//			ImageTMLogVO log = new ImageTMLogVO();
//			log.setBillid(billid);
//			log.setBillno(billcode);
//			log.setTm_content(com.alibaba.fastjson.JSONObject.toJSONString(send));
//			log.setTm_result(com.alibaba.fastjson.JSONObject.toJSONString(result));
//			log.setApicode(urlcode);
//			if(!StringUtils.isBlank(code) && "200".equals(code)) {
//				log.setTm_status("S");
//			} else {
//				log.setTm_status("F");
//			}
//			// ־
//			getDAO().insertVO(log);
//		}
//		BaseDAO dao = null;
//
//		private BaseDAO getDAO() {
//			if (dao == null) {
//				dao = new BaseDAO();
//			}
//			return dao;
//		}
}
