package nc.net.pu.utils;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.OutputStream;
import java.io.OutputStreamWriter;
import java.net.HttpURLConnection;
import java.net.URL;
import java.net.URLConnection;
import java.text.DateFormat;
import java.text.SimpleDateFormat;
import java.util.Calendar;
import java.util.Date;
import java.util.HashMap;
import java.util.UUID;

import com.alibaba.fastjson.JSONObject;

import nc.bs.framework.common.NCLocator;
import nc.itf.sap.log.ISapLog;
import nc.itf.uap.IUAPQueryBS;
import nc.jdbc.framework.processor.ColumnProcessor;
import nc.jdbc.framework.processor.MapProcessor;
import nc.vo.esb.EsbInfoVO;
import nc.vo.esb.EsbVO;
import nc.vo.esb.QueryInfoVO;
import nc.vo.pub.BusinessException;
import nc.vo.sap.log.SapPurchaseLogVO;
import nc.vo.ws.esb.BasicTool;

/**
 * @author  2018-04-11
 * SAPϵͳESBӿڷ(󹤾)
 *
 */
public class PubUtils {
	
	
	/**
	 * ʱ侫ȷ
	 */
	public static SimpleDateFormat dateFormat = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss:SSS");
	
	private static ISapLog saplog;
	
	private static IUAPQueryBS queryBS;
	
	/**
	* ָ URL POST󣨷ֵ
    * @param url  URL
    * @param paramJson jsonʽı
    * @param esbcode ӿڰȫȨ 
    * @return ԶԴӦ(ֵΪJson)
    */
   public static JSONObject sendJsonPost_GX(String url, String paramJson,String esbcode) throws Exception{
	   OutputStreamWriter out = null;
       BufferedReader in = null;
       InputStreamReader conninput = null;
       int responseCode = 0;    //ԶӦHTTP״̬
       StringBuffer result = new StringBuffer();
       try {
           URL realUrl = new URL(url);
           // 򿪺URL֮
           HttpURLConnection conn = (HttpURLConnection) realUrl.openConnection();
           // ͨõ 
           conn.setRequestProperty("accept", "*/*");
           conn.setRequestProperty("connection", "Keep-Alive");
           conn.setRequestProperty("user-agent",  "Mozilla/4.0 (compatible; MSIE 6.0; Windows NT 5.1;SV1)");
           //ַ  ַֹԭ򣨷UTF-8µýӿڲһ±Ͳһ£ 
           conn.setRequestProperty("Content-Type", "application/json;charset=UTF-8");
           BasicTool.addHeaderBasic(esbcode,conn);//HttpBasic֤
           // POST
           conn.setDoOutput(true);
           conn.setDoInput(true);
           // ȡURLConnectionӦ
           out = new OutputStreamWriter(conn.getOutputStream(), "UTF-8");
           // 
           out.write(paramJson);
           // flushĻ
           out.flush();
           responseCode = conn.getResponseCode();  
           //ȡԴ
           if(responseCode == HttpURLConnection.HTTP_OK) {//xug 
        	   // BufferedReaderȡURLӦ
               conninput = new InputStreamReader(conn.getInputStream(), "UTF-8");//xug  new֮ͷ
           }else {
        	   // BufferedReaderȡURLӦ
               conninput = new InputStreamReader(conn.getErrorStream(), "UTF-8");//xug  new֮ͷ
           }
           in = new BufferedReader(conninput);
           String line;
           while ((line = in.readLine()) != null) {
               result.append(line);
           }
       } catch (Exception e) {
    	   throw new Exception("xӿڵô", e);
       }
       //ʹfinallyر
       finally{
           try{
               if(out!=null){
                   out.close();
               }
               if(in!=null){
                   in.close();
               }
               if(conninput!=null){
            	   conninput.close();
               }
           }
           catch(IOException ex){
               ex.printStackTrace();
           }
       }
       //xug add Ϣ޸
       if(responseCode == HttpURLConnection.HTTP_OK) {
           if(result!=null && result.length()>0)//תΪJson
        	   return com.alibaba.fastjson.JSONObject.parseObject(result.toString());
           else
        	   return null; 
       }else {
    	   throw new Exception("Էӿڷ״̬:"+responseCode+";msg="+result);
       }
       //xug end Ϣ޸
   }
   
	/**
	* ָ URL POST󣨷ֵ
    * @param url  URL
    * @param paramJson jsonʽı
    * @param esbcode ӿڰȫȨ 
    * @return ԶԴӦ(ֵΪJson)
    */
   public static JSONObject sendJsonPost(String url, String paramJson,String esbcode) throws Exception{
	   OutputStreamWriter out = null;
       BufferedReader in = null;
       InputStreamReader conninput = null;
       StringBuffer result = new StringBuffer();
       try {
           URL realUrl = new URL(url);
           // 򿪺URL֮
           URLConnection conn = realUrl.openConnection();
           // ͨõ 
           conn.setRequestProperty("accept", "*/*");
           conn.setRequestProperty("connection", "Keep-Alive");
           conn.setRequestProperty("user-agent",  "Mozilla/4.0 (compatible; MSIE 6.0; Windows NT 5.1;SV1)");
           //ַ  ַֹԭ򣨷UTF-8µýӿڲһ±Ͳһ£ 
           conn.setRequestProperty("Content-Type", "application/json;charset=UTF-8");
           BasicTool.addHeaderBasic(esbcode,conn);//HttpBasic֤
           // POST
           conn.setDoOutput(true);
           conn.setDoInput(true);
           // ȡURLConnectionӦ
           out = new OutputStreamWriter(conn.getOutputStream(), "UTF-8");
           // 
           out.write(paramJson);
           // flushĻ
           out.flush();
           // BufferedReaderȡURLӦ
           conninput = new InputStreamReader(conn.getInputStream(), "UTF-8");//xug  new֮ͷ
           in = new BufferedReader(conninput);
           String line;
           while ((line = in.readLine()) != null) {
               result.append(line);
           }
       } catch (Exception e) {
           throw e;
       }
       //ʹfinallyر
       finally{
           try{
               if(out!=null){
                   out.close();
               }
               if(in!=null){
                   in.close();
               }
               if(conninput!=null){
            	   conninput.close();
               }
           }
           catch(IOException ex){
               ex.printStackTrace();
           }
       }
       if(result!=null && result.length()>0)//תΪJson
    	   return com.alibaba.fastjson.JSONObject.parseObject(result.toString());
       else
    	   return null;
   }
   
   public static JSONObject sendHttpJsonPost(String url,String param,String esbcode) throws Exception{  
       HttpURLConnection httpURLConnection = null;  
       OutputStream out = null; //д  
       BufferedReader br = null;   //  
       int responseCode = 0;    //ԶӦHTTP״̬ 
       InputStreamReader conninput = null;
       StringBuffer result=new StringBuffer();  
       try{  
           URL sendUrl = new URL(url);  
           httpURLConnection = (HttpURLConnection)sendUrl.openConnection();  
           //postʽ  
           httpURLConnection.setRequestMethod("POST");  
           //ͷϢ  
           httpURLConnection.setRequestProperty("headerdata", "ceshiyongde");  
           //һҪ Content-Type ҪȻ˽ղ  
           httpURLConnection.setRequestProperty("Content-Type", "application/Json; charset=UTF-8");  
           //ָʾӦóҪдURL,ֵĬΪfalseǷ񴫲Σ  
           httpURLConnection.setDoOutput(true);  
           httpURLConnection.setDoInput(true);   
             
           httpURLConnection.setUseCaches(false);//ʹû
           httpURLConnection.setConnectTimeout(120000); //120ӳʱ  
           httpURLConnection.setReadTimeout(120000);    //120ȡʱ  
           BasicTool.addHeaderBasic(esbcode,httpURLConnection);//HttpBasic֤
           //  
           out = httpURLConnection.getOutputStream();  
           out.write(param.getBytes());  
           out.flush(); //ջ,  
           responseCode = httpURLConnection.getResponseCode();  
           //ȡԴ 
           conninput = new InputStreamReader(httpURLConnection.getInputStream(),"UTF-8");//xug  new֮ͷ
           br = new BufferedReader(conninput);  
           String line="";
           while ((line = br.readLine()) != null) {
               result.append(line);
           }
       }catch(Exception e) {
    	   throw e;
       }finally{
			try {
				if(out!=null)
					out.close();
				if(br!=null)
					br.close();
	            if(conninput!=null){
	               conninput.close();
	            }
			} catch (IOException e) {
				e.printStackTrace();
			}  
       }
       if(result!=null && result.length()>0)//תΪJson
    	   return com.alibaba.fastjson.JSONObject.parseObject(result.toString());
       else
    	   return null; 
   }
   
   /**
	 * ESB
	 * ԶװEsbVO
	 */
	public static EsbVO createRequestEsbVO(final EsbVO esb){
		Date date=Calendar.getInstance().getTime();//ȡǰʱ
		EsbInfoVO esbInfo=new EsbInfoVO();
		esbInfo.setInstId(getStringUUID());//ʹUUIDΪˮ
		QueryInfoVO queryInfo=new QueryInfoVO();
//		queryInfo.setTotal_Page("1");//ĬҳΪ 1
//		queryInfo.setCurrent_page("1");//ĬϵǰҳΪ 1
		esbInfo.setRequestTime(dateFormat.format(date));//ʱ
		esb.setEsbInfo(esbInfo);
		esb.setQueryInfo(queryInfo);
		return esb;
	}
	
	/**
	 * UUIDֵ
	 */
	public static String getStringUUID(){
		return UUID.randomUUID().toString();
	}
	
	/**
	 * ־ڽ־SapPurchaseLogVOݿ
	 */
    public static ISapLog getSaplog(){
    	if(saplog==null)
    		saplog=NCLocator.getInstance().lookup(ISapLog.class);
    	return saplog;
    }
    
    /**
     *  NCSAP ־VO
     * @param pk_org ֯
     * @param billid ID
     * @param billno ݺ
     * @param pk_billtypecode	
     * @param pk_transtypecode	
     * @param send_data_ns	
     * @param resultdata_ns	Ӧ
     * @param msg_ns	ʾϢ
     * @param issuccess_ns	Ƿɹ  Y(ɹ)/N(ʧ)
     * @param classname	ִȫ
     * @return ־VO
     */
    public static SapPurchaseLogVO createNSLog(String pk_org,String billid,String billno,String pk_billtypecode,
    		String pk_transtypecode,String send_data_ns,String resultdata_ns,String msg_ns,String issuccess_ns,String classname){
    	SapPurchaseLogVO log=new SapPurchaseLogVO();
    	log.setPk_org(pk_org);
    	log.setBillid(billid);
    	log.setBillno(billno);
    	log.setPk_billtypecode(pk_billtypecode);
    	log.setPk_transtypecode(pk_transtypecode);
    	log.setSend_data_ns(send_data_ns);
    	log.setResultdata_ns(resultdata_ns);
    	log.setMsg_ns(msg_ns);
    	log.setIssuccess_ns(issuccess_ns);
    	log.setDef1(classname);
    	
    	//wby 20211017 ־ʱ
    	SimpleDateFormat df = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");//ڸʽ
    	log.setTs(df.format(new Date()));
    	return log;
    }
    
    /**
     *  SAPNC ־VO
     * @param pk_org ֯
     * @param billid ID
     * @param billno ݺ
     * @param pk_billtypecode	
     * @param pk_transtypecode	
     * @param send_data_sn	
     * @param resultdata_sn	Ӧ
     * @param msg_sn	ʾϢ
     * @param issuccess_sn	Ƿɹ  Y(ɹ)/N(ʧ)
     * @param classname	ִȫ
     * @return ־VO
     */
    public static SapPurchaseLogVO createSNLog(String pk_org,String billid,String billno,String pk_billtypecode,
    		String pk_transtypecode,String send_data_sn,String resultdata_sn,String msg_sn,String issuccess_sn,String classname){
    	SapPurchaseLogVO log=new SapPurchaseLogVO();
    	log.setPk_org(pk_org);
    	log.setBillid(billid);
    	log.setBillno(billno);
    	log.setPk_billtypecode(pk_billtypecode);
    	log.setPk_transtypecode(pk_transtypecode);
    	log.setSend_data_sn(send_data_sn);
    	log.setResultdata_sn(resultdata_sn);
    	log.setMsg_sn(msg_sn);
    	log.setIssuccess_sn(issuccess_sn);
    	log.setDef1(classname);
    	
    	//wby 20211017 ־ʱ
    	SimpleDateFormat df = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");//ڸʽ
    	log.setTs(df.format(new Date()));
    	return log;
    }
    
    /**
	 * @param e	쳣
	 * return 쳣ϸϢ
	 */
	public static String getExceptionDetail(Exception e) {  
		if(e==null)
			return null;
        StringBuffer stringBuffer = new StringBuffer(e.toString() + "\n");  
        if(e.getStackTrace()==null || e.getStackTrace().length==0)
        	return stringBuffer.toString();  
        StackTraceElement[] messages = e.getStackTrace();  
        int length = messages.length;  
        for (int i = 0; i < length; i++) {  
            stringBuffer.append("\t"+messages[i].toString()+"\n");  
        }  
        return stringBuffer.toString();  
    }
	
	/**
	 * ж֯ǷSAP (ڲֵûжô˷)
	 * @author  20180625
	 * @param pk_org ֯PKֵ
	 * @return trueϣ/falseδϣ
	 * @throws BusinessException
	 */
	public static boolean isSapOrg(String pk_org) throws BusinessException{
		String sql="select count(pk_org) from org_orgs where pk_org='"+pk_org+"' and def38='Y' and enablestate=2 and isnull(dr,0)=0";
		Integer num=(Integer) getQueryBS().executeQuery(sql, new ColumnProcessor());
		return num!=null && num.intValue()>0;
	}
	
	/**
	 * ж֯ǷSAPʱSAPʱ䣩
	 * @author  20180623
	 * @param pk_org ֯PKֵ
	 * @param date Ƶ
	 * @return trueϣ/falseδϣ
	 * @throws BusinessException
	 */
	public static boolean isSapOrg(String pk_org,String date) throws BusinessException{
		String sql="select def38,def39 from org_orgs where pk_org='"+pk_org+"' and enablestate=2 and isnull(dr,0)=0";
		HashMap<String,String> orgmap=(HashMap<String,String>) getQueryBS().executeQuery(sql, new MapProcessor());
		if(orgmap==null || orgmap.size()==0 || orgmap.get("def38")==null || orgmap.get("def39")==null)
			return false;
		if(!"Y".equals(orgmap.get("def38")))//ǷSAPYδ
			return false;
		DateFormat df = new SimpleDateFormat("yyyy-MM-dd");
		try {
			Date qdate=df.parse(orgmap.get("def39"));//
			Date sdate=df.parse(date);//
			if(sdate.getTime()<qdate.getTime()){
				return false;
			}
		} catch (Exception e) {
			return false;
		}
		return true;
	}
	
	public static IUAPQueryBS getQueryBS(){
		if(queryBS==null)
			queryBS=NCLocator.getInstance().lookup(IUAPQueryBS.class);
		return queryBS;
	}
}
