package nc.net.servlet;

import java.io.IOException;
import java.io.OutputStreamWriter;
import java.io.PrintWriter;
import java.text.SimpleDateFormat;
import java.util.Calendar;
import java.util.Date;
import java.util.UUID;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import nc.bcmanage.bs.IBusiCenterManageService;
import nc.bs.framework.adaptor.IHttpServletAdaptor;
import nc.bs.framework.common.InvocationInfoProxy;
import nc.bs.framework.common.NCLocator;
import nc.bs.framework.comn.NetStreamContext;
import nc.bs.framework.server.ISecurityTokenCallback;
import nc.itf.ws.esb.IEsbDAO;
import nc.pub.sap.constant.SapConstants;
import nc.pubitf.para.SysInitQuery;
import nc.vo.esb.EsbInfoVO;
import nc.vo.esb.EsbVO;
import nc.vo.esb.QueryInfoVO;
import nc.vo.esb.ResultEsbVO;
import nc.vo.esb.ResultVO;
import nc.vo.pub.BusinessException;
import nc.vo.ws.esb.CertificateVO;
import nc.vo.ws.esb.EsbinfoVO;
import nccloud.framework.core.exception.ExceptionUtils;

/**
 * ԽESB װServlet
 * @author  2018-09-28
 *
 */
public abstract class SapToNcEsbJsonServlet implements IHttpServletAdaptor {

        /**
         * ʱ侫ȷ
         */
        public static SimpleDateFormat dateFormat = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss:SSS");

        private static IEsbDAO service;


        private String beginDateStr;

        @Override
        public void doAction(HttpServletRequest request, HttpServletResponse response)
                        throws ServletException, IOException {
                beginDateStr=dateFormat.format(Calendar.getInstance().getTime());//ʼʱ
                initInvocationInfo();
                if(true){//֤ͨcheckEsbkey(request)

                        execFunction(request,response);

                }else{//֤ʧܴ
                        ResultVO result=new ResultVO();
                        result.setCode(IReturnStatus.FAILING);//ʧ
                        String esbkey=request.getHeader("esbkey");
                        if(esbkey==null){
                                result.setMessage("esbkeyΪգȨ֤ʧ!");
                        }else{
                                result.setMessage("esbkeyȨ֤ʧ!["+esbkey+"]ǷΪ֤keyֵ!");
                        }
                        ResultEsbVO<ResultVO> esb=new ResultEsbVO<ResultVO>();//Ӧ
                        createResultEsbVO(esb);//ʼӦ
                        esb.getEsbInfo().setReturnStatus(IReturnStatus.ESB_FAILING);
                        esb.setResultInfo(result);
                        sendResponse(response,esb);
                }
        }

        /**
         * ֤esbkey
         * @param request 
         * @return true(֤ͨ)/false(֤ʧ)
         */
        private boolean checkEsbkey(final HttpServletRequest request){
                boolean isok=true;
        try{
                String pathinfo=request.getPathInfo();
                if(pathinfo!=null){
                        pathinfo=pathinfo.substring(1, pathinfo.length());
                        EsbinfoVO[] esbinfos=(EsbinfoVO[]) getService().findESB("interfacename='"+pathinfo+"'");
                        if(esbinfos!=null && esbinfos.length>0){
                                String esbkey=request.getHeader("esbkey");
                                for(EsbinfoVO esb:esbinfos){
                                        if(esb.getIsstart()!=null && "1".equals(esb.getIsstart())){//Ƿ
                                                CertificateVO typevo=getService().findByPkCode(esb.getCertificate());
                                                if(typevo==null||!typevo.getEsbkey().equals(esbkey)){
                                                        isok=false;
                                                        break;
                                                }
                                        }else{
                                                isok=false;
                                                break;
                                        }
                                }
                        }else{
                                isok=false;
                        }
                }
        }catch(Exception e){
                isok=false;
        }
        return isok;
        }


        /**
         * ӦϢ
         * @param response
         * @param esb
         */
        public void sendResponse(final HttpServletResponse response,ResultEsbVO esb){
                String jsondata=com.alibaba.fastjson.JSONObject.toJSONString(esb);
                PrintWriter out=null;
                try {
                        response.setHeader("Content-type", "application/json;charset=UTF-8");
                        out = new PrintWriter(new OutputStreamWriter(response.getOutputStream(),"UTF-8"));
                out.write(jsondata);
                out.flush();
                } catch (IOException e) {
                        e.printStackTrace();
                }finally{
                        if(out!=null){
                                out.close();
                        }
                }
        }

        /**
         * ESB ߼ӿ
         * @return
         */
        private static IEsbDAO getService(){
        if(service==null)
                service=NCLocator.getInstance().lookup(IEsbDAO.class);
        return service;
        }

        /**
         * ESB
         * @param newi
         * @param esb VO
         * @return newi=0()
         */
        public void createEsbVO(final EsbVO esb){
                EsbInfoVO esbInfo=new EsbInfoVO();
                QueryInfoVO queryInfo=new QueryInfoVO();
                Date date=Calendar.getInstance().getTime();//ȡǰʱ
                //ʱ
                esbInfo.setRequestTime(dateFormat.format(date));
                esbInfo.setInstId(getStringUUID());//ʹUUIDΪˮ
                esb.setEsbInfo(esbInfo);
                esb.setQueryInfo(queryInfo);
        }
        /**
         * ESBӦ
         * @param esb
         */
        public void createResultEsbVO(final ResultEsbVO esb){
                EsbInfoVO esbInfo=new EsbInfoVO();
                QueryInfoVO queryInfo=new QueryInfoVO();
                Date date=Calendar.getInstance().getTime();//ȡǰʱ
                //Ӧʱ
                esbInfo.setInstId(getStringUUID());//ʹUUIDΪˮ
                esbInfo.setRequestTime(getBeginDateStr());//ʼʱ
                esbInfo.setResponseTime(dateFormat.format(date));//Ӧʱ
                esbInfo.setReturnStatus(IReturnStatus.ESB_SUCCEED);//ĬӦɹ
                esbInfo.setReturnCode(IReturnStatus.ESB_SUCCEED_CODE);//Ĭϳɹcode
                esbInfo.setReturnMsg("ɹ");//ĬӦɹʾ
                esb.setEsbInfo(esbInfo);
                esb.setQueryInfo(queryInfo);
        }

        /**
         * UUIDֵ
         */
        public static String getStringUUID(){
                return UUID.randomUUID().toString();
        }

        /**
         * @param e     쳣
         * return 쳣ϸϢ
         */
        public String getExceptionDetail(Exception e) {  
                if(e==null)
                        return null;
        StringBuffer stringBuffer = new StringBuffer(e.toString() + "\n");  
        if(e.getStackTrace()==null || e.getStackTrace().length==0)
                return stringBuffer.toString();  
        StackTraceElement[] messages = e.getStackTrace();  
        int length = messages.length;  
        for (int i = 0; i < length; i++) {
            stringBuffer.append("\t"+messages[i].toString()+"\n");  
        }  
        return stringBuffer.toString();  
    }

        /**
         * ʼʱ
         * @return
         */
        public String getBeginDateStr(){
                return beginDateStr;
        }


        /**
         * ҵ߼ִк
         * @param request
         * @param response
         */
        public abstract void execFunction(HttpServletRequest request, HttpServletResponse response);

        private void initInvocationInfo() {

    		NCLocator.getInstance().lookup(ISecurityTokenCallback.class).token("NCSystem".getBytes(), "pfxx".getBytes());
        	try {
    			IBusiCenterManageService busiCenterManageService=NCLocator.getInstance().lookup(IBusiCenterManageService.class);
    			InvocationInfoProxy.getInstance().setUserDataSource(busiCenterManageService.getAvailableBusiCenterDsNames()[0]);
    			InvocationInfoProxy.getInstance().setGroupId(SysInitQuery.getParaString("GLOBLE00000000000000", "GROUP"));
    			InvocationInfoProxy.getInstance().setUserId(SysInitQuery.getParaString("GLOBLE00000000000000", "WYBCUSER"));
    		} catch (BusinessException e) {
    			ExceptionUtils.wrapBusinessException(e.getMessage());
    		}
    		//ISecurityTokenCallback tc = NCLocator.getInstance().lookup(ISecurityTokenCallback.class);
    		//byte[] token = tc.token("__system".getBytes(), "NC".getBytes());
    		//NetStreamContext.setToken(token);
    		
        }
}