package nc.vo.pub.formulaset;

import java.lang.reflect.Array;
import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Enumeration;
import java.util.HashMap;
import java.util.Iterator;
import java.util.LinkedHashMap;
import java.util.List;
import java.util.Map;
import java.util.Vector;

import nc.vo.logging.Debug;
import nc.vo.ml.NCLangRes4VoTransl;
import nc.vo.pub.formulaset.core.EvaluatorVisitor;
import nc.vo.pub.formulaset.function.ICustomFunction;
import nc.vo.pub.formulaset.function.NcCustomFunction;
import nc.vo.pub.formulaset.function.PostfixMathCommandI;
import nc.vo.pub.formulaset.jep.JEPExpression;
import nc.vo.pub.formulaset.jep.JEPExpressionParser;
import nc.vo.pub.formulaset.model.FormulaError;
import nc.vo.pub.formulaset.util.BooleanObject;
import nc.vo.pub.formulaset.util.FormulaParseLogger;
import nc.vo.pub.formulaset.util.FormulaUtils;
import nc.vo.pub.formulaset.util.NullZeroNumber;
import nc.vo.pub.formulaset.util.ScaleManager;
import nc.vo.pub.formulaset.util.StringUtil;
import nc.vo.pub.lang.UFDouble;

/**
 * ʽ࣬еĹʽõ <br>
 * <br>
 * һģ飬άһԼһĹʽʼ<br>
 * ʽʹ÷:<br>
 * <code>
 * 
 *       String formula = "a->charAt(var,4)"; <br>
 *       FormulaParseFather f = new FormulaParse();<br>
 *       f.setExpress(formula);<br>
 *       f.addVariable(var,"teststring");<br>
 *       String result = f.getValue(); </code>
 * <p>
 * 
 * ߣ
 * <p>
 * <code>
 *      String[] formulas = new String[]{...};<br>
 *      FormulaParseFather f = new FormulaParse();<br>
 *      f.addVariable("cch",new Double(56));<br>
 *      f.setExpressArray(formulas);<br>
 *      VarryVO[] varrys = f.getVarryArray();  <br>
 *      f.addVariable("var",new String[]{"a","b","c"});
 *      String[][] resArray = f.getValueSArray();<br>
 *      </code>
 * <p>
 * <b>ע⣺ ʽĳʼ˵ǺʱԶ<font color=red>ǰ̨</font>ʽ벻Ҫÿζ <br>
 * 䲻ҪѭﴴЧ⣬ÿģһʵ</b><br>
 * ڽϳʹһʵʹgarbage()ձ(@sinceV56) <br>
 * <b>̨ʹʱͬһ߳ʹͬһʵ
 * 
 * @author cch (cch@ufida.com.cn) 2006-2-24-17:09:34
 * 
 */
abstract public class FormulaParseFather {
	/**
	 * The module ID which owns current parser. Null means this parser is a
	 * common one.
	 */
	private String						m_ownModuleID			= null;

	/**
	 * ʽ
	 */
	protected int						m_expressCount;

	/**
	 * ԭʼʽ
	 */
	protected String[]					m_formulas;

	/**
	 * ̬չĹʽЩʽ磺
	 * a,b,c->getColsValue("table","col1","col2","col3","colname",pkvars) չΪ
	 * a->getColsValue("table","col1","col2","col3","colname",pkvars)
	 * b->getColsValue("table","col1","col2","col3","colname",pkvars)
	 * c->getColsValue("table","col1","col2","col3","colname",pkvars)
	 */
	protected String[]					m_extendedFormulas;

	/**
	 * ÿֵĸ,йʽһ
	 */
	protected int						valueNum				= 1;

	/**
	 * ʽֺĽ
	 */
	protected List						formulavos				= null;

	/**
	 * Ϣ
	 */
	private FormulaError				m_error					= new FormulaError();

	/**
	 * ת
	 */
	private IFormulaConvertor			m_convertor				= new FormulaConvertor(this);

	private ScaleManager				m_scaleManager			= new ScaleManager();							// ȹ

	private final int					OBJECTTYPE				= 1;											// 󴫵

	private final int					STRINGTYPE				= 0;											// ַ

	private int							m_inputArgType			= 0;

	/**
	 * ¼ʽ
	 */
	private boolean						m_bParseError			= false;

	/**
	 * nullɷ0
	 */
	private boolean						m_bNullAsZero			= false;

	/* #################޸Ķ̶ִ߳ʾ#########Begin########## */

	/**
	 * Զ庯Ϣ
	 */
	private FormulaCustomFunctionCache	m_customfunctionCache	= new FormulaCustomFunctionCache();

	/**
	 * JEPʽ
	 */
	private JEPExpressionParser			m_jepParser				= null;

	/**
	 * ÿһ̶߳ʹõĹʽvisitor
	 */
	private EvaluatorVisitor			m_evaluator				= new EvaluatorVisitor();

	/**
	 * ʱıϢ
	 */
	private Map							m_parserInfoPool		= null;

	// ڵ
	private Map							m_expressionCache		= null;

	// ΪЧʣʽвݿѯʱһκת
	private boolean						m_doPostConvert			= true;

	// ͳһһ,Ч
	IFormulaAnalyser					analyser				= new FormulaAnalyser(this, getConvertor());	// תʽ

	private final static int			LRUSIZE					= 1000;

	private static class LRUMap<K, V> extends LinkedHashMap<K, V> {
		/**
         * 
         */
		private static final long	serialVersionUID	= 1L;

		public LRUMap(int initSize) {
			super(initSize, 0.75f, true);
		}

		protected boolean removeEldestEntry(Map.Entry<K, V> eldest) {
			if (size() > LRUSIZE)
				return true;
			else
				return false;
		}
	}

	/**
	 * ȡExpressionMap
	 * 
	 * @return
	 */
	protected Map getExpressionCache() {
		if (m_expressionCache == null)
			m_expressionCache = new LRUMap<String, JEPExpression>(100);
		return m_expressionCache;
	}

	/**
	 * JEPExpression뵽
	 * 
	 * @param exphashcode
	 *            hash
	 * @param expression
	 *            ѾϵJEPʽ(ڵ)
	 */
	public void addToExpressionCache(String formula, JEPExpression expression) {
		getExpressionCache().put(formula, expression);
	}

	/**
	 * ȡùʽ
	 * 
	 * @param exphashcode
	 *            hash
	 * @return
	 */
	public JEPExpression getExpressionFromCache(String formula) {
		return (JEPExpression) getExpressionCache().get(formula);
	}

	/**
	 * ǷҪñ任
	 * 
	 * @return
	 */
	public boolean isNeedDoPostConvert() {
		return m_doPostConvert;
	}

	/**
	 * ǷҪñ任
	 * 
	 * @param postConvert
	 */
	public void setNeedDoPostConvert(boolean postConvert) {
		m_doPostConvert = postConvert;
	}

	/**
	 * õԶ庯
	 * 
	 * @return Returns the m_customfunctionmap.
	 */
	public FormulaCustomFunctionCache getCustomfunctionCache() {
		return m_customfunctionCache;
	}

	/**
	 * JEPParserõJEP
	 * 
	 * @return Returns the m_jepParser.
	 */
	public JEPExpressionParser getJepParser() {
		return m_jepParser;
	}

	/* #################޸Ķ̶ִ߳ʾ########End########### */

	/**
	 * ݿѯĻ
	 */
	protected int			m_cacheType			= INT_MIX_CACHE;
	public final static int	INT_BD_CACHE		= 0;
	public final static int	INT_FOREDB_CACHE	= 1;
	public final static int	INT_MIX_CACHE		= 2;

	/**
	 * û,V5ϳϰBDCACHE,Դ˴ѾҪ
	 * 
	 * @param cacheType
	 * @deprecated
	 */
	public void setCacheType(int cacheType) {
		m_cacheType = cacheType;
	}

	/**
	 * õ,V5ϳϰBDCACHE,Դ˴ѾҪ
	 * 
	 * @param cacheType
	 * @deprecated
	 */
	public int getCacheType() {
		return m_cacheType;
	}

	protected ScaleManager getScaleManager() {
		return m_scaleManager;
	}

	/**
	 * 캯һЩʽĳʼ
	 */
	public FormulaParseFather() {
		// еĸϢ³ʼ
		initEnvironment();
	}

	/**
	 * 캯һЩʽĳʼ add by cch on 2007-05-22
	 * 
	 * @param ownModuleID
	 *            ģʶֲͬģĹʽ<br>
	 *            ֵĿΪԲͬģĽͬĳʼԶ庯
	 */
	public FormulaParseFather(String ownModuleID) {
		// еĸϢ³ʼ
		m_ownModuleID = ownModuleID;
		initEnvironment();
	}

	/**
	 * @return ģʶ
	 */
	public String getOwnModuleID() {
		return m_ownModuleID;
	}

	/**
	 * 
	 * 
	 * @return 
	 */
	public FormulaError getErrorVO() {
		if (null == m_error)
			m_error = new FormulaError();
		return m_error;
	}

	/**
	 * õϢ
	 * 
	 * @return ַ
	 */
	public String getError() {
		return getErrorVO().getError();
	}

	protected IFormulaConvertor getConvertor() {
		return m_convertor;
	}

	/**
	 * ҪĹʽ˹ʽʵ֮һô˷, ˷õʽ
	 * 
	 * @param expr
	 *            ʽַ
	 * @return ùʽͬʱֵʾõĹʽǷȷ
	 * @see public boolean setExpressArray(String[] newExpress)
	 */
	public boolean setExpress(String expr) {
		return setExpressArray(new String[] { expr });
	}

	/**
	 * ҪĹʽ˹ʽʵ֮һô˷
	 * 
	 * @param newExpress
	 *            ʽַ
	 * @return ùʽͬʱֵʾõĹʽǷȷ
	 * @see public boolean setExpress(String expr)
	 */
	public boolean setExpressArray(String[] newExpress) {
		if(FormulaParseLogger.isLogOn())
		{//ùʽ:"
			FormulaParseLogger.debug("setting formula:" + Arrays.asList(newExpress));
		}
		valueNum = 1;
		// ʽô
		// FormulaCallInfo.getInstance().addParsenum();
		if(FormulaParseLogger.isLogOn())
		{//ʼʽ:
			FormulaParseLogger.debug("start parasing formula:" + Arrays.asList(newExpress));
		}
		m_bParseError = false;
		getErrorVO().clearError();
		if (newExpress == null || newExpress.length == 0)
			return true;
		// ԭʼϢ
		// m_expressCount = newExpress.length;
		m_formulas = newExpress;

		// 鿴ǰ߳Ƿеǰʽִ
		registerParserToCurrentThread();

		// д
		formulavos = analyser.split(newExpress); // ֽ
		m_expressCount = formulavos.size();
		if (m_expressCount > m_formulas.length) {
			m_extendedFormulas = new String[m_expressCount];
			for (int i = 0; i < m_expressCount; i++) {
				m_extendedFormulas[i] = ((JEPExpression) formulavos.get(i)).getExpression();
			}
		} else
			m_extendedFormulas = m_formulas;

		String errorinfo = getError();
		if (errorinfo != null && errorinfo.length() != 0) {
			//ʽ:\n
			FormulaParseLogger.error("error of parsing formula \n" + getErrorVO().getError());
			//ǰĺб:%s
			FormulaParseLogger.error(String.format("current formula parser function list is %s", getJepParser().getFunctions()));
			//getErrorVO().clearError();
			m_bParseError = true;
			FormulaThread.release();
			return false;
		}
		if(FormulaParseLogger.isLogOn())
		{//ʽ!
			FormulaParseLogger.debug("parser formula is end!");
		}
		FormulaThread.release();
		return true;
	}

	/**
	 * 鹫ʽǷϷⲿ
	 * 
	 * @param formula
	 *            ҪĹʽ
	 * @return ǷϷ
	 * @see checkExpressArray(String[] formulas)
	 */
	public boolean checkExpress(String formula) {
		// Ƿд
		return checkExpressArray(new String[] { formula });
	}

	/**
	 * 鹫ʽǷϷⲿ
	 * 
	 * @param formulas
	 *            ҪĹʽַ
	 * @return ǷϷ
	 * @see checkExpress(String formula)
	 */
	public boolean checkExpressArray(String[] formulas) {
		getErrorVO().clearError();
		// ʽô
		// FormulaCallInfo.getInstance().addChecknum();
		if(FormulaParseLogger.isLogOn())
		{//ʼ鹫ʽ:
			FormulaParseLogger.debug("Start checking formula " + Arrays.asList(formulas));
		}
		if (formulas == null || formulas.length == 0) // ʽΪգΪȷ
			return true;
		// 鿴ǰ߳Ƿеǰʽִ
		registerParserToCurrentThread();

		// д
		analyser.split(formulas); // ֽ
		String errorinfo = getError();
		if (errorinfo != null && errorinfo.length() != 0) {
			//ʽȷִ\n
			FormulaParseLogger.error("an error occur on checking formula \n" + errorinfo);
			getErrorVO().clearError();
			FormulaThread.release();
			return false;
		}
		if(FormulaParseLogger.isLogOn())
		{
			//ʽȷ!
			FormulaParseLogger.debug("checking result is correct!");
		}
		FormulaThread.release();
		return true;
	}

	/**
	 * 鹫ʽ
	 * 
	 * @return
	 */
	public boolean check() {
		// Ƿд
		if (getErrorVO().getError() != null)
			return false;
		else
			return true;
	}

	/**
	 * ȡùʽһ깫ʽʽúӦɵô˷õʽֵ <br>
	 * <font color=red><b>ʽԶʽ</b></font>
	 * 
	 * @return ά飬һάӦʽĸڶάӦĳ
	 *         <p>
	 *         йʽ:<br>
	 *         "a->b+c;d->4*a" <br>
	 *         b=[1,2,3,4],c=[2,2,2,2]<br>
	 *         ôֵΪһ2*4Ķά飬ÿһԪΪInteger<br>
	 *         һάΪa = [3,4, 5, 6]<br>
	 *         ڶάΪc = [4,8,12,16]
	 * @see public String[][] getValueSArray()
	 */
	public Object[][] getValueOArray() {
		// ʽô
		// FormulaCallInfo.getInstance().addComputenum();
		if(FormulaParseLogger.isLogOn())
		{//ȡʽֵ:"
			FormulaParseLogger.debug("evaluate formula " + Arrays.asList(m_formulas));
		}
		// жϹʽΪ
		if (m_formulas == null || m_formulas.length == 0) {
			//ڹʽֵǰҪùʽʽ!
			FormulaParseLogger.error("to set formula expression before evaluate formula");
			return null;
		}
		// ʽֵΪգعʽ
		m_expressCount = formulavos.size();
		Object[][] result = new Object[m_expressCount][];

		if(FormulaParseLogger.isLogOn())
		{//ʼȡʽֵ...
		FormulaParseLogger.debug("evaluate formula...");
		}
			
		// Ƿд
		if (m_bParseError) {
			reStoreFormulaSet(); // ԭʽϢ
			for (int i = 0; i < m_expressCount; i++) {
				result[i] = new Object[] { m_extendedFormulas[i] };
			}
			if(FormulaParseLogger.isLogOn())
			{ 
				FormulaParseLogger.debug(String.format("current formula is %s and evaluate result is%s", Arrays.asList(m_formulas), result));
			}
			return result;
		}

		// 鿴ǰ߳Ƿеǰʽִ
		registerParserToCurrentThread();

		// 㹫ʽֵͬʱ²
		for (int i = 0; i < formulavos.size();) {
			JEPExpression exp = (JEPExpression) formulavos.get(i);
			// update by 20201112
			Object resobj = null;
			String expression = null;
			String leftName = null;
			try {
				expression = exp.getExpression();
				leftName = exp.getLeftName();
				resobj = (exp == null) ? null : exp.getResult();
				
			}catch(Exception e2) {
				throw new RuntimeException("ִйʽ쳣ֶα룺"+leftName+"ʽ"+expression+"");
			}
			
			if (resobj == null) {
				if(FormulaParseLogger.isLogOn())
				{
					FormulaParseLogger.debug("formula is [" + (exp == null ? "" : exp.getExpression()) + "]" + "and evaluate result is null");
				}
				// еĴ
				if (exp != null && exp.getErrorInfo() != null) {
					// 2007.11.12,append the error info of expression to Formula
					// error
					getErrorVO().appendError("\n" + exp.getErrorInfo());
					FormulaParseLogger.error(exp.getErrorInfo());
				}
				result[i++] = null;
				continue;
			} else if (resobj instanceof List || resobj instanceof Vector) // Listʽ
			{
				if (FormulaParseLogger.isLogOn())
					{
					FormulaParseLogger.debug("formula is [" + exp.getExpression() + "]" + " and evaluate result is " + resobj);
					}
				List rowvalues = (List) resobj;
				convertListToObjectArray(rowvalues, result, i, exp);
				updateVariableMap(exp.getLeftName(), rowvalues); // ²
				i++;
			} else {
				result[i] = new Object[1];
				result[i][0] = resobj;
				updateVariableMap(exp.getLeftName(), resobj);
				i++;
				if (FormulaParseLogger.isLogOn())
				{//ʽ[" + exp.getExpression() + "]" + "ִнΪ:" 
					FormulaParseLogger.debug("formula is [" + exp.getExpression() + "]" + " and evaluate result is " + resobj);
				}
			}

		}
		// ԷǷʽصNULLֵд
		result = dealResultValue(result);
		if (getError() != null)
			FormulaParseLogger.error(getError());
		reStoreFormulaSet(); // ԭʽϢ
		FormulaThread.release();
		if(FormulaParseLogger.isLogOn())
		{//ǰʽ%s ִнΪ:%s
			FormulaParseLogger.debug(String.format("current formula is %s and evaluate result is %s", Arrays.asList(m_formulas), result));
		}
		return result;
	}

	/**
	 * ȡöʽֵ,getValueOArray()ͬǣ˷ؽתΪString<br>
	 * V30Ƽʹ
	 * 
	 * @return
	 * @see public Object[][] getValueOArray()
	 */
	public String[][] getValueSArray() {
		// 㹫ʽֵ
		Object[][] oresult = getValueOArray();
		if (oresult == null || oresult.length == 0)
			return null;
		String[][] result = new String[m_expressCount][];
		for (int i = 0; i < oresult.length; i++) {
			Object[] objects = oresult[i];
			if (objects != null) {
				result[i] = new String[objects.length];
				for (int j = 0; j < objects.length; j++) {
					Object object = objects[j];
					if (object == null)
						result[i][j] = "";
					else
						result[i][j] = object.toString();
				}
			}
		}
		return result;
	}

	/**
     * 
     */
	private void registerParserToCurrentThread() {
		FormulaThread.registerJepParser(this);
		FormulaThread.registerEvVisitor(m_evaluator);
	}

	/**
	 * Էֵд
	 * 
	 * @param result
	 */
	protected Object[][] dealResultValue(Object[][] result) {
		if (result == null)
			return null;
		boolean bAllNull = true;

		// ֵ
		for (int i = 0; i < result.length; i++) {
			if (result[i] != null && result[i].length > valueNum)
				valueNum = result[i].length;
		}

		for (int i = 0; i < result.length; i++) {
			// ֵĴ
			if (result[i] == null || result[i].length == 0) {
				result[i] = new Object[valueNum];
			}
			// ԳĳȽе
			else if (result[i].length == 1 && result[i].length < valueNum) {
				Object saveobj = result[i][0];
				result[i] = new Object[valueNum];
				for (int j = 0; j < valueNum; j++) {
					result[i][j] = saveobj;
				}
				bAllNull = false; // зǿֵ
			} else {
				bAllNull = false;
			}
            if(formulavos==null||formulavos.size()<=i){ // λʱȸĶһΪܹݹʽ
            	break;
            }
			// Բֵͽ
			JEPExpression exp = (JEPExpression) formulavos.get(i);
			if (result[i] != null && result[i].length > 0) {
				for (int j = 0; j < result[i].length; j++) {
					Object obj = result[i][j];
					if (FormulaUtils.isParamNull(obj)) // ΪnullĻָ
					{
						obj = null;
					} else if (obj instanceof NullZeroNumber) {
						obj = new Double(0);
					} else if (obj instanceof BooleanObject)
						obj = ((BooleanObject) obj).toBoolean();

					// ȴ--ȥdoubleתUFDouble0ᶪʧ
					if (obj instanceof Double) {
						// Double
						obj = getScaleManager().getScaledValue(exp.getLeftName(), (Double) obj);
					} else if (obj instanceof UFDouble) {
						// UFdouble
						obj = getScaleManager().getScaledValue(exp.getLeftName(), (UFDouble) obj);
					}
					result[i][j] = obj;
				}

			}
		}
		// NULLֵ
		if (bAllNull)
			result = null;
		return result;
	}

	/**
	 * ʼʽִ
	 */
	protected void initEnvironment() {
		// operators
		// modified by cch 2011-4-12
		// modified by mazqa 2011-5-10 avoid memeory leak.
		// Operator.registerEvOperator();
		// init variable
		m_jepParser = new JEPExpressionParser(getOwnModuleID());
		// 
		getScaleManager().setDefaultRoudingUp(BigDecimal.ROUND_HALF_UP);
	}

	/**
	 * listתΪ
	 * 
	 * @param rowvalues
	 * @param result
	 * @param i
	 * @param exp
	 * @return
	 */
	private void convertListToObjectArray(List rowvalues, Object[][] result, int i, JEPExpression exp) {
		int rowsize = rowvalues.size();
		if (rowvalues == null || rowsize == 0) {
			getErrorVO().appendError(FormulaError.ERR_ILLEGALRESULT);
			return;
		}
		// õʽĲȣڽֵֵ
		valueNum = rowsize;
		result[i] = new Object[rowsize];
		for (int j = 0; j < rowsize; j++) {
			Object o = rowvalues.get(j);
			result[i][j] = o;
		}
		return;
	}

	/**
	 * ²
	 * 
	 * @param rowvalues
	 */
	protected synchronized void updateVariableMap(String varname, Object rowvalues) {
		m_jepParser.addVariable(varname, rowvalues);
	}

	/**
	 * ˷ڷصʽҲµԶʽ<br>
	 * ʽǶֻصһ<br>
	 * Ϊ飬ҲֻضӦڵһ<br>
	 * 
	 * @return ʽ巵صĶȡڹʽ<br>
	 *         UFDoubleôصUFDouble,<br>
	 *         ʽ򷵻صBoolean
	 * @see public String getValue()
	 */
	public Object getValueAsObject() {
		Object[] re = getValueO();
		if (re == null || re.length == 0)
			return null;
		return re[0];
	}

	/**
	 * ˷ڷصʽҲµ,ַʽ<br>
	 * ʽǶֻصһ<br>
	 * Ϊ飬ҲֻضӦڵһ<br>
	 * 
	 * @return ʽ,תΪַ
	 * @see public Object getValueAsObject()
	 */
	public String getValue() {
		String[] re = getValueS();
		if (re == null || re.length == 0)
			return null;
		return re[0];
	}

	/**
	 * ˷ڷصʽ,Զʽ<br>
	 * ʽǶֻصһ<br>
	 * 
	 * @return ʽ巵صĶȡڹʽ<br>
	 *         UFDoubleôصUFDouble,<br>
	 *         ʽ򷵻صBoolean
	 * 
	 * @see public Object getValueAsObject()
	 */
	public Object[] getValueO() {
		Object[][] res = getValueOArray();
		if (res == null || res.length == 0)
			return null;
		return res[0];
	}

	/**
	 * ˷ڷصʽ,ַʽ<br>
	 * ʽǶֻصһ<br>
	 * 
	 * @return
	 * @see public String getValue()
	 */
	public String[] getValueS() {
		String[][] res = getValueSArray();
		if (res == null || res.length == 0)
			return null;
		return res[0];
	}

	/**
	 * ò,V3ϽӿڣƼʹãҪ :<br>
	 * <br>
	 * <font color=red>public void setDataSArray(Map keyListMap)</font> ߣ
	 * <p>
	 * <font color=red>public void addVariable(String name, Object value)</font>
	 * .
	 * 
	 * @param varryDataArray
	 *            java.util.Hashtable[]
	 * @deprecated
	 */
	public void setDataSArray(java.util.Hashtable[] varryDataArray) {
		m_inputArgType = STRINGTYPE;
		for (int i = 0; i < varryDataArray.length; i++) {
			Map hashtable = varryDataArray[i];
			addVariablesFromMap(hashtable);
		}
	}

	/**
	 * ò ,Objectsʽ(ΪUFDouble,Integer,Stringȵ)<br>
	 * ʾʹ(fΪʽʵ)
	 * <p>
	 * <code>
	 *  List v1 = new ArrayList();<br>
        v1.add("1001AA10000000000DZY"); //row value<br>
        v1.add("1001AA10000000000DZY"); //row value<br>
        v1.add("1001AA10000000000DZY"); //row value<br>
        Map map = new HashMap();<br>
        map.put("pk_deptdoc", v1);<br>
        f.setDataSArray(map);<br></code>
	 * 
	 * @param keyListMap
	 *            hashmap
	 */
	public void setDataSArray(Map keyListMap) {
		m_inputArgType = OBJECTTYPE;
		addVariablesFromMap(keyListMap);
	}

	/**
	 * ⲿܲ
	 * 
	 * @param keyListMap
	 */
	private void addVariablesFromMap(Map keyListMap) {
		// ²
		// m_variablemap.update(null, null);
		for (Iterator iterator = keyListMap.keySet().iterator(); iterator.hasNext();) {
			boolean berror = false;
			String colName = (String) iterator.next();
			Object tempvalues = keyListMap.get(colName);
			List values = null;
			if (tempvalues instanceof List) {
				values = (List) tempvalues;
			} else if (tempvalues instanceof Object[]) {
				values = new ArrayList();
				values.addAll(Arrays.asList((Object[]) tempvalues));
			} else {
				// ĲͲ֧
				berror = true;
			}

			// ĲΪ0
			if (values == null || values.size() == 0 || berror) {
				// ±
				updateVariableMap(colName, null);
			} else {
				valueNum = values.size();
				// 飬UFDOUBLEתΪDouble
				convertDataToKnownType(values);
				// ±
				updateVariableMap(colName, values);
			}

		}
	}

	/**
	 * Ϊʽӱ,ӱķΪ򵥶<br>
	 * ҲΪList
	 * <p>
	 * ʹ÷<br>
	 * <code>
	 *  List deptcode = new ArrayList();<br>
        deptcode.add("dept003");<br>
        f.addVariable("deptcode",deptcode);<br></code>
	 * 
	 * @param name
	 *            
	 * @param value
	 *            ֵ ָֻ֧ͼ飬List
	 * 
	 */
	public void addVariable(String name, Object value) {
		m_inputArgType = OBJECTTYPE;
		updateVariableMap(name, convertDataToKnownType(value));
	}

	/**
	 * ΪʽעԶ庯
	 * 
	 * @param name
	 *            
	 * @param value
	 *            ʵʵ,ʵPostfixMathCommandIӿڵ
	 */
	public void addFunction(String name, PostfixMathCommandI value) {
		if (!nc.vo.jcom.lang.StringUtil.isEmpty(name))
			m_jepParser.addFunction(name.toUpperCase(), value);
	}

	/**
	 * ĶһתֵĴԼNC30ϵĴֵʽ
	 * 
	 * @param obj
	 */
	protected Object convertDataToKnownType(Object obj) {
		try {
			if (obj == null) {
				return null;
			} else if (obj.getClass().isArray()) {
				List newlist = new ArrayList();
				int rawLen = Array.getLength(obj);
				for (int i = 0; i < rawLen; i++) {
					newlist.add(convertDataToKnownType(Array.get(obj, i)));
				}
				return newlist;
			} else if (obj instanceof List) {
				return dealObjectOfList((List) obj);
			} else if (obj instanceof Boolean) {
				return new BooleanObject((Boolean) obj); // Booleanʹ
			} else if (obj instanceof String && m_inputArgType == STRINGTYPE) // ϵķʽ
			{
				String str = obj.toString();
				return StringUtil.getValueFromString(str);
			}
			return obj;
		} catch (ClassCastException e) {
			getErrorVO().appendError(FormulaError.ERR_ARGTYPEDIFFER);
			//ʹ!
			FormulaParseLogger.error("incoming object type is error", e);
		} catch (Exception e) {
			//Դתʱִ!
			FormulaParseLogger.error("an error occur on converting incoming object type", e);
		}
		return null;
	}

	private Object dealObjectOfList(List obj) {
		List inlist = (List) obj;
		// ĲΪArrayListΪ
		if (inlist.size() == 0)
			return null;
		for (int i = 0; i < inlist.size(); i++) {
			Object o = inlist.get(i);
			inlist.set(i, convertDataToKnownType(o));
		}
		return inlist;
	}

	/**
	 * Listһת
	 * 
	 * @param srclist
	 */
	private void convertDataToKnownType(List srclist) {
		for (int i = 0; i < srclist.size(); i++) {
			Object obj = srclist.get(i);
			srclist.set(i, convertDataToKnownType(obj));
		}
	}

	/**
	 * õϢ
	 * 
	 * @return VarryVO
	 */
	public VarryVO getVarry() {
		VarryVO[] varvos = getVarryArray();
		if (varvos != null)
			return varvos[0];
		return null;
	}

	/**
	 * õָʽıϢ
	 * 
	 * @return VarryVO
	 */
	public VarryVO getVarry(String formula) {
		int npos = -1;
		if (m_formulas != null) {
			for (int i = 0; i < m_formulas.length; i++) {
				if (m_formulas[i].equals(formula)) {
					npos = i;
					break;
				}
			}
		}
		if (npos == -1) // ûùʽ߹ʽûҵ
		{
			setExpress(formula);
			npos = 0;
		}
		VarryVO[] varvos = getVarryArray();
		if (varvos != null) {
			return varvos[npos];
		}
		return null;
	}

	/**
	 * õйʽеıϢ
	 * 
	 * @return VarryVO[]
	 */
	public VarryVO[] getVarryArray() {
		if(FormulaParseLogger.isLogOn())
		{
			//ʼӹʽȡñ...
			FormulaParseLogger.debug("Get variables from formula...");
		}
		VarryVO[] resvos = new VarryVO[m_expressCount];
		if (m_formulas == null || formulavos == null || formulavos.size() == 0)
			return null;
		for (int i = 0; i < m_expressCount; i++) {
			if (formulavos.get(i) != null) {
				resvos[i] = ((JEPExpression) formulavos.get(i)).getVarryVO();
				// FormulaParseLogger.debug("ʽ" + i +
				// Arrays.asList(resvos[i].getVarry()));
			}
		}
		if(FormulaParseLogger.isLogOn())
		{//عʽеı!
			FormulaParseLogger.debug("Retun variables from formula!");
		}
		return resvos;
	}

	/**
	 * ʽעԶ庯Ϣⲿķעắ
	 * 
	 * @param className
	 *            
	 * @param methodName
	 *            
	 * @param returnType
	 *            ֵ
	 * @param argTypes
	 *            
	 */
	public void setSelfMethod(String className, String methodName, Class returnType, Class[] argTypes) {
		setSelfMethod(className, methodName, returnType, argTypes, true);
	}

	/**
	 * עắJEP
	 * 
	 * @param methodName
	 * @param className
	 * @throws InstantiationException
	 * @throws IllegalAccessException
	 * @throws ClassNotFoundException
	 */
	private void addFunctionToJepParser(String methodName, String className, boolean isNullAsZero)
			throws InstantiationException, IllegalAccessException, ClassNotFoundException {
		Object obj = Class.forName(className).newInstance();
		if (obj instanceof ICustomFunction)
			m_jepParser.addFunction(methodName.toUpperCase(), (PostfixMathCommandI) obj);
		else
			m_jepParser.addFunction(methodName.toUpperCase(), new NcCustomFunction(isNullAsZero));
	}

	/**
	 * Զ庯Ϣ ڣ(2001-7-9 15:01:50)
	 * 
	 * @param className
	 *            java.lang.String
	 * @param methodName
	 *            java.lang.String
	 * @param returnType
	 *            java.lang.Class
	 * @param argTypes
	 *            ava.lang.Class[]
	 * @param argValues
	 *            java.lang.Object[]
	 */
	public void setSelfMethod(String className, String methodName, Class returnType, Class[] argTypes,
			Object[] argValues) {
		try {
			addToCustomFunctionCache(methodName, className, methodName, argTypes, returnType);
			// صJEP
			addFunctionToJepParser(methodName, className, true);
		} catch (Exception e) {
			FormulaParseLogger.error(e.getMessage(), e);
			getErrorVO().appendError(FormulaError.ERR_CLASSNOTFOUND);
		}

	}

	public void setSelfMethod(String className, String methodName, Class returnType, Class[] argTypes,
			boolean isNullAsZero) {
		try {
			addToCustomFunctionCache(methodName, className, methodName, argTypes, returnType);
			// صJEP
			addFunctionToJepParser(methodName, className, isNullAsZero);
		} catch (Exception e) {
			FormulaParseLogger.error(e.getMessage(), e);
			getErrorVO().appendError(FormulaError.ERR_CLASSNOTFOUND);
		}

	}

	/**
	 * Զ庯Ϣ ڣ(2001-7-9 15:01:50)
	 * 
	 * @param method
	 *            java.lang.String
	 * @param className
	 *            java.lang.String
	 * @param methodName
	 *            java.lang.String
	 * @param returnType
	 *            java.lang.Class
	 * @param argTypes
	 *            java.lang.Class[]
	 */
	public void setSelfMethod(String method, String className, String methodName, Class returnType, Class[] argTypes) {
		try {
			addToCustomFunctionCache(method, className, methodName, argTypes, returnType);
			// صJEP
			addFunctionToJepParser(method, className, true);
		} catch (Exception e) {
			FormulaParseLogger.error(e.getMessage(), e);
			getErrorVO().appendError(FormulaError.ERR_CLASSNOTFOUND);
		}
	}

	/**
	 * ӵԶ庯
	 * 
	 * @param method
	 * @param className
	 * @param methodName
	 * @param argTypes
	 * @param returnType
	 */
	private void addToCustomFunctionCache(String method, String className, String methodName, Class[] argTypes,
			Class returnType) {
		m_customfunctionCache.addClassName(method, className);
		m_customfunctionCache.addArgType(method, argTypes);
		m_customfunctionCache.addReturnType(method, returnType);
		m_customfunctionCache.addCallMethod(method, methodName);
	}

	/**
	 * ÷ؽľ
	 * 
	 * @param scale
	 */
	public void setScale(int scale) {
		getScaleManager().setDefaultScale(scale);
	}

	/**
	 * ÷ؽľ
	 * 
	 * @param scale
	 */
	public void setScale(int scale, int roundingup) {
		getScaleManager().setDefaultScale(scale);
		getScaleManager().setDefaultRoudingUp(roundingup);
	}

	/**
	 * ñķؾ
	 * 
	 * @param varname
	 * @param scale
	 */
	public void setScale(String varname, int scale) {
		getScaleManager().addVarScale(varname, scale);
	}

	/**
	 * ñķؾ
	 * 
	 * @param varname
	 * @param scale
	 */
	public void setScale(String varname, int scale, int roundingup) {
		getScaleManager().addVarScale(varname, scale, roundingup);
	}

	/**
	 * ˴뷽˵ ܣò ڣ(2001-4-25 8:51:15)
	 * 
	 * @param varryData
	 *            java.util.Hashtable
	 */
	public void setDataS(java.util.Hashtable varryData) {
		setDataSArray(new java.util.Hashtable[] { varryData });
	}

	/**
	 * ùʽ,V3Ͻӿڣʹ<br>
	 * ʹ:<br>
	 * public void addVariable(String name, Object value) <br>
	 * 
	 * @param varryData
	 *            java.util.Hashtable
	 * @deprecated
	 */
	public void setData(java.util.Hashtable varryData) {
		if (varryData != null) {
			Enumeration enu = varryData.keys();

			if (enu != null) {
				String key = "";
				while (enu.hasMoreElements()) {
					try {
						key = (String) enu.nextElement();
						Object invalue = varryData.get(key);
						Object[] canShu = null;
						if (invalue instanceof String) {
							canShu = new String[1];
							canShu[0] = invalue;
						} else
							canShu = (Object[]) invalue;
						varryData.put(key, canShu); // ò
					} catch (Exception ex) {
						FormulaParseLogger.error(ex.getMessage(), ex);
						//ʾֵ󣡲:
						getErrorVO().appendError("an error occur on assign. parameter is " + key);
					}
				}
			}
		}
		setDataS(varryData);
	}

	/**
	 * NULLǷ0á ڣ(2001-7-9 15:13:42)
	 * 
	 * @return boolean
	 */
	public boolean isNullAsZero() {
		return m_bNullAsZero;
	}

	/**
	 * NULLǷԵ0á ڣ(2001-7-9 15:13:42)
	 * 
	 * @param newNullAsZero
	 *            boolean
	 */
	public void setNullAsZero(boolean newNullAsZero) {
		m_bNullAsZero = newNullAsZero;
	}

	/**
	 * ַ߼",ʹ֮Ϊַ V3Ϸʹ,NC30ӿ
	 * 
	 * @param st
	 * @return
	 * @deprecated
	 * @see StringUtil.toString(st)
	 */
	public String toString(String st) {
		return StringUtil.toString(st);
	}

	/**
	 * ַ߼",ʹ֮Ϊַ V3Ϸʹ,NC30ӿ
	 * 
	 * @param st
	 * @return
	 * @deprecated
	 * @see StringUtil.toString(st)
	 */
	public String[] toString(String st[]) {
		if (st == null || st.length <= 0)
			return null;

		String[] reSt = new String[st.length];
		for (int i = 0; i < st.length; i++) {
			reSt[i] = toString(st[i]);
		}
		return reSt;
	}

	/**
	 * ʽԭ ԵĻӦͳһЩϢ
	 * 
	 */
	public void buildReStorePoint() {
		if(FormulaParseLogger.isLogOn())
		{//ʽԭ...
			FormulaParseLogger.debug("buildding restore point for formulaparser");
		}
		if (m_parserInfoPool == null)
			m_parserInfoPool = new HashMap();
		// ҪϢ
		m_parserInfoPool.put("nullaszero", new Boolean(isNullAsZero()));
		m_parserInfoPool.put("cachetype", Integer.valueOf(getCacheType()));
		m_parserInfoPool.put("nodb", new Boolean(isNeedDoPostConvert()));
	}

	/**
	 * ԭʽϢ
	 * 
	 */
	public void reStoreFormulaSet() {
		if(FormulaParseLogger.isLogOn())
		{//ԭʽϢ...
			FormulaParseLogger.debug("restore formulaparser ...");
		}
		if (m_parserInfoPool == null)
			return;
		Boolean nullaszero = (Boolean) m_parserInfoPool.get("nullaszero");
		if (nullaszero != null)
			setNullAsZero(nullaszero.booleanValue());
		Integer cachetype = (Integer) m_parserInfoPool.get("cachetype");
		if (cachetype != null)
			setCacheType(cachetype.intValue());
		Boolean nodb = (Boolean) m_parserInfoPool.get("nodb");
		if (nodb != null)
			setNeedDoPostConvert(nodb.booleanValue());
		Debug.setDebuggable(false);
	}

	/**
	 * ձڴ
	 * 
	 * @since V56
	 */
	public void garbage() {
		// ձڴ
		VarryVO[] varries = getVarryArray();
		if (varries != null) {
			for (int i = 0; i < varries.length; i++) {
				String[] vars = varries[i].getVarry();
				if (vars != null) {
					for (int j = 0; j < vars.length; j++) {
						getJepParser().getVariables().put(vars[j], null);
					}
				}
				if (varries[i].getFormulaName() != null) {
					getJepParser().getVariables().put(varries[i].getFormulaName(), null);
				}
				// ҪǹʽΪյ
				// getJepParser().getVariables().put(varries[i].getFormulaName(),
				// null);
			}
		}
	}

	/**
	 * õԱ,̨ĬΪ,ǰ̨
	 * 
	 * @return
	 */
	public String getLangCode() {
		return "simpchn";
	}

	/**
	 * V3Ϸʹ
	 * 
	 * @return
	 * @deprecated
	 */
	public String getStarts() {
		return StringUtil.START_ST;
	}

	/**
	 * V3Ϸʹ
	 * 
	 * @return
	 * @deprecated
	 */
	public String getEnds() {
		return StringUtil.END_ST;
	}

	/**
	 * 滻ʽıõ滻Ĺʽַ
	 * 
	 * @param replacedFormula
	 *            - 滻Ĺʽַ
	 * @param varnames
	 *            - map<ԭ,滻>
	 * @return
	 */
	public String replaceVariableInExpression(String replacedFormula, Map varnames) {
		StringBuffer resultStr = new StringBuffer();
//		String[] formulas = replacedFormula.split(";");
		String[] formulas = replacedFormula.split(";(\\s*;\\s*)?");
		setExpressArray(formulas);
		VarryVO[] varries = getVarryArray();
		for (int i = 0; i < formulavos.size(); i++) {
			VarryVO varryVO = varries[i];
			if (varryVO!=null &&  varryVO.getFormulaName() != null && !varryVO.getFormulaName().startsWith("NC_FORMULA_VAR"))
				resultStr.append(varryVO.getFormulaName()).append("->");
			JEPExpression obj = (JEPExpression) formulavos.get(i);
			if(obj!=null)
			{resultStr.append(((JEPExpression) obj).replaceVariables(varnames));
			}
			if (i != formulavos.size() - 1)
				resultStr.append(";");
		}
		return resultStr.toString();
	}

	/**
	 * ÷ֵϢ
	 * 
	 * @param formulas
	 * @return
	 */
	public String getReturnInfo(String[] formulas) {
		if(FormulaParseLogger.isLogOn())
		{//ʼ鹫ʽ:
			FormulaParseLogger.debug("Start checking formulas" + Arrays.asList(formulas));
		}
		if (formulas == null || formulas.length == 0) // ʽΪգΪȷ
			return NCLangRes4VoTransl.getNCLangRes().getStrByID("formulaparse", "FormulaParseFather-000000")/*
																											 * ʽ֤ȷ
																											 * 
																											 * ûз
																											 */;
		// 鿴ǰ߳Ƿеǰʽִ
		registerParserToCurrentThread();

		StringBuilder result = new StringBuilder(NCLangRes4VoTransl.getNCLangRes().getStrByID("formulaparse",
				"FormulaParseFather-000002")/* ʽ:\n */);
		// д
		String errorinfo = getError();
		try {
			Map<String, IFormulaValidateType> varry2TypeArray = getReturnType(formulas);
			if(FormulaParseLogger.isLogOn())
			{//ʽȷ!
				FormulaParseLogger.debug("checking result is correct!");
			}
			FormulaThread.release();
			for (String key : varry2TypeArray.keySet()) {
				result.append(String.format("variable is %s type is %s\n", key, varry2TypeArray.get(key).getDisplayName()));
			}
		} catch (FormulaValidateException e) {
			result.append(e.getMessage());
		}
		if (errorinfo != null && errorinfo.length() != 0) {
			//ʽȷִ\n
			FormulaParseLogger.error("formula is incorrect:\n" + errorinfo);
			getErrorVO().clearError();
			FormulaThread.release();
			return String.format(
					NCLangRes4VoTransl.getNCLangRes().getStrByID("formulaparse", "FormulaParseFather-000001")/*
																											 * ʽȷ
																											 * 
																											 * ִ
																											 * 
																											 * \
																											 * n
																											 * %
																											 * s
																											 */,
					errorinfo);
		}
		return result.toString();
	}

	/**
	 * ÷ֵMap
	 * 
	 * @param formulas
	 * @return
	 */
	public Map<String, IFormulaValidateType> getReturnType(String[] formulas) throws FormulaValidateException {
		return analyser.getReturnType(formulas);
	}

	public List getFormulaExpressionVos() {
		return formulavos;
	}

}