package ncc.pub.wywgpt.utils;

import java.util.ArrayList;
import java.util.Collections;
import java.util.HashMap;
import java.util.HashSet;
import java.util.List;
import java.util.Set;

import com.alibaba.fastjson.JSONObject;

import nc.bs.dao.BaseDAO;
import nc.bs.framework.common.InvocationInfoProxy;
import nc.bs.framework.common.NCLocator;
import nc.bs.logging.Logger;
import nc.bs.uap.tools.formula.ExtFormulaParser;
import nc.itf.sap.bill.IResponseBill;
import nc.itf.sap.log.ISapLog;
import nc.itf.sap.valid.ISapItfValid;
import nc.itf.uap.IUAPQueryBS;
import nc.itf.uap.pf.IPFBusiAction;
import nc.itf.uap.pf.IWorkflowMachine;
import nc.itf.uif.pub.IUifService;
import nc.itf.ws.esb.IEsbDAO;
import nc.jdbc.framework.SQLParameter;
import nc.jdbc.framework.processor.ColumnProcessor;
import nc.net.pu.utils.PubUtils;
import nc.pub.sap.constant.SapConstants;
import nc.pub.sap.sort.SapVOSort;
import nc.vo.esb.EsbInfoVO;
import nc.vo.esb.EsbVO;
import nc.vo.esb.QueryInfoVO;
import nc.vo.jcom.lang.StringUtil;
import nc.vo.pub.AggregatedValueObject;
import nc.vo.pub.BusinessException;
import nc.vo.pub.CircularlyAccessibleValueObject;
import nc.vo.pub.lang.UFBoolean;
import nc.vo.pub.workflownote.WorkflownoteVO;
import nc.vo.pubapp.AppContext;
import nc.vo.pubapp.pattern.exception.ExceptionUtils;
import nc.vo.sap.result.SAPResultVO;
import nc.vo.sap.syproconfig.SyProConfigBVO;
import nc.vo.wfengine.definition.WorkflowTypeEnum;
import nc.vo.wfengine.pub.WfTaskOrInstanceStatus;
import nc.vo.ws.esb.EsbinfoVO;
import nccloud.commons.collections.CollectionUtils;
import nccloud.commons.lang.ArrayUtils;
import nccloud.commons.lang.StringUtils;
import nccloud.framework.service.ServiceLocator;
/**
 * @Description: 
 * 
 * @author л ̹԰SAPר
 * @date 2018-4-8
 * @version with NCC
 */
@SuppressWarnings("unchecked")
public class WyWGPTUtils {
	/**
	 * ѯʽ
	 * @param code			ͷ
	 * @param direction		SAP->NC ? NC->SAP
	 * @return
	 * @throws BusinessException
	 */
	public static HashMap<String,ArrayList<String>> getFormulas(String code,int direction) throws BusinessException{
			StringBuffer sqlstr = new StringBuffer("");
			sqlstr.append("item = (select pk_head").append("\r\n");
			sqlstr.append("  from sap_syproconfig").append("\r\n");
			sqlstr.append(" where billno = '");
			sqlstr.append(code);
			sqlstr.append("'").append("\r\n");
			sqlstr.append("   and nvl(dr, 0) = 0) and nvl(dr, 0) = 0  and isenable_sn='Y' "); 
			List<SyProConfigBVO> syProConfigBVOs = (List<SyProConfigBVO>)getQueryBS().retrieveByClause(SyProConfigBVO.class, sqlstr.toString());
			if(syProConfigBVOs!=null && syProConfigBVOs.size()>0){
			HashMap<String,ArrayList<String>> formulasMap = new HashMap<String,ArrayList<String>>();
			//ǿֶ
			ArrayList<String> notNullField = new ArrayList<String>();
			//SAP->NC  NC->SAP ʽ
			ArrayList<String> formula = new ArrayList<String>();
			//NCֶα
			ArrayList<String> nc_field_code = new ArrayList<String>();
			//NCֶ
			ArrayList<String> nc_field_name = new ArrayList<String>();
			//SAPֶα
			ArrayList<String> sap_field_code = new ArrayList<String>();
			Collections.sort(syProConfigBVOs, new SapVOSort(direction));
			for(SyProConfigBVO syProConfigBVO:syProConfigBVOs){
				if(SapConstants.DIRECTION_SAP2NC==direction){
					//SAP->NC
					if(syProConfigBVO.getIsenable_sn().booleanValue()){
						if(!syProConfigBVO.getNullflag().booleanValue()){
							notNullField.add(syProConfigBVO.getField_code());
							nc_field_name.add(syProConfigBVO.getField_name());
						}
						formula.add(syProConfigBVO.getFormula_sn());
					}
					//NCҲŽȥ begin
					nc_field_code.add(syProConfigBVO.getField_code());
					//NCҲŽȥ end
				}else if(SapConstants.DIRECTION_NC2SAP==direction){
					//NC->SAP
					if(syProConfigBVO.getIsenable_ns().booleanValue()){
						formula.add(syProConfigBVO.getFormula_ns());
						nc_field_code.add(syProConfigBVO.getField_code());
						sap_field_code.add(syProConfigBVO.getField_code_sap());
					}
				}
			}
			formulasMap.put(SapConstants.NOTNULL_FIELD_KEY, notNullField);
			formulasMap.put(SapConstants.FORMULA_KEY, formula);
			formulasMap.put(SapConstants.NC_FIELD_CODE, nc_field_code);
			formulasMap.put(SapConstants.SAP_FIELD_CODE, sap_field_code);
			formulasMap.put(SapConstants.NC_FIELD_NAME, nc_field_name);
			return formulasMap;
		}
		return null;
	}
	
	/**
	 * ǿУ+ִйʽ
	 * @param hConfigCode
	 * 				ͷʽñ
	 * @param bConfigCode
	 * 				幫ʽñ
	 * @param headVO
	 * 				ͷVO
	 * @param bodyVOs
	 * 				VO
	 * @throws BusinessException
	 */
	public static void notNullCheckAndExFormula(String hConfigCode,String bConfigCode,AggregatedValueObject aggVO) throws Exception {
		HashMap<String,ArrayList<String>> hFormulaone = WyWGPTUtils.getFormulas(hConfigCode,SapConstants.DIRECTION_SAP2NC);
		HashMap<String,ArrayList<String>> bFormulaone = WyWGPTUtils.getFormulas(bConfigCode,SapConstants.DIRECTION_SAP2NC);
		List<String> headKeys = hFormulaone.get(SapConstants.NOTNULL_FIELD_KEY);
		List<String> headKeYsName = hFormulaone.get(SapConstants.NC_FIELD_NAME);
		List<String> bodyKeys = new ArrayList<String>();
		List<String> bodyKeysName = new ArrayList<String>();
		if(bFormulaone!=null){
			bodyKeys=bFormulaone.get(SapConstants.NOTNULL_FIELD_KEY);	
			 bodyKeysName=bFormulaone.get(SapConstants.NC_FIELD_NAME);	
		}
		
		
		ArrayList<String> hFormula = hFormulaone.get(SapConstants.FORMULA_KEY);
		ArrayList<String> bFormula = new ArrayList<String>(); 
		if(bFormulaone!=null){
			bFormula =bFormulaone.get(SapConstants.FORMULA_KEY);
		}
		ExtFormulaParser extFormulaParser = new ExtFormulaParser();
//		if(aggVO instanceof BXVO){//
//			
//			BXVO bxvo=(BXVO)aggVO;
//			// ÷̯ϢNCûзرsap  begin
//			CShareDetailVO[] shareVO=bxvo.getcShareDetailVo();
//			if(shareVO!=null&&shareVO.length>0){
//				notNullCheck(headKeys,headKeYsName,bodyKeysName,bodyKeys, aggVO.getParentVO(), bxvo.getcShareDetailVo(),1);	
//				extFormulaParser.execFormulas(hFormula.toArray(new String[0]), bFormula.toArray(new String[0]), bxvo, null);
//				notNullCheck(headKeys,headKeYsName,bodyKeysName,bodyKeys, aggVO.getParentVO(),bxvo.getcShareDetailVo(),2);
//			}else {
//				notNullCheck(headKeys,headKeYsName,bodyKeysName,bodyKeys, aggVO.getParentVO(), aggVO.getChildrenVO(),1);	
//				extFormulaParser.execFormulas(hFormula.toArray(new String[0]), bFormula.toArray(new String[0]), bxvo, null);
//				notNullCheck(headKeys,headKeYsName,bodyKeysName,bodyKeys, aggVO.getParentVO(),aggVO.getChildrenVO(),2);
//			}
//			//÷̯ϢNCûзرsap end
//			
//		}else 
			notNullCheck(headKeys,headKeYsName,bodyKeysName,bodyKeys, aggVO.getParentVO(), aggVO.getChildrenVO(),1);
			extFormulaParser.execFormulas(hFormula.toArray(new String[0]), bFormula.toArray(new String[0]),aggVO);
			notNullCheck(headKeys,headKeYsName,bodyKeysName,bodyKeys, aggVO.getParentVO(),aggVO.getChildrenVO(),2);
	
	}
	/**
	 * ǿУ+ִйʽ
	 * @param hConfigCode
	 * 				ͷʽñ
	 * @param bConfigCode
	 * 				幫ʽñ
	 * @param headVO
	 * 				ͷVO
	 * @param bodyVOs
	 * 				VO
	 * @throws BusinessException
	 */
	public static void notNullCheckAndExFormulaTwo(String hConfigCode,String bConfigCode,AggregatedValueObject aggVO) throws Exception {
		HashMap<String,ArrayList<String>> hFormulaone = WyWGPTUtils.getFormulas(hConfigCode,SapConstants.DIRECTION_SAP2NC);
		HashMap<String,ArrayList<String>> bFormulaone = WyWGPTUtils.getFormulas(bConfigCode,SapConstants.DIRECTION_SAP2NC);
		List<String> headKeys = hFormulaone.get(SapConstants.NOTNULL_FIELD_KEY);
		List<String> headKeYsName = hFormulaone.get(SapConstants.NC_FIELD_NAME);
		List<String> bodyKeys = new ArrayList<String>();
		List<String> bodyKeysName = new ArrayList<String>();
		if(bFormulaone!=null){
			bodyKeys=bFormulaone.get(SapConstants.NOTNULL_FIELD_KEY);	
			 bodyKeysName=bFormulaone.get(SapConstants.NC_FIELD_NAME);	
		}
		
		
		ArrayList<String> hFormula = hFormulaone.get(SapConstants.FORMULA_KEY);
		ArrayList<String> bFormula = new ArrayList<String>(); 
		if(bFormulaone!=null){
			bFormula =bFormulaone.get(SapConstants.FORMULA_KEY);
		}
		ExtFormulaParser extFormulaParser = new ExtFormulaParser();
//		if(aggVO instanceof BXVO){//
//			
//			BXVO bxvo=(BXVO)aggVO;
//			// ÷̯ϢNCûзرsap  begin
//			CShareDetailVO[] shareVO=bxvo.getcShareDetailVo();
//			if(shareVO!=null&&shareVO.length>0){
//				notNullCheck(headKeys,headKeYsName,bodyKeysName,bodyKeys, aggVO.getParentVO(), bxvo.getcShareDetailVo(),1);	
//				extFormulaParser.execFormulas(hFormula.toArray(new String[0]), bFormula.toArray(new String[0]), bxvo, null);
//				notNullCheck(headKeys,headKeYsName,bodyKeysName,bodyKeys, aggVO.getParentVO(),bxvo.getcShareDetailVo(),2);
//			}else {
//				notNullCheck(headKeys,headKeYsName,bodyKeysName,bodyKeys, aggVO.getParentVO(), aggVO.getChildrenVO(),1);	
//				extFormulaParser.execFormulas(hFormula.toArray(new String[0]), bFormula.toArray(new String[0]), bxvo, null);
//				notNullCheck(headKeys,headKeYsName,bodyKeysName,bodyKeys, aggVO.getParentVO(),aggVO.getChildrenVO(),2);
//			}
//			//÷̯ϢNCûзرsap end
//			
//		}else 
			//notNullCheck(headKeys,headKeYsName,bodyKeysName,bodyKeys, aggVO.getParentVO(), aggVO.getChildrenVO(),1);
			extFormulaParser.execFormulas(hFormula.toArray(new String[0]), bFormula.toArray(new String[0]),aggVO);
			notNullCheck(headKeys,headKeYsName,bodyKeysName,bodyKeys, aggVO.getParentVO(),aggVO.getChildrenVO(),2);
	
	}
	/**
	 * ǿУ
	 */
	public static void notNullCheck(List<String> keys,List<String> keYsName,List<CircularlyAccessibleValueObject> lst_bdvo)throws Exception{
		Set<String> keySetName = new HashSet<String>();
		Object value;
		CircularlyAccessibleValueObject bdvo=null;
		if(null!=lst_bdvo&&lst_bdvo.size()>0){
			for(int j=0;j<lst_bdvo.size();j++){
				bdvo=lst_bdvo.get(j);
				if(CollectionUtils.isNotEmpty(keys) && bdvo!=null){
					for (int i = 0; i < keys.size(); i++) {
						String key=keys.get(i);
						value = bdvo.getAttributeValue(key);
						if(value==null || StringUtil.isEmptyWithTrim(value.toString())){
							keySetName.add(keYsName.get(i));
						}
					}
					if(keySetName.size()>0){
						String keyName = StringUtils.join(keySetName.toArray(), "");
						throw new BusinessException( "ֶβΪջNCӦĵڣ"+keyName);	
					}
				}
			}
		}
	}
	
	/**
	 * ǿֶУ
	 * @param headKeys
	 * 			ͷֶ
	 * @param bodyKeys
	 * 			ֶ
	 * @param bodyKeys2 
	 * @param bodyKeysName 
	 * @param headVO
	 * 			ͷVO
	 * @param bodyVOs
	 * 			VO
	 * @param type
	 * 			1һηǿУ飬2תǿУ
	 * @throws Exception
	 */
	public static void notNullCheck(List<String> headKeys,List<String> headKeYsName,List<String> bodyKeysName, List<String> bodyKeys, CircularlyAccessibleValueObject headVO,CircularlyAccessibleValueObject[] bodyVOs,int type) throws Exception{
		Set<String> keySetName = new HashSet<String>();
		Object value;
		if(CollectionUtils.isNotEmpty(headKeys) && headVO!=null){
			for (int i = 0; i < headKeys.size(); i++) {
				String key=headKeys.get(i);
				value = headVO.getAttributeValue(key);
				if(value==null || StringUtil.isEmptyWithTrim(value.toString())){
					keySetName.add(headKeYsName.get(i));
				}
			}
		}
		if(CollectionUtils.isNotEmpty(bodyKeys) && ArrayUtils.isNotEmpty(bodyVOs)){
		     for (int i = 0; i < bodyKeys.size(); i++) {
				for(CircularlyAccessibleValueObject bodyVO:bodyVOs){
					String key=bodyKeys.get(i);
					value = bodyVO.getAttributeValue(key);
					if(value==null || StringUtil.isEmptyWithTrim(value.toString())){
						keySetName.add(bodyKeysName.get(i));
					}
				}
			}
		}
		if(keySetName.size()>0){
			String keyName = StringUtils.join(keySetName.toArray(), "");
			if(type==1){
				throw new BusinessException( "ֶβΪգ"+keyName);	
			}else{
				throw new BusinessException( "ֶתʧܣ"+keyName);	
			}
		}
	}
	
	
	/**
	 * ѯNCֶαSAP
	 * @param code			ͷ
	 * @param direction		SAP->NC ? NC->SAP
	 * @return SAP->NC
	 * @throws BusinessException
	 */
	public static HashMap<String,String> getTranNCcodes(String code,int direction) throws BusinessException{
		StringBuffer sqlstr = new StringBuffer("");
		sqlstr.append("item = (select pk_head").append("\r\n");
		sqlstr.append("  from sap_syproconfig").append("\r\n");
		sqlstr.append(" where billno = '");
		sqlstr.append(code);
		sqlstr.append("'").append("\r\n");
		sqlstr.append("   and nvl(dr, 0) = 0) and nvl(dr, 0) = 0 "); 
		List<SyProConfigBVO> syProConfigBVOs = (List<SyProConfigBVO>)getQueryBS().retrieveByClause(SyProConfigBVO.class, sqlstr.toString());
		if(syProConfigBVOs!=null && syProConfigBVOs.size()>0){
			HashMap<String,String> tranNCcodeMap = new HashMap<String,String>();
			for(SyProConfigBVO syProConfigBVO:syProConfigBVOs){
				if(SapConstants.DIRECTION_SAP2NC==direction){
					//SAP->NC					
					if(syProConfigBVO.getIsenable_sn().booleanValue()){//Ƿsap-nc
						String code_sap=syProConfigBVO.getField_code_sap();
						if(code_sap!=null&&!"".equals(code_sap.trim())&&!"1".equals(code_sap.trim())){
							tranNCcodeMap.put(code_sap,syProConfigBVO.getField_code());
						}
					}					
				}
			}
			return tranNCcodeMap;
		}
		return null;
	}
	/**
	 * Ƿ񴫵SAP
	 * @param pk_transtypecode
	 * 			ͱ
	 * @return
	 * table  finfield ѯֶ
	 * @throws Exception
	 */
	public static boolean isSendToSAP(String pk_transtypecode,String table,String finfield) throws Exception{
		StringBuffer sqlstr = new StringBuffer("");
		sqlstr.append("select "+finfield+" from "+table+" where DJLXBM = '"); //def2  er_djlx
		sqlstr.append(pk_transtypecode); 
		sqlstr.append("'"); 
		String isSendToSAP = (String)getQueryBS().executeQuery(sqlstr.toString(), new ColumnProcessor());
		if(UFBoolean.TRUE.toString().equals(isSendToSAP)){
			return true;
		}
		return false;
	}
	
	/**
	 * Ƿ񴫵SAP(Զѯ)
	 * @author ҫ
	 * @time 2018917
	 * @param table
	 * @param finfield
	 * @param condition
	 * @return
	 * @throws Exception
	 */
	public static boolean isSendToSAP(String pk_transtypecode,String table,String finfield,String condition) throws Exception{
		StringBuffer sqlstr = new StringBuffer("");
		sqlstr.append("select "+finfield+" from "+table+" where ");
		sqlstr.append(condition); 
		String isSendToSAP = (String)getQueryBS().executeQuery(sqlstr.toString(), new ColumnProcessor());
		if(UFBoolean.TRUE.toString().equals(isSendToSAP)){
			return true;
		}
		return false;
	}
	
	/**
	 * ͨEsbJSonݵSAP/
	 * @param jsonData
	 * @param itfCode
	 * @return
	 * @throws Exception
	 */
	public static JSONObject sendToESB_GX(String jsonData,String itfCode) throws Exception {
		JSONObject resultinfo = null;
		IEsbDAO service = ServiceLocator.find(IEsbDAO.class);
		EsbinfoVO[] esbinfos = (EsbinfoVO[]) service.findESB("code='"+itfCode+"'");
		if(esbinfos==null){
			ExceptionUtils.wrappBusinessException("ûҵӿϢ-ӿڱ룺"+itfCode);
		}
		if(esbinfos.length>1){
			ExceptionUtils.wrappBusinessException("ӿϢѯ1"+esbinfos.length+"-ӿڱ룺"+itfCode);
		}
		String isstart = esbinfos[0].getIsstart();
		if("1".equals(isstart)){
			//ӿ
			String url = esbinfos[0].getUrl();
			String code = esbinfos[0].getCode();
			String msg = "󣺽ӿڱ룺"+itfCode+"\n"+"ģ\n"+jsonData;
			Logger.error(msg);
			resultinfo = PubUtils.sendJsonPost_GX(url, jsonData, code);
			if(resultinfo!=null){
				msg += "\nرģ\n"+resultinfo.toString();
			}
			Logger.error(msg);
		}else{
			Logger.error("ӿδãӿڱ룺"+itfCode);
		}
		return resultinfo;
	}
	
	/**
	 * ͨEsbJSonݵSAP/
	 * @param jsonData
	 * @param itfCode
	 * @return
	 * @throws Exception
	 */
	public static JSONObject sendToESB(String jsonData,String itfCode) throws Exception {
		JSONObject resultinfo = null;
		IEsbDAO service = ServiceLocator.find(IEsbDAO.class);
		EsbinfoVO[] esbinfos = (EsbinfoVO[]) service.findESB("code='"+itfCode+"'");
		if(esbinfos==null){
			ExceptionUtils.wrappBusinessException("ûҵӿϢ-ӿڱ룺"+itfCode);
		}
		if(esbinfos.length>1){
			ExceptionUtils.wrappBusinessException("ӿϢѯ1"+esbinfos.length+"-ӿڱ룺"+itfCode);
		}
		String isstart = esbinfos[0].getIsstart();
		if("1".equals(isstart)){
			//ӿ
			String url = esbinfos[0].getUrl();
			String code = esbinfos[0].getCode();
			String msg = "󣺽ӿڱ룺"+itfCode+"\n"+"ģ\n"+jsonData;
			Logger.error(msg);
			resultinfo = PubUtils.sendJsonPost(url, jsonData, code);
			if(resultinfo!=null){
				msg += "\nرģ\n"+resultinfo.toString();
			}
			Logger.error(msg);
		}else{
			Logger.error("ӿδãӿڱ룺"+itfCode);
		}
		return resultinfo;
	}
	
	public static String getSendToEsbData(String instId,Object requestInfo){
		EsbVO esbVO = new EsbVO();
		EsbInfoVO esbInfoVO = new EsbInfoVO();
		QueryInfoVO queryInfoVO = new QueryInfoVO();
		//ӿΨһ IDд˵ӿڱ+Long ͵ǰʱ䣬D02S-SAPMDM-1804-008-301235201459
		esbInfoVO.setInstId(instId);
		//÷ýӿʱ,ʽyyyy-MM-dd HH24:mm:ss:SSS
		esbInfoVO.setRequestTime(AppContext.getInstance().getServerTime().toString());
		//ֶ д˵ֶΣʱֵ
		esbInfoVO.setAttr1("");
		esbInfoVO.setAttr2("");
		esbInfoVO.setAttr3("");
		
		//ҳС
		queryInfoVO.setPageSize("1");
		//ڼҳ
		queryInfoVO.setCurrentPage("1");
		
		esbVO.setEsbInfo(esbInfoVO);
		esbVO.setQueryInfo(queryInfoVO);
		esbVO.setRequestInfo(requestInfo);
		return JSONObject.toJSONString(esbVO);
	}
	
	/**
	 * ͨͼѯϢ
	 * @param pk_tradetype ҵ񵥾ݽ
	 * @param pk_busibill ҵ񵥾
	 * @return Ϣ
	 * @throws BusinessException
	 */
//	public SettlementAggVO findSettlementByBillPK(String pk_tradetype,String pk_busibill) throws BusinessException{
//		Object pk_settlement=getQueryBS().executeQuery("select pk_settlement from cmp_settlement where pk_tradetype='"+pk_tradetype+"' and pk_busibill='"+pk_busibill+"' and isnull(dr,0)=0", new ColumnProcessor());
//		if(pk_settlement==null || "".equals(pk_settlement.toString().trim()))
//			return null;
//		SettlementAggVO aggvo=(SettlementAggVO) getService().queryBillVOByPrimaryKey(
//				new String[]{
//				SettlementAggVO.class.getName(),
//				SettlementHeadVO.class.getName(),
//				SettlementBodyVO.class.getName()}
//				, pk_settlement.toString());
//		return aggvo;
//	}
	/**
	 * ԶǩֽϢ
	 * @param aggvos
	 * @throws BusinessException
	 */
//	public void autoSettles(final SettlementAggVO[] aggvos) throws BusinessException{
//		UFDate date=new UFDate();
//		for(int i=0;i<aggvos.length;i++){
//			SettlementHeadVO headvo=(SettlementHeadVO)aggvos[i].getParentVO();
//			headvo.setSettletype(SettleType.HAND_SETTLE.getStatus());
//			headvo.setPk_executor(headvo.getPk_signer());//ǩΪǰ
//			headvo.setLastupdater(headvo.getPk_signer());//ǩΪ¸
//			//headvo.setLastupdatedate(date);
//			aggvos[i].setParentVO(headvo);
//		}
//		SettleUtils.fillSettleDate(date, aggvos);//
//		getSettle().settleArray(aggvos);
//	}
	/**
	 * ԶǩֽϢ
	 * @param aggvos
	 * @throws BusinessException
	 */
//	public void autoSign(final SettlementAggVO[] aggvos) throws BusinessException{
//		UFDate date=new UFDate();
//		for(int i=0;i<aggvos.length;i++){
//			SettlementHeadVO headvo=(SettlementHeadVO)aggvos[i].getParentVO();
//			//headvo.setBusistatus(8);
//			headvo.setPk_signer(INCSystemUserConst.NC_USER_PK);// NCϵͳ Ϊǰǩ
//			//headvo.setLastupdatedate(date);
//			headvo.setLastupdater(INCSystemUserConst.NC_USER_PK);// NCϵͳ Ϊ¸
//			aggvos[i].setParentVO(headvo);
//		}
//		SettleUtils.fillSignDate(date, aggvos);//ǩ
//		getSettle().signArray(aggvos);
//	}
	
	/**
	 * ѯ̴
	 * @param billType
	 * @param billId
	 * @return
	 * @throws Exception
	 */
	public static String queryWorkUserID(String billType,String billId)throws Exception {
		String userID = null;
		String strWfTypeSql = " and workflow_type in" + WorkflowTypeEnum.getInstanceTypeInSql(WorkflowTypeEnum.Approveflow.getIntValue());
		String where = "pk_billtype=? and billversionpk=? and ismsgbind='N' "
				+ strWfTypeSql
				+ " and actiontype<>'"
				+ WorkflownoteVO.WORKITEM_TYPE_BIZ
				+ "' and approvestatus in("
				+ WfTaskOrInstanceStatus.getUnfinishedStatusSet()
				+ ") order by senddate";
		SQLParameter para = new SQLParameter();
		para.addParam(billType);
		para.addParam(billId);
		List<WorkflownoteVO> co = (List<WorkflownoteVO>)new BaseDAO().retrieveByClause(WorkflownoteVO.class, where, para);
		if(co!=null && co.size()>0){
			userID = co.get(0).getCheckman();
		}
		if(userID==null || userID.trim().length()<20){
			userID = InvocationInfoProxy.getInstance().getUserId();
		}
		return userID;
	}
	/**
	 * ѯϢ
	 * @param actionCode
	 * @param billType
	 * @param billVO
	 * @return
	 * @throws BusinessException
	 */
	public static WorkflownoteVO getWorkflownoteVO(String actionCode,String billType,AggregatedValueObject billVO,HashMap hmPfExParams) throws BusinessException{
		WorkflownoteVO worknoteVO = getIWorkflowMachine().checkWorkFlow(actionCode, billType, billVO, hmPfExParams);
		if(worknoteVO!=null){
			worknoteVO.setApproveresult("Y");
			worknoteVO.setChecknote("׼");
		}
		return worknoteVO;
	}
	public static void setResultVO(String billno,String issuccess,String msg,SAPResultVO sapResultVO){
		sapResultVO.setBillid(billno);
		sapResultVO.setIssuccess(issuccess);
		sapResultVO.setMsg(msg);
	}
	/**
	 * ֻ2000ַ
	 * @param str
	 * @return
	 */
	public static String getNewStr(String str) {
		if(str==null || "".equals(str)){
			return str;
		}
        int length = 0;
        int j = 0;
        for(int i = 0; i < str.length(); i++){
            int ascii = Character.codePointAt(str, i);  
            if(ascii >= 0 && ascii <=255){
            	length++;
            }else{
            	length += 2;
            }
            if(length>2000){
            	break;
            }
            j = i;
        }
       return str.substring(0,j+1);
    }
	
	public static IUAPQueryBS getQueryBS() {
		return NCLocator.getInstance().lookup(IUAPQueryBS.class);
	}

	public IUifService getService(){
		return NCLocator.getInstance().lookup(IUifService.class);
	}
	
//	public ISAPAutoSettles getSettle(){
//		return NCLocator.getInstance().lookup(ISAPAutoSettles.class);
//	}
	/**
	 * Уӿ
	 * @return	ISapItfValid
	 */
	public static ISapItfValid getISapItfValid(){
		return ServiceLocator.find(ISapItfValid.class);
	}
	/**
	 * ־ӿ
	 * @return	ISapLog
	 */
	public static ISapLog getISapLog(){
		return NCLocator.getInstance().lookup(ISapLog.class);
	}
	
//	public static IBXBillPrivate getIBXBillPrivate(){
//		return NCLocator.getInstance().lookup(IBXBillPrivate.class);
//	}
	
	public static IResponseBill getIResponseBill(){
		return NCLocator.getInstance().lookup(IResponseBill.class);
	}
	
	public static IPFBusiAction getIPFBusiAction(){
		return NCLocator.getInstance().lookup(IPFBusiAction.class);
	}
	public static IWorkflowMachine getIWorkflowMachine() {
		return NCLocator.getInstance().lookup(IWorkflowMachine.class);
	}
}
