package nc.net.uapbd.activity;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;
import java.util.stream.Stream;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import nc.bs.bd.baseservice.busilog.IBDBusiLogUtil;
import nc.bs.dao.BaseDAO;
import nc.bs.framework.common.InvocationInfoProxy;
import nc.bs.framework.common.NCLocator;
import nc.bs.uap.tools.formula.ExtFormulaParser;
import nc.itf.bd.psn.psndoc.IPsndocQueryService;
import nc.itf.bd.psn.psndoc.IPsndocService;
import nc.itf.bd.psnbankacc.IPsnBankaccQueryService;
import nc.itf.bd.psnbankacc.IPsnBankaccService;
import nc.itf.uap.IUAPQueryBS;
import nc.itf.uap.IVOPersistence;
import nc.itf.uap.rbac.IRoleManage;
import nc.itf.uap.rbac.IRoleManageQuery;
import nc.itf.uap.rbac.IUserManage;
import nc.itf.uap.rbac.IUserManageQuery;
import nc.jdbc.framework.processor.BeanListProcessor;
import nc.jdbc.framework.processor.BeanProcessor;
import nc.jdbc.framework.processor.ColumnProcessor;
import nc.net.pu.utils.PubUtils;
import nc.net.servlet.NewEsbJsonServlet;
import nc.pub.sap.constant.SapConstants;
import nc.pubitf.para.SysInitQuery;
import nc.uapbd.service.rest.util.JsonTools;
import nc.vo.bd.bankaccount.BankAccSubVO;
import nc.vo.bd.bankaccount.BankAccbasVO;
import nc.vo.bd.bankdoc.BankdocVO;
import nc.vo.bd.psn.PsndocVO;
import nc.vo.bd.psn.PsnjobVO;
import nc.vo.bd.psnbankacc.PsnBankaccUnionVO;
import nc.vo.bd.psnbankacc.PsnBankaccVO;
import nc.vo.esb.ResultVO;
import nc.vo.om.job.JobVO;
import nc.vo.pub.BusinessException;
import nc.vo.pub.CircularlyAccessibleValueObject;
import nc.vo.pub.SuperVO;
import nc.vo.pub.lang.UFBoolean;
import nc.vo.pub.lang.UFDate;
import nc.vo.pub.lang.UFDateTime;
import nc.vo.pub.lang.UFLiteralDate;
import nc.vo.pub.para.SysInitVO;
import nc.vo.pubapp.AppContext;
import nc.vo.sap.log.SapPurchaseLogVO;
import nc.vo.sm.UserVO;
import nc.vo.uap.rbac.UserGroupVO;
import nc.vo.uap.rbac.role.RoleVO;
import nccloud.commons.lang.StringUtils;
import uap.json.JSONArray;
import uap.json.JSONObject;

public class MDG2NCCPsndocServelet extends NewEsbJsonServlet {


	private BaseDAO dao = null;
	private IPsndocQueryService iPsndocQueryService = null;
	private IUserManage userManageSerivce = null;
	private IRoleManageQuery roleManageQuery = null;
	private IRoleManage roleManageSercvice = null;
	private IBDBusiLogUtil busiLogUtil = null;

	private String pk_group = null;
	private String creater = null;
	private String code = null;
	private String bank = null;
	String uuid = null;
	String issuccess_sn = "Y";

	private IUserManage getUserManageSerivce() {
		if (userManageSerivce == null) {
			userManageSerivce = (NCLocator.getInstance().lookup(IUserManage.class));
		}

		return userManageSerivce;
	}

	private BaseDAO getDao() {
		if (dao == null) {
			dao = new BaseDAO();
		}
		return dao;
	}

	private IRoleManageQuery getIRoleManageQuery() {
		if (roleManageQuery == null) {
			roleManageQuery = (NCLocator.getInstance().lookup(IRoleManageQuery.class));
		}

		return roleManageQuery;
	}

	private IRoleManage getIRoleManage() {
		if (roleManageSercvice == null) {
			roleManageSercvice = (NCLocator.getInstance().lookup(IRoleManage.class));
		}
		return roleManageSercvice;
	}

	@Override
	public void execFunction(HttpServletRequest request, HttpServletResponse response, JSONObject jsonobj)
			throws Exception {
		Map<String, Object> outlook = new HashMap<String, Object>();
		String puuid = jsonobj.getJSONObject("ESB").getJSONObject("DATA").getJSONObject("DATAINFOS").getString("PUUID");
		Map<String, String> successPsnCode = new HashMap<String, String>();
		ResultVO resultvo = new ResultVO();
		//wby 20211017 ռԱڼ¼־
		StringBuilder sb_psnCode = new StringBuilder();
		try {
			JSONArray items = new JSONArray(ReceiveUtils.convert2Array(
					(com.alibaba.fastjson.JSONObject.parseObject(jsonobj.toString())).getJSONObject("ESB")
					.getJSONObject("DATA").getJSONObject("DATAINFOS").getJSONArray("DATAINFO")
					).toString());

			Map<String, Map<String, Object>> mapItems = ReceiveUtils
					.convert2Map((com.alibaba.fastjson.JSONObject.parseObject(jsonobj.toString())).getJSONObject("ESB")
							.getJSONObject("DATA").getJSONObject("DATAINFOS").getJSONArray("DATAINFO")
							);
			pk_group = ((SysInitVO) ((ArrayList) NCLocator.getInstance().lookup(IUAPQueryBS.class)
					.retrieveByClause(SysInitVO.class, "initcode='GROUP'")).get(0)).getValue();
			creater = ((SysInitVO) ((ArrayList) NCLocator.getInstance().lookup(IUAPQueryBS.class)
					.retrieveByClause(SysInitVO.class, "initcode='ITFUSER'")).get(0)).getValue();
			ExtFormulaParser extFormulaParser = new ExtFormulaParser();

			//ԱϢ
			HashMap<String, ArrayList<String>> formulaone = JsonTools.getFormulas("MDM2NccPsndoc", 0);
			if(formulaone == null) {
				throw new Exception( "ԱϢδãMDM2NccPsndocúͬ");
			}

			//Ա¼
			HashMap<String, ArrayList<String>> formulaoneStation = JsonTools.getFormulas("MDM2NccRY", 0);
			if(formulaoneStation == null) {
				throw new Exception( "Ա¼δãMDM2NccRYúͬ");
			}

			ArrayList<String> formulas = formulaone.get(SapConstants.FORMULA_KEY);
			//ÿԱ
			mapItems.forEach((k, v) -> {
				try {
					String def1 = new JSONObject(k).getString("code");
					String pk_psncl = null;
					List<Map<String, Object>> list = Stream.of(v).collect(Collectors.toList());
					JSONArray item = new JSONArray(com.alibaba.fastjson.JSONObject
							.parseArray(com.alibaba.fastjson.JSONObject.toJSONString(list)).toString());
					JSONArray stationItem = item.getJSONObject(0).getJSONArray("station");
					JSONObject psn = item.getJSONObject(0).getJSONObject("psn");
					JSONArray psnItem = new JSONArray();
					psnItem.put(psn);
					String sex = psn.getString("EMP_SEX") == null ? "" : psn.getString("EMP_SEX");
					if ("F".equalsIgnoreCase(sex)) {// MDG FΪŮMΪ
						sex = "2";
					} else if ("M".equalsIgnoreCase(sex)) {
						sex = "1";
					}

					List<CircularlyAccessibleValueObject> listDoc = JsonTools.setRecValues(
							(Class<? extends CircularlyAccessibleValueObject>) Class.forName("nc.vo.bd.psn.PsndocVO"),
							psnItem, formulaone);
					List<CircularlyAccessibleValueObject> listJob = JsonTools.setRecValues(
							(Class<? extends CircularlyAccessibleValueObject>) Class.forName("nc.vo.bd.psn.PsnjobVO"),
							stationItem, formulaoneStation);
					// update by guojx ӸλϢ
					List<CircularlyAccessibleValueObject> listStation = JsonTools.setRecValues(
							(Class<? extends CircularlyAccessibleValueObject>) Class.forName("nc.vo.om.job.JobVO"),
							stationItem, formulaoneStation);
					extFormulaParser.execFormulas(formulas.toArray(new String[formulas.size()]),
							listJob
							.toArray(new CircularlyAccessibleValueObject[listJob.size()]));
					extFormulaParser.execFormulas(formulas.toArray(new String[formulas.size()]),
							listDoc
							.toArray(new CircularlyAccessibleValueObject[listDoc.size()]));
					CircularlyAccessibleValueObject docVO = listDoc.get(0);
					//Ա
					String psnCode = (String) docVO.getAttributeValue("code");
					sb_psnCode.append(psnCode);
					//					CircularlyAccessibleValueObject stationVO = listStation.get(0);
					String mrPsncl = getQueryVal(" select pk_psncl from bd_psncl where code='01' ");
					pk_psncl = mrPsncl;// ԱĬϺͬ
					Map<String, String> mapStatus = new HashMap<String, String>() {
						{
							put("0", "");
							put("1", "");
							put("2", "ת");
						}
					};
					// ְж
					for (int i = 0; i < listJob.size(); i++) {
						String jobcode = (String) listStation.get(i).getAttributeValue("jobcode");
						List<JobVO> stations = (List<JobVO>) NCLocator.getInstance().lookup(IUAPQueryBS.class)
								.retrieveByClause(nc.vo.om.job.JobVO.class, "jobcode = '" + jobcode + "'");
						if (stations.size() > 0) {
							JobVO station = stations.get(0);
							// ΪգΪ£jobVOҪˢʱ
							String pk = station.getPrimaryKey();
							listStation.get(i).setPrimaryKey(pk);
							NCLocator.getInstance().lookup(IVOPersistence.class).updateVO((SuperVO) listStation.get(i));
							listJob.get(i).setAttributeValue("pk_job", station.getAttributeValue("pk_job"));
						} else {
							NCLocator.getInstance().lookup(IVOPersistence.class).insertVO((SuperVO) listStation.get(i));
							JobVO newJob = ((List<JobVO>) NCLocator.getInstance().lookup(IUAPQueryBS.class)
									.retrieveByClause(nc.vo.om.job.JobVO.class, "jobcode = '" + jobcode + "'")).get(0);
							listJob.get(i).setAttributeValue("pk_job", newJob.getAttributeValue("pk_job"));// ԱְϢ
						}

						//ְ¼ְ˾
						//						if(listJob.get(i).getAttributeValue("pk_org") == null) {
						//							throw new Exception( "Աְ֯Ϊգӿڱģ");
						//						}
						//Ա˾
						if(docVO.getAttributeValue("pk_org") == null) {
							throw new Exception( "Ա֯Ϊգӿڱģ");
						}

						String jobOrgCode = (String) docVO.getAttributeValue("pk_org");
						//wby 20211117 ҵԪԹˣҵԪûй
						String pk_org = getPKfromCode("org_orgs", "pk_org", "code", jobOrgCode, "isbusinessunit='Y'");
						if(StringUtils.isEmpty(pk_org)) {
							throw new Exception( "Աְ֯ڣͬ֯" + jobOrgCode + ",Ա:" + psnCode);
						}
						listJob.get(i).setAttributeValue("pk_org", pk_org);

						//ְ¼ְŴ
						if(psn.getString("NCC_FIN_DEPT_CODE") == null || "" == psn.getString("NCC_FIN_DEPT_CODE")) {
							throw new Exception( "ԱְűNCC_FIN_DEPT_CODEΪգӿڱģ");
						}

						String jobDeptCode = psn.getString("NCC_FIN_DEPT_CODE");
						//						String jobDeptCode = (String) listJob.get(i).getAttributeValue("pk_dept");
						//Ϊ Ҫ״
						String pk_dept = getQueryVal("select pk_dept from org_dept where code='" + jobDeptCode + "' and pk_org = '" + pk_org + "'");
						if(StringUtils.isEmpty(pk_dept)) {
							throw new Exception( "ԱְŲڣͬţ" + jobDeptCode + ",Ա:" + psnCode);
						}

						listJob.get(i).setAttributeValue("pk_dept", pk_dept);
						listJob.get(i).setAttributeValue("pk_group", pk_group);
						listJob.get(i).setAttributeValue("pk_psncl", pk_psncl);
						listJob.get(i).setAttributeValue("ismainjob",
								stationItem.getJSONObject(i).getInt("DESC5") == 1 ? "Y" : "N");
						listJob.get(i).setAttributeValue("psncode", psnCode);
						listJob.get(i).setAttributeValue("def10", mapStatus.get(listJob.get(i).getAttributeValue("def10")));

					}
					docVO.setAttributeValue("def1", def1);
					docVO.setAttributeValue("sex", sex);


					String orgCode = (String) docVO.getAttributeValue("pk_org");
					String pk_org = getPKfromCode("org_orgs", "pk_org", "code", orgCode, "isbusinessunit='Y'");
					if(StringUtils.isEmpty(pk_org)) {
						throw new Exception( "Ա֯֯ڣͬ֯" + orgCode + ",Ա:" + psnCode);
					}

					docVO.setAttributeValue("pk_org", pk_org);
					docVO.setAttributeValue("pk_group", pk_group);
					if(docVO.getAttributeValue("def5") != null) {
						docVO.setAttributeValue("def5", docVO.getAttributeValue("def5").equals("A") ? "ְ" : "ְ");// ڸ״̬
					}
					else {
						docVO.setAttributeValue("def5", "ְ");
					}

					//Ա
					StringBuffer error = new StringBuffer();
					error = handlePsn(psnCode, listJob, listDoc, docVO, error);
					if(!StringUtils.isEmpty(error.toString())) {
						issuccess_sn = "N";
						outlook.put(k, "Աִʧܣԭ" + error.toString());
						return;
					}

					//û
					handleUser(psnCode,docVO.getAttributeValue("def5"));

					outlook.put(k, "Աִͬгɹ" + error + ",Ա:" + psnCode);
					successPsnCode.put(psnCode, k);
					issuccess_sn = "Y";
				} catch (Exception e) {
					issuccess_sn = "N";
					//					outlook.put(k, "Աִʧܣԭ" + (e.getMessage() != null ? e.getMessage() : e.toString()));
					outlook.put(k, "Աִͬʧܣԭ" + e.toString());
					return;
					//								new JSONArray(com.alibaba.fastjson.JSONObject.parseArray(com.alibaba.fastjson.JSONObject.toJSONString(Stream.of(v).collect(Collectors.toList()))).toString()).getJSONObject(0).getJSONObject("psn").getString("PS_EMP_PK")+e.getMessage()
				}
			});

			// ݳɹԱȥ˻
			List<String[]> afterFiliter = resolveArray(items);
			if (successPsnCode.size() != 0) {
				afterFiliter.forEach(x -> {
					if (!successPsnCode.containsKey(x[3])) {
						outlook.put(successPsnCode.get(x[3]), "ڴԱ,޷˻:"+x[3]);
						return;
					}
					try {
						this.handleBank(x);
						outlook.put(successPsnCode.get(x[3]), outlook.get(successPsnCode.get(x[3])) + ",˻ִгɹ");
					} catch (BusinessException e) {
						e.printStackTrace();
						outlook.put(successPsnCode.get(x[3]),
								outlook.get(successPsnCode.get(x[3])) + ",˻ִʧ+" + e.getMessage());
					}
				});
			}

		} catch (Exception e) {
			issuccess_sn = "N";
			outlook.put("all", "Աͬʱ쳣");
			sendResponse(response, ReceiveUtils.responseMsg("S", "Աͬ쳣" + e.getMessage(), puuid, outlook));
			resultvo.setError(e.getMessage());
		} finally {
			List<SapPurchaseLogVO> logvo_list = new ArrayList<SapPurchaseLogVO>();
			String billno = sb_psnCode.toString();
			//wby 20211017 ÿαԱ¼־billnoֶ
			SapPurchaseLogVO logvo = PubUtils.createSNLog("MDG-NCC-PSNDOC", "", billno, "",
					"", jsonobj.toString(), outlook.toString(), "" + resultvo.getError(), issuccess_sn,
					this.getClass().getName());
			logvo_list.add(logvo);
			PubUtils.getSaplog().insertPurchaseLog_RequiresNew(logvo_list);
			if ("N".equals(issuccess_sn)) {
				sendResponse(response, ReceiveUtils.responseMsg("N", "Աͬ쳣", puuid, outlook));
			} else {
				sendResponse(response, ReceiveUtils.responseMsg("S", "Աͬɹ", puuid, outlook));
			}
		}
	}

	/*
	 * wby 20211017 ûҵ8
	 * update by daim Աְ ͣ˻ 20220517
	 */
	private void handleUser(String code,Object status) throws BusinessException {
		//ѯԱ
		String condition = "code='" + code + "' and nvl(dr,0)=0 ";
		PsndocVO[] psndocVOs = getPsndocQueryService().queryPsndocVOsByCondition(condition);
		if(psndocVOs == null || psndocVOs.length == 0) {
			return;
		}

		PsndocVO psndocVO = psndocVOs[0];
		String whereSql = " pk_psndoc='" + psndocVO.getPk_psndoc() + "'"+" or user_code = '"+psndocVO.getDef2()+"'";
		UserVO[] users = NCLocator.getInstance().lookup(IUserManageQuery.class).queryUserByClause(whereSql);
		//ڵûش
		if(users != null && users.length > 0) {
			UserVO user = users[0];
			//Աͣûͣ
			if( !"ְ".equals(status) ) {
				getUserManageSerivce().disableUser(user);
			}else if(user.getEnablestate()!=2){
				getUserManageSerivce().enableUser(user);
			}
			if(!user.getPk_base_doc().equals(psndocVO.getPk_psndoc())) {
				user.setPk_base_doc(psndocVO.getPk_psndoc());
				getUserManageSerivce().updateUser(user);
			}

		} else { //û򴴽û
			//BIP˺def2ΪԶû
			if(!StringUtils.isEmpty(psndocVO.getDef2())) {
				UserVO uservo = new UserVO();
				uservo.setUser_code(psndocVO.getDef2());
				uservo.setUser_name(psndocVO.getName());
				uservo.setEnablestate(Integer.valueOf(2));
				uservo.setPk_group(psndocVO.getPk_group());
				uservo.setPk_psndoc(psndocVO.getPk_psndoc());
				uservo.setBase_doc_type(Integer.valueOf(0));
				uservo.setPk_base_doc(psndocVO.getPk_psndoc());
				uservo.setIdentityverifycode("staticpwd");
				//				LanguageVO currentLang = MultiLangContext.getInstance().getCurrentLangVO();
				uservo.setContentlang("zhCN0000000000000000");
				uservo.setPwdlevelcode("update");
				uservo.setFormat("FMT0Z000000000000000");
				UFDate enableDate = new UFDate(true);
				uservo.setAbledate(enableDate);
				//ΪʹϵͳĬ
				uservo.setUser_password(null);
				uservo.setUser_type(1);
				//Ĭҵû
				String pk_userGroup = getQueryVal("select pk_usergroup, groupcode, groupname groupname, parentid, pk_group, dr, innercode, pk_org from sm_usergroup where groupcode='002' ");
				if(!StringUtils.isEmpty(pk_userGroup)) {
					UserGroupVO userGroupVo = (UserGroupVO)getDao().retrieveByPK(UserGroupVO.class, pk_userGroup, new String[] { "pk_org" });
					uservo.setPk_org(userGroupVo == null ? null : userGroupVo.getPk_org());
					uservo.setPk_usergroupforcreate(pk_userGroup);
				} else {
					uservo.setPk_org(null);
					uservo.setPk_usergroupforcreate(null);
				}
				uservo = getUserManageSerivce().addUser(uservo);

				RoleVO rolevo = getIRoleManageQuery().queryRoleByCode("SF_Role", psndocVO.getPk_group());
				if(rolevo != null) {
					getIRoleManage().assignRole2User(uservo.getCuserid(), new RoleVO[] { rolevo }, uservo.getPk_org(), enableDate, null);
				}

				//дҵ־
				//				new BDBusiLogUtil(getMDId()).writeBusiLog("CreateUser", null, psndocVO);
			}
		}
	}

	/**
	 *  2021101613:55:44 ߼
	 * @return
	 */
	public StringBuffer handlePsn(String code,List<CircularlyAccessibleValueObject> listJob,List<CircularlyAccessibleValueObject> listDoc,CircularlyAccessibleValueObject docVO,StringBuffer error) throws BusinessException{
		String condition = "code='" + code + "' and nvl(dr,0)=0 ";
		PsndocVO[] psndocVOs = getPsndocQueryService().queryPsndocVOsByCondition(condition);//ݱѯǷڴԱ
		PsndocVO newdocVO = (PsndocVO) docVO;
		newdocVO.setPsnjobs(listJob.toArray(new PsnjobVO[listJob.size()]));
		//add by daim Ĭϵ޸ ޸ʱ
		newdocVO.setModifiedtime(new UFDateTime(new Date()));
		newdocVO.setModifier(creater);
		//wby 20220617 
		InvocationInfoProxy.getInstance().setUserId(creater);
		//Ա벻ڵ
		if (psndocVOs == null || psndocVOs.length == 0) {
			//update by daim 20220517 ޸û
			NCLocator.getInstance().lookup(IPsndocService.class).insertPsndoc((PsndocVO) docVO, true);
			//			PsndocVO[] afterInsertParentVOs = getPsndocQueryService().queryPsndocVOsByCondition(condition);
			//PsndocVO afterInsertParentVO = getPsndocQueryService().queryPsndocVOsByCondition(condition)[0];
			//error.append(handlePsnjob(listJob, afterInsertParentVO, true, error));
		} else {//ԱڵθԱϢԹϢͬĳԹϢӦĴ
			//޸
			PsndocVO oldVO = psndocVOs[0];
			newdocVO.setAttributeValue("modifier", creater);
			newdocVO.setAttributeValue("modifiedtime", AppContext.getInstance().getServerTime());
			newdocVO.setPrimaryKey(oldVO.getPrimaryKey());
			listJob.forEach(x -> x.setStatus(1));

			//add by daim ԱϢ
			error=checkIsUapPsnjob(newdocVO,oldVO,error);
			//wby 20220228 Ϣ
			//error.append(handlePsnjob(listJob, oldVO, false, error));
			//			if (oldVO.getPsnjobs() != null) {
			//				//ǷСڵµְǷ ӾɹϢְΪյǸvo Ĵְж
			//				// update begin =====
			//				for (PsnjobVO vo : oldVO.getPsnjobs()) {
			//					//ְϢΪְΪգһ߼
			//					if(new UFBoolean(true).equals(vo.getIsmainjob())&&vo.getEnddutydate()==null) {
			//						//жϣĴְڱڵµְ
			//						listJob.forEach(x->{
			//							if(new UFBoolean(true).equals(x.getAttributeValue("ismainjob"))
			//									&& vo.getIndutydate().before((UFLiteralDate) x.getAttributeValue("indutydate"))) {//жǷΪְұĴְڴھvoְ
			//									UFLiteralDate date = (UFLiteralDate) x.getAttributeValue("indutydate");
			//									UFLiteralDate newDate = date.getDateBefore(1);
			//									vo.setAttributeValue("enddutydate", newDate);
			//									try {
			//										NCLocator.getInstance().lookup(IVOPersistence.class).updateVO((SuperVO) vo);
			//										//ְ
			//										if(x.getAttributeValue("pk_dept")==null) {
			//											error.append("Ų,ְ޷");
			//											return;
			//										}
			//										x.setAttributeValue("pk_psndoc", oldVO.getPrimaryKey());
			//										NCLocator.getInstance().lookup(IVOPersistence.class).insertVO((SuperVO) x);
			//
			//									} catch (BusinessException e) {
			//										// TODO Auto-generated catch block
			//										error.append("ԱϢʱ");
			//										e.printStackTrace();
			//									}
			//								}
			//						});
			//
			//					}
			//				}
			//			}
			//ְ
			//			listJob.stream().filter(x->new UFBoolean(false).equals(x.getAttributeValue("ismainjob"))).forEach(y->{
			//				try {
			//					y.setAttributeValue("pk_psndoc", oldVO.getPrimaryKey());
			//					NCLocator.getInstance().lookup(IVOPersistence.class).insertVO((SuperVO) y);
			//				} catch (BusinessException e) {
			//					// TODO Auto-generated catch block
			//					error.append("ԱϢʱ");
			//					e.printStackTrace();
			//				}
			//			});
		}
		return error;
	}

	private StringBuffer checkIsUapPsnjob(PsndocVO newdocVO, PsndocVO psndoc, StringBuffer error) {
		//ǰԱйϢ
		PsnjobVO[] jobs = psndoc.getPsnjobs();
		List<PsnjobVO> newPsnJob = new ArrayList<PsnjobVO>();
		//´ĹϢ
		List<PsnjobVO> listJob  = new ArrayList<PsnjobVO>(Arrays.asList(newdocVO.getPsnjobs()));
		boolean isNewJob = false;
		for(PsnjobVO newJob:listJob) {
			try {
				//¹ϢɹϢԱȴ
				for(PsnjobVO oldJob : jobs) {
					//ҵǰΨһְ
					if(oldJob.getIsmainjob().equals(new UFBoolean(true))&&(oldJob.getEnddutydate()==null||oldJob.getEnddutydate().compareTo(newJob.getIndutydate())>0)) {
						//жϲź֯Ƿͬ
						//ͬ ޸ľݵĽ
						//ݴ
						if(!oldJob.getPk_dept().equals(newJob.getPk_dept()) &&oldJob.getIndutydate().equals(newJob.getIndutydate())) {
							isNewJob  = true;
							oldJob.setPk_dept(newJob.getPk_dept());
							oldJob.setStatus(1);
						}
						else if(!oldJob.getPk_dept().equals(newJob.getPk_dept()) ||!oldJob.getPk_org().equals(newJob.getPk_org())) {
							isNewJob  = true;
							UFLiteralDate date = newJob.getIndutydate();
							UFLiteralDate newDate = date.getDateBefore(1);
							if(newDate.compareTo(oldJob.getIndutydate())>=0) {
								oldJob.setEnddutydate(newDate);
								oldJob.setStatus(1);
							}
						}
						else {
							//ͬ֯ ʼڲͬҲ
							if(!oldJob.getIndutydate().equals(newJob.getIndutydate())) {
								isNewJob  = true;
								UFLiteralDate date = newJob.getIndutydate();
								UFLiteralDate newDate = date.getDateBefore(1);
								if(newDate.compareTo(oldJob.getIndutydate())>=0) {
									oldJob.setEnddutydate(newDate);
									oldJob.setStatus(1);
								}
							}

						}
					}
					newPsnJob.add(oldJob);
				}
				//
				if(isNewJob) {
					//ְ
					newJob.setAttributeValue("pk_psndoc", psndoc.getPk_psndoc());
					newJob.setStatus(2);
					newPsnJob.add(newJob);
				}
			} catch(Exception ex) {
				error.append("ͬԱϢʱ" + ex.getMessage());
			}
		}
		//ְ
		newdocVO.setPsnjobs(newPsnJob.toArray(new PsnjobVO[newPsnJob.size()]));
		newdocVO.setTs(psndoc.getTs());
		try {
			NCLocator.getInstance().lookup(IPsndocService.class).updatePsndoc(newdocVO,false);
		} catch (BusinessException e) {
			error.append("ͬԱϢʱ" + e.getMessage());
			return error;
		}

		return error;
	}

	/*
	 * wby 20220228 ԱϢ
	 */
	private StringBuffer handlePsnjob(List<CircularlyAccessibleValueObject> listJob, PsndocVO psndoc, boolean isNewPsn, StringBuffer error) throws BusinessException {
		//ԱֱӹϢ
		if(isNewPsn) {
			listJob.forEach(newJob -> {
				newJob.setAttributeValue("pk_psndoc", psndoc.getPk_psndoc());
				try {
					NCLocator.getInstance().lookup(IVOPersistence.class).insertVO((SuperVO) newJob);
				} catch (BusinessException e) {
					error.append("ԱϢʱ");
					e.printStackTrace();
				}
			});
		} else {
			//޸ԱϢδźְһ£Ϊδ
			//wby 20220510 ظɹ¼Ż

			PsnjobVO[] jobs = psndoc.getPsnjobs();
			//			List<PsnjobVO> listOldJob = Arrays.asList(jobs);

			listJob.forEach(newJob -> {
				try {
					//¹ϢɹϢԱȴ
					boolean isNewJob = true;
					//					listOldJob.forEach(oldJob -> {
					for(PsnjobVO oldJob : jobs) {
						if(oldJob.getPk_dept().equals(newJob.getAttributeValue("pk_dept"))) {
							//һ£ڻǷְһ£޸
							boolean isUpdate = false;
							if(!newJob.getAttributeValue("ismainjob").equals(oldJob.getIsmainjob())) {
								oldJob.setIsmainjob((UFBoolean)newJob.getAttributeValue("ismainjob"));
								if(newJob.getAttributeValue("ismainjob").equals(new UFBoolean(true))) {
									UFLiteralDate date = (UFLiteralDate) oldJob.getAttributeValue("indutydate");
									UFLiteralDate newDate = date.getDateBefore(1);
									oldJob.setAttributeValue("enddutydate", newDate);
									oldJob.setEnddutydate((UFLiteralDate)newJob.getAttributeValue("enddutydate"));
									isUpdate = true;
								}
							}

							if(newJob.getAttributeValue("enddutydate") != null && oldJob.getEnddutydate() != null && !newJob.getAttributeValue("enddutydate").equals(oldJob.getEnddutydate())) {
								oldJob.setEnddutydate((UFLiteralDate)newJob.getAttributeValue("enddutydate"));
								isUpdate = true;
							}

							if(isUpdate) {
								NCLocator.getInstance().lookup(IVOPersistence.class).updateVO(oldJob);
								//							NCLocator.getInstance().lookup(IVOPersistence.class).deleteVO((SuperVO) oldJob);
								error.append("¼޸ĳɹ(" + oldJob.getPk_psnjob() + ")");
							}

							isNewJob = false;
						}
					}

					//ְŲһ£Ϊ
					if(isNewJob) {
						//ְ
						if(newJob.getAttributeValue("pk_dept") == null) {
							error.append("Ų,ְ޷");
							return;
						}

						newJob.setAttributeValue("pk_psndoc", psndoc.getPk_psndoc());
						NCLocator.getInstance().lookup(IVOPersistence.class).insertVO((SuperVO) newJob);
						error.append("¼ӳɹ(" + newJob.getAttributeValue("pk_dept") + ")");
					}
				} catch(BusinessException ex) {
					error.append("ͬԱϢʱ" + ex.getMessage());
				}
			});

		}

		return error;
	}

	/*
	 * Ϣ
	 */
	public void handleBank(String[] params) throws BusinessException {
		//		String accname = params[4];
		StringBuffer buffer = new StringBuffer();
		bank = params[0];
		String accnum = params[0];
		PsnBankaccUnionVO unionvo = new PsnBankaccUnionVO();
		PsnBankaccVO psnbankvo = new PsnBankaccVO();// ˻ (bd_psnbankacc)
		BankAccbasVO basavo = new BankAccbasVO();// ˻Ϣ (bd_bankaccbas)
		BankAccSubVO subvo = new BankAccSubVO();// ˻ӻ (bd_bankaccsub )
		String pk_bankaccbas = getPKfromCode("bd_bankaccbas", "pk_bankaccbas", "accnum", accnum);
		//wby Ա
		String pk_psndoc = getPKfromCode("bd_psndoc", "pk_psndoc", "code", params[3]);
		//˻Ѵ
		if (!StringUtils.isEmpty(pk_bankaccbas)) {
			String pk_psnbankacc = getPKfromCode("bd_psnbankacc", "pk_psnbankacc", "pk_bankaccbas", pk_bankaccbas);
			//˻ϢѴ
			if (!StringUtils.isEmpty(pk_psnbankacc)) {
				PsnBankaccUnionVO[] unionvos = NCLocator.getInstance().lookup(IPsnBankaccQueryService.class)
						.queryPsnBankaccUnionVosByPks(new String[] { pk_psnbankacc });

				if (unionvos == null) {
					throw new BusinessException("ڸ˻飡");
				}

				psnbankvo = unionvos[0].getPsnbankaccVO();
				basavo = unionvos[0].getBankaccbasVO();
				subvo = basavo.getBankaccsub()[0];
			}

		}

		String pk_org = getPKfromCode("org_orgs", "pk_org", "code", params[2], "isbusinessunit='Y'");
		psnbankvo.setPk_org(isNotNull(pk_org));// ҵԪ
		psnbankvo.setPk_psndoc(isNotNull(pk_psndoc));// Ա
		psnbankvo.setDr(0);
		// ˻ĬΪ
		basavo.setAccountproperty(1);
		unionvo.setPsnbankaccVO(psnbankvo);
		if (!StringUtils.isEmpty(accnum)) {
			basavo.setAccnum(accnum);// ˺
		} else {
			buffer.append("˺ŲΪգ飡");
		}
		//wby 20211023 еֻ״̬
		//		String pk_bankdoc = getPKfromCode("bd_bankdoc", "pk_bankdoc", "pcombinenum", params[1]);
		String sql = "select * from bd_bankdoc where nvl(dr,0)=0 and enablestate=2 and pcombinenum='" + params[1] + "'";
		BankdocVO bankVO = (BankdocVO)getDao().executeQuery(sql, new BeanProcessor(BankdocVO.class));
		if(bankVO == null) {
			buffer.append("екΪ" + params[1] + "ڻͣã飡");
		} else {
			basavo.setPk_bankdoc(bankVO.getPk_bankdoc());// 
			basavo.setPk_banktype(bankVO.getPk_banktype());// 
		}

		if (buffer.length() > 0) {
			throw new BusinessException(buffer.toString());
		}

		basavo.setAccopendate(new UFDate("2020-01-01"));// 
		basavo.setAccname(params[4]);// 
		basavo.setAccclass(0);// ˻
		basavo.setDataoriginflag(0);// ֲʽ
		String pk_user = SysInitQuery.getParaString("GLOBLE00000000000000", "ITFUSER");// getPKfromCode("sm_user","cuserid","user_code","jkzdr");
		basavo.setCreator(pk_user);// 
		basavo.setDr(0);
		basavo.setGroupaccount(UFBoolean.FALSE);
		basavo.setIsenableelecbill(UFBoolean.FALSE);
		basavo.setIsinneracc(UFBoolean.FALSE);
		basavo.setIssigned(UFBoolean.FALSE);
		basavo.setPk_org(pk_org);
		basavo.setQrybalanceitf(0);
		basavo.setSharetag(UFBoolean.FALSE);
		basavo.setEnablestate(2);

		subvo.setPk_currtype("1002Z0100000000001K1");//  Ĭ
		if (StringUtils.isEmpty(pk_bankaccbas)) {
			subvo.setStatus(2);
		}
		basavo.setBankaccsub(new BankAccSubVO[] { subvo });
		unionvo.setBankaccbasVO(basavo);

		//update by daim 20220421 ǰѯǰû¼п ҹʿĬϿֶ ȫΪnull start
		//ѯ˻ΪĬϱ pk_psndoc
		sql = "select * from bd_psnbankacc where pk_psndoc='"  + pk_psndoc + "' and isexpenseacc = 'Y'";
		List<PsnBankaccVO> hlist = (List<PsnBankaccVO>)getDao().executeQuery(sql, new BeanListProcessor(PsnBankaccVO.class));
		if(hlist != null && hlist.size() > 0) {
			for(PsnBankaccVO vo: hlist) {
				vo.setIsexpenseacc(new UFBoolean("N")); //Ĭϱ
				vo.setPayacc(null); //ÿ
				NCLocator.getInstance().lookup(IVOPersistence.class).updateVO(vo);
			}
		}
		//update by daim 20220421 ǰѯǰû¼п ҹʿĬϿֶ ȫΪnull end

		//˻Ѵڣֱ޸˻Ϣ
		if (!StringUtils.isEmpty(pk_bankaccbas)) {
			PsnbankUpdateImpl impl = new PsnbankUpdateImpl();
			impl.update(unionvo);
		} else { //˻,˻Աе˺
			//wby 20211023 ĸ˻ΪĬϱ͹ʿ1Ѵڵĸ˻Ĭϱ͹ʿ1޸ΪĬϱ͹ʿ0
			//ѯ˻ΪĬϱ pk_psndoc
			//			sql = "select * from bd_psnbankacc where isexpenseacc='Y' and pk_psndoc='"  + pk_psndoc + "'";
			//		    List<PsnBankaccVO> hlist = (List<PsnBankaccVO>)getDao().executeQuery(sql, new BeanListProcessor(PsnBankaccVO.class));
			//		    if(hlist != null && hlist.size() > 0) {
			//		    	//ȡĬϱ
			//		    	for(PsnBankaccVO vo: hlist) {
			//		    		vo.setIsexpenseacc(new UFBoolean(false)); //Ĭϱ
			//		    		vo.setPayacc(null); //ÿ
			//		    		NCLocator.getInstance().lookup(IVOPersistence.class).updateVO(vo);
			//		    	}
			//		    }

			//˺ΪµĬϱ
			psnbankvo.setIsexpenseacc(new UFBoolean("Y"));// Ĭϱ
			psnbankvo.setPayacc(1); //	1=ʿ1; 2=ʿ2; 3=ʿ3;
			unionvo.setPsnbankaccVO(psnbankvo);
			NCLocator.getInstance().lookup(IPsnBankaccService.class).insertPsnBankacc(unionvo);


		}

	}

	public List<String[]> resolveArray(JSONArray beforefiliter) {
		List<com.alibaba.fastjson.JSONObject> list = com.alibaba.fastjson.JSONArray
				.toJavaObject(com.alibaba.fastjson.JSONObject.parseArray(beforefiliter.toString()), ArrayList.class);
		// 0:п 1: 2:ҵԪ 3:Ա 4:
		return list.stream()
				.map(x -> new String[] { x.getString("BANK_CARD"), x.getString("OPENING_BANK"),
						x.getString("NCC_FIN_ORG_CODE"), x.getString("PS_EMP_PK"), x.getString("EMP_NAME") })
				.collect(Collectors.toList());
	}

	private String getPKfromCode(String tableName, String pk, String code, String code_value) throws BusinessException {
		return getPKfromCode(tableName, pk, code, code_value, "");
	}

	private String getPKfromCode(String tableName, String pk, String code, String code_value, String otherWhereSql) throws BusinessException {
		String sql = "select " + pk + " from " + tableName + " where nvl(dr,0)=0 and " + code + "='" + code_value
				+ "' ";
		if(!StringUtils.isEmpty(otherWhereSql)) {
			sql += " and " + otherWhereSql;
		}
		String codes = (String) getDao().executeQuery(sql, new ColumnProcessor());
		return codes;
	}

	private String isNotNull(String fieldValue) {
		return StringUtils.isEmpty(fieldValue) ? null : fieldValue;
	}

	public IPsndocQueryService getPsndocQueryService() {
		if (iPsndocQueryService == null) {
			iPsndocQueryService = NCLocator.getInstance().lookup(IPsndocQueryService.class);
		}
		return iPsndocQueryService;
	}


	private String getQueryVal(String querysql) {
		String queryvo = null;
		try {
			queryvo = (String) getDao().executeQuery(querysql, new ColumnProcessor());
			return queryvo;
		} catch (BusinessException e) {
			e.printStackTrace();
		}
		return null;
	}

}
