package nc.bs.bd.psn.psndoc.validator;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;
import java.util.Comparator;
import java.util.HashMap;
import java.util.HashSet;
import java.util.List;
import java.util.Map;
import java.util.Set;

import nc.bs.framework.common.NCLocator;
import nc.bs.logging.Logger;
import nc.bs.uif2.validation.ValidationFailure;
import nc.bs.uif2.validation.Validator;
import nc.itf.uap.IUAPQueryBS;
import nc.vo.bd.psn.PsnClVO;
import nc.vo.bd.psn.PsndocVO;
import nc.vo.bd.psn.PsnjobVO;
import nc.vo.bd.psn.util.GetBusiDateUtil;
import nc.vo.jcom.lang.StringUtil;
import nc.vo.org.DeptVO;
import nc.vo.pub.BusinessException;
import nc.vo.pub.VOStatus;
import nc.vo.pub.lang.UFLiteralDate;

/**
 * ԱʱϢӱУ
 * 
 * @author jiangjuna
 * 
 */
public class PsnjobValidator implements Validator {

	private static final long serialVersionUID = -2286186646912330964L;
	private PsndocVO oldVO = null;
	private static IUAPQueryBS querySerivce=null;

	private UFLiteralDate nowDate=getNowDate();
	
	/**
	 * 
	 * @param oldVO
	 */
	public PsnjobValidator(PsndocVO oldVO) {

		this.oldVO = oldVO;
	}

	public ValidationFailure validate(Object obj) {

		PsndocVO vo = (PsndocVO) obj;
		ValidationFailure f = null;

		// ޸ĺĹϢ
		List<PsnjobVO> job_list = new ArrayList<PsnjobVO>();
		List<PsnjobVO> newJob_list = new ArrayList<PsnjobVO>();

		PsnjobVO[] jobs = vo.getPsnjobs();

		if (getOldVO() == null) {
			// ʱȫΪ
			if (jobs != null && jobs.length > 0) {
				for(PsnjobVO job:jobs){
					job.setStatus(VOStatus.NEW);
				}
				job_list.addAll(Arrays.asList(jobs));
			}
		} else {
			// δ޸ĹϢݣУ
			if (jobs == null || jobs.length == 0) {
				return null;
			} else {
				// ԭݻӱ
				PsnjobVO[] oldjobs = getOldVO().getPsnjobs();
				Map<String, PsnjobVO> map = new HashMap<String, PsnjobVO>();
				// ԭеֱΪ
				if (oldjobs != null && oldjobs.length > 0) {
					for (PsnjobVO psnjobVO : oldjobs) {
						map.put(psnjobVO.getPrimaryKey(), psnjobVO);
					}
				}
				for (PsnjobVO psnjobVO : jobs) {
					// ݵ״̬ɾ滻ԭ
					int state = psnjobVO.getStatus();
					switch (state) {
					case VOStatus.DELETED:
						map.remove(psnjobVO.getPrimaryKey());
						break;
					case VOStatus.UPDATED:
						if(map.containsKey(psnjobVO.getPrimaryKey())){
							map.put(psnjobVO.getPrimaryKey(), psnjobVO);
						}else{
							psnjobVO.setStatus(VOStatus.NEW);
							job_list.add(psnjobVO);
							newJob_list.add(psnjobVO);
						}
						break;
					case VOStatus.NEW: {
						job_list.add(psnjobVO);
						newJob_list.add(psnjobVO);
						break;
					}
					default:
						break;
					}
				}
				job_list.addAll(map.values());
			}
		}

		// ԱҵԪǿɷǿУ鱣֤
		String pk_org = vo.getPk_org();
		String msg = checkPsnjobs(pk_org, job_list.toArray(new PsnjobVO[0]),newJob_list.toArray(new PsnjobVO[0]));
		if(job_list!=null && job_list.size()>0){
			for(PsnjobVO jobvo:job_list.toArray(new PsnjobVO[0])){
				if(jobvo.getEnddutydate()!=null && jobvo.getEnddutydate().equals("9999-12-31")){
					jobvo.setEnddutydate(null);
				}
			}
		}
		
		if (msg != null && msg.trim().length() > 0) {
			f = new ValidationFailure();
			f.setMessage(msg.toString());
		}

		return f;
	}


	/**
	 * ԱϢУ飬ϢΪգ
	 * 
	 * @param pk_org
	 *            ҵԪ
	 * @param jobs
	 *            УԱȫϢ
	 * @return
	 */
	private String checkPsnjobs(String pk_org, PsnjobVO[] jobs,PsnjobVO[] psnclCheckVos) {
		List<String> msgList = new ArrayList<String>();
		// ϢΪʱУ
		if (jobs != null && jobs.length > 0) {
			// 
			List<PsnjobVO> jobsList = Arrays.asList(jobs);
			Collections.sort(jobsList, Comparator.comparing(PsnjobVO::getIndutydate));
			jobs=jobsList.toArray(new PsnjobVO[jobsList.size()]);
			// ǷڲŲظ
			boolean isDeptUnique = true;
			Set<String> deptSet = new HashSet<String>();
			
			//УְʼںְǷȷ
			CheckDutyDateIsCorrect(msgList,jobs);
			// ǷְΨһ
			boolean isMainjobUnique = true;
			boolean isMainjobExist = false;  
			//һְ¼ѡְ
			boolean mustHasOneMainJob=false;

			boolean isOrg=false;
			
			int mainJobCount=0;//Чְ

			for (PsnjobVO psnjobVO : jobs) {
//				String pk_dept = psnjobVO.getPk_dept();

//				// ڲѴʱ
//				if (isDeptUnique && !deptSet.add(pk_dept)) {
//					isDeptUnique = false;
//				}
				
				if(psnjobVO.getIsmainjob().booleanValue()){
					mustHasOneMainJob=true;
				}

				if (isMainjobUnique) {
					// Ƿְ
					boolean isMainJob=false;
					if(psnjobVO.getIsmainjob().booleanValue()&& (psnjobVO.getIndutydate().compareTo(nowDate)<=0 || psnjobVO.getIndutydate().isSameDate(nowDate))
							&&(psnjobVO.getEnddutydate()==null || (nowDate.compareTo(psnjobVO.getEnddutydate())<=0) || nowDate.isSameDate(psnjobVO.getEnddutydate()))){
						isMainJob=true;
						isMainjobExist=true;
						mainJobCount++;
					}
				
					// ΪְݣְΨһָЧְ
					if (mainJobCount>1) {
						isMainjobUnique = false;
					}
					if(isMainJob)
					{
						String job_org=psnjobVO.getPk_org();
						if(pk_org.equalsIgnoreCase(job_org))
							isOrg=true;
					}
					
				}
			}

//			// Ϣظʱ
//			if (!isDeptUnique) {
//				msgList.add(nc.vo.ml.NCLangRes4VoTransl.getNCLangRes().getStrByID("10140psn","010140psn0055"));//ͬһҵԪµͬһֻһְϢ
//			}
			
			if(!mustHasOneMainJob){
				
			}

			// ǷְΨһʱ
			if (!isMainjobUnique) {
				if(!msgList.contains(nc.vo.ml.NCLangRes4VoTransl.getNCLangRes().getStrByID("10140psn","110140psn0032"))){
				msgList.add(nc.vo.ml.NCLangRes4VoTransl.getNCLangRes().getStrByID("10140psn","110140psn0032"));//ͬһԱͬʱֻһְ
				}
			}	

//			// Ƿְʱ
//			if (!isMainjobExist) {
//				msgList.add(nc.vo.ml.NCLangRes4VoTransl.getNCLangRes().getStrByID("10140psn","010140psn0057"));//ԱϢһΪְ
//			}
			//ְҵԪ
			if(isMainjobExist&&(!isOrg))
			{
				msgList.add(nc.vo.ml.NCLangRes4VoTransl.getNCLangRes().getStrByID("10140psn","010140psn0058"));//ְְҵԪΪԱڵҵԪ
			}

		} else {
			msgList.add(nc.vo.ml.NCLangRes4VoTransl.getNCLangRes().getStrByID("10140psn","010140psn0059"));//ԱһϢ
		}
		if(psnclCheckVos!=null&&psnclCheckVos.length>0)
		{
			for(int i=0;i<psnclCheckVos.length;i++)
			{
				String pk_psncl=psnclCheckVos[i].getPk_psncl();
				String pk_dept=psnclCheckVos[i].getPk_dept();
				try
				{
				PsnClVO vo=(PsnClVO)getQueryBS().retrieveByPK(PsnClVO.class, pk_psncl,new String[]{"enablestate"});
				DeptVO  deptVo=(DeptVO)getQueryBS().retrieveByPK(DeptVO.class, pk_dept, new String[]{"enablestate"});
				int enablestate=vo.getEnablestate();
				if(enablestate==3)
				{
					msgList.add(nc.vo.ml.NCLangRes4VoTransl.getNCLangRes().getStrByID("10140psn","010140psn0060"));//ְϢԱͣõ
					break;
				}
				enablestate=deptVo.getEnablestate();
				if(enablestate==3)
				{
					msgList.add(nc.vo.ml.NCLangRes4VoTransl.getNCLangRes().getStrByID("10140psn","010140psn0061"));//ְϢŲͣõĲţ
				}
				}
				catch(BusinessException e)
				{
					Logger.error(e);
				}
				
			}
		}

		if (msgList.size() > 0) {
			return StringUtil.toString(msgList.toArray(), "\n");
		}
		return null;
	}

	/**
	 * УְʼںְǷȷ
	 * 1ְʼڱְ
	 * 2ְж¼1,2,3ѡôЩ1,2,3¼ְʼںְڲܳص
	 * ҪĿľΪȷһʱڣֻһְ
	 */
	private void CheckDutyDateIsCorrect(List<String> msgList,PsnjobVO[] jobs){
		List<PsnjobVO> mainJobList=new ArrayList<PsnjobVO>();//ѡǷְļ¼
		List<PsnjobVO> partTimeJobList=new ArrayList<PsnjobVO>();//ְδѡǷְ
		Map<UFLiteralDate,UFLiteralDate> mainJobMap=new HashMap<UFLiteralDate,UFLiteralDate>();
		Map<UFLiteralDate,UFLiteralDate> indutyAndEnddutydateMainJobMap=new HashMap<UFLiteralDate,UFLiteralDate>();
		for(PsnjobVO job:jobs){
			if(job.getIndutydate()!=null && job.getEnddutydate()!=null){
				if(job.getIndutydate().compareTo(job.getEnddutydate())>0){
					msgList.add(nc.vo.ml.NCLangRes4VoTransl.getNCLangRes().getStrByID("10140psn","110140psn0031")
							/* ְڱְʼڣ*/);				
				}
			}
			if(job.getEnddutydate()==null){
				job.setEnddutydate(new UFLiteralDate("9999-12-31"));
			}
			if(job.getIsmainjob().booleanValue()){	
				mainJobList.add(job);
				indutyAndEnddutydateMainJobMap.put(job.getIndutydate(),job.getEnddutydate());
			}else{
				partTimeJobList.add(job);
			}
		}
		int mainJobCount=0;//ڵǰҵ£Чְ
		if(mainJobList!=null && mainJobList.size()>0){			
			for(PsnjobVO jobvo:mainJobList){	
				if(jobvo.getIndutydate().compareTo(nowDate)<=0
					&&nowDate.compareTo(jobvo.getEnddutydate())<=0){
						mainJobCount++;
					}	
			}
		}

		if(mainJobList.size()<1){
			msgList.add(nc.vo.ml.NCLangRes4VoTransl.getNCLangRes().getStrByID("10140psn","110140psn0038")
					/*ԱϢһѡǷְ*/);
		}
		if(mainJobCount>1){
			if(!msgList.contains(nc.vo.ml.NCLangRes4VoTransl.getNCLangRes().getStrByID("10140psn","110140psn0032"))){
				msgList.add(nc.vo.ml.NCLangRes4VoTransl.getNCLangRes().getStrByID("10140psn","110140psn0032")
						/* ͬһԱͬʱֻһְ*/);
			}
					
		}else if(mainJobCount==1 && mainJobList.size()>1){
			/**
			 * УͬһʱڣֻһЧְ
			 * 1ְʼںְظģôͬһʱֻһЧְ
			 * 2ְʼںְڶͬжְʼںͽǷص
			 * Ҫʱ䲻صͬһʱֻһЧְ
			 */
			boolean dateIsRepeat=false;
			List<UFLiteralDate> startAndEndDateList=new ArrayList<UFLiteralDate>();
			for(PsnjobVO vo:mainJobList){
				if(vo!=null){
					UFLiteralDate startDate=vo.getIndutydate();
					UFLiteralDate endDate=vo.getEnddutydate();
					if(startAndEndDateList.contains(startDate)){//||startAndEndDateList.contains(endDate)
						dateIsRepeat=true;
					}
					if(!startAndEndDateList.contains(startDate)){
						startAndEndDateList.add(startDate);
					}
					if(!startAndEndDateList.contains(endDate)){
						startAndEndDateList.add(endDate);
					}	
				}		
			}
			if(dateIsRepeat){//keyظģʾʱص
				if(!msgList.contains(nc.vo.ml.NCLangRes4VoTransl.getNCLangRes().getStrByID("10140psn","110140psn0032"))){
					msgList.add(nc.vo.ml.NCLangRes4VoTransl.getNCLangRes().getStrByID("10140psn","110140psn0032")
							/* ͬһԱͬʱֻһְ*/);
				}
			}else{//keyظȫmap
				for(PsnjobVO vo:mainJobList){
					if(vo!=null){
						mainJobMap.put(vo.getIndutydate(), vo.getEnddutydate());
					}		
				}
				for(UFLiteralDate date:startAndEndDateList){
					for(UFLiteralDate key:mainJobMap.keySet()){
						if(key.compareTo(date)<0 && date.compareTo(mainJobMap.get(key))<0){
							if(!msgList.contains(nc.vo.ml.NCLangRes4VoTransl.getNCLangRes().getStrByID("10140psn","110140psn0032"))){
								msgList.add(nc.vo.ml.NCLangRes4VoTransl.getNCLangRes().getStrByID("10140psn","110140psn0032")
										/* ͬһԱͬʱֻһְ*/);
							}
							return;
							}
						}
					}
				}
		}
		//Уְڵʱڣмְ
		checkPartTimeJobIsCorrect(msgList,partTimeJobList,indutyAndEnddutydateMainJobMap);
		
		
	}
	
	/**
	 * Уְڵʱڣмְڡ
	 */
	private void checkPartTimeJobIsCorrect(List<String> msgList,List<PsnjobVO> partTimeJobList,Map<UFLiteralDate,UFLiteralDate> indutyAndEnddutydateMainJobMap){
		if(partTimeJobList==null || partTimeJobList.size()==0 ||indutyAndEnddutydateMainJobMap==null ||indutyAndEnddutydateMainJobMap.size()==0){
			return;
		}
		boolean startFlag=false;
		boolean endFlag=false;
		for(PsnjobVO jobvo:partTimeJobList){
			UFLiteralDate ptStartDate=jobvo.getIndutydate();//ְĿʼʱ
			UFLiteralDate ptEndDate=jobvo.getEnddutydate();//ְĽʱ
			UFLiteralDate mainEndOneDate=null;//ְĵһʱ
			UFLiteralDate mainEndTwoDate=null;//ְĵڶʼʱ
			for(UFLiteralDate key:indutyAndEnddutydateMainJobMap.keySet()){
				if((key.compareTo(ptStartDate)<=0 || key.isSameDate(ptStartDate))&& ptStartDate.compareTo(indutyAndEnddutydateMainJobMap.get(key))<=0){
					startFlag=true;
					mainEndOneDate=indutyAndEnddutydateMainJobMap.get(key);
				}
				if(key.compareTo(ptEndDate)<=0 && ptEndDate.compareTo(indutyAndEnddutydateMainJobMap.get(key))<=0){
					endFlag=true;
					mainEndTwoDate=indutyAndEnddutydateMainJobMap.get(key);
				}
			}
			if(startFlag && endFlag && mainEndOneDate!=null && mainEndTwoDate!=null){
				for(UFLiteralDate key:indutyAndEnddutydateMainJobMap.keySet()){
					if(mainEndOneDate!=null && indutyAndEnddutydateMainJobMap.get(mainEndOneDate.getDateAfter(1))!=null){
						mainEndOneDate=indutyAndEnddutydateMainJobMap.get(mainEndOneDate.getDateAfter(1));
					}
				}
				if(mainEndOneDate!=null && mainEndTwoDate!=null &&
						mainEndOneDate.compareTo(mainEndTwoDate)<0){
					msgList.add(nc.vo.ml.NCLangRes4VoTransl.getNCLangRes().getStrByID("10140psn","110140psn0039")
							/*Աְλְ봦*/);
					return;
				}
			}else{
				msgList.add(nc.vo.ml.NCLangRes4VoTransl.getNCLangRes().getStrByID("10140psn","110140psn0039")
						/*Աְλְ봦*/);
				return;
			}		
		}
	}
	
	/**
	 * ԭԱݣΪnullʱĬΪ
	 * 
	 * @return
	 */
	protected PsndocVO getOldVO() {
		return oldVO;
	}
	private IUAPQueryBS getQueryBS()
	{
		if(querySerivce==null)
			querySerivce=NCLocator.getInstance().lookup(IUAPQueryBS.class);
		return querySerivce;
	}
	
	private UFLiteralDate getNowDate(){
		if(nowDate==null){
			nowDate=new GetBusiDateUtil().getNowDate();
		}
		return nowDate;
	}

}
