package nc.net.servlet;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.io.PrintWriter;
import java.text.SimpleDateFormat;
import java.util.Calendar;
import java.util.Date;
import java.util.Properties;
import java.util.UUID;

import javax.servlet.ServletException;
import javax.servlet.ServletInputStream;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import nc.bs.framework.adaptor.IHttpServletAdaptor;
import nc.bs.framework.common.InvocationInfoProxy;
import nc.bs.framework.common.NCLocator;
import nc.bs.framework.comn.NetStreamContext;
import nc.bs.framework.server.ISecurityTokenCallback;
import nc.itf.uap.IUAPQueryBS;
import nc.itf.ws.esb.IEsbDAO;
import nc.vo.esb.EsbInfoVO;
import nc.vo.esb.EsbVO;
import nc.vo.esb.QueryInfoVO;
import nc.vo.esb.ResultEsbVO;
import nc.vo.esb.ResultVO;
import nc.vo.pub.BusinessException;
import nc.vo.ws.esb.CertificateVO;
import nc.vo.ws.esb.EsbinfoVO;
import uap.json.JSONObject;

/**
   * ԽESB װServlet
 * @author  2021-06-21
 *
 */
public abstract class NewEsbJsonServlet implements IHttpServletAdaptor {
	
	/**
	 * ʱ侫ȷ
	 */
	public static SimpleDateFormat dateFormat = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss:SSS");
	
	private static IEsbDAO service;
	
	private JSONObject jsonvalue;
	
	private String beginDateStr;
	
	private static Properties _prop = new Properties();
	
	@Override
	public void doAction(HttpServletRequest request, HttpServletResponse response)
			throws ServletException, IOException {
		beginDateStr=dateFormat.format(Calendar.getInstance().getTime());//ʼʱ
		
		try {
			initInvocationInfo();
		} catch (BusinessException e1) {
			// TODO Auto-generated catch block
			e1.printStackTrace();
		}
		
		if(true){//֤ͨcheckEsbkey(request)
			try{
				jsonvalue=findPostJsonValue(request);//ȡPostֵ
				if(jsonvalue==null || "".equals(jsonvalue)){//Postύֵ
					ResultVO result=new ResultVO();
					result.setCode(IReturnStatus.FAILING);//ʧ
					result.setMessage("PostύJsonʽֵ!");
					ResultEsbVO<ResultVO> esb=new ResultEsbVO<ResultVO>();
					createResultEsbVO(esb);
					esb.getEsbInfo().setReturnStatus(IReturnStatus.ESB_FAILING);
					esb.setResultInfo(result);
					sendResponse(response,esb);
				}else{
				    /** end ϵͳBGY **/
					execFunction(request,response,jsonvalue);
				}
			}catch(Exception e){
				ResultVO result=new ResultVO();
				result.setCode(IReturnStatus.ERROR);//쳣
				result.setError(getExceptionDetail(e));
				ResultEsbVO<ResultVO> esb=new ResultEsbVO<ResultVO>();//Ӧ
				createResultEsbVO(esb);//ʼӦ
				esb.getEsbInfo().setReturnStatus(IReturnStatus.ESB_ERROR);
				esb.setResultInfo(result);//Ӧ
				sendResponse(response,esb);
			}
		}else{//֤ʧܴ
			ResultVO result=new ResultVO();
			result.setCode(IReturnStatus.FAILING);//ʧ
			String esbkey=request.getHeader("esbkey");
			if(esbkey==null){
				result.setMessage("esbkeyΪգȨ֤ʧ!");
			}else{
				result.setMessage("esbkeyȨ֤ʧ!["+esbkey+"]ǷΪ֤keyֵ!");
			}
			ResultEsbVO<ResultVO> esb=new ResultEsbVO<ResultVO>();//Ӧ
			createResultEsbVO(esb);//ʼӦ
			esb.getEsbInfo().setReturnStatus(IReturnStatus.ESB_FAILING);
			esb.setResultInfo(result);
			sendResponse(response,esb);
		}
	}
	
	/**
	 * ֤esbkey
	 * @param request 
	 * @return true(֤ͨ)/false(֤ʧ)
	 */
	private boolean checkEsbkey(final HttpServletRequest request){
		boolean isok=true;
    	try{
    		String pathinfo=request.getPathInfo();
    		if(pathinfo!=null){
    			pathinfo=pathinfo.substring(1, pathinfo.length());
    			EsbinfoVO[] esbinfos=(EsbinfoVO[]) getService().findESB("interfacename='"+pathinfo+"'");
    			if(esbinfos!=null && esbinfos.length>0){
    				String esbkey=request.getHeader("esbkey");
    				for(EsbinfoVO esb:esbinfos){
    					if(esb.getIsstart()!=null && "1".equals(esb.getIsstart())){//Ƿ
	    					CertificateVO typevo=getService().findByPkCode(esb.getCertificate());
	    					if(typevo==null||!typevo.getEsbkey().equals(esbkey)){
	    						isok=false;
	    						break;
	    					}
    					}else{
    						isok=false;
    						break;
    					}
    				}
    			}else{
    				isok=false;
    			}
    		}
    	}catch(Exception e){
    		isok=false;
    	}
    	return isok;
	}
	
	/**
	 * PostύJson
	 * @param request
	 * @return
	 * @throws Exception 
	 */
	private JSONObject findPostJsonValue(final HttpServletRequest request) throws Exception{
		BufferedReader br=null;
		try {
			br= new BufferedReader(new InputStreamReader(
					(ServletInputStream) request.getInputStream(), "utf-8"));
			StringBuffer sb = new StringBuffer();
			String temp=null;
			while ((temp = br.readLine())!= null) {
				sb.append(temp);
			}
			return new JSONObject(sb.toString());
		} catch (Exception e) {
			throw e;
		}finally{
			try {
				if(br!=null)
					br.close();
			} catch (IOException e) {
				e.printStackTrace();
			}
		}
	}
	
	/**
	 * ӦϢ
	 * @param response
	 * @param esb
	 */
	public void sendResponse(final HttpServletResponse response,ResultEsbVO esb){
		String jsondata=com.alibaba.fastjson.JSONObject.toJSONString(esb);
		PrintWriter out=null;
		try {
			response.setHeader("Content-type", "application/json;charset=UTF-8");
			out = new PrintWriter(new OutputStreamWriter(response.getOutputStream(),"UTF-8"));
	        out.write(jsondata);
	        out.flush();
		} catch (IOException e) {
			e.printStackTrace();
		}finally{
			if(out!=null){
				out.close();
			}
		}
	}
	
	public void sendResponse(final HttpServletResponse response,String responseMsg) {
		PrintWriter out=null;
		try {
			response.setHeader("Content-type", "application/json;charset=UTF-8");
			out = new PrintWriter(new OutputStreamWriter(response.getOutputStream(),"UTF-8"));
	        out.write(responseMsg);
	        out.flush();
		} catch (IOException e) {
			e.printStackTrace();
		}finally{
			if(out!=null){
				out.close();
			}
		}
	}
	
	/**
	 * PostύJson
	 * @return
	 */
	public JSONObject getPostJsonValue(){
		return jsonvalue;
	}
	
	/**
	 * ESB ߼ӿ
	 * @return
	 */
	private static IEsbDAO getService(){
    	if(service==null)
    		service=NCLocator.getInstance().lookup(IEsbDAO.class);
    	return service;
	}
	
	/**
	 * ESB
	 * @param newi
	 * @param esb VO
	 * @return newi=0()
	 */
	public void createEsbVO(final EsbVO esb){
		EsbInfoVO esbInfo=new EsbInfoVO();
		QueryInfoVO queryInfo=new QueryInfoVO();
		Date date=Calendar.getInstance().getTime();//ȡǰʱ
		//ʱ
		esbInfo.setRequestTime(dateFormat.format(date));
		esbInfo.setInstId(getStringUUID());//ʹUUIDΪˮ
		esb.setEsbInfo(esbInfo);
		esb.setQueryInfo(queryInfo);
	}
	/**
	 * ESBӦ
	 * @param esb
	 */
	public void createResultEsbVO(final ResultEsbVO esb){
		EsbInfoVO esbInfo=new EsbInfoVO();
		QueryInfoVO queryInfo=new QueryInfoVO();
		Date date=Calendar.getInstance().getTime();//ȡǰʱ
		//Ӧʱ
		String instid=getRequestInstId();
		if(instid!=null && !"".equals(instid)){
			esbInfo.setInstId(instid);
		}else{
			esbInfo.setInstId(getStringUUID());//ʹUUIDΪˮ
		}
		esbInfo.setRequestTime(getBeginDateStr());//ʼʱ
		esbInfo.setResponseTime(dateFormat.format(date));//Ӧʱ
		esbInfo.setReturnStatus(IReturnStatus.ESB_SUCCEED);//ĬӦɹ
		esbInfo.setReturnCode(IReturnStatus.ESB_SUCCEED_CODE);//Ĭϳɹcode
		esbInfo.setReturnMsg("ɹ");//ĬӦɹʾ
		esb.setEsbInfo(esbInfo);
		esb.setQueryInfo(queryInfo);
	}
	
	/**
	 * UUIDֵ
	 */
	public static String getStringUUID(){
		return UUID.randomUUID().toString();
	}
	
	/**
	 * @param e	쳣
	 * return 쳣ϸϢ
	 */
	public String getExceptionDetail(Exception e) {
		if(e==null)
			return null;
        StringBuffer stringBuffer = new StringBuffer(e.toString() + "\n");  
        if(e.getStackTrace()==null || e.getStackTrace().length==0)
        	return stringBuffer.toString();  
        StackTraceElement[] messages = e.getStackTrace();  
        int length = messages.length;  
        for (int i = 0; i < length; i++) {
            stringBuffer.append("\t"+messages[i].toString()+"\n");  
        }  
        return stringBuffer.toString();  
    }
	
	/**
	 * ʼʱ
	 * @return
	 */
	public String getBeginDateStr(){
		return beginDateStr;
	}
	
	/**
	 * ȡ instId ֵ
	 * @return
	 */
	public String getRequestInstId(){
		if(jsonvalue!=null){
			return jsonvalue.getJSONObject("esbInfo").getString("instId");
		}
		return null;
	}
	
	/**
	 * ҵ߼ִк
	 * @param request
	 * @param response
	 */
	public abstract void execFunction(HttpServletRequest request, HttpServletResponse response,JSONObject jsonobj) throws Exception;
	
//	private void initInvocationInfo() {
//		/*
//		 * ISecurityTokenCallback tc = NCLocator.getInstance().lookup(
//		 * ISecurityTokenCallback.class); byte[] token = tc.token("__system".getBytes(),
//		 * "NC".getBytes()); NetStreamContext.setToken(token); //NCCԱ String
//		 * sql="select cuserid from sm_user where user_code ='NCCadmin'"; String cuserid
//		 * =""; try { cuserid = (String) getUAPQueryBS().executeQuery(sql, new
//		 * ColumnProcessor()); } catch (BusinessException e) { e.printStackTrace(); } //
//		 * InvocationInfoProxy.getInstance().setUserDataSource(SapConstants.NUMSOURSE);
//		 * try {
//		 * InvocationInfoProxy.getInstance().setGroupId(SysInitQuery.getParaString(
//		 * "GLOBLE00000000000000", "GROUP")); } catch (BusinessException e) { // TODO
//		 * Auto-generated catch block e.printStackTrace(); }
//		 * InvocationInfoProxy.getInstance().setUserId(cuserid);
//		 */
//		PropertiesUtil.readProperties("use_datasource.properties");
//		String datasource = PropertiesUtil.getProperty("datasource");
//		NCLocator.getInstance().lookup(ISecurityTokenCallback.class).token("NCSystem".getBytes(), "pfxx".getBytes());
//		try {
//			//IBusiCenterManageService busiCenterManageService=NCLocator.getInstance().lookup(IBusiCenterManageService.class);
//			InvocationInfoProxy.getInstance().setUserDataSource(datasource);
//			InvocationInfoProxy.getInstance().setGroupId(SysInitQuery.getParaString("GLOBLE00000000000000", "GROUP"));
//			InvocationInfoProxy.getInstance().setUserId(SysInitQuery.getParaString("GLOBLE00000000000000", "ITFUSER"));
//		} catch (BusinessException e) {
//			// TODO Auto-generated catch block
//			e.printStackTrace();
//		}
//		/*
//		 * ISecurityTokenCallback tc = NCLocator.getInstance().lookup(
//		 * ISecurityTokenCallback.class); byte[] token = tc.token("__system".getBytes(),
//		 * "NC".getBytes()); NetStreamContext.setToken(token);
//		 */
//
//	}
	private void initInvocationInfo() throws BusinessException {
		try {
			//InvocationInfoProxy.getInstance().setGroupId(SysInitQuery.getParaString("GLOBLE00000000000000", "GROUP"));
			//InvocationInfoProxy.getInstance().setUserId(SysInitQuery.getParaString("GLOBLE00000000000000", "ITFUSER"));
			 InputStream in = NewEsbJsonServlet.class.getResourceAsStream("loginmessage.properties");
	         BufferedReader bf = new BufferedReader(new InputStreamReader(in));
	         _prop.load(bf);
	         //IBusiCenterManageService busiCenterManageService=NCLocator.getInstance().lookup(IBusiCenterManageService.class);
//	        InvocationInfoProxy.getInstance().setUserDataSource(busiCenterManageService.getAvailableBusiCenterDsNames()[0]);
	        InvocationInfoProxy.getInstance().setUserDataSource( _prop.getProperty("userDataSource") );	
	        InvocationInfoProxy.getInstance().setGroupId(_prop.getProperty("pkGroup"));
			InvocationInfoProxy.getInstance().setUserId(_prop.getProperty("userId"));
			ISecurityTokenCallback tc = NCLocator.getInstance().lookup(ISecurityTokenCallback.class);
			byte[] token = tc.token("__system".getBytes(), "NC".getBytes());
			NetStreamContext.setToken(token);
		} catch (Exception e) {
			// TODO Auto-generated catch block
			throw new BusinessException(e.getMessage());
			
		}
	}
	
	private IUAPQueryBS uapQueryBS;
    public IUAPQueryBS getUAPQueryBS() {
        if (uapQueryBS == null) {
        uapQueryBS = NCLocator.getInstance().lookup(IUAPQueryBS.class);
        }
        return uapQueryBS;
        }
    
    
}
