package ncc.net.servlet;

import java.io.IOException;
import java.io.OutputStreamWriter;
import java.io.PrintWriter;
import java.text.SimpleDateFormat;
import java.util.Calendar;
import java.util.Date;
import java.util.Map;
import java.util.UUID;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import nc.bs.dao.BaseDAO;
import nc.bs.framework.adaptor.IHttpServletAdaptor;
import nc.bs.framework.common.InvocationInfoProxy;
import nc.bs.framework.common.NCLocator;
import nc.bs.framework.comn.NetStreamContext;
import nc.bs.framework.server.ISecurityTokenCallback;
import nc.itf.ws.esb.IEsbDAO;
import nc.jdbc.framework.processor.ColumnProcessor;
import nc.jdbc.framework.processor.MapProcessor;
import ncc.net.servlet.status.WyReturnStatus;
import ncc.pub.wy.constant.WyConstants;
import ncc.vo.esb.WyEsbInfoVO;
import ncc.vo.esb.WyEsbVO;
import ncc.vo.esb.WyQueryInfoVO;
import ncc.vo.esb.WyResultEsbVO;
import ncc.vo.esb.result.WyResultVO;

/**
 * ԽESB װServlet
 * @author Ƽ
 * @date 2020-12-03
 *
 */
public abstract class NccEsbJsonServletUtil implements IHttpServletAdaptor {
	
	/**
	 * ʱ侫ȷ
	 */
	public static SimpleDateFormat dateFormat = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss:SSS");
	
	private static IEsbDAO service;
	
	
	private String beginDateStr;
	
	@Override
	public void doAction(HttpServletRequest request, HttpServletResponse response)
			throws ServletException, IOException {
		beginDateStr=dateFormat.format(Calendar.getInstance().getTime());//ʼʱ
		initInvocationInfo();
//		if(checkEsbkey(request)){//֤ͨ
		if(true){	
			execFunction(request,response);
			
		}else{//֤ʧܴ
			WyResultVO result=new WyResultVO();
			result.setCode(WyReturnStatus.FAILING);//ʧ
			String esbkey=request.getHeader("esbkey");
			if(esbkey==null){
				result.setMessage("esbkeyΪգȨ֤ʧ!");
			}else{
				result.setMessage("esbkeyȨ֤ʧ!["+esbkey+"]ǷΪ֤keyֵ!");
			}
			WyResultEsbVO<WyResultVO> esb=new WyResultEsbVO<WyResultVO>();//Ӧ
			createResultEsbVO(esb);//ʼӦ
			esb.getEsbInfo().setReturnStatus(WyReturnStatus.ESB_FAILING);
			esb.setResultInfo(result);
			sendResponse(response,esb);
		}
	}
	
	/**
	 * ֤esbkey
	 * @param request 
	 * @return true(֤ͨ)/false(֤ʧ)
	 */
	private boolean checkEsbkey(final HttpServletRequest request){
		boolean isok=true;
    	try{
    		String pathinfo=request.getPathInfo();
    		if(pathinfo!=null){
    			pathinfo=pathinfo.substring(1, pathinfo.length());
    			String sql = "select distinct isstart,certificate from bgy_esbinfo where interfacename='"+pathinfo+"'";
    			Map map = (Map) new BaseDAO().executeQuery(sql, new MapProcessor());
    			String isstart = "";
    			String certificate = "";
    			if(null != map && map.size()>0) {
    				String esbkey=request.getHeader("esbkey");
    				isstart = (String) map.get("isstart");
    				certificate = (String) map.get("certificate");
    				if(null != isstart && "1".equals(isstart) && null !=certificate) {//Ƿ
    					String sjesbkey = "select esbkey from bgy_certificate where pk_code='"+certificate+"'";
    					String esb = (String) new BaseDAO().executeQuery(sjesbkey, new ColumnProcessor());
    					if(null == esb ||!esb.equals(esbkey)) {
    						isok=false;
    					}
    				}else{
						isok=false;
					}
    			}else{
    				isok=false;
    			}
    		}
    	}catch(Exception e){
    		isok=false;
    	}
    	return isok;
	}
	
	
	/**
	 * ӦϢ
	 * @param response
	 * @param esb
	 */
	public void sendResponse(final HttpServletResponse response,WyResultEsbVO esb){
		String jsondata=com.alibaba.fastjson.JSONObject.toJSONString(esb);
		PrintWriter out=null;
		try {
			response.setHeader("Content-type", "application/json;charset=UTF-8");
			out = new PrintWriter(new OutputStreamWriter(response.getOutputStream(),"UTF-8"));
	        out.write(jsondata);
	        out.flush();
		} catch (IOException e) {
			e.printStackTrace();
		}finally{
			if(out!=null){
				out.close();
			}
		}
	}
	
	
	/**
	 * ESB
	 * @param newi
	 * @param esb VO
	 * @return newi=0()
	 */
	public void createEsbVO(final WyEsbVO esb){
		WyEsbInfoVO esbInfo=new WyEsbInfoVO();
		WyQueryInfoVO queryInfo=new WyQueryInfoVO();
		Date date=Calendar.getInstance().getTime();//ȡǰʱ
		//ʱ
		esbInfo.setRequestTime(dateFormat.format(date));
		esbInfo.setInstId(getStringUUID());//ʹUUIDΪˮ
		esb.setEsbInfo(esbInfo);
		esb.setQueryInfo(queryInfo);
	}
	/**
	 * ESBӦ
	 * @param esb
	 */
	public void createResultEsbVO(final WyResultEsbVO esb){
		WyEsbInfoVO esbInfo=new WyEsbInfoVO();
		WyQueryInfoVO queryInfo=new WyQueryInfoVO();
		Date date=Calendar.getInstance().getTime();//ȡǰʱ
		//Ӧʱ
		esbInfo.setInstId(getStringUUID());//ʹUUIDΪˮ
		esbInfo.setRequestTime(getBeginDateStr());//ʼʱ
		esbInfo.setResponseTime(dateFormat.format(date));//Ӧʱ
		esbInfo.setReturnStatus(WyReturnStatus.ESB_SUCCEED);//ĬӦɹ
		esbInfo.setReturnCode(WyReturnStatus.ESB_SUCCEED_CODE);//Ĭϳɹcode
		esbInfo.setReturnMsg("ɹ");//ĬӦɹʾ
		esb.setEsbInfo(esbInfo);
		esb.setQueryInfo(queryInfo);
	}
	
	/**
	 * UUIDֵ
	 */
	public static String getStringUUID(){
		return UUID.randomUUID().toString();
	}
	
	/**
	 * @param e	쳣
	 * return 쳣ϸϢ
	 */
	public String getExceptionDetail(Exception e) {  
		if(e==null)
			return null;
        StringBuffer stringBuffer = new StringBuffer(e.toString() + "\n");  
        if(e.getStackTrace()==null || e.getStackTrace().length==0)
        	return stringBuffer.toString();  
        StackTraceElement[] messages = e.getStackTrace();  
        int length = messages.length;  
        for (int i = 0; i < length; i++) {
            stringBuffer.append("\t"+messages[i].toString()+"\n");  
        }  
        return stringBuffer.toString();  
    }
	
	/**
	 * ʼʱ
	 * @return
	 */
	public String getBeginDateStr(){
		return beginDateStr;
	}
	
	
	/**
	 * ҵ߼ִк
	 * @param request
	 * @param response
	 */
	public abstract void execFunction(HttpServletRequest request, HttpServletResponse response);
	
	protected void initInvocationInfo() {
		
		InvocationInfoProxy.getInstance().setUserDataSource("NCCDATA");
		//InvocationInfoProxy.getInstance().setUserDataSource(WyConstants.NUMSOURSE);
		InvocationInfoProxy.getInstance().setGroupId(WyConstants.GROUPID);
		InvocationInfoProxy.getInstance().setUserId(
				WyConstants.NCCADMIN_CUSERID);
		ISecurityTokenCallback tc = NCLocator.getInstance().lookup(
				ISecurityTokenCallback.class);
		byte[] token = tc.token("__system".getBytes(), "NC".getBytes());
		NetStreamContext.setToken(token);
	}
}
