/**
 *
 */
package com.ufsoft.iufo.fml.util;

import java.awt.Color;
import java.awt.print.PageFormat;
import java.awt.print.Paper;
import java.util.ArrayList;
import java.util.Date;
import java.util.HashMap;
import java.util.Hashtable;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import java.util.Set;
import java.util.Vector;

import javax.print.attribute.Size2DSyntax;
import javax.print.attribute.standard.MediaSize;
import javax.print.attribute.standard.MediaSizeName;

import org.apache.poi.hssf.usermodel.HSSFFont;
import org.apache.poi.hssf.usermodel.HSSFPatriarch;
import org.apache.poi.hssf.util.HSSFColor;
import org.apache.poi.ss.usermodel.BorderStyle;
import org.apache.poi.ss.usermodel.Cell;
import org.apache.poi.ss.usermodel.CellStyle;
import org.apache.poi.ss.usermodel.DataFormat;
import org.apache.poi.ss.usermodel.FillPatternType;
import org.apache.poi.ss.usermodel.Font;
import org.apache.poi.ss.usermodel.HorizontalAlignment;
import org.apache.poi.ss.usermodel.PrintSetup;
import org.apache.poi.ss.usermodel.Row;
import org.apache.poi.ss.usermodel.Sheet;
import org.apache.poi.ss.usermodel.VerticalAlignment;
import org.apache.poi.ss.usermodel.Workbook;
import org.apache.poi.ss.util.CellRangeAddress;

import com.ufida.dataset.IContext;
import com.ufida.iufo.pub.tools.AppDebug;
import com.ufida.iufo.table.exarea.ExtendAreaCell;
import com.ufsoft.iufo.excel.util.FmtExcelImpExpUtil;
import com.ufsoft.iufo.fmtplugin.dynarea.DynAreaUtil;
import com.ufsoft.iufo.fmtplugin.dynarea.DynamicAreaModel;
import com.ufsoft.iufo.fmtplugin.formula.FormulaModel;
import com.ufsoft.iufo.fmtplugin.formula.FormulaVO;
import com.ufsoft.iufo.fmtplugin.formula.UfoFmlExecutor;
import com.ufsoft.iufo.fmtplugin.key.KeywordModel;
import com.ufsoft.iufo.inputplugin.biz.FontFactory;
import com.ufsoft.report.CellFormatUtil;
import com.ufsoft.report.constant.DefaultSetting;
import com.ufsoft.report.sysplugin.excel.ExcelExpUtil;
import com.ufsoft.report.sysplugin.excel.IPostProcessor;
import com.ufsoft.script.base.IParsed;
import com.ufsoft.script.exception.ParseException;
import com.ufsoft.script.expression.IExcelCmdLet;
import com.ufsoft.table.AreaPosition;
import com.ufsoft.table.CellPosition;
import com.ufsoft.table.CellsModel;
import com.ufsoft.table.CombinedAreaModel;
import com.ufsoft.table.CombinedCell;
import com.ufsoft.table.IArea;
import com.ufsoft.table.IAreaAtt;
import com.ufsoft.table.PrintSetModel;
import com.ufsoft.table.format.DefaultDataFormat;
import com.ufsoft.table.format.DefaultFormatValue;
import com.ufsoft.table.format.IFormat;
import com.ufsoft.table.format.INumberFormat;
import com.ufsoft.table.format.NumberFormat;
import com.ufsoft.table.format.StringFormat;
import com.ufsoft.table.format.TableConstant;
import com.ufsoft.table.print.PrintSet;

import nc.vo.iufo.keydef.KeyVO;

/**
 * @author liuchuna
 * @created at 2011-5-5,08:02:04
 *
 */
public class FmlExcelExpPubUtil {

	static final double FONT_SISE_SCALE_TOEXCEL = 20 * 3 / 4.0 * 0.8436;

	//IUFOֽΪ:A4,A5,Letter,A3,A6, B4, B5, B6
	private static short[] EXCEL_PAPERSIZE={9, 11,1,8, 70, 12, 13, 14};
	private static Vector<MediaSizeName> MEDIA_NAME=new Vector<MediaSizeName>();
	static{
		MEDIA_NAME.add(MediaSizeName.ISO_A4);
		MEDIA_NAME.add(MediaSizeName.ISO_A5);
		MEDIA_NAME.add(MediaSizeName.NA_LETTER);
		MEDIA_NAME.add(MediaSizeName.ISO_A3);
		MEDIA_NAME.add(MediaSizeName.ISO_A6);
		MEDIA_NAME.add(MediaSizeName.ISO_B4);
		MEDIA_NAME.add(MediaSizeName.ISO_B5);
		MEDIA_NAME.add(MediaSizeName.ISO_B6);
	}

	//ڵͼƬʱsheetֻʹһHSSFPatriarch
	private static HSSFPatriarch m_patri = null;

	//ֹϲԪͼƬε, ˵ݲڲ⡣
	private static List<String> m_cell2Pic = null;

	public static void covertModel2Sheet(CellsModel cellsModel,
			Sheet sheet, Workbook workBook,
			IPostProcessor postProcessor,
			FontFactory fontFactory, IContext context) {

		m_patri = null;
		m_cell2Pic = new Vector<String>();

		// תPrintSet
		convertPrintSet(PrintSetModel.getInstance(cellsModel).getPrintSet(), sheet.getPrintSetup(), sheet,
				workBook);
		// תһ
		Hashtable<String, CellStyle> hashStyleByKey = new Hashtable<String, CellStyle>();

		int maxRow=cellsModel.getRowNum();
		if(cellsModel.getRowNum()>DefaultSetting.MAX_ROW_NUM){
			maxRow=DefaultSetting.MAX_ROW_NUM;
			AppDebug.debug(nc.vo.ml.NCLangRes4VoTransl.getNCLangRes().getStrByID("1820001_0","01820001-0099")/*@res "Excel,ֻǰ"*/+DefaultSetting.MAX_ROW_NUM+nc.vo.ml.NCLangRes4VoTransl.getNCLangRes().getStrByID("1820001_0","01820001-0100")/*@res ""*/);
		}

		int maxCol=cellsModel.getColNum();
		if(cellsModel.getColNum()>DefaultSetting.EXCEL_MAX_COL_NUM){
			maxCol=DefaultSetting.EXCEL_MAX_COL_NUM;
			AppDebug.debug(nc.vo.ml.NCLangRes4VoTransl.getNCLangRes().getStrByID("1820001_0","01820001-0101")/*@res "Excel,ֻǰ"*/+DefaultSetting.EXCEL_MAX_COL_NUM+nc.vo.ml.NCLangRes4VoTransl.getNCLangRes().getStrByID("1820001_0","01820001-0102")/*@res ""*/);
		}

		FormulaModel fmlModel = FormulaModel.getInstance(cellsModel);
		UfoFmlExecutor fmlExecutor = UfoFmlExecutor.getInstance(context, cellsModel);
		for (int rowIndex = 0; rowIndex < maxRow; rowIndex++) {
			Row row = sheet.createRow(rowIndex);
			for (int colIndex = 0; colIndex < maxCol; colIndex++) {
				Cell cell = row.createCell((short) colIndex);
				covertCell(cellsModel, cell, rowIndex, colIndex, workBook,sheet,
						postProcessor, postProcessor==null?false:postProcessor.isShowZero(), hashStyleByKey, fontFactory);

				// Թʽзװ
				convertFormula(fmlExecutor, fmlModel, cellsModel, cell, rowIndex, colIndex);
			}
		}

		treateHeightWidth(cellsModel, sheet);

		// תϵԪ
		convertCombinedCell(cellsModel, sheet);
		// 
		// sheet.setDefaultRowHeightInPoints(TableStyle.ROW_HEIGHT);//Ч
		sheet.setDefaultColumnWidth((short) 13);// TableStyle.COLUMN_WIDTH);

		m_patri = null;
	}

	/**
	 * ʽзװ
	 *
	 * @create by liuchuna at 2011-5-5,08:27:25
	 *
	 * @param cellsModel
	 * @param sheet
	 */
	protected static void convertFormula(UfoFmlExecutor fmlExecutor, FormulaModel fmlModel, CellsModel cellsModel, Cell cell, int rowIndex, int colIndex) {

		CellPosition cellPos = CellPosition.getInstance(rowIndex, colIndex);
        if(cellPos == null) {
        	return;
        }
		IArea realFmlArea = fmlModel.getRelatedFmlArea(cellPos, FormulaModel.TYPE_CELL_FML);
		if(realFmlArea == null) {
			return;
		}
		FormulaVO fmlVO = fmlModel.getPublicDirectFml(realFmlArea);
		if(fmlVO != null) {
			// ʽΪexcelֵ֧ʽ
			String strFml = getExcelFmlContent(cellsModel, fmlVO, realFmlArea, fmlExecutor);
			try{
				cell.setCellFormula(strFml);
			}catch(Exception e) {
				AppDebug.debug(nc.vo.ml.NCLangRes4VoTransl.getNCLangRes().getStrByID("1820001_0","01820001-0103")/*@res "Ƿexcelʽʽݣ"*/ + strFml);
			}
		}
	}

	/*
	 * tianchuan 2012.12.14
	 * CellsModelתΪSheetȫʽǷExcelֵ֧Ĺʽ
	 * ÷ڸʽ-ʽʹ
	 */
	public static void covertModel2SheetWithAllFormulas(CellsModel cellsModel,String repCode,
			Workbook workBook,
			IPostProcessor postProcessor,
			FontFactory fontFactory,
			int fmlType,IContext context) {
		String fmlTypeName = null;
		

		fmlTypeName  = repCode + FmtExcelImpExpUtil.getFmlTypeName(fmlType);
		Sheet sheet = workBook.createSheet(fmlTypeName);
		
		FormulaModel formulaModel = FormulaModel.getInstance(cellsModel);
		UfoFmlExecutor fmlExecutor = formulaModel.getUfoFmlExecutor();
		
		if(fmlExecutor==null){
			fmlExecutor = UfoFmlExecutor.getInstance(context, cellsModel);
			KeywordModel keyModel = DynAreaUtil.getKeywordModel(cellsModel);
			if(keyModel != null) {
				ArrayList<KeyVO> repKeys = keyModel.getMainKeyVO();
				if(repKeys != null && !repKeys.isEmpty()){
					fmlExecutor.getCalcEnv().setKeys(repKeys.toArray(new KeyVO[0]));
				}
			}
			formulaModel.setUfoFmlExecutor(fmlExecutor);
		}
		m_patri = null;
		m_cell2Pic = new Vector<String>();

		// תPrintSet
		convertPrintSet(PrintSetModel.getInstance(cellsModel).getPrintSet(), sheet.getPrintSetup(), sheet,
				workBook);
		// תһ
		Hashtable<String, CellStyle> hashStyleByKey = new Hashtable<String, CellStyle>();

		int maxRow=cellsModel.getRowNum();
		if(cellsModel.getRowNum()>DefaultSetting.MAX_ROW_NUM){
			maxRow=DefaultSetting.MAX_ROW_NUM;
			AppDebug.debug(nc.vo.ml.NCLangRes4VoTransl.getNCLangRes().getStrByID("1820001_0","01820001-0099")/*@res "Excel,ֻǰ"*/+DefaultSetting.MAX_ROW_NUM+nc.vo.ml.NCLangRes4VoTransl.getNCLangRes().getStrByID("1820001_0","01820001-0100")/*@res ""*/);
		}

		int maxCol=cellsModel.getColNum();
		if(cellsModel.getColNum()>DefaultSetting.EXCEL_MAX_COL_NUM){
			maxCol=DefaultSetting.EXCEL_MAX_COL_NUM;
			AppDebug.debug(nc.vo.ml.NCLangRes4VoTransl.getNCLangRes().getStrByID("1820001_0","01820001-0101")/*@res "Excel,ֻǰ"*/+DefaultSetting.EXCEL_MAX_COL_NUM+nc.vo.ml.NCLangRes4VoTransl.getNCLangRes().getStrByID("1820001_0","01820001-0102")/*@res ""*/);
		}

		FormulaModel fmlModel = formulaModel;
		
		for (int rowIndex = 0; rowIndex < maxRow; rowIndex++) {
			Row row = sheet.createRow(rowIndex);
			for (int colIndex = 0; colIndex < maxCol; colIndex++) {
				Cell cell = row.createCell((short) colIndex);
				covertCell(cellsModel, cell, rowIndex, colIndex, workBook,sheet,
						postProcessor, postProcessor==null?false:postProcessor.isShowZero(), hashStyleByKey, fontFactory);

				// Թʽзװ
				addFormula(fmlExecutor, fmlModel, cellsModel, cell, rowIndex, colIndex, fmlType);
			}
		}

		treateHeightWidth(cellsModel, sheet);

		// תϵԪ
		convertCombinedCell(cellsModel, sheet);
		// 
		// sheet.setDefaultRowHeightInPoints(TableStyle.ROW_HEIGHT);//Ч
		sheet.setDefaultColumnWidth((short) 13);// TableStyle.COLUMN_WIDTH);

		m_patri = null;
	}
	
	/*
	 * tianchuan 2012.12.14
	 * ֱӽʽݼExcelԪ
	 */
	protected static void addFormula(UfoFmlExecutor fmlExecutor, FormulaModel fmlModel, CellsModel cellsModel, Cell cell, int rowIndex, int colIndex,int fmlType) {

		CellPosition cellPos = CellPosition.getInstance(rowIndex, colIndex);
        if(cellPos == null) {
        	return;
        }
//		IArea realFmlArea = fmlModel.getRelatedFmlArea(cellPos, FormulaModel.TYPE_CELL_FML);
		IArea realFmlArea = (IArea)FmlDefPubUtil.getRelatedFmlVO(fmlModel,cellPos,fmlType)[0];
		
		if(realFmlArea == null) {
			return;
		}
		FormulaVO fmlVO=FmlDefPubUtil.getFormula(fmlModel,cellPos,fmlType);
		if(fmlVO != null) {
			String strDynPK=FmlDefPubUtil.getDynPKByFmlArea(cellPos, cellsModel);
			String userDefContent=fmlModel.getUfoFmlExecutor().getUserDefFmlContent(fmlVO, cellPos, strDynPK);
			if(userDefContent!=null && userDefContent.length()>0){
				cell.setCellValue("="+userDefContent);
			}
		}
	}
	
	public static String getExcelFmlContent(CellsModel cellsModel, FormulaVO fVO, IArea area, UfoFmlExecutor fmlExecutor) {
		if (fVO != null) {
			String strContent = fVO.getFormulaContent();
			if (fVO.isErrorFml() == true || strContent == null
					|| strContent.length() == 0)
				return strContent;

			IParsed cmdLet = fVO.getLet();
			if (cmdLet == null) {
				try {
					String strDynPK = getDynPKByFmlArea(area, cellsModel);
					fmlExecutor.getCalcEnv().setDynAreaInfo(strDynPK, null);
					if (strDynPK == null) {
						cmdLet = fmlExecutor.getFormulaProxy().parseFormula(area,
								strContent);
					} else {
						cmdLet = fmlExecutor.getFormulaProxy().parseExpr(strContent);
					}
				} catch (ParseException e) {
					return fVO.getFormulaContent();
				}
			}
			if(cmdLet instanceof IExcelCmdLet) {
				return ((IExcelCmdLet) cmdLet).toExcelString(fmlExecutor.getCalcEnv());
			} else {
				return fVO.getLet().toUserDefString(fmlExecutor.getCalcEnv());
			}
		}
		return null;
	}

	private static String getDynPKByFmlArea(IArea selArea, CellsModel cellsModel) {
		ExtendAreaCell[] dynCellsTemp = DynamicAreaModel
				.getInstance(cellsModel).getDynAreaCellByArea(selArea);
		String strDynPK = null;
		if (dynCellsTemp != null && dynCellsTemp.length > 0)
			strDynPK = dynCellsTemp[0].getBaseInfoSet().getExAreaPK();
		return strDynPK;
	}

	/**
	 * CellsModelָУӿʼеУӵSheet
	 * @author biancm 20101117
	 *
	 * @param cellsModel
	 * @param sheet
	 * @param workBook
	 * @param postProcessor
	 * @param fontFactory
	 * @param startRow CellsModelʼУ0ʼ
	 * @param endRow CellsModel ,
	 */
	public static void appendCellsModel2Sheet(CellsModel cellsModel,
			Sheet sheet, Workbook workBook,
			IPostProcessor postProcessor,
			FontFactory fontFactory,
			int startRow, int endRow) {

		m_patri = null;
		m_cell2Pic = new Vector<String>();

		// תPrintSet
		convertPrintSet(PrintSetModel.getInstance(cellsModel).getPrintSet(), sheet.getPrintSetup(), sheet,
				workBook);
		// תһ
		Hashtable<String, CellStyle> hashStyleByKey = new Hashtable<String, CellStyle>();

		int maxRow=cellsModel.getRowNum();
		if(endRow >= maxRow){
			endRow = maxRow -1;

		}

		int maxCol=cellsModel.getColNum();
		if(cellsModel.getColNum()>DefaultSetting.EXCEL_MAX_COL_NUM){
			maxCol=DefaultSetting.EXCEL_MAX_COL_NUM;
			AppDebug.debug(nc.vo.ml.NCLangRes4VoTransl.getNCLangRes().getStrByID("1820001_0","01820001-0101")/*@res "Excel,ֻǰ"*/+DefaultSetting.EXCEL_MAX_COL_NUM+nc.vo.ml.NCLangRes4VoTransl.getNCLangRes().getStrByID("1820001_0","01820001-0102")/*@res ""*/);
		}

		int sheetStartRow = sheet.getRow(0) == null ? 0 : sheet.getLastRowNum() + 1;//ҳʼ
		int sheetRowIndex = sheetStartRow;
		for (int rowIndex = startRow; rowIndex <= endRow; rowIndex++, sheetRowIndex++) {
			Row row = sheet.createRow(sheetRowIndex);
			for (int colIndex = 0; colIndex < maxCol; colIndex++) {
				Cell cell = row.createCell((short) colIndex);
				covertCell(cellsModel, cell, rowIndex, colIndex, workBook,sheet,
						postProcessor, postProcessor==null?false:postProcessor.isShowZero(), hashStyleByKey, fontFactory);
			}
		}

		//к-
		treateHeightWidth(cellsModel, sheet, startRow, endRow, sheetStartRow);

		// תϵԪ
		convertCombinedCell(cellsModel, sheet);
		// 
		// sheet.setDefaultRowHeightInPoints(TableStyle.ROW_HEIGHT);//Ч
		sheet.setDefaultColumnWidth((short) 13);// TableStyle.COLUMN_WIDTH);

		m_patri = null;
	}

	public static int covertPartModel2Sheet(CellsModel cellsModel,
			Sheet sheet, Workbook workBook,
			IPostProcessor postProcessor,
			FontFactory fontFactory,int iFixCol,int iStartCol,int iMaxCol) {

		m_patri = null;

		// תPrintSet
		convertPrintSet(PrintSetModel.getInstance(cellsModel).getPrintSet(), sheet.getPrintSetup(), sheet,workBook);
		// תһ
		Hashtable hashStyleByKey = new Hashtable();
		int iRetCol=-1;
		List<Integer> vCol=new ArrayList<Integer>();
		int[] iMaxRowCols=cellsModel.getValidHeaders();
		for (int rowIndex = 0; rowIndex < iMaxRowCols[0]; rowIndex++) {
			Row row = sheet.createRow(rowIndex);
			int iRealCol=-1;
			int sStartCol=iStartCol;
			for (int colIndex = 0; iRealCol < iMaxRowCols[1]+1 && colIndex<iMaxCol; colIndex++) {
				Cell cell = row.createCell((short) colIndex);
				if (iStartCol==0){
					iRealCol=sStartCol;
					sStartCol++;
				}else if (iFixCol>=0 && colIndex<=iFixCol){
					iRealCol=colIndex;
				}else{
					iRealCol=sStartCol;
					sStartCol++;
				}
				if (rowIndex==0)
					vCol.add(iRealCol);
				covertCell(cellsModel, cell, rowIndex, iRealCol, workBook,sheet,
						postProcessor, postProcessor==null?false:postProcessor.isShowZero(), hashStyleByKey, fontFactory);

			}
			iRetCol=Math.max(iRetCol, iRealCol);
		}

		treatePartHeightWidth(cellsModel, sheet,vCol);

		// תϵԪ
		convertPartCombinedCell(cellsModel, sheet,vCol);
		// 
		// sheet.setDefaultRowHeightInPoints(TableStyle.ROW_HEIGHT);//Ч
		sheet.setDefaultColumnWidth((short) 13);// TableStyle.COLUMN_WIDTH);

		m_patri = null;

		if (vCol.size()<iMaxCol || iRetCol>=(iMaxRowCols[1]))
			return -1;
		return iRetCol+1;
	}

	static void treatePartHeightWidth(CellsModel cellsModel, Sheet sheet,List<Integer> vCol) {
		int[] iMaxRowCols=cellsModel.getValidHeaders();
		for (int rowIndex = 0; rowIndex < iMaxRowCols[0]; rowIndex++) {
			int height = cellsModel.getRowHeaderModel().getSize(rowIndex);
			if (height < 4)
				height = 0;

			Row row = sheet.getRow(rowIndex);
			row.setHeight((short) (((double) height) * 20 * 3 / 4 * 0.9346));
		}

		for (int colIndex = 0; colIndex < vCol.size(); colIndex++) {
			int width = cellsModel.getColumnHeaderModel().getSize(vCol.get(colIndex));
			if (width < 4)
				width = 0;
			sheet.setColumnWidth((short) colIndex,
					(short) (((double) width) * 256 / 7 * 0.892));
		}
	}

	static void convertPartCombinedCell(CellsModel cellsModel, Sheet sheet,List<Integer> vCol) {
		List<IAreaAtt> areaCellList = cellsModel.getAreaDatas();
		for (IAreaAtt iAreaAtt : areaCellList) {
			IAreaAtt areaCell = iAreaAtt;
			if (areaCell instanceof CombinedCell) {
				AreaPosition area = areaCell.getArea();

				int iStartCol=-1;
				int iEndCol=-1;
				for (int i=0;i<vCol.size();i++){
					int iCol=vCol.get(i);
					for (int j=area.getStart().getColumn();j<=area.getEnd().getColumn();j++){
						if (iCol==j){
							if(iStartCol==-1)
								iStartCol=i;
							iStartCol=Math.min(iStartCol,i);
							if (iEndCol==-1)
								iEndCol=i;
							iEndCol=Math.max(iEndCol, i);
							break;
						}
					}
				}

				if (iStartCol<0 || iEndCol<0)
					continue;

				if (iEndCol<iStartCol)
					continue;

				if (iEndCol==iStartCol && area.getStart().getRow()==area.getEnd().getRow())
					continue;

				sheet.addMergedRegion(new CellRangeAddress(area.getStart().getRow(),area.getEnd()
						.getRow(), iStartCol, iEndCol));
			}
		}

	}

	public static void convertPrintSet(PrintSet ps, PrintSetup excelPs,
			Sheet sheet, Workbook workBook) {
		excelPs.setScale((short) (ps.getPrintScale() * 100));
		// ûа취תֽŴС
		// ֽŷ
		if (ps.getPaper().getPageformat().getOrientation() == PageFormat.PORTRAIT) {
			excelPs.setLandscape(false);
		} else {
			excelPs.setLandscape(true);
		}

//			excelPs.setOptions((short) (excelPs.getOptions() | (short) 0x0002));
//		} else {
//			excelPs.setOptions((short) (excelPs.getOptions() | (short) 0xFFFD));
//		}

////		// ߾  λ㳬鷳. ʱ߾ർ.
//		double iSize = 1/25.4;//1;//
//		sheet.setMargin(HSSFSheet.TopMargin, iSize
//				* ps.getPageformat().getImageableX());
//		sheet.setMargin(HSSFSheet.BottomMargin, iSize
//				* (ps.getPageformat().getHeight() - ps.getPageformat()
//						.getImageableX()));
//		sheet.setMargin(HSSFSheet.LeftMargin, iSize
//				* ps.getPageformat().getImageableY());
//		sheet.setMargin(HSSFSheet.RightMargin, iSize
//				* (ps.getPageformat().getWidth() - ps.getPageformat()
//						.getImageableY()));
//
    	double d = 72D;
    	Paper pp=ps.getPaper().getPageformat().getPaper();
    	MediaSizeName mediasizename=MediaSize.findMedia((float)(pp.getWidth()/d),(float)(pp.getHeight()/d),Size2DSyntax.INCH);
    	int iIndex=MEDIA_NAME.indexOf(mediasizename);
    	if (iIndex<0)
    		iIndex=0;
    	excelPs.setPaperSize(EXCEL_PAPERSIZE[iIndex]);

		int sheetIndex = -1;
		for (int i = 0; i < workBook.getNumberOfSheets(); i++) {
			if (workBook.getSheetAt(i) == sheet) {
				sheetIndex = i;
				break;
			}
		}

		// ̶С
		if (ps.getColHeadRang() != null || ps.getRowHeadRang() != null) {
			int startCol = ps.getColHeadRang() == null ? 0 : ps
					.getColHeadRang()[0];
			int endCol = ps.getColHeadRang() == null ? 0
					: ps.getColHeadRang()[1];
			int startRow = ps.getRowHeadRang() == null ? 0 : ps
					.getRowHeadRang()[0];
			int endRow = ps.getRowHeadRang() == null ? 0
					: ps.getRowHeadRang()[1];
//			workBook.setRepeatingRowsAndColumns(sheetIndex, startCol, endCol,
//					startRow, endRow);
			sheet.setRepeatingRows(new CellRangeAddress(startCol,endCol,startRow,endRow));
			sheet.setRepeatingColumns(new CellRangeAddress(startCol,endCol,startRow,endRow));
		}
	}

	static void treateHeightWidth(CellsModel cellsModel, Sheet sheet) {
		for (int rowIndex = 0; rowIndex < cellsModel.getRowNum(); rowIndex++) {
			int height = cellsModel.getRowHeaderModel().getSize(rowIndex);
			if (height < 4)
				height = 0;

			Row row = sheet.getRow(rowIndex);
			//row.setHeight((short) (((double) height) * 20 * 3 / 4 * 0.9346));
			row.setHeightInPoints((float)(height/4.0/25.4*72));
		}

		for (int colIndex = 0; colIndex < cellsModel.getColNum(); colIndex++) {
			int width = cellsModel.getColumnHeaderModel().getSize(colIndex);
			if (width < 4)
				width = 0;
			sheet.setColumnWidth((short) colIndex,
					(short) (((double) width) * 256 / 7 * 0.9426));//0.892
		}
	}

	/**
	 * CellsModel޸sheetип
	 *
	 * @param cellsModel
	 * @param sheet
	 * @param startRow CellsModelĿʼ
	 * @param endRow  CellsModelĽ
	 * @param sheetStartRow ҳʼ
	 */
	static void treateHeightWidth(CellsModel cellsModel, Sheet sheet, int startRow, int endRow, int sheetStartRow) {
		for (int rowIndex = startRow; rowIndex <= endRow; rowIndex++) {
			int height = cellsModel.getRowHeaderModel().getSize(rowIndex);
			if (height < 4)
				height = 0;

			Row row = sheet.getRow(sheetStartRow + rowIndex - startRow);
			//row.setHeight((short) (((double) height) * 20 * 3 / 4 * 0.9346));
			row.setHeightInPoints((float)(height/4.0/25.4*72));
		}

		for (int colIndex = 0; colIndex < cellsModel.getColNum(); colIndex++) {
			int width = cellsModel.getColumnHeaderModel().getSize(colIndex);
			if (width < 4)
				width = 0;
			sheet.setColumnWidth((short) colIndex,
					(short) (((double) width) * 256 / 7 * 0.9426));//0.892
		}
	}

//	static void convertCombinedCell(CellsModel cellsModel, HSSFSheet sheet) {
//		ArrayList areaCellList = cellsModel.getAreaDatas();
//		for (Iterator iter = areaCellList.iterator(); iter.hasNext();) {
//			AreaCell areaCell = (AreaCell) iter.next();
//			if (areaCell instanceof CombinedCell) {
//				AreaPosition area = areaCell.getArea();
//				sheet.addMergedRegion(new Region(area.getStart().getRow(),
//						(short) area.getStart().getColumn(), area.getEnd()
//								.getRow(), (short) area.getEnd().getColumn()));
//			}
//		}
//
//	}

//	Ϊ5.02ʹĴ롣  ¸汾롣
	private static void convertCombinedCell(CellsModel cellsModel, Sheet sheet) {
		CombinedCell[] cCells  = CombinedAreaModel.getInstance(cellsModel).getCombineCells();
		 for(CombinedCell areaCell: cCells){
				AreaPosition area = areaCell.getArea();
				sheet.addMergedRegion(new CellRangeAddress(area.getStart().getRow(),area.getEnd()
						.getRow(), area.getStart().getColumn(), area.getEnd().getColumn()));

		}

	}

	public static void covertCell(CellsModel cellsModel, Cell cell, int rowIndex,
			int colIndex, Workbook workBook, Sheet sheet, IPostProcessor postProcessor,
			boolean bShowZero, Hashtable<String, CellStyle> hashStyleByKey,
			FontFactory fontFactory) {

		CellPosition cellPosition = CellPosition
				.getInstance(rowIndex, colIndex);

		IFormat format = cellsModel.getRealFormat(cellPosition);
		// תʽ

		Object value = cellsModel.getCellValue(CellPosition.getInstance(
				rowIndex, colIndex));

		if (postProcessor != null)
			value = postProcessor.postProcessValue(cellsModel, rowIndex,
					colIndex, value, format);

		boolean bNumber = format != null
				&& format.getCellType() == TableConstant.CELLTYPE_NUMBER;
		boolean bBigNumber = format != null
		        && format.getCellType() == TableConstant.CELLTYPE_BIGNUMBER;
		if (value != null) {
			if(bBigNumber) {
				String strVal = "" + value;
				cell.setCellValue(strVal);
			} else if (bNumber) {
				String strVal = "" + value;
				try {
					if (strVal.length() > 0) {
						double dbVal = Double.parseDouble(strVal);
						if (bShowZero == true || dbVal != 0)
							cell.setCellValue(dbVal);
					}
				} catch (NumberFormatException e) {
					if (value instanceof String) {
						cell.setCellValue((String) value);
					} else if (value instanceof Double) {
						cell.setCellValue(((Double) value).doubleValue());
					} else if (value instanceof Boolean) {
						cell.setCellValue(((Boolean) value).booleanValue());
					} else if (value instanceof Date) {
						cell.setCellValue((Date) value);

					} else {
						cell.setCellValue(value.toString());
					}
				} catch (Exception e) {
					AppDebug.debug(e);
				}

			} else {
				if (value instanceof String) {
					cell.setCellValue((String) value);
				} else if (value instanceof Double) {
					cell.setCellValue(((Double) value).doubleValue());
				} else if (value instanceof Boolean) {
					cell.setCellValue(((Boolean) value).booleanValue());
				} else if (value instanceof Date) {
					cell.setCellValue((Date) value);

				}

//				else if (value instanceof ImageIcon || value instanceof IChartModel) {
//					// liuyy. 2007-07-18
//					try {
//
//						//liuyy+, ϵԪֻ׵Ԫɡ2008-08-12
//						CombinedCell cc = cellsModel.getCombinedAreaModel().belongToCombinedCell(cellPosition);
//						if(cc == null || cellPosition.equals(cc.getArea().getStart())){
//
//							IArea area = cellPosition;
//							if(cc != null){
//								area = cc.getArea();
//							}
//
//							BufferedImage bufferedImage = null;
//							if(value instanceof IChartModel){
//								IChartModel chartModel = (IChartModel) value;
//								JFreeChart chart = chartModel.getChart();
//								if(chart != null){
//									Rectangle rct = cellsModel.getCellRect(area, false);
//									bufferedImage = chart.createBufferedImage((int)rct.getWidth(), (int)rct.getHeight());
//								}
//
//							} else if(value instanceof ImageIcon){
//								ImageIcon image = (ImageIcon) value;
//								bufferedImage = new BufferedImage(image.getIconWidth(),image.getIconHeight()
//										, BufferedImage.TYPE_4BYTE_ABGR);
//								Graphics2D g2D = (Graphics2D) bufferedImage.getGraphics();
//								g2D.drawImage(image.getImage(), 0, 0,
//										image.getImageObserver());
//
//							}
//
//							if(bufferedImage != null){
//								ByteArrayOutputStream bos = new ByteArrayOutputStream();
//								ImageIO.write(bufferedImage, "PNG", bos);
//
//								CellPosition startp = area.getStart();
//								CellPosition endp = area.getEnd();
//
//								ClientAnchor anchor = new ClientAnchor(0, 0,
//										1023, 255, (short) startp.getColumn(), startp
//										.getRow(), (short) endp.getColumn(),
//										endp.getRow());
//								anchor.setAnchorType(AnchorType.MOVE_AND_RESIZE);
//
////								Sheet sheet = workBook.getSheetAt(0);
//
//								if(m_patri == null){
//									m_patri = sheet.createDrawingPatriarch();
//								}
//
//								m_patri.createPicture(anchor, workBook.addPicture(bos
//										.toByteArray(), Workbook.PICTURE_TYPE_PNG));
//							}
//
//						}
//
//					} catch (IOException e1) {
//						AppDebug.debug(e1);
//					}
//				}

				else {
					cell.setCellValue(value.toString());
				}
			}
		}

		if (format == null)
			return;

		String strKey = getCellStyleKey(cellPosition, cellsModel, format);
		CellStyle cellStyle = hashStyleByKey.get(strKey);
		if (cellStyle != null) {
			cell.setCellStyle(cellStyle);
			return;
		}

		cellStyle = workBook.createCellStyle();
		hashStyleByKey.put(strKey, cellStyle);
		cell.setCellStyle(cellStyle);
		// ɫ
		if (format.getFont().getBackgroundColor() != null) {
			cellStyle.setFillForegroundColor(getColor(format
					.getFont().getBackgroundColor()));
			cellStyle.setFillPattern(FillPatternType.SOLID_FOREGROUND);// (short)0);//fillpattern򱳾ɫ޷ʾ
		}
		// 뷽ʽ
		if (format.getAlign().getHalign() != TableConstant.UNDEFINED) {
			cellStyle.setAlignment(getAlignment(format.getAlign().getHalign()));
		} else {
			value = cellsModel.getCellValue(cellPosition);
			if (value != null && value instanceof Double)
				cellStyle.setAlignment(getAlignment(TableConstant.HOR_RIGHT));
			else
				cellStyle.setAlignment(getAlignment(TableConstant.HOR_LEFT));
		}

		if (format.getAlign().getValign() != TableConstant.UNDEFINED) {
			cellStyle.setVerticalAlignment(getVerticalAlignment(format.getAlign().getValign()));
		} else {
			cellStyle.setVerticalAlignment(getVerticalAlignment(TableConstant.VER_CENTER));
		}
		// 
		Font cellFont = workBook.createFont();
		if (format.getFont().getForegroundColor() != null) {
			cellFont.setColor(getColor(format.getFont().getForegroundColor()));
		}
		if (format.getFont().getFontname() != null) {
			cellFont.setFontName(format.getFont().getFontname());
		} else {
			cellFont.setFontName(DefaultFormatValue.FONTNAME);
		}

		int iFontSize = format.getFont().getFontsize();
		if (iFontSize <= 0)
			iFontSize = DefaultSetting.DEFAULT_FONTSIZE;
/*		cellFont
				.setFontHeight((short) (((double) iFontSize) * FONT_SISE_SCALE_TOEXCEL));*/
		cellFont.setFontHeightInPoints((short)iFontSize);

		int fontStyle = format.getFont().getFontstyle();

		if (fontStyle >= 0) {
			if ((fontStyle & TableConstant.FS_BOLD) != 0) {
				cellFont.setBold(true);
			}
			if ((fontStyle & TableConstant.FS_SLOPE) != 0) {
				cellFont.setItalic(true);
			}
			if ((fontStyle & TableConstant.FS_UNDERLINE) != 0) {
				cellFont.setUnderline(HSSFFont.U_SINGLE);
			}
		}
		cellStyle.setFont(fontFactory.getShareInstance(cellFont));

		// ۵ʾ
		cellStyle.setWrapText(format.getAlign().getFontFold() == TableConstant.TRUE);
		// ߿Ժͱ߿ɫ
		cellStyle
				.setBorderTop(getBorderType(format.getLines().getLineType(IFormat.TOPLINE)));
		cellStyle.setBorderBottom(getBorderType(format
				.getLines().getLineType(IFormat.BOTTOMLINE)));
		cellStyle.setBorderLeft(getBorderType(format
				.getLines().getLineType(IFormat.LEFTLINE)));
		cellStyle.setBorderRight(getBorderType(format
				.getLines().getLineType(IFormat.RIGHTLINE)));
//		> HSSFCellStyle.THICK_BACKWARD_DIAG
//		> HSSFCellStyle.THICK_FORWARD_DIAG
//		> HSSFCellStyle.THIN_BACKWARD_DIAG
//		> HSSFCellStyle.THIN_FORWARD_DIAG
//		cellStyle.setFillPattern(HSSFCellStyle.THIN_FORWARD_DIAG);

		if (format.getLines().getLineColor(IFormat.TOPLINE) != null) {
			cellStyle.setTopBorderColor(getColor(format
					.getLines().getLineColor(IFormat.TOPLINE)));
		}
		if (format.getLines().getLineColor(IFormat.BOTTOMLINE) != null) {
			cellStyle.setBottomBorderColor(getColor(format
					.getLines().getLineColor(IFormat.BOTTOMLINE)));
		}
		if (format.getLines().getLineColor(IFormat.LEFTLINE) != null) {
			cellStyle.setLeftBorderColor(getColor(format
					.getLines().getLineColor(IFormat.LEFTLINE)));
		}
		if (format.getLines().getLineColor(IFormat.RIGHTLINE) != null) {
			cellStyle.setRightBorderColor(getColor(format
					.getLines().getLineColor(IFormat.RIGHTLINE)));
		}

		// ʽ
		StringBuffer strFmt = new StringBuffer();
		if(format.getCellType() == TableConstant.CELLTYPE_NUMBER){
			NumberFormat numberFormat = (NumberFormat)format.getDataFormat();
			// ֵǷôٷֺ
			if (numberFormat.getPercent() > 0) {
				strFmt.append("0.00%");
			} else {
				// ($#,##0_);[Red]($#,##0)
				String sSymbol = CellFormatUtil.getCurrencySymbolStr(format);
				// ŷָ
				String sComma = "";
				if (numberFormat.getComma() > 0) {
					sComma = "#,##";
				}
				// Сβ
				int nNumDig = numberFormat.getDecimalDigits();
				if (nNumDig == TableConstant.UNDEFINED) {
					nNumDig = DefaultSetting.DEFAULT_DECIMALDIGITS;
				}
				String sNumDig = "0";
				if (nNumDig > 0) {
					char[] chars = new char[nNumDig + 1];
					chars[0] = '.';
					for (int i = 1; i <= nNumDig; i++) {
						chars[i] = '0';
					}
					sNumDig = sNumDig + new String(chars);
				}
				if (sSymbol != null && !(sSymbol.equalsIgnoreCase(""))) {
					sComma="#,##";
					if (sSymbol.equals(nc.vo.ml.NCLangRes4VoTransl.getNCLangRes().getStrByID("1820001_0","01820001-0104")/*@res ""*/) || sSymbol.equals(nc.vo.ml.NCLangRes4VoTransl.getNCLangRes().getStrByID("1820001_0","01820001-0105")/*@res ""*/)){
						sSymbol="$";
					}
				    else if (sSymbol.equals(nc.vo.ml.NCLangRes4VoTransl.getNCLangRes().getStrByID("1820001_0","01820001-0106")/*@res ""*/))
				    	sSymbol="[$CNY] ";
				    else
				    	sSymbol="[$"+sSymbol+"] ";

					strFmt.append(sSymbol);
					strFmt.append(sComma);
					strFmt.append(sNumDig);

					strFmt.append(";");

					strFmt.append(sSymbol);
					strFmt.append("-");
					strFmt.append(sComma);
					strFmt.append(sNumDig);
					strFmt.append("");
				} else {
					strFmt.append(sComma);
					strFmt.append(sNumDig);
				}
			}
		}else if(format.getDataFormat() instanceof StringFormat || format.getDataFormat() instanceof DefaultDataFormat){
			strFmt.append("TEXT");
		}
		if (strFmt.length() == 0) {
			strFmt.append("General");
		}
		// HSSFDataFormat dataFmt = new HSSFDataFormat(m_workbook);
		DataFormat dataFmt=workBook.createDataFormat();
		cellStyle.setDataFormat(dataFmt.getFormat(strFmt.toString()));
	}

	static String getCellStyleKey(CellPosition cell, CellsModel cellsModel,
			IFormat format) {
		StringBuilder key = new StringBuilder();

		// 
		// ɫ
		key.append("FC" + getColor(format.getFont().getForegroundColor()));

		// ʽ
		String str = format.getFont().getFontname() == null ? format.getFont().getFontname()
				: DefaultFormatValue.FONTNAME;
		key.append("FNT" + str);

		// Biff8С
		int iFontStyle = format.getFont().getFontstyle();
		if (iFontStyle >= 0) {
			if ((iFontStyle & TableConstant.FS_BOLD) != 0) {
				key.append("I");
			}
			if ((iFontStyle & TableConstant.FS_SLOPE) != 0) {
				key.append("B");
			}
			if ((iFontStyle & TableConstant.FS_UNDERLINE) != 0) {
				key.append("U");
			}
		}

		// С
		int nFontSize = format.getFont().getFontsize() > 0 ? format.getFont().getFontsize()
				: DefaultSetting.DEFAULT_FONTSIZE;
		key.append(nFontSize - 2);
		key.append("-");

		// 뷽ʽ
		int iHalign = format.getAlign().getHalign();
		if (iHalign == TableConstant.HOR_CENTER) {
			key.append("HC");
		} else if (iHalign == TableConstant.HOR_LEFT) {
			key.append("HL");
		} else if (iHalign == TableConstant.HOR_RIGHT) {
			key.append("HR");
		} else {
			Object value = cellsModel.getCellValue(cell);
			if (value != null && value instanceof Double)
				key.append("HR");
			else
				key.append("HL");
		}
		key.append("-");

		int iVAlign = format.getAlign().getValign();
		if (iVAlign == TableConstant.VER_UP) {
			key.append("VT");
		} else if (iVAlign == TableConstant.VER_DOWN) {
			key.append("VB");
		} else {
			key.append("VM");
		}

		// ɫ
		int iBakColor = getColor(format.getFont().getBackgroundColor());
		key.append("F" + iBakColor);
		key.append("B" + iBakColor);

//		key += "-" + "FP" + format.getFillPattern() + "-";

		// ñ߿
		key.append( "L" + format.getLines().getLineType(IFormat.LEFTLINE));
		key.append("R" + format.getLines().getLineType(IFormat.RIGHTLINE));
		key.append("T" + format.getLines().getLineType(IFormat.TOPLINE));
		key.append("B" + format.getLines().getLineType(IFormat.BOTTOMLINE));
		key.append( "-");

		// ñ߿ɫ
		key.append("L"
				+ getColor(format.getLines().getLineColor(IFormat.LEFTLINE)));
		key.append( "R"
				+ getColor(format.getLines().getLineColor(IFormat.RIGHTLINE)));
		key.append("T" + getColor(format.getLines().getLineColor(IFormat.TOPLINE)));
		key.append("B"
				+ getColor(format.getLines().getLineColor(IFormat.BOTTOMLINE)));
		key.append("-");

		if (format.getAlign().getFontFold() == TableConstant.TRUE)
			key.append("w");
		else
			key.append("nw");
		key.append("-");

		// ʾʽֻṩExcelķʽ
		StringBuffer strFmt = new StringBuffer();
		// ֵǷôٷֺ
		if(format.getCellType() == TableConstant.CELLTYPE_NUMBER || format.getCellType() == TableConstant.CELLTYPE_BIGNUMBER){
			INumberFormat numberFormat = (INumberFormat)format.getDataFormat();
			if (numberFormat.getPercent() > 0) {
				strFmt.append("0.00%");
			} else {
				// ($#,##0_);[Red]($#,##0)
				int iCurrency = numberFormat.getCurrencySymbol();
				String sSymbol = null;
				// ҷ
				if (iCurrency < 0
						|| iCurrency >= DefaultSetting.currencySymbolLocale.length) {
					sSymbol = "";
				} else {
					sSymbol = "$";
				}
				// ŷָ
				String sComma = "";
				if (numberFormat.getComma() > 0) {
					sComma = "#,##";
				}
				// Сβ
				int nNumDig = numberFormat.getDecimalDigits();
				if (nNumDig == TableConstant.UNDEFINED) {
					nNumDig = DefaultSetting.DEFAULT_DECIMALDIGITS;
				}
				String sNumDig = "0";
				if (nNumDig > 0) {
					char[] chars = new char[nNumDig + 1];
					chars[0] = '.';
					for (int i = 1; i <= nNumDig; i++) {
						chars[i] = '0';
					}
					sNumDig = sNumDig + new String(chars);
				}

				// ַ
				// ($#,##0.00_);[Red]($#,##0.00)
				if (sSymbol != null && !(sSymbol.equalsIgnoreCase(""))) {
					sComma="#,##";
					if (sSymbol.equals(nc.vo.ml.NCLangRes4VoTransl.getNCLangRes().getStrByID("1820001_0","01820001-0104")/*@res ""*/) || sSymbol.equals(nc.vo.ml.NCLangRes4VoTransl.getNCLangRes().getStrByID("1820001_0","01820001-0105")/*@res ""*/)){
						sSymbol="$";
					}
				    else if (sSymbol.equals(nc.vo.ml.NCLangRes4VoTransl.getNCLangRes().getStrByID("1820001_0","01820001-0106")/*@res ""*/))
				    	sSymbol="[$CNY] ";
				    else
				    	sSymbol="[$"+sSymbol+"] ";

					strFmt.append(sSymbol);
					strFmt.append(sComma);
					strFmt.append(sNumDig);

					strFmt.append(";");

					strFmt.append(sSymbol);
					strFmt.append("-");
					strFmt.append(sComma);
					strFmt.append(sNumDig);
					strFmt.append("");
				} else {
					strFmt.append(sComma);
					strFmt.append(sNumDig);
				}
			}
		}else if(format.getDataFormat() instanceof StringFormat || format.getDataFormat() instanceof DefaultDataFormat){
			strFmt.append("TEXT");
		}
		if (strFmt.length() == 0) {
			strFmt.append("General");
		}
		key.append(strFmt);
		return key.toString();
	}


	private static Map<Integer,Integer> m_mapColorIndex=new HashMap<Integer,Integer>();

	static short getColor(Color color) {
		if (color == null)
			return -1;

		int colorHashcode = color.hashCode();
		Integer iIndex = m_mapColorIndex.get(colorHashcode);
		if (iIndex!=null)
			return (short)iIndex.intValue();

		int diff = Integer.MAX_VALUE;
		short minDiffIndex = -1;
		Set<Integer> keySet=ExcelExpUtil.s_colorIndexHash.keySet();
		Iterator<Integer> it=keySet.iterator();
		while(it.hasNext()){
			Integer index = it.next();
			HSSFColor aColor = (HSSFColor) ExcelExpUtil.s_colorIndexHash
					.get(index);
			short[] aRgb = aColor.getTriplet();
			int aDiff = (int) (Math.pow(aRgb[0] - color.getRed(), 4)
					+ Math.pow(aRgb[1] - color.getGreen(), 4) + Math.pow(
					aRgb[2] - color.getBlue(), 4));
			if (aDiff == 0) {
				minDiffIndex = index.shortValue();
				break;
//				return index.shortValue();
			} else {
				if (aDiff < diff) {
					diff = aDiff;
					minDiffIndex = index.shortValue();
				}
			}
		}
		//tianchuan 2012.6.19 new IntegerInteger.valueOf(int)
//		m_mapColorIndex.put(colorHashcode, new Integer(minDiffIndex));
		m_mapColorIndex.put(colorHashcode, Integer.valueOf(minDiffIndex));
		return minDiffIndex;
	}

	static HorizontalAlignment getAlignment(int halign) {
		switch (halign) {
		case TableConstant.HOR_LEFT:
			return HorizontalAlignment.LEFT;
		case TableConstant.HOR_CENTER:
			return HorizontalAlignment.CENTER;
		case TableConstant.HOR_RIGHT:
			return HorizontalAlignment.RIGHT;

		default:
			throw new RuntimeException();
		}
	}
	
	static VerticalAlignment getVerticalAlignment(int halign) {
		switch (halign) {
		case TableConstant.HOR_CENTER:
			return VerticalAlignment.CENTER;
		case TableConstant.VER_UP:
			return VerticalAlignment.TOP;
		case TableConstant.VER_DOWN:
			return VerticalAlignment.BOTTOM;

		default:
			throw new RuntimeException();
		}
	}

	static BorderStyle getBorderType(int lineType) {
		switch (lineType) {
		case TableConstant.L_DASH:
			return BorderStyle.DASHED;
		case TableConstant.L_DASHDOT:
			return BorderStyle.DASH_DOT;
		case TableConstant.L_DOT:
			return BorderStyle.DOTTED;
		case TableConstant.L_NULL:
		case TableConstant.UNDEFINED:
			return BorderStyle.NONE;
		case TableConstant.L_SOLID1:
			return BorderStyle.THIN;
		case TableConstant.L_SOLID2:
			return BorderStyle.MEDIUM;
		case TableConstant.L_SOLID3:
			return BorderStyle.THICK;
		case TableConstant.L_SOLID4:
			return BorderStyle.THICK;

		default:
			throw new RuntimeException();
		}
	}

	/** **********תеĹ߷************************ */
	/**
	 * ColorתΪexcelеColor Index
	 *
	 * @param backgroundColor
	 * @return
	 */
	public static Map<Integer,HSSFColor> s_colorIndexHash = HSSFColor.getIndexHash();



}